package Tablasfuncq;
use warnings;
use strict;
use GlobalesSimusol;
use Algebraico;
use Ayudas;
use Controles;
use Data::Dumper;
$Data::Dumper::Indent = 1; 
our ($codconhandles,  $codelems, $codnodos); #definidas en Desdexml
BEGIN {
     use Exporter ();
     our ($VERSION,@ISA,@EXPORT,@EXPORT_OK,%EXPORT_TAGS);
     @ISA=qw(Exporter);
     @EXPORT=qw(&analizar_tablas
                &evaluar_q_n
                &evaluar_tabla_n
                &depurar_tablas &depurar_tablas_archivos
                &partir_tablas
                &sust_num_en_tablas 
                &tipear &tokensep
                &tratar_funciones &registrar_funciones
                &rec_apl_tablas
                &usados &resumir_fun_par_tab_var_funx &fun_par_tab_var
       );  
};
END();
# ---------------------------------------------------------------------------
sub tipear{#($valor,$todo,$sustargus) $tipo,$dentro,$func,$tiparg,$nvalor,$ref
  comfin('com tipear',@_);
  my ($ref,$valor, $todo,$sustargus) = @_; my $coderr = '';
  # aqui ya viene estandarizado y sin X.. interiores
  # $todo para calcular( con true)  o no tipos de argumentos
  # sustargus para redondear (con false) o no resultados numéricos
  # devuelve  ($tipo,$dentro,$func,$tiparg,$nvalor)
  # tipo puede ser
  #  'n' numérico
  #  'a' variable atómica con nombre que no empieza con 'P'
  #   o mas detallada con tipo su primer letra mayuscula ( que no sea P)
  #  'G' global; empieza con G; se declara en cuadro GLOBALES o directamente
  #      en FORTRAN
  #  'p' parametro (variable atómica con nombre que empieza con 'P'
  #  (no controla que haya sido declarada como parametro) 
  #  'e' error
  #  'f' función de nombre que no empieza con 'Q' ni con 'X' ni con 'T'
  #  'q' función de nombre que empieza con 'Q'
  #  't' tabla (funcion que empiez con t)
  #  'x' expresión
  #  'y' si es una lista con algun separador :
  # durante el proceso posterior pueden aparecer tipos nuevos para parámetros:
  #   'b' que no hara falta sustituirlo nunca más
  #   'r' que hubo pedido de rerun y no debe sustituirse
  #   'w' no definido
  #   'W' argumento de entrada en un modelo
  #   'Y' argumento de salida en modelo; debera ser sobreescrito 
  my ($dentro, $func, $pretipo,$nvalor) = analizar($ref,$valor);#en tipear 
  impr_debug(__LINE__.' Tabl $func,$pretipo,$dentro',[$func,$pretipo,$dentro]);
  my $refarg;       
  my $tiparg ='';my ($tipo);my @listargus;
  $pretipo eq 'n' and return 'n',$nvalor,'','',$nvalor;
  if ($pretipo eq 'e') {
      return 'e','','','',$valor;
  } elsif ($pretipo eq 'y') {
     return 'y','','','',$valor;  
  };
  
  if ($func eq '' and $pretipo !~ /[WY]/) {                    
      $dentro =~ /^P\w+$/i and $tipo = 'p'
      or $dentro =~ /^\D\w*$/i and $tipo = 'a'
      or $dentro =~ /^\d.*$/i and do {
	   avgrav("Expresión que  no es aceptable como número;
               $valor");
           return 'e','','','',$valor # empieza con digito pero no fue 'n'
      }
      or do{avnograv("\" $valor \" no es aceptable como nombre de variable");
            return 'z','','','',$valor; 
      };
  } elsif ($pretipo eq 'f') {
      if (lc($func) eq 'listalis' or lc($func) eq 'listaresu') {
          $tipo = ','
      } elsif ($dentro !~ /\S/) {  
           avgrav("\" $valor \" no es aceptable como expresión");
           return 'e','','','',$valor; 
      } else {
          $func =~ /^(\w)(\w*)$/;
          $tipo = lc($1);
          $tipo =~ /[qt]/ or $tipo = 'f';
      };
  } else {
      $tipo = $pretipo;
  };
  impr_debug(__LINE__.' Tabl $tipo,$dentro',[$tipo,$dentro]);
  if ($tipo =~ /[pnawWY]/) {
      $tiparg = $tipo; $refarg = [$dentro];
      comfin('fin tipear $tipo, $dentro, $func, $tiparg, $nvalor, @$refarg'
           , $tipo, $dentro, $func, $tiparg, $nvalor, $refarg,__LINE__);
      return $tipo,$dentro,$tipo,$tiparg,$nvalor,$refarg; 
  };
  if ($todo == 0) {
      my $valorpuro = $dentro;
      $tipo ne 'x' and $valorpuro = $nvalor;
      return $tipo,$valorpuro;
  };
  # continua con $todo true;
      ($coderr, @listargus) = juntar_por_paren(',',split (',',$dentro));
      my (@tipito,@valorpurito,@tipargcito);
      for(my $i = 0; $i < @listargus; $i++) {
          ($tipito[$i],$valorpurito[$i]) = tipear($ref,$listargus[$i],0);
           #not $sustargus and $tipito[$i] eq 'n' and 
           #   $valorpurito[$i] = sprintf ("%G",$valorpurito[$i]);
           #$tipito[$i] eq 'n' and $valorpurito[$i] =~ s/e/E/;
         
      };#for $i
      $dentro = join ',',@valorpurito;
      $tiparg = join '',@tipito;
      $refarg = \@listargus;

  $func =~ /^X/i and $tiparg =~ /^[pna]$/ and do{ #no 'es' una expresion
      $func = ''; $tipo = $tiparg; $tiparg ='';   
  };     
  $nvalor = $dentro;
  $func ne '' and $nvalor = "$func($dentro)";
  if ($tipo =~/[xf]/) {
       ($tiparg, $refarg,$dentro) = tokensep($dentro);
      if ($tiparg eq 'n' and $valor =~ /^X\w*\(/) {
          $tipo = 'n'; $nvalor = $dentro; $tiparg = ''; $refarg = 0;
      }
  };
  comfin('fin tipear $tipo, $dentro, $func, $tiparg, $nvalor, @$refarg'
           , $tipo, $dentro, $func, $tiparg, $nvalor, $refarg);
  return $tipo,$dentro,$func,$tiparg,$nvalor,$refarg;
}# tipear
#----------------------------------------------------------------------------
sub tokensep{
  #comfin('com tokensep',@_);
  my ($expresion) = @_; 
  $expresion ='XXXXXXX(' .$expresion. ')'; 
  my @listamezcla = $expresion =~ /([\w\.]+)/g; #lista de pre-toquens 
  my @listasepa = split /[\w\.]+/, $expresion; #lista de separadores
  shift @listasepa;
  my @listameztotal; my $tips= '';
  my @listatokens;
  push @listameztotal, "$listamezcla[0]$listasepa[0]";
   for (my $i = 1; $i < @listamezcla; $i++) {
      my $palabra = $listamezcla[$i];my $palabran = $palabra;
      my $sepa = $listasepa[$i];
      #impr_debug(__LINE__.' Tabl $palabra',$palabra);
      #impr_debug(__LINE__.' Tabl $sepa',$sepa);
      if ($palabra =~ /^[\d\.]+E$/i) {
          if ($sepa =~/^[\+\-]/ and $listamezcla[$i+1]) {
              $palabra = "$palabra$listasepa[$i]$listamezcla[$i+1]";
              $sepa = $listasepa[$i+1]; 
	      $tips .= 'n';
 	      $i++;
 	  } else {
	      parar1(66, 0, "Error inesperado en $expresion", $CORTOA);
          };
      } elsif ($palabra =~ /^[\d\.]+$/) {
          $tips .= 'n';
      } else {
	  if ($palabra =~ /^X/ and $sepa =~ /^\(/){
              $tips .= 'x';
          } elsif ($palabra =~ /^\d/) {
              $tips .= 'n';
	  } elsif ($palabra =~ /^([PRCEJL]).+/ ) {#puede confundir funcion cos
                      # con capacitor
              $tips .= lc($1);
	  } elsif ($palabra =~ /^([VI])[RCEJL].+/) {
	      $tips .= lc($1);
          } elsif ($palabra =~ /^Q/i and $sepa =~ /^\(/) {
              $tips .= 'q';
          } elsif ($palabra =~ /^T/i and $sepa =~ /^\(/) {
              $tips .= 't';
          } else {
              $tips .= 'a'
          }
      }; 
      #impr_debug(__LINE__.'Tabl tokensep @listameztotal', \@listameztotal);
      push @listameztotal,"$palabra$sepa";
      push @listatokens, $palabra
  }; #for
  my ($coderr,@lista) = juntar_por_paren('',@listameztotal);
  $coderr or @lista >1 and do{
      porparar1($coderr,0,"Paréntesis mal apareadps en $expresion",$CORTOA);
      return $coderr;
  };
  $listameztotal[0] =~ s/^XXXXXXX\(//;
  $listameztotal[-1] =~ s/\)$//;
  $tips =~ s/^x//;
  my $sepas = '/[\+\-\*\/\,]/';
  my $dentro = join '',@listameztotal;
  #comfin('fin tokensep', $tips, @listatokens,$dentro);
  return $tips, \@listatokens,$dentro;
}#tokensep
# ---------------------------------------------------------------------------
sub analizar{
  # supone no recibir lista
  # supone que no hay grandes errores de sintaxis y que esta estandarizado
  # devuelve $dentro, $func , $pretipo y $valor
  # $func es '' y $pretipo es '' si la expresion es atomica (tipos p n a)
  # $pretipo es 'x para indicar expresion 
  # si hay un solo X.. donde corresponde, lo respeta
  comfin('com analizar',@_);  
  my ($ref,$expre) = @_; my $coderr; 
  impr_debug(__LINE__.' Tabl $expre',"$expre");
  $expre =~ /^\s*$/ and return '','','z',''; 
  use warnings  FATAL => qw(numeric uninitialized syntax);
  my $valor = ';' . lc($expre);
  if ($valor =~ /^(.*)(\W)0\d/) {
      $2 ne '.' and  "$1$2" !~ /e[\+\-]$/  and do{avgrav(
          "\" $valor \" no es aceptable (número que empieza con 0 sin . ");
          return '','','e',$valor;
      };
  };
  $valor =~ /\:/ and return $valor,'','y',$valor; 
  my $posi_num = 1;
  # si en $valor hay : devuelve el eval de la parte final
  while ($valor ne '' and $valor =~ s/(\W)(\w+)\(/$1\(/) {
      unless ($acep_fun{lc($2)}) {
	  $posi_num ='';
	  last;
      };
  };
  if ($posi_num) {
      $valor = lc($expre);
      $valor =~ s/\*(\w)/\* $1/g; #para evitar ambiguedades  
      my $nuevovalor = eval($valor);
      if ((not $@ and  defined $nuevovalor)
            and ($nuevovalor =~ /^\d/ or $nuevovalor =~ /^\-\d/)) {
          $valor = $nuevovalor; 
          $valor =~ s/^(\W*\d+)(E[+-]\d+)$/$1\.$2/; 
          $valor =~ s/e/E/;
          #a sceptre le molesta en las expresiones 5E-4 pero no 5.E-4 
          comfin('fin analizar',$valor,'','n',$valor);
          return ($valor,'','n',$valor);
      } else {
      };
  };
  my ($num,$dat,$resto) = sacar_paren_ext($expre);
  $num == -1 and do{
      avgrav("hay parentesis sin cerrar en $expre");
        return '','','e',$expre;
  };
  $dat  =~ /^\s*$/ and return '','','z',''; 

  $expre = $dat if $resto eq '';
   
  ($expre =~ tr/\(//) ==  ($expre =~ tr/\)//) or do { 
      avgrav("Paréntesis no balanceados en $expre");
      return '','','e',$expre;
  };
  $expre =~ s/(\W)(\w+\()/$1&$2&/g;#aqui g es mejor que un while
  $expre =~ s/^(\w+\()/$1&/;
  $expre =~ s/(\))/&$1&/ig;  #REVISAR
  my ($expresion,$func,$pretipo) = ('','','');
  ($coderr,my @listaamper) = juntar_por_paren('',(split(/&+/,$expre)));
  impr_debug(__LINE__.' Tabl @listaamper',\@listaamper);
  my $dentro='';
  if(@listaamper >1) {
      $pretipo = 'x';
      $listaamper[0] =~ s/^X\w+\(//i; #este tambien era interior
      $func = "XXX";
      $dentro =  join ('', @listaamper);
  } elsif ($listaamper[0] =~ /^(\w)(\w*)\((.*)\)/) {
      $func = "$1$2"; $dentro = $3; $pretipo = 'f';
      if (uc($1) eq 'X' and $2 ne '') {
          $pretipo = 'x';
      };
  } elsif ($listaamper[0] =~ /[\+\-\*\/]/) {
      $pretipo = 'x'; # no tenia el X.. habra que ponerlo
      $func = 'XXX';$dentro = $listaamper[0];
  } elsif (defined $ref->{TIPPARAMETROS}->{$listaamper[0]}) {
      $pretipo = $ref->{TIPPARAMETROS}->{$listaamper[0]};
      if ($pretipo =~ /[pand]/) {#un solo token 
	 $dentro = $ref->{PARAMETROS}->{$listaamper[0]};
      } else {	  
	  $dentro = $listaamper[0];
      };
  } else {
      $pretipo ='a'; $dentro = $listaamper[0];
  };
  impr_debug(__LINE__.' Tabl @listaamper',\@listaamper);
  $valor = $dentro;
  $func ne '' and $valor = "$func($dentro)";
  comfin('fin analizar',$dentro,$func,$pretipo,$valor);
  return $dentro, $func, $pretipo, $valor;
} # analizar
# ----------------------------------------------------------------------------
sub evaluar_tabla_n{
  #guarda los valores o para con mensaje de error
  comfin('com evaluar_tabla_n', @_);  
  my ($ref,$que,@listakey) = @_;
  my @noposibles;
  $ref->{usaTABLAS} = {};
  foreach my $key (@listakey) {
      my ($valor,$tipo,$tiparg,$refarg) = tomar_datos($ref,$que,$key);
      next unless $tipo eq 't' and $tiparg eq 'n';
      my ($idtabla,$absc) = ($valor =~ /^T(.+)\((.+)\)/);
      my @abscisas = @{$ref->{absTABLAS}->{$idtabla}};
      if ($absc < $abscisas[0] or $absc > $abscisas[-1]) {
          parar1(66,$ref,"Abscisa $absc para tabla $idtabla fuera de rango
                   $abscisas[0]  :  $abscisas[-1]");
     };
      my @ordenadas = @{$ref->{ordTABLAS}->{$idtabla}};
      my $nuevovalor;
      for (my $i= 1; $i<@abscisas; $i ++) {
         next if $absc > $abscisas[$i];
         if ($absc == $abscisas[$i]) {
            if ($i < @abscisas and $absc ==  $abscisas[$i+1]) {
		$nuevovalor =  ($ordenadas[$i] + $ordenadas[$i+1])/2;
            } else {   
                $nuevovalor = $ordenadas[$i];
	    };
         } else {
             my $ab1 = $abscisas[$i-1]; my $or1 = $ordenadas[$i-1];
             my $ab2 = $abscisas[$i]; my $or2 = $ordenadas[$i];
             $nuevovalor = $or1 + ($absc-$ab1)*($or2-$or1)/($ab2-$ab1);
         };
         last; 
      }; 
      cargar_datos($ref,$que,$key,$nuevovalor,'n',''
               ,__LINE__.' Tabl','et');
      $ref->{usaTABLAS}->{$idtabla} = 1;
  };
  comfin('fin evaluar_tabla_n',[$que],$ref,'impr');
    return '';
}#evaluar_tabla_n
# ---------------------------------------------------------------------------
sub evaluar_q_n{ 
  # se llega aqui con valores que son funciones-Q evaluadas con param.
  #  numericos; actualiza valor y retorna codigo de error
  comfin('com? evaluar_q_n', @_);  
  my ($ref,$que,@listakey) = @_;
  my $sepa = '[\+\-\*\/\(\)\,]';  
  impr_debug(__LINE__.' Tabl @listakey ', \@listakey);
  foreach my $key (@listakey) {
      my $expr = $ref->{$que}->{$key};  
      my ($func,$dentro) = ($expr =~ /^(Q\w+)\((.+)\)/);
      impr_debug(__LINE__.' Tabl $key $expr $func $dentro'
                   , [$key,$expr,$func,$dentro]);
      my @lisparam = split ',',$dentro;
      my $valor;
      if ($func eq 'QPRODUCTO') {
          $valor = 1;
          map ( $valor *= $_, @lisparam);
      } elsif ($func eq 'QSUMA') {
          $valor = 0;
          map ( $valor += $_, @lisparam);          
      } else {
	  if ($ref->{definicionFUNCIONES}->{$func}) {  
              $valor = lc($ref->{definicionFUNCIONES}->{$func});
              #impr_debug(__LINE__.' Tabl $func $valor ', [$func,$valor]);
	  } else {    
 #             avnograv("La función $func no está definida en el diagrama
 #              funciones.for? ");
              return '';
          };
          $valor =~ s/^.+=//;
	  #impr_datos(__LINE__. ' Tabl', ['FUNCIONES'], $ref);
          #impr_debug(__LINE__.' Tabl listaargFUNCIONES '
          #     , Dumper $ref->{definicionFUNCIONES});
          #impr_debug(__LINE__.' Tabl definicionFUNCIONES '
          #     , Dumper $ref->{listaargFUNCIONES});
          my $lisformales = $ref->{listaargFUNCIONES}->{$func}; 
          #impr_debug(__LINE__.' Tabl listaargFUNCIONES '
          #           , $ref->{listaargFUNCIONES});
          #impr_debug(__LINE__.' Tabl @lisparam ', \@lisparam);
          @$lisformales == @lisparam or do {avgrav(
             "$func definida con " . scalar @$lisformales. " argumentos
                 y usada con ".  scalar @lisparam);
              return 66;
          };
          for (my $i = 0; $i < @$lisformales; $i ++) {
              my $formal = lc($lisformales->[$i]); my $sust = $lisparam[$i];
              while ($valor =~ s/($sepa)($formal)($sepa)/$1($sust)\&$3/ig){};
          };
          $valor =~ s/\&//g;
          my $nvalor = eval($valor);
          not defined $nvalor and do{
              avgrav("no pude calcular $expr = $valor");
              return 66;
          };
          $valor = $nvalor;
      };
      cargar_datos($ref, $que, $key,$valor,'n','',0
            ,__LINE__.' Tabl evaluar_q_n');
  };
  comfin('fin evaluar_q_n', ["$que"], $ref, 'impr');
  return '';  
}  
# ---------------------------------------------------------------------------
sub sust_num_en_tablas{
    #sustituye parametros mumericos en tablas, cuadro CONTROLES, 
    #GRAFICOS (con precaucion)
    comfin('com sust_num_en_tablas', @_);
    my $ref= $_[0];
    my @listap =  grep($ref->{TIPPARAMETROS}->{$_} =~ /[nb]/,
                       keys %{$ref->{PARAMETROS}});
    return unless @listap;
    my %hash;
   map ($hash{$_} = $ref->{PARAMETROS}->{$_}, @listap);
    foreach my $clase ('TABLAS_ARCHIVOS', 'TABLAS') {
        my $textodespl = Dumper $ref->{refvalores}->{$clase};
        if ($textodespl) {
            for my $key (keys %hash) { 
                my $valor = $hash{$key};
                while ($textodespl =~ s/(\W)$key(\W)/$1$valor$2/i) {
                    $ref->{parametrossustituidos}->{$key} = 1;   
                }; 
            };
            my $VAR1;
            $ref->{refvalores}->{$clase} = eval($textodespl);
        };
    };
    comfin('fin sust_num_en_tablas');
    return '';
}#sust_num_en_tablas
# ---------------------------------------------------------------------------
sub revisar_tabla{
  comfin('con revisar_tabla', @_);
  #controla consistencia de los datos para la tabla escrita en el diagrama, 
  # con excepcion de abscisas crecientes!!
  my ($refcirc, $idtabla, @renglones) = @_;
  my (@coment,@reng); my $coderr = '';
  foreach my $renglon (@renglones) { 
      if ($renglon =~ /\s*([^\;]*)\s*(\;.*)/) {
          push @coment, $2;
          $1 ne '' and push @reng, $1;    
      } else {
          push @reng, $renglon;
      };
  };
  push @{$refcirc->{comTABLAS}->{$idtabla}}, @coment  if @coment;
  my $crudo = join ",", @reng;
  $crudo =~ s/\s*\,\s*/\,/g;
  $crudo =~ s/\s+/ /g;
  if ($crudo =~ s/\,\s*$//) {
      avnograv("Tabla que parece incompleta, termina con coma:
        TABLA $idtabla");
      push @{$refcirc->{comTABLAS}->{$idtabla}}
           ,'; La tabla terminaba con coma'; 
  };
  $crudo =~ /\w/ or do{
      avgrav( "No se da: No hay datos suficientes para la tabla 
            $idtabla");
  };
  my @listaatom  = split /[\s\,]/, $crudo; 
  my $hayparen = ($crudo =~ tr/()//);
  #impr_debug(__LINE__." Tabl tabla $idtabla  listaatom ",\@listaatom);
  if ($hayparen) {
      ($coderr,@listaatom) = juntar_por_paren(',',@listaatom);
  };          
  @listaatom % 2 and do{
      avnograv(
   "Tabla con  número impar de elementos; revise puntos y comas;
             se ignora último para poder continuar;
       TABLA $idtabla");
      #esto suele ser consecuencia de comas o puntos incorrectos
      pop @listaatom;
  }; 
  my @buenos; 
  foreach my $atom (@listaatom) {
      my ($tipo,$natom) = tipear($refcirc,uc($atom),0); 
      $tipo ne 'n' and do {#quizas ya marcado antes como error
           parar1(152,$refcirc
                 ,"Tabl $idtabla tiene \"$atom\" que no es numérico" );
      };
      push @buenos, $natom;
  };
  $avisosgrav and parar1(66,$refcirc,"Errores en tabla $idtabla");  
  @listaatom = @buenos;
  comfin('fin revisar_tabla', "   Tabla $idtabla");
  return  \@listaatom;   
}#revisar_tabla
# ---------------------------------------------------------------------------
sub modificadores_tablas_archivos{ # porparar1
  comfin( 'com modificadores_tablas_archivo',@_);
  my $refcirc = $_[0];my ($cosa, $tabla, $archivo);  
  my (%arch,%simbarch,%maxcol,
      %col1,%col2,%fac1,%fac2, %primero,%ultimo,%repeticiones,%ordenfilas);
  # %arch: a cada nombre simbolico le asigna el archivo real
  # %simbarch: a cada identificador de tabla le asigna un archivo simbolico 
  my $noseent = 0;
  my %todos = %{$refcirc->{refvalores}->{TABLAS_ARCHIVOS}}; 
  foreach (keys %todos) {
      my @listadatos = @{$todos{$_}};
      #impr_debug(__LINE__.' Tabl',Dumper \@listadatos);
      @listadatos = juntar_por_signos_y_paren('',@listadatos);
      #impr_debug(__LINE__.' Tabl',Dumper \@listadatos);
      my $idtabla;
      foreach my $renglonori (@listadatos) {
          if ($renglonori =~ /^(\S+)\s+(.+\S)\s*=\s*(.*\S)\s*/) {
              my ($cosa, $tabla, $archivo,$derecha,@cosa,@lista); 
              $cosa = lc($1); my $nombre =  uc($2); $derecha = $3;
	      #impr_debug(__LINE__.' Tabl $cosa, $nombre, $derecha'
              # , [$cosa, $nombre,$derecha]);
              @lista = split(/\s*[,:]\s*/,$derecha);
              #impr_debug(__LINE__.' Tabl @lista',\@lista); 
	      if ($cosa =~ /archivo/) {
                   if (@lista == 1) { 
                       $arch{$nombre} = $lista[0];
                   } else {
                       porparar1(154, $refcirc
                      , "No se entiende la definición de archivo del renglón, 
                 $renglonori
           a la derecha del \"=\" sólo va  el nombre real del archivo");
                       return 154;
                   };
	      } else {
                  my $idtabla;
                  if ($nombre =~  /\s*TABL[AE]\s*(.+)/ 
                    or $nombre =~  /\s*T\s*(.+)/)  {# ya está en mayúsculas 
                      $idtabla = $1; 
                      push @{$refcirc->{textodefiTABLAS}->{$idtabla}}
                        , $renglonori;
	          } else {
                     porparar1(155, $refcirc,
                  "En TABLAS_ARCHIVOS, falta identificación de tabla en comando
                          $renglonori;
                     $nombre no identifica una tabla");
                     return 155;
	          };
                  if ($cosa =~ /^col/i) {
                      if ( @lista == 3) {
		          defined  $refcirc->{objTABLA}->{$idtabla} and 
                          do {$refcirc->{errTABLAS}->{$idtabla} = 'otra def';
                              porparar1(159,$refcirc,
                              "En TABLAS_ARCHIVOS, nueva definición de tabla
                               tabla  $idtabla");
                                return 159;                  
                          };
                          $refcirc->{objTABLA}->{$idtabla} = $_;
                          $lista[1] .= ':' . $lista[2] if defined $lista[2]; 
                          $simbarch{$idtabla} = uc($lista[0]);
                          if ($lista[1] =~ /^\s*(\d+)\s*[:,]\s*(\d+)\s*$/) { 
	                      $col1{$idtabla} = $1; $col2{$idtabla} = $2;
	                  } else {
	                      porparar1(160,$refcirc,
                             "En TABLAS_ARCHIVOS, renglón no correcto:\n"
			     ."           $renglonori;
	                  no está claro cuales columnas usar 
		          de $simbarch{$tabla} para tabla $idtabla" );
                              $refcirc->{errTABLAS}->{$idtabla} = 'columnas';
                              return 160;
                          };
                      } else {
                          porparar1(161,$refcirc,
                        "En TABLAS_ARCHIVOS, no se entiende comando
                            $renglonori
                        luego del \"=\" se espera, por ejemplo, 
                        EXPE, 1:3");
                          return 161;  
                      };     
	          } elsif ($cosa =~ /^fact/ and @lista == 2 ) {#factores
                      $fac1{$idtabla} = $lista[0]; 
                      $fac2{$idtabla} = $lista[1]; 
		      #impr_debug(__LINE__.' Tabl factores',Dumper \@lista);
	          } elsif ($cosa =~ /^rango/) {
                      if (@lista == 2) {#rangox
                          $primero{$idtabla} = $lista[0]; 
                          $ultimo{$idtabla}  = $lista[1];   
                      } else {
                          porparar1(153,$refcirc,
                         "En TABLAS_ARCHIVOS, especificación incorrecta:
      TABLA $idtabla    $renglonori");                   
                          explic( "para indicar un rango, use por ejemplo; 
             rangox tabla $idtabla = 50:1000");
                          $refcirc->{errTABLAS}->{$idtabla} = 'columnas';
                          return 153;                  
                      };   
                  } elsif ($cosa =~ /^rep/ and @lista == 1) {#repeticiones
                      $repeticiones{$idtabla} = $lista[0];
		  } elsif ($cosa =~ /^orden/) {#ordenfilas
                      $ordenfilas{$idtabla} = $lista[0];
                      #$lista[0] puede ser 'invertido', 'ordenado', 'talcual'
                      #'talcual' es el por defecto  
	          } else {
                      porparar1(156,$refcirc
                       , "No se entiende en TABLAS_ARCHIVOS un renglón 
                        $renglonori
                        Utilice  \";\" para indicar comentarios");
                      $noseent++;
                      next;  
	          };# if elsif else $cosa -- segundo
              };#  if  else $cosa  -- primero) 
	  } elsif ($renglonori =~ /(\S+)\s*=\s*(.*\S)\s*/) {
	      my $cosa = $1; 
              $cosa =~ /^(col|fact|rango|rep|orden)/ and do{
                  porparar1(154, $refcirc, 
                   "En TABLAS_ARCHIVOS, no se entiende un renglón
                             $renglonori
                    quizás olvidó identificar la tabla");
                  return 154;
              }; 
          } else { #renglonori
               avnoseent(",  en TABLAS_ARCHIVOS:  $renglonori;
                 utilice   ;   para marcar los comentarios");
	      $noseent++;
              next;
          }; # if ... else $renglonori
      }; # foreach $renglonori
      #impr_debug(__LINE__.' Tabl',Dumper $refcirc->{textodefiTABLAS});
  }; #foreach (keys  
  #impr_debug(__LINE__.' Tabl %arch ',Dumper \%arch);
  #impr_debug(__LINE__.' Tabl %simbarch ',Dumper \%simbarch);
  comfin( 'fin modificadores_tablas_archivos',hashrenglon('', %simbarch));
  return   \%arch,\%simbarch,\%maxcol,
        \%col1,\%col2,\%fac1,\%fac2, \%primero,\%ultimo,\%repeticiones
        ,\%ordenfilas;
} #modificadores_tablas_archivos
# ---------------------------------------------------------------------------
sub depurar_tablas_archivos{ # porparar1
  comfin('com? depurar_tablas_archivos', @_);
  my $refcirc = $_[0]; my ($cosa, $tabla, $archivo, @lista);
  #impr_datos (__LINE__. ' Tabl', ['PARAMETROS'], $refcirc); 
  my ($arch,$simbarch,$maxcol,
        $col1,$col2,$fac1,$fac2, $primero,$ultimo,$repeticiones,$ordenfilas) =
	    modificadores_tablas_archivos($refcirc);
  # si todo fue bien son referencias a hashes con indices la identif. de tabla

  defined $simbarch or return $arch; #sera un codigo de error 
  foreach my $idtabla (sort keys %$simbarch) {
      #impr_debug(__LINE__.' Tabl $idtabla '
      #         ,[$idtabla, $simbarch->{$idtabla}]);
      my $error = '';
      my $archivo = $arch->{$simbarch->{$idtabla}};
      $archivo =~ /^\// or $archivo = $refcirc->{BASEARCH} . $archivo;	 
      open(ARCHIVOTABLA,$archivo) or do{
	 if ($refcirc->{clasearch} eq 'elementos') {
            $refcirc->{archivoTABLAS}->{$idtabla} = $archivo;
            #$refcirc->{modificTABLAS}->{$idtabla} = \@listamodi;
            $hash_tablas_definidas{$idtabla}->
                {$refcirc->{BASEARCH}.$refcirc->{PROPIO}} = 1;
	    return;
	 } else {
            porparar1(140,$refcirc,"No existe el archivo que define la tabla
           $archivo");
           return 140;
	 };
      }; # open
      my $c1 = $col1->{$idtabla};
      my $c2 = $col2->{$idtabla};
      my $cmax = $c2; $cmax = $c1 if $c1 > $c2;
      my ($unoant,$dosant) ;
      my $numfila = -1;my $provi = -1; 
      my (@abscisas,@ordenadas);
      my $ordenf;
      $ordenf = $ordenfilas->{$idtabla} or $ordenf = 'talcual';
      my $mensaje = "para tabla $idtabla, en archivo $archivo
                Si quiere, puede anular todo el renglon del archivo 
                anteponiendo #";
      my %hash;
      while (my $linea = <ARCHIVOTABLA>) {
	  my ($uno,$dos);
          $numfila ++;$provi ++;
          chomp($linea);
	  $linea =~ s/^\s*//;
	  $linea =~ s/\s*$//;
          $linea =~ s/[\#\*].*//;$linea =~ s/^\s*$//;
	  next if $linea eq  '';
          my @listi = split (/\s*[,\s]\s*/,$linea);
	  if ($cmax > @listi) {
              porparar1(153,$refcirc,"No hay suficientes columnas en archivo 
                $archivo	para la tabla $tabla");
              return 153
	  };
          $uno = $listi[$c1-1];
          $dos = $listi[$c2-1];
          my @buenos;
          defined $unoant and defined $dosant 
              and $unoant eq $uno and $dosant eq $dos and next; 
          foreach my $atom ($uno,$dos) {
              my ($tipo,$natom) = tipear($refcirc,uc($atom),0); 
              $tipo ne 'n' and #quizas ya marcado como error
              do { porparar1(152,$refcirc ,"Tabla con valor no numérico:
                  Tabla $idtabla  con  \"$atom\"" );
                  return 152;
              };
              push @buenos, $natom;
          };
	  ($uno,$dos) = @buenos;
          if ($ordenf eq 'talcual') {#por defecto
              defined $unoant and $unoant > $uno  and
              do {porparar1(146,$refcirc,
                  "Abscisas decrecientes en tabla\n     $unoant > $uno
                  $abscisas[-1], $ordenadas[-1]  
                  $linea\n     $mensaje");
                 return 146;
	     };
              push @abscisas, $uno; push @ordenadas, $dos;
              $unoant = $uno; $dosant = $dos
	  } elsif ($ordenf =~ /inv/) {#invertido
              defined $unoant and $unoant < $uno and do{
                  porparar1(146,$refcirc,"$unoant < $uno en los valores 
                  $abscisas[0], $ordenadas[0]\n"  
                  . "                  $linea\n" 
		  . " $mensaje");
                  return 146
	      };
             unshift @abscisas, $uno; unshift @ordenadas, $dos;
             $unoant = $uno; $dosant = $dos
	     } else {#ordenadas
			 $hash{$uno} = $dos;
             };
      }; #while
      close ARCHIVOTABLA;
      $error and next;
      if ($ordenf !~ /ordena/) {
          push @{$refcirc->{absTABLAS}->{$idtabla}}, @abscisas;
          push @{$refcirc->{ordTABLAS}->{$idtabla}}, @ordenadas;;
      } elsif ($ordenf =~ /ordena/) {#ordenadas
	  foreach my $absc ( sort {$a<=>$b} keys %hash) {
              push @{$refcirc->{absTABLAS}->{$idtabla}}, $absc;
              push @{$refcirc->{ordTABLAS}->{$idtabla}}, $hash{$absc};
	  };
      };          
      my $repet;
      $repet = $repeticiones->{$idtabla} or $repet = 1;  
      $repet > 1 and repetir_tabla($refcirc, $idtabla, $repet, $ordenf);
      my ($prix,$ultx);
      $prix = $primero->{$idtabla}; # luego se detecta si esta indefinido
      $ultx =   $ultimo->{$idtabla};
      my ($factor1,$factor2);
      $factor1 = $fac1->{$idtabla} or $factor1 = 1;
      $factor2 = $fac2->{$idtabla} or $factor2 = 1;
      my $coderr = selec_fact_guardar_tabla(  #en depurar_tablas_archivos
                   $refcirc, $idtabla , $factor1, $factor2, $prix, $ultx); 
      $coderr and return $coderr;
      $refcirc->{archivoTABLAS}->{$idtabla} = $archivo;
  }; #tabla  
  #impr_tablas(__LINE__.' Tabl',$refcirc);
  comfin('fin  depurar_tablas_archivos');
  return '';
} #depurar_tablas_archivos
# ---------------------------------------------------------------------------
sub selec_fact_guardar_tabla{
  comfin('com selec_fact_guardar_tabla',@_);
  my ($refcirc,$idtabla,$fact1,$fact2,$prix,$ultx) = @_;
  my @absci = @{$refcirc->{absTABLAS}->{$idtabla}};
  my @orden = @{$refcirc->{ordTABLAS}->{$idtabla}};
  my (@abscisas,@ordenadas);
  my ($tipo1,$valor1) = tipear($refcirc,$fact1,0);

  my ($tipo2,$valor2) = tipear($refcirc,$fact2,0);
  if ($tipo1 eq 'n' and $tipo2 eq 'n') {
      $fact1 = $valor1; $fact2 = $valor2;
  } else {
      porparar1(147,$refcirc,"Factores no numéricos para la tabla
      $idtabla; $fact1 $fact2");
      return 147;
  };
  #impr_debug(__LINE__.'Tabl factores', [$factor1,$factor2]);
  if (defined $prix) {
      my ($unoant, $dosant);my ($ya,$yad) = ('',1);
      for (my $i = 0; $i < @absci; $i ++) {
          my $uno = $absci[$i];
          my $dos = $orden[$i]; 
          if ($ya) {
              push @abscisas, $uno;
              push @ordenadas, $dos;     
	      if ($yad  and $uno > $ultx) {last}; 
          } else {
              if ($uno >= $prix) {
	          $ya = 1;
                  if (defined $unoant) {
                      push @abscisas, $unoant;
                      push @ordenadas, $dosant;
                  }; 
                  push @abscisas, $uno;
                  push @ordenadas, $dos; 
	      };
          }; # $ya
          $unoant = $uno; $dosant = $dos;
      };
  } else {
      @abscisas = @absci; @ordenadas = @orden;
  };
  map ($_ = sprintf("%G",$_ * $fact1), @abscisas) if $fact1 ne 1;
  map ($_ = sprintf("%G",$_ * $fact2), @ordenadas) if $fact2 ne 1;
  $refcirc->{absTABLAS}->{$idtabla} =\@abscisas;
  $refcirc->{ordTABLAS}->{$idtabla} =\@ordenadas;
  $hash_tablas_definidas{$idtabla}->
     {$refcirc->{BASEARCH}.$refcirc->{PROPIO}} = 1;
  $refcirc->{priTABLAS}->{$idtabla} = [0];
  $refcirc->{ultTABLAS}->{$idtabla} = [@abscisas -1];
  comfin('fin selec_fact_guardar_tabla');
  return '';
}# selec_fact_guardar_tabla
# ---------------------------------------------------------------------------
sub depurar_tablas{ # porparar1
  comfin('com? depurar_tablas',@_);
  # interpreta tablas dadas en el diagrama
  my $refcirc = $_[0];
  my $reftablas = $refcirc->{refvalores}->{TABLAS};
  foreach my $idtabla (keys %{$reftablas}) {
      my ($factor1, $factor2, $repet, $prix, $ultx);
      $refcirc->{errTABLAS}->{$idtabla} =''; 
      my @crudas = @{$reftablas->{$idtabla}};
      #impr_debug(__LINE__.' Tabl @crudas', Dumper \@crudas);
      @crudas = juntar_por_signosf_y_paren('',@crudas); 
      #impr_debug(__LINE__.' Tabl @crudas', Dumper \@crudas);
      @crudas or  do {
          $refcirc->{errTABLAS}->{$idtabla} = "Sin datos";
          parar1(141,$refcirc,"Tabla sin datos:\n  TABLA $idtabla");
          return 141;
      };   
      my @renglonesmod;
      my $renglon = $crudas[0];
      while ($renglon =~ /^\s*\;|fac|rep|ran/i and @crudas > 1) {
          my $completo = $renglon;
	  push @renglonesmod, $completo;
          shift @crudas;
          $renglon = $crudas[0];
      };  
      #impr_debug(__LINE__.' Tabl @crudas', Dumper \@crudas);
      #impr_debug(__LINE__.' Tabl @renglonesmod', Dumper \@renglonesmod);
      @crudas >1 or do{
	  parar1(145,$refcirc,"Tabla con datos insuficientes:\n    $idtabla");
          return 145;
      };
      $refcirc->{textodefiTABLAS}->{$idtabla} = \@renglonesmod;
      if (@renglonesmod) {
          ($factor1, $factor2,$repet, $prix, $ultx) =
	      modificadores_tabla($refcirc, $idtabla, @renglonesmod);
          defined $factor2 or return $factor1;#sera un codigo de error 
      } else {
          $factor1 = $factor2 = $repet = 1;
      };
      my $listaatom = revisar_tabla($refcirc, $idtabla, @crudas);
      my @lis = @$listaatom;
      my $ant = $lis[0];
      while (@lis) {
	  my $act = shift @lis;
	  $act >= $ant   or   do{
              porparar1(146,$refcirc
                    , "Tabla con  abscisas que  disminuyen:
              TABLA $idtabla             $ant > $act ");
              return 146; 
          };
          $ant = $act; 
          push @{$refcirc->{absTABLAS}->{$idtabla}}, $act; 
	  my $ord;# = shift @lis;
          push @{$refcirc->{ordTABLAS}->{$idtabla}},  shift(@lis);
      }; #while
      $repet > 1 and repetir_tabla($refcirc, $idtabla, $repet);
      my $coderr = selec_fact_guardar_tabla(  # en  depurar_tablas
                     $refcirc, $idtabla , $factor1, $factor2, $prix, $ultx); 
      $coderr and return $coderr;
  };
  comfin('fin depurar_tablas');
  return '';
}# depurar_tablas
# ---------------------------------------------------------------------------
sub modificadores_tabla{ # porparar1
  my ($refcirc, $idtabla, @renglones) = @_;
  my ($fac1, $fac2, $repet, $prix, $ultx, $ordenfilas); 
  my $conpyc = 
        "\n       (los ';' comienzan comentarios que pasaríann al sceptre)";
  #impr_debug(__LINE__.' Tabl @renglones',Dumper \@renglones);
  foreach my $renglon (@renglones) {
      my $renglonori = $renglon;
      if ($renglon =~ s/\;(.*)//) {
         push @{$refcirc->{comTABLAS}->{$idtabla}}, $1  if $1;
         $renglon or next;
      };     
      if ($renglon =~ /^\s*fac/i and not defined $fac1) { #factor, factores
	  my @lisf = split /\s*\,\s*/, $renglon;
          foreach (@lisf) {
	      $_ =~ s/^fac\w*\s*=\s*//i;
          };         
          @lisf == 2 or do {
              my $agre = ''; $agre = $conpyc if $renglonori =~ /\;/;
              porparar1(143,$refcirc
                 ,"Hay que dar valores para los dos factores;
                 no sirve \"$renglonori\" para tabla $idtabla$conpyc"); 
                  $refcirc->{errTABLAS}->{$idtabla} = 'factores';
                  return 143;
          };
          foreach my $fac (@lisf) {
              (my $tipo,$fac) = tipear($refcirc,$fac,0); 
              $tipo ne 'n' and do{
                  porparar1(144, $refcirc
      ,"Tabla definida en el diagrama  con expresión para factores incorrecta:
      TABLA $idtabla    $renglon");                   
                  explic( "para la tabla $idtabla podría indicar por ejemplo;
                         factor = 3600, factor = 1 o 
                         factores = 3600,1");
                  $refcirc->{errTABLAS}->{$idtabla} = 'factores';
                  return 144;                  
              };
          };
          ($fac1,$fac2) = @lisf if @lisf;
      } elsif ($renglon =~ /^\s*rep[\D]+(\d+)/i and not defined $repet) {
          $repet = $1; #repeticiones
      } elsif ($renglon =~/^\s*ran.*=\s*(\S+)\s*:\s*(\S*)\s*$/i and 
               not defined $prix) { #rangox
          $prix = $1; $ultx= $2; 
      } elsif (defined $fac1 and defined $repet and defined $prix) {
          my $renglones = join "\n   ", @renglones;
          porparar1(150, $refcirc
           ,"Hay modificadores redefinidos para la tabla $idtabla
               @renglones");
          $refcirc->{errTABLAS}->{$idtabla} = 'redefinidos';
          return 150;
     } else {
	 porparar1(151,$refcirc
         ,"En TABLAS no se entiende renglón para tabla
        $renglon para la tabla $idtabla");
         $refcirc->{errTABLAS}->{$idtabla} = 'no se entiende';
         return 151;
     };
  };
  not defined $fac1  and do{$fac1 = 1; $fac2 = 1};
  not defined $repet and $repet = 1;  
  return $fac1, $fac2, $repet, $prix, $ultx;
}# modificadores_tabla
# ---------------------------------------------------------------------------
sub repetir_tabla{
  my ($refcirc, $idtabla, $repet) = @_;
  my @abscisas = @{$refcirc->{absTABLAS}->{$idtabla}};
  my @ordenadas = @{$refcirc->{ordTABLAS}->{$idtabla}};
  for (my $i = 1; $i < $repet; $i ++) {
      my $delta = $abscisas[-1] * $i; my @abscisasdelta;
     map (push(@abscisasdelta,$_ + $delta), @abscisas);
      push @{$refcirc->{absTABLAS}->{$idtabla}},@abscisasdelta;
      push @{$refcirc->{ordTABLAS}->{$idtabla}},@ordenadas;
  };
}
# ---------------------------------------------------------------------------
sub partir_tablas{
  comfin('com.  partir_tablas', @_);
  my ($ref,$cual,@quiebres) = @_;
  #imprhash(__LINE__.' Tabl $ref ', %$ref);
  my $cualmin = $quiebres[0]; my $cualmax = $quiebres[-1];
  for(my $j = 0; $j < @quiebres -1; $j ++) {
      $quiebres[$j]<$quiebres[$j+1] or 
        parar1(222,$ref,"Los tiempos de interrupción del cálculo deben crecer;
          pero en @quiebres 
            $quiebres[$j] no es menor que $quiebres[$j+1]");   
 };
  my @amirar = (values %{$ref->{DATOS}},values %{$ref->{PARAMETROS}});
  my $amirar = join ';', @amirar;
  my @listatablas = ($amirar =~ /\WT(\w+)\($cual\)/g);
  push @listatablas,  ($amirar =~ /\WXTABLE\(T(\w+)\,$cual\)/g);
  @listatablas = union_conjunto @listatablas;
  my %hashtablas;
  map ( $hashtablas{$_} = 1, @listatablas);
  my $difmax = 1; #cualquier tabla debe tener al menos dos puntos
  #impr_debug(__LINE__.' Tabl @listatablas',\@listatablas);
  # en lo posible se pide que la ultima fila sea mayor por si al calcular
  # se va un poquito del rango calculado
  foreach my $idtabla (@listatablas) {
      my $difmax = 1; #cualquier tabla debe tener al menos dos puntos
      my $reft = $ref->{defiTABLAS}->{$idtabla};
      next unless defined $reft;
      #que el rango esta cubiero lo controla &controlar_tiempos
      my $numfilas = @{$reft->{absTABLAS}->{$idtabla}}; 
      my @abscisas = @{$reft->{absTABLAS}->{$idtabla}};
      my @ordenadas = @{$reft->{ordTABLAS}->{$idtabla}}; 
      my $iant=0; my $i = 0;
      $reft->{priTABLAS}->{$idtabla} = [];
      $reft->{ultTABLAS}->{$idtabla} = [];
      my $ifila = 0;my ($menorigual,$mayorigual)= (0,-1); my (@ma,@me);
      for (my $j = 0; $j < @quiebres; $j++) {
          $ifila = $menorigual;
          $ifila = $me[$j-1] if $j >0; 
          $menorigual = $ifila;$mayorigual = -1;
          my $quieb = $quiebres[$j];
          while ($mayorigual == -1  and $ifila < $numfilas) { 
	      my $absc = $abscisas[$ifila];
	      #$absc = $abscisas[$ifila];
	      if ($absc <= $quieb) {
	          $menorigual = $ifila;
              } elsif ($absc > $quieb) {
                  $mayorigual = $ifila;
              };
              $ifila ++;
          }; #while
          $mayorigual == -1 and $abscisas[$ifila-1] == $quieb
               and $mayorigual = $ifila-1;  
         $me[$j] = $menorigual; $ma[$j] = $mayorigual;
      };#foreach $j
      #impr_debug(__LINE__.' Tabl $idtabla,@me @ma'
      #              , [$idtabla,';',@me,'---',@ma]);
      for (my $j= 0; $j <@quiebres-1;$j++) {
          my $menorigual = $me[$j]; my $mayorigual = $ma[$j+1];
          if ($menorigual == $mayorigual) {
              $menorigual > 0 and $menorigual --;
              $mayorigual < $numfilas - 1 and $mayorigual ++;
          };
          my $dif = $mayorigual-$menorigual;
          $difmax = $dif if $dif > $difmax; 
          push @{$reft->{priTABLAS}->{$idtabla}}, $menorigual;   
          push @{$reft->{ultTABLAS}->{$idtabla}}, $mayorigual;  
          push @{$reft->{difTABLAS}->{$idtabla}}, $dif;
          $reft->{difmaxTABLAS}->{$idtabla} = $difmax;
      };  
      my $j = -1;
      foreach my $dif (@{$reft->{difTABLAS}->{$idtabla}}) {
          $j ++;        
          next if $dif == $reft->{difmaxTABLAS}->{$idtabla};
          # en todos los rerun las tablas deben tener igual largo
          while ($dif<$difmax and $reft->{priTABLAS}->{$idtabla}->[$j]>0) {
              $dif ++; $reft->{priTABLAS}->{$idtabla}->[$j] --;
          };
          while ($dif<$difmax  and $reft->{ultTABLAS}->{$idtabla}->[$j]
                            < @{$reft->{absTABLAS}->{$idtabla}}) {
              $dif ++; $reft->{ultTABLAS}->{$idtabla}->[$j] ++;      
          };   
      };
      #seria posible no reiterar las tablas coincidentes en todos los rerun;
      #el archivo para sceptre seria mas chico; pero no necesita mas memoria
      # para ejecutarse
  }; #foreach $idtabla
  comfin('fin  partir_tablas');
} #partir_tablas
# ---------------------------------------------------------------------------
sub registrar_funciones{
  #llena el %hash_funciones_definidas para las funciones propias
  # tambien pasan por aqui los archivo ele aunque no sean el principal
  # (no se nota por $debug1)
  comfin('com registrar_funciones',@_);
  my $refc = $_[0];
  impr_debug(__LINE__.' Tabl %hash_funciones_definidas '
             ,Dumper \%hash_funciones_definidas);
  my %hash_nombrepuro;
  my $op = '[\+\-\*\/\(\)]';
  foreach my $nombre (keys %{$refc->{FUNCIONES}}) {
      next if $refc->{TIPFUNCIONES}->{$nombre} eq ';';
      #impr_debug(__LINE__.' Tabl $nombre ',$nombre);
      my ($nombrefun,$stringarg)
              = ($nombre =~ /^(\w+)\s*\(([\w\,\s]+)\)\s*$/);
      defined $nombrefun or  
          do{porparar1(180,$refc,"Falta identificador para función;
              no se puede extraer de $nombre");
             return 180;
          };
      $nombrefun  =~ s/^EQUATION/Q/i;
      $nombrefun =~ /^Q/i  or 
          do{porparar1(181,$refc
           ,"Para Sceptre el identificador de una función debe comenzar
             con Q o con EQUATION;  $nombre no lo cumple");
             delete $hash_funciones_definidas{$nombre};
             return 181;  
          };
      $stringarg =~ s/\s+//g; my $nombren = "$nombrefun($stringarg)";
      $nombre ne $nombren and 
          mover_datos($refc, 'FUNCIONES', $nombre
               , $refc, 'FUNCIONES', $nombren,__LINE__.' Tabl reg.func');
      push @{$hash_nombrepuro{$nombrefun}}, $nombren;
  };
  #impr_debug(__LINE__.' Tabl %hash_nombrepuro ',Dumper \%hash_nombrepuro);
  foreach my $nombrefun (keys %hash_nombrepuro) {
      my @nombres = @{$hash_nombrepuro{$nombrefun}};
      #impr_debug(__LINE__.' Tabl @nombres ',Dumper \@nombres);
      if (@nombres >1) {
         avnoseent("para qué hay más de una definición para la función
               $nombrefun
           ". join('   ',@nombres));
         map (borrar_datos($refc,'FUNCIONES',$_,'',__LINE__.' reg.func ')
	   , @nombres );
      } else {
          my $archori = $refc->{archivo};
          defined $archori or $archori = $refc->{refcirc}->{archivo};
          $hash_funciones_definidas{$nombres[0]}->{$archori} = 1;
      };
  };
  my $coderr = '';
  $coderr = controlar_def_funciones_propias($refc) #en registrar_funciones
     if scalar %{$refc->{FUNCIONES}};  
  impr_debug(__LINE__.' Tabl %hash_funciones_definidas '
             ,Dumper \%hash_funciones_definidas);
  impr_datos(__LINE__.' Tabl DOLO',['FUNCIONES'],$refc); 
  comfin('fin registrar_funciones',@_);
  return $coderr;
}#registrar_funciones
# ---------------------------------------------------------------------------
sub tratar_funciones{
  #incorpora al ref del circuito las funciones definidas en otros archivos
  #que no chocan con las propias cuidando por repetidas
  comfin('com tratar_funciones',@_);
  my $refc = $_[0];
  my $op = '[\+\-\*\/\(\)]';
  impr_debug(__LINE__.' Tabl USAELE', Dumper $refc->{USAELE});
  impr_debug(__LINE__.' Tabl USAMOD', Dumper $refc->{USAMOD});
  impr_debug(__LINE__.' Tabl %hash_funciones_definidas'
            , Dumper \%hash_funciones_definidas);
  foreach my $nombre (keys %hash_funciones_definidas) {
      my @defis = sort keys %{$hash_funciones_definidas{$nombre}};
      if (defined $hash_funciones_definidas{$nombre}->{$CORTOA}) {
          #impr_debug(__LINE__
          #.' $hash_funciones_definidas{$nombre}->{$CORTOA} '
          #, Dumper $hash_funciones_definidas{$nombre}->{$CORTOA}); 
          $refc->{defiFUNCIONES}->{$nombre} = $refc;
      } else {
         my @defismejor = grep (do {defined $refc->{USAMOD}->{$_} }, @defis);
         push @defismejor, grep (do {defined $refc->{USAELE}->{$_} }, @defis); 
         @defismejor  or @defismejor = @defis;
         impr_debug(__LINE__.' Tabl DOLO',[@defismejor]); 
         if (@defismejor > 1) {
             avnograv("Hay varias definiciones para la función 
             $nombre;   en  @defismejor; usaremos la de $defismejor[0]");
         }; 
	 $refc->{defiFUNCIONES}->{$nombre} = $reffi{$defismejor[0]};
	 impr_datos(__LINE__.' Tabl DOLO',['FUNCIONES'],$reffi{$defismejor[0]});
      };
      impr_debug(__LINE__.' Tabl defiFUNCIONES',[keys %{$refc->{defiFUNCIONES}}]);
      foreach my $nombre (keys %{$refc->{defiFUNCIONES}}) {
          my $nombrefun = $nombre;
          $nombrefun =~ s/\(.+\)$//;
          my $ref = $refc->{defiFUNCIONES}->{$nombre};
	  impr_datos(__LINE__.' Tabl DOLO',['FUNCIONES'],$ref);
	  impr_debug(__LINE__.' Tabl DOLO',$ref->{TIPFUNCIONES});
          $refc->{TIPFUNCIONES}->{$nombre} 
              = $ref->{TIPFUNCIONES}->{$nombre}; 
          $refc->{FUNCIONES}->{$nombre} 
              = $ref->{FUNCIONES}->{$nombre}; 
          $refc->{TIPARGFUNCIONES}->{$nombre} 
              = $ref->{TIPARGFUNCIONES}->{$nombre}; 
          @{$refc->{listaargFUNCIONES}->{$nombrefun}} 
              = @{$ref->{listaargFUNCIONES}->{$nombrefun}}; 
          $refc->{definicionFUNCIONES}->{$nombrefun}
	      =  $ref->{definicionFUNCIONES}->{$nombrefun};
          $refc->{archivoFUNCIONES}->{$nombrefun} = $ref->{archivo}
               unless $refc eq $ref; 
      };
  };
  impr_datos(__LINE__.' Tabl DOLO',['FUNCIONES'],$refc);
  impr_debug(__LINE__.' Tabl $refc->{definicionFUNCIONES} '
            , Dumper $refc->{definicionFUNCIONES}); 
  impr_debug(__LINE__.' Tabl $refc->{listaargFUNCIONES} '
            , Dumper $refc->{listaargFUNCIONES}); 
  controlar_def_funciones_todas($refc); 
  comfin('fin tratar_funciones');
  return '';
}#tratar_funciones
# ---------------------------------------------------------------------------
sub analizar_tablas{
  comfin('com analizar_tablas',@_);
  my $refc = $_[0];
  #impr_debug(__LINE__.' Tabl analizar_tablas %hash_tablas_definidas'
  #	    , Dumper \%hash_tablas_definidas);
  foreach my $idtabla (keys %hash_tablas_definidas) {
      my @defis = sort keys %{$hash_tablas_definidas{$idtabla}};
      #impr_debug(__LINE__.' Tabl analizar_tablas $idtabla @defis'
      #   , [$idtabla,@defis]);
      if ($hash_tablas_definidas{$idtabla}->{$refc->{CORTO}}) {
          $refc->{defiTABLAS}->{$idtabla} = $refc;
      } else {
          my @defismejor = grep (do {defined $refc->{USAMOD}->{$_} }, @defis);
          push @defismejor, grep (do {defined $refc->{USAELE}->{$_} }, @defis);
          @defismejor  or @defismejor = @defis;
          if (@defismejor >1) {
              avnograv("Hay definiciones para la tabla
                $idtabla en  @defismejor; usaremos la de $defismejor[0]");
          };
	  $refc->{defiTABLAS}->{$idtabla} = $reffi{$defismejor[0]};
      };
      #impr_tablas(__LINE__.' Tabl', $refc);
  };
  #impr_debug(__LINE__.' Tabl analizar_tablas defiTABLAS'
  #       , Dumper $refc->{defiTABLAS});
  comfin('fin analizar_tablas');
}#analizar_tablas
# ---------------------------------------------------------------------------
sub rec_apl_tablas{
  comfin('com? rec_apl_tablas',@_);
  my $ref = $_[0]; my $coderr;
  if (defined $ref->{PARAMETROS} and 
	scalar %{$ref->{PARAMETROS}}) {
      $coderr = sust_num_en_tablas($ref);
      $coderr and return $coderr;
  };
  if (defined $ref->{refvalores}->{TABLAS}) {
      $coderr = depurar_tablas($ref);  #para TABLAS 
      $coderr and return $coderr;
  };
  if (defined $ref->{refvalores}->{TABLAS_ARCHIVOS}) {
      $coderr = depurar_tablas_archivos($ref); #para TABLAS_ARCHIVOS
      $coderr and return $coderr;
  }; 
  if (defined $ref->{PARAMETROS}) {
      my @lista = grep(do{$ref->{TIPPARAMETROS}->{$_} eq 't' or
                          $ref->{TIPARGPARAMETROS}->{$_} eq 't'}
                       ,keys %{$ref->{PARAMETROS}});
      evaluar_tabla_n($ref,'PARAMETROS',@lista);
  }; 
  if (defined $ref->{INICIALES}) {
      evaluar_tabla_n($ref,'INICIALES',keys %{$ref->{INICIALES}});
  }; 
  comfin('fin rec_apl_tablas');
  return '';
}
#----------------------------------------------------------------------------
sub fun_par_tab_var{
  comfin('com fun_par_tab_var',@_);
  my ($expresion, $ref,$aignorar) = @_;
  #devuelve referencias a hashes para fun, par,tab, var, funx, arg 
  # hashes de las funciones, parametros, tablas, variables, funciones
  # que comienzan con x que aparecen en expresion, y cantidad de argumentos
  # de todas las funciones
  # funciones, variables, listalis o listaresu, prohibidas
  # variables 'e' o 'E' prohibidas
  # tampoco pueden comenzar con digito 
  # y las funciones no empiezan con X
  #      SI pueden empezar con X; de hecho las XTABLE ....
  # los parametros deben estar definidos como tales; de otro modo 
  # se clasifican como variables
  #nodos y elementos se clasifican como variables? 
  my (%param_incorr,%noderivada);
  my %prohibidas = ('LISTALIS' => 1, 'LISTARESU' => 1,
                    'e' => 1, 'E' => 1); # no se contabilizaran; 
      #números tampoco
  $expresion =";$expresion;"; 
  #impr_debug(__LINE__.' Tabl $expresion',$expresion);
  #impr_datos(__LINE__. ' Tabl fun_par_tab', ['DATOS','PARAMETROS'], $ref);
  # las "funciones" listalis se distinguen un poco por su primer argumento; 
  # pero aun asi pueden tener igual primer argumento y diferente numero de
  # argumentos: de todos modos el primer "argumento puede ser ...
  $expresion =~ s/(\W)listalis\((\w+)\,/$1listalis_$2\(/ig;
  my @listamezcla = $expresion =~ /([\w\.]+)/g; #lista de palabras 
  my @listasepa = split /[\w\.]+/, $expresion; #lista de separadores
  #impr_debug(__LINE__.' Tabl palabras',\@listamezcla);
  #impr_debug(__LINE__.' Tabl separadores',\@listasepa);
  if (@listamezcla + 1 != @listasepa) {
           error_progr($ref,"No se esperaba una expresión así
                  $expresion
            ". __LINE__.' Tabl')};
  my ($reffun, $refpar, $reftab, $refvar, $reffunx,$refarg,$refnodo) 
       = ({},{},{},{},{},{},{}); 
  #impr_debug(__LINE__.' Tabl $aignorar',$aignorar);
  for (my $i = 0; $i < @listamezcla; $i++) {
      my $palabra = uc($listamezcla[$i]);
      next if $prohibidas{$palabra}  or $palabra =~ /^[\d\.]/
            or $aignorar->{$palabra} or $acep_fun{lc($palabra)};
      if ($listasepa[$i+1] =~ /^\s*\(/) {
          #corresponde a funcion de algun tipo
	  my $abre = 1; my $j = $i+2; my $comas = 0;
          while ($j < @listasepa and $abre >0) {
              my $signo = $listasepa[$j];
              my @signos = split '',$signo; my $k = 0;
              while ($k < @signos) {
	          $_ = $signos[$k];
                  if ( /\s*\)/) {$abre --
                  } elsif  (/\s*\(/) {$abre ++        
                  } elsif (/\,/ and $abre == 1) {$comas ++
                  };$k++;
	      }; $j++;
          };
          if ($abre>0) {
              avgrav("abre $abre i $i j $j Expresion mal apareada
                $expresion ")
          }; 
          push @{$refarg->{$palabra}}, $comas +1;
          if ($palabra =~ /^X/) {
              $reffunx->{$palabra}++; 
          } elsif ($palabra =~ /^T/) {
              $reftab->{$palabra}++;
          } elsif (not defined $acep_fun{$palabra}) {
              $reffun->{$palabra}++;
          };
      } elsif (defined $ref->{cualobjtextonodo}->{$palabra}) { 
          $refnodo->{$palabra} ++;
      } elsif ($palabra =~ /^P/) {
           if (defined $ref->{PARAMETROS}->{$palabra}) {
              $refpar->{$palabra}++;
               if (defined $ref->{PARAMETROS}->{"D$palabra"}) {
                   $refpar->{$palabra}++;
                   $refpar->{"D$palabra"} = 2;
                    #solo importa que sea mayor que 1
               };
           } elsif (defined $ref->{PARAMETROS}->{"D$palabra"}) {
               $refpar->{$palabra}++;
               $refpar->{"D$palabra"} = 2;
           } else {
               $param_incorr{$palabra} = 1;
           };
   
      } elsif ($palabra =~ /^D(.+)/ 
	       and defined $ref->{PARAMETROS}->{$palabra}) {
           $noderivada{$palabra} = 1;   
      } elsif ($aignorar->{$palabra}) {
      } else {
	  $refvar->{$palabra}++; 
          #se controla despues que realmente sea variable para sceptre
      };   
  }; #listamezcla
  #impr_debug(__LINE__.' Tabl %param_incorr ', Dumper \%param_incorr);
  if (scalar %param_incorr) {
      my %defini = (%{$ref->{DATOS}},%{$ref->{PARAMETROS}});
      my @usan;
      foreach my $noesp (keys %param_incorr) {
          push (@usan, grep(";$defini{$_};" =~ /\W$noesp\W/
			    , keys %defini));
      };
      my $donde = join (' ', keys %param_incorr) . " usado(s) por @usan";
      porparar1(190,$ref,
        "Uso incorrecto de posible(s)  parámetro(s) (definición?)
        "  . $donde);
       return 190; 
  };
  if (scalar %noderivada) {
      my $donde = join ' ', keys %noderivada;
      porparar1(191,$ref,"Sceptre no calcula derivadas: 
         " . $donde);
      return 191; 
  };
  foreach my $key (keys %$refarg) {
      my @lista = union_conjunto(@{$refarg->{$key}});
      $refarg->{$key} = \@lista;
  };
  my @cosas = keys %{$ref->{no_formales}};
  foreach my $cosa (@cosas) {
      if ($cosa =~ /^P/) {
          $refpar->{$cosa}++
      } else {
          $refvar->{$cosa}++
      };
  };
  #impr_debug(__LINE__.' Tabl reffun ', $reffun) if scalar %$reffun;  
  #impr_debug(__LINE__.' Tabl refpar ', $refpar) if scalar %$refpar;  
  #impr_debug(__LINE__.' Tabl reftab ', $reftab) if scalar %$reftab;  
  #impr_debug(__LINE__.' Tabl refvar ', $refvar) if scalar %$refvar;  
  #impr_debug(__LINE__.' Tabl reffunx ',$reffunx) if scalar %$reffunx;  
  #impr_debug(__LINE__.' Tabl refarg ', Dumper $refarg) if scalar %$refarg;  
  comfin('fin fun_par_tab_var');
  return '',$reffun, $refpar, $reftab, $refvar, $reffunx, $refarg,$refnodo;
}# fun_par_tab_var 
#----------------------------------------------------------------------------
sub usados{#pos. parada
  comfin('com usados',@_); 
  # devuelve refer. a hashes de fun, par, tab y var usados y ref a hash de
  # parametros no definidos
  my ($porquienes,$ref,$aignorar) = @_;
  my $lisvalues = '';
  foreach my $quien (@$porquienes) {
      next unless defined $ref->{$quien};
      my @listavalues = values %{$ref->{$quien}};
      @listavalues = grep ($_ !~ /^\;/,@listavalues);
      $lisvalues .= ';' . join(';' ,@listavalues); 
  };
  $lisvalues .= ";"; 
  my ($coderr,$reffun, $refpar, $reftab, $refvar, $reffunx,$refarg,$refnodo) =
      fun_par_tab_var($lisvalues, $ref,$aignorar);# en usados 
  $coderr and porparar1($coderr,$ref);
  #impr_datos(__LINE__.' Tabl',['DATOS','PARAMETROS'],$ref); 
  #impr_debug(__LINE__.' Tabl $reff por USAVAR ', Dumper $refvar);  
  my @lisDP = grep(do{defined $ref->{TIPPARAMETROS}->{$_}
                      and $ref->{TIPPARAMETROS}->{$_} ne ','},keys %$refpar);
  @lisDP = grep (do{/^DP/ and $refpar->{$_} >1},@lisDP);
  foreach my $funcion (keys %$refarg) {
      next if $funcion eq 'QPRODUCTO' or $funcion eq 'QSUMA';
      my @listacuantos = union_conjunto(@{$refarg->{$funcion}});
      scalar @listacuantos == 1 or do{
          porparar1(192,$ref,"$funcion usada con números de argumentos:
                    @listacuantos" ); return 192; 
      }; 
      ($funcion =~ /^T/ and $listacuantos[0]!= 1) and do{
         porparar1(193,$ref,"Tabla $funcion usada con más de 1 argumento");
         return 193;
      };  
  };
  comfin('fin usados');
  return $reffun, $refpar, $reftab, $refvar, $reffunx, $refnodo;
}#usados
#---------------------------------------------------------------------------
sub resumir_fun_par_tab_var_funx{# calc. {USAPAR},etc; pos. parada por usados
  comfin('com resumir_fun_par_tab_var',@_);
  my ($ref,$circmod) = @_;
  #impr_datos(__LINE__. ' Tabl', ['CONTROLES'], $ref);
  my ($reff,$refp,$reft,$refv,$refx,$refnodo) 
      =  usados(['DATOS','PARAMETROS','RESULTADOS'],$ref,{'LISTARESU' =>1});
    #en resumir_fun_par ...
  not defined $refp  and do{
     parar1($reff,$ref); #$reff es el código de error
  };
  $ref->{USAFUN} = $reff; 
  $ref->{USAPAR} = $refp; 
  $ref->{USATAB} = $reft; 
  $ref->{USAVAR} = $refv; 
  $ref->{USAFUNX} = $refx; 
  $ref->{USANODO} = $refnodo;
  #impr_debug(__LINE__.' Tabl USAFUN', Dumper $ref->{USAFUN});
  #impr_debug(__LINE__.' Tabl USAPAR', Dumper $ref->{USAPAR});
  my @terminate = grep (/^TERMINATE/
                 ,@{$ref->{listaCONTROLES}}); 
  my @listita; my $relacion = '\.(LT|GT|EQ|NE|LE|GE)\.';
  #impr_debug(__LINE__.' Tabl \@listita', \@listita);
  foreach (@terminate) {
      if (/^TERMINATE\s*IF\s*\(\s*(.+)$relacion(.+)\s*\)/) {
          push @listita, $1,$3;
      };
  };
  @listita = grep (/^P/i,@listita);
  #impr_debug(__LINE__.' Tabl \@listita', \@listita);
  
  map ($ref->{USAPAR}->{$_}++,@listita);
  comfin('fin resumir_fun_par_tab_var');
  return '';  
}#  
1
