package Simusol::Ampliaciones;
use Simusol::GlobalesSimusol;
use Simusol::Controles;
use Simusol::Ayudas;
use Simusol::Algebraico;
use Simusol::Tablasfuncq;
use Simusol::Termicos;
use Simusol::TraAbrev;

use warnings;
use strict;
use Data::Dumper;
$Data::Dumper::Indent = 1; 
BEGIN {
     use Exporter ();
     our ($VERSION,@ISA,@EXPORT,@EXPORT_OK,%EXPORT_TAGS);
     @ISA=qw(Exporter);
     @EXPORT=qw(&agregar_objeto
                &asignar_mod &cajear
                &desplegar_ele &desplegar_mod
 		&crear_objeto &replicar_objeto &completar_nodos
                &llenar_rama &llenar_conect
                &interpretar_MODELOS_ARCHIVOS
		&marcar_nodos
        );  
};
END();
#------------------------------------------------------------------------------
sub agregar_objeto{
  comfin('comm agregar_objeto',@_);
  my ($reflay, $refgraf, $obj, $cod, $texto, $codvalor
   , $numplantilla, $numshape, $lay, $lugar,$numfile) = @_;
  $obj == scalar @$codlista or
     error_progr($reflay,__LINE__.' Ampl error en agregar_objetos');
  my $pcs = $numplantilla . 'c' . $numshape;
  if ($cod eq 'O') {
      push @{$reflay->{cualobjpcs}->{$pcs}},$obj;
  } else {
      push @{$refgraf->{lisobjnoO}},$obj;
  };
#  push @{$reflay->{lisobjtodos}},$obj;
  if ($cod ne 'O') {
      if ($texto =~ /^\s*(\S+)\s+\S/) {
          impr_debug(__LINE__.' Ampl @_',\@_);
          mensajear( "No se aceptan espacios intermedios; "
           . "se cambia la identificacion $texto por $1");
          $texto = $1;
      };
  };
  my $numobj = "#numobj$obj";#para la numeracion de los cuadros 
  if ($cod =~ /$codramas/) {
      push @{$refgraf->{lisramascrudas}},$obj;#a $reflay llegaran ya procesados
      $texto = $obj;
      $refgraf->{hashclasegr}->{ramas} = 1;
      $refall->{hashclasegr}->{ramas} = 1;
      impr_debug(__LINE__.' Ampl DDDDDD',Dumper $refall->{hashclasegr});  
  } elsif ($cod =~ /$codelemTs/) {
      push @{$refgraf->{lisobjelemTs}},$obj;
      $refgraf->{tieneplantilla}->{$numplantilla} = 1;
      if ($cod eq 'T') {
         push @{$refgraf->{lisobjTs}},$obj;
         $refgraf->{tienepcsT}->{$pcs} =1; 
         $refgraf->{hashclasegr}->{iconosT} = 1;
         $refall->{hashclasegr}->{iconosT} = 1;
      } else {
          push @{$refgraf->{lisobjelems}},$obj;
	  $refgraf->{tienepcs}->{$pcs} = 1;
	  $refgraf->{hashclasegr}->{iconos} = 1;
          $refall->{hashclasegr}->{iconos} = 1;
       };
  } elsif ($cod =~ /$codnodos/ ) {
      push @{$refgraf->{lisobjnodos}},$obj;
      $refgraf->{hashclasegr}->{iconos} = 1;
      $refall->{hashclasegr}->{iconos} = 1;
  } elsif ($cod eq 'O') {
      push @{$reflay->{lisobjO}},$numobj;
      push @{$refall->{lisobjO}},$numobj;
  };
  cargar_listas($obj, $cod, $texto, $codvalor, $numplantilla, $numshape
		 , $lay, $lugar,$numfile);
  $cod =~ /^[cejlr]$/ and $cod = uc($cod) ;
  # no cambia el $cod guardado en $codlista
  if ($cod ne 'O') { 
      push @{$refgraf->{cualobjnoigno}->{$cod.$texto}}, $obj;
      push @{$refall->{cualobjnoigno}->{$cod.$texto}}, $obj;
  };
  # {cualobjnoigno} se usa para asegurar que al crear objetos 
     # no se elijan nombres repetidos
  comfin('finm agregar_objeto'
   ,$lugar,$cod,$codvalor,$texto,$lay,$numplantilla,$numshape); 
  return;
}#agregar_objeto
# ---------------------------------------------------------------------------
sub cargar_listas{
  comfin('comm cargar_listas',@_);
  # se usa en agregar objetos y al cambiar una rama en resistencia nula
  # en el ultimo caso vienen indefinidas $lay y $lugar
  my ($obj, $cod, $texto, $codvalor, $plantilla, $shape
      , $lay, $lugar,$numfile) = @_;
  $codlista->[$obj] = $cod;
  $textolista->[$obj] = $texto;
  $codvalorlista->[$obj] = $codvalor;
  $plantillalista->[$obj] = $plantilla;
  $shapelista->[$obj] = $shape;
  $filelista->[$obj] = $numfile;
  $laylista->[$obj] = $lay;
  $lugarlista->[$obj] = $lugar;
  $filelista->[$obj] = $numfile;
  comfin('finm cargar_listas');
  return '';
}#cargar_listas
# ----------------------------------------------------------------------------
sub marcar_nodos{
  comfin('comm marcar_nodos',@_);
  my ($ref,$refhashpalabras) = @_; my $agre;
  my $codcirc = $ref->{clasearch};
  $codcirc eq 'modelo' and $agre = 'NODOMOD'
      or return;
  my @listanodos = keys %{$ref->{cualobjtextonodo}};
  impr_debug(__LINE__.'Ampl @listanodos',\@listanodos);
  my @palabras = @$refhashpalabras;
  impr_datos(__LINE__.' Ampl',['DATOS','PARAMETROS','INICIALES'],$ref);
  impr_debug(__LINE__.' Ampl ',\@palabras); 
  impr_debug(__LINE__.' Ampl @palabras',\@palabras); 
  foreach my $que ('PARAMETROS','DATOS') {  #CUIDADO!!!!!!!!
      next unless $ref->{$que} and scalar keys %{$ref->{$que}};
      my $VAR1;
      my $todo = Dumper $ref->{$que};
      impr_campo(__LINE__.' Ampl $ref',$ref,$que);
      $todo =~ s/\s+//g; 
      foreach my $palabra (@palabras) {
         $todo !~ /\W$palabra/ and next;
          foreach my $nodo (@listanodos) {
              impr_debug(__LINE__.' Ampl $nodo',$nodo);
              $todo !~ /\W$nodo\W/ and next;
              my $cosav = $palabra.$nodo;
              my $cosaw = $palabra.'\('.$nodo.'\)';
              my $sust = "$palabra($agre$nodo)";
              while ($todo =~ s/(\W)$cosav(\W)/$1$sust$2/) {};
              while ($todo =~ s/(\W)$cosaw(\W)/$1$sust$2/) {};
#              while ($todo =~ /\($nodo\)/) {
#		  if ($ref->{cualobjele}->{$nodo}) {
#                      parar1(55,$ref,"ambigüedad entre nodo y elemento para
#                         el token $nodo");
#                  } else {
#                      $todo =~ s/\($nodo\)/(NODOMOD$nodo)/;
#  	          };
#              };
	  };
      };
      eval($todo);
      $ref->{$que} = $VAR1;
      impr_debug(__LINE__.' Ampl $ref->{$que} fin de marcar '
          ."$que\n ",Dumper $ref->{$que});
}; #foreach my $que
comfin('finm marcar_nodos',['PARAMETROS','DATOS'],$ref);
}#marcar_nodos
# ----------------------------------------------------------------------------
sub asignar_mod{
  comfin('comm asignar_mod', @_);
  #se define un unico modelo en un archivo
  my $ref = $_[0];
  #impr_debug(__LINE__. " Ampl ", Dumper $ref->{uni};
  #impr_debug(__LINE__. " Ampl ", Dumper $nombreplantilla);
  my %uso = %{$ref->{USO}}; #se espera un solo par
  #impr_debug(__LINE__.' Ampl uso', Dumper $ref->{USO});
  (my $comodin) = keys %uso;
  $ref->{nodos} = $ref->{uni}->{$comodin};
  my @lista = split /\s*\,\s*/, $uso{$comodin};
  #impr_debug(__LINE__.' Ampl del uso', \@lista);
  my $nombremod = uc(shift @lista);
  my $obj = $ref->{cualobjmod}->{$comodin}->[-1]; 
  $comodin =~ /^T(.+)/ and defined $obj    
  or do{
        porparar1(99,$ref,
        "No se entiende como explicación de USO del modelo
         $comodin = $uso{$comodin},  en $ref->{CORTO}:
            no hay un ícono de modelo identificado con $1;
             No se puede usar este modelo");
        return 99;
  };
  $ref->{uso} = "$comodin = $uso{$comodin}";
  $ref->{comodin} = $comodin;
  my $plantillacshape =  $plantillalista->[$obj] . 'c' . $shapelista->[$obj]; 
  $nombre_menu_Dia->{$plantillacshape} = $nombremod; 
  $ref->{plantillacshape} = $plantillacshape;
  $ref->{nombremod} = $nombremod;
  push(@{$ref->{listaarg}},@lista); #los arg de la def. de un modelo
  map($ref->{ARGUS}->{$_} = 1, @lista);
  my $refcirca = $DEFIMOD->{$plantillacshape}->{$nombremod};
  defined $refcirca and 
  do {mensajear("El modelo $nombremod ya fue definido por
      $refcirca->{archivo}; se ignora $ref->{archivo}");
      porparar1(244,$ref); return 244;
  }; 
  impr_ARCHIVOS(__LINE__.' Ampl'); 
  $DEFIMOD->{$plantillacshape}->{uc($nombremod)} = $ref;
  #disminuira si se usan nombres largos en la def. del modelo.
  foreach (@{$ref->{listaDEFINICION}}) {       
      # a los nombres de los parametros tienen la terminacion
      # con ident. del modelo
      # sólo se admitiran nombres no largos; y el {topeind} dara cuantos 
      # caracteres puede tener el comodin al usarlo.
      #impr_debug(__LINE__.' Ampl cosa en asignar_mod',"$_ $val");  
      if (/^P/ or /^DP/) {
          $ref->{PARAMETROS}->{$_} = $ref->{DEFINICION}->{$_};
          push @{$ref->{listaPARAMETROS}}, $_; #en asignar_mod
      } elsif (/^INICIAL(.+)$/i) {
          $ref->{INICIALES}->{$1} = $ref->{DEFINICION}->{$_};
          push @{$ref->{listaINICIALES}}, $_; #en asignar_mod
      } else {
          $ref->{DATOS}->{$_} = $ref->{DEFINICION}->{$_};
          push @{$ref->{listaDATOS}}, $_; #en asignar_mod 
      };
  };
  impr_datos(__LINE__.' Ampl',['PARAMETROS','DATOS','INICIALES'],$ref);
  #delete $ref->{USO};
  delete $ref->{DEFINICION};
  delete $ref->{listaDEFINICION};
  #impr_debug(__LINE__.' Ampl listaDATOS', $ref->{listaDATOS});
  #impr_datos(__LINE__.' Ampl',['DATOS','PARAMETROS'], $ref);
  #impr_debug(__LINE__.' Ampl $ref->{hashpalabras}'
  #           , $ref->{hashpalabras});
  # CAMBIAR TEMP POR ... 
  my $coderr = sust_datos_num($ref,  # asignar_mod
          ['PARAMETROS','DATOS'],['PARAMETROS']);
  $coderr and return $coderr;
  my $lidm = length($comodin) -1;#largo del identif, del modelo; con 1 alcanza
  my @nombrestodosd = keys %{$ref->{DATOS}};
  my @nombreslargosd = grep(length($_)-$lidm > 5,@nombrestodosd);
      #+1 para V o I
  my @nombrestodosp = keys %{$ref->{PARAMETROS}};
  my @nombreslargosp = grep(length($_)-$lidm > 6,@nombrestodosp);
  my @nombreslargos = (@nombreslargosd,@nombreslargosp);
  @nombreslargos and do{
      avgrav("Modelo con nombres largos
     $nombremod:       @nombreslargos;  no se puede usar");
      porparar1(98,$ref);
      return 98; 
  };
  my $tope_ind =  3; #maxima cantidad de caracteres para iden. propio modelo
      #si no tiene elementos; solo parametros; si tiene elem., 2
  map(do{(5 - length($_)+$lidm < $tope_ind) 
             and $tope_ind = 5 - length($_)+$lidm},
      @nombrestodosd);
  map(do{(6 - length($_)+$lidm < $tope_ind) 
             and $tope_ind = 6 - length($_)+$lidm},
      @nombrestodosp);
  $ref->{topeind}= $tope_ind;
  my $lisque = ['DATOS','PARAMETROS','INICIALES'];
  $coderr = normalizar($ref, $lisque); # en asignar_mod
  not $coderr and $coderr = limpiar_unico($ref, $lisque);# en asignar_mod
  if ($coderr or $avisosgrav) {mensajear('No se puede usar este modelo');
      porparar1(97,$ref);
      return 97;
  }; 
  #$modelo{$plantillacshape}->{uc($nombremod)} = $ref; 
  my @keysmod = keys %$ref;
  #impr_debug(__LINE__.' Ampl asignar_mod ',join ("\n",@keysmod)); 
  #impr_debug(__LINE__.' Ampl asignar_mod ',Dumper $ref);
  if (@$plantillalista) {
      registrar_equivalencias($ref); #para modelos?
      my ($hashpalabras, $equivpalabra) = ($ref->{hashpalabras}
					    , $ref->{equivpalabra});
      preparar_abreviaturas($ref,$ref->{cualobjelem}, #en asignar_mod
          $ref->{cualobjtextonodo},'modelo');
  };
  comfin('finm asignar_mod', ['DATOS','PARAMETROS'],$ref);
  return '0', $plantillacshape,uc($nombremod);
} #asignar_mod  
# ----------------------------------------------------------------------------
sub desplegar_ele{
  #trabaja sobre $refdespl creado a su pedido por procesar_ele 
  #y guarda sus resultados en $refcircv
  comfin('comm desplegar_ele', @_);
  my $coderr;
  my ($refcircv,$circmod) = @_;
  my $CAJASPOR = {};
  #impr_debug(__LINE__." Ampl  cualobjele "
  #   ,Dumper $refcircv->{cualobjele});
  foreach my $idenv (sort keys %{$refcircv->{DATOS}}) {
     next unless $refcircv->{TIPDATOS}->{$idenv} eq ',' and $idenv !~ /^M/; 
     
     #impr_debug(__LINE__." Ampl uni $idenv"
     #          ,Dumper $refcircv->{uni}->{$idenv});
     my $valor = $refcircv->{DATOS}->{$idenv};
     (my $formula = $valor) =~ s/^listalis\((\w+)/$1/;       
     #my $pararchtab = $refdespl->{parnombrearchivotabla};
     #impr_debug(__LINE__.' Ampl $DEFIELE',Dumper $DEFIELE);


     my ($refcircm,$refdespl) = procesar_ele($refcircv,$idenv,$CAJASPOR);
     next unless $refcircm; #elemento inexistente, ya anunciado por proc_ele
     #impr_debug(__LINE__.' Ampl $refdespl',Dumper $refdespl);
     #impr_debug(__LINE__.' Ampl uni',Dumper $refcircv->{uni}->{$idenv});
     if ($refcircm !~ /^HASH/) { #significa error ya anunciado por proc_ele
        return $refcircm; 
     }; 
     my $archivoele = $refdespl->{archivoele};
     my $lisque = ['DATOS','PARAMETROS'];
     my @listaPAR = @{$refdespl->{listaPARAMETROS}};
     #impr_debug(__LINE__.' Ampl uni',Dumper $refcircv->{uni}->{$idenv});
     if (@listaPAR >1) {
         $coderr = simpl_parametros($refdespl);  
         $coderr and parar1($coderr, $refcircv);
     };
     my @lispar = grep($refdespl->{TIPPARAMETROS}->{$_}=~/[nap]/,
                         keys %{$refdespl->{PARAMETROS}});
     @lispar and $circmod eq 'circuito' 
         and sust_par_nap($refdespl,'[nap]');# en desplegar_ele
     my @listacondiciones =  @{$refdespl->{condicion}};
     #impr_debug(__LINE__.' Ampl uni',Dumper $refcircv->{uni}->{$idenv});
     controlar_condiciones_ele($refdespl,$refcircv,$idenv) 
             if @listacondiciones;
     reempl_ele($lisque,$refdespl->{comodin},$idenv,$refdespl,$refcircv); 
     despl2circv($refdespl,$refcircv,'elementos','desplegar_ele'); 
     $refcircv->{USAELE}->{$archivoele} = 1;
  }#foreach my $idenv
  foreach (sort keys %$CAJASPOR) {
     $CAJAS->{$refcircv->{CORTO}} 
          .=  "#usado $_ para (" . join (',', @{$CAJASPOR->{$_}}) . ")\n";
  };
  comfin('finm desplegar_ele', ['DATOS','PARAMETROS'],$refcircv);
  return 0;
}#desplegar_ele
# ----------------------------------------------------------------------------
sub controlar_condiciones_ele{
  comfin('comm controlar_condiciones_ele',@_);
  my ($refdespl,$refcircv,$idenv) = @_;
  my @listacondiciones =  @{$refdespl->{condicion}};
  #impr_debug(__LINE__.' Ampl',Dumper $refdespl->{condicion});
  #impr_debug(__LINE__.' Ampl',Dumper $refdespl->{varcond});
  #impr_datos(__LINE__.' Ampl',['arg','PARAMETROS'], $refdespl);
  #impr_datos(__LINE__.' Ampl',['DATOS','PARAMETROS'], $refcircv);
  #foreach my $arg ($refdespl->{@listaarg) {
  #    foreach mt $par 
  foreach my $condi (@listacondiciones) {
      my $condich = "($condi)";
      foreach my $var (keys %{$refdespl->{varcond}}) {
          my $que = $refdespl->{varcond}->{$var};
          my $sust = $refdespl->{$que}->{$var};
          my $tipo = lc($refdespl->{"TIP$que"}->{$var});
          my $hay = '';
          while ($condich =~ s/(\W)$var(\W)/$1$sust$2/i) {$hay = 1};
          if ($hay) {
              $tipo eq 'n' or 
                do {avnograv( "Para $idenv, la condición ($condi) tiene a
  $var($sust) que no es numérico; no lo controlará Simusol;
  si Ud. tiene dudas, use TERMINATE en un cuadro CONTROLES");
                    $condich = 1;
                    next;
	      };
          };
      };
      my $resul = eval($condich);
      #impr_debug(__LINE__.' Ampl $condi $condich $resul'
      #           ,[$condi, $condich, $resul]); 
      defined $resul and $resul  
        or do{parar1(29,$refcircv,
		"Para $idenv, la condición ($condi) se reduce a  
         ($condich)  que  no se cumple");
      };
  };
  comfin('finm controlar_condiciones_ele',@_);
  return;
}#controlar_condiciones_ele 
# ----------------------------------------------------------------------------
sub usar_nuevos_nombres{
  my ($refdespl,$refcircv,$origen) = @_;
  my @lispar =  sort keys %{$refdespl->{PARAMETROS}};
  #impr_datos(__LINE__.' Ampl] usr_n_n',['DATOS','PARAMETROS'], $refdespl);
  foreach my $viepar (@lispar) {
      my $valor = $refdespl->{PARAMETROS}->{$viepar};
      my $nuevopar = $refcircv->{valuespar}->{$valor};
      if (not defined $nuevopar) {
          $nuevopar = 'PE1';
          while (defined $refdespl->{PARAMETROS}->{$nuevopar}
                  or defined $refcircv->{PARAMETROS}->{$nuevopar}) {
              $nuevopar++;
          };
          $refdespl->{parscreados}->{$nuevopar} = 1; 
          $refcircv->{parscreados}->{$nuevopar} = 1;
          push @{$refcircv->{listaPARAMETROS}},$nuevopar;#en usar_nuevos_n---
          push @{$refcircv->{lisPARAMETROS}}, $nuevopar;#en usar_nuevos_n---
      };
      #impr_datos(__LINE__.' Ampl' . " $origen $nuevopar"
      #      ,['DATOS','PARAMETROS'], $refdespl);
      my $VAR1;
      my $textodespl = Dumper $refdespl;
      while ($textodespl =~ s/(\W)$viepar(\W)/$1$nuevopar$2/) {};
      $refdespl = eval($textodespl);  
      #impr_datos(__LINE__.' Ampl' . " $origen $nuevopar"
      #      ,['DATOS','PARAMETROS'], $refdespl);
      return $refdespl;
   };
}#usar_nuevos_nombres
# ----------------------------------------------------------------------------
sub despl2circv{
  comfin('comm despl2circv', @_);
  my ($refdespl,$refcircv,$origen) = @_; 
  my $operabre = '[\(\+\-\*\/,]'; my $opercierra ='[\)\+\-\*\/,]';
  # se preparar y  lleva parametros y datos desde $refdespl a $refcircv
  my $lisque = ['PARAMETROS','DATOS','INICIALES'];
  my @listapar = keys %{$refdespl->{PARAMETROS}};
  @listapar =  grep(
       uc($refdespl->{TIPPARAMETROS}->{$_}) ne $refdespl->{TIPPARAMETROS}->{$_}
       ,@listapar); 
  if ($origen eq 'elementos' and @listapar) {
      $refdespl = usar_nuevos_nombres($refdespl,$refcircv,$origen); 
  };
  foreach my $que (@$lisque) { 
      my @amover = keys %{$refdespl->{$que}};
      foreach my $key (@amover) { 
          if ($que eq 'PARAMETROS') { 
              my ($valor,$tipo,$tiparg) = tomar_datos($refdespl,$que, $key);
              next if $tipo =~ /[bPANTQ]/; 
              $refcircv->{valuespar}->{$valor} = $key; 
              $refcircv->{parscreados}->{$key} = 1; 
              push @{$refcircv->{listaPARAMETROS}}, $key; #en despl2circv 
              push @{$refcircv->{lisPARAMETROS}}, $key; #en despl2circv 
          };
          if (defined $refcircv->{$que}->{$key} and $origen eq 'modelo'){
              parar1(94,$refcircv,"$key representa un elemento o parámetro 
          del circuito y del modelo; cambie el nombre para el circuito");
          };
          copiar_datos($refdespl, $que, $key, $refcircv, $que, $key
                        ,__LINE__. ' Ampl despl2circv'); 
      };
  };
  #borrar_datos($refcircv,'DATOS', 
  if ($origen eq 'elementos') {
      comfin('finm despl2circv', ['PARAMETROS','DATOS'],$refcircv);
      return;
  };
  foreach my $key (keys %{$refdespl->{DATOS}}) {
      $refcircv->{uni}->{$key} = $refdespl->{uni}->{$key};
  };   
  comfin('finm despl2circv', ['DATOS','PARAMETROS'],$refcircv);
  return;
}#despl2circv
# ----------------------------------------------------------------------------
sub desplegar_mod{
  comfin('comm desplegar_mod', @_);
  my $debug1 = $debug; #$debug = '';
   #Solo pone los elementos y nodos que corresponden a cada modelo y hace la
  #sustituciones de argumentos o  los atiende con nuevos 
  #parametros del circuito  
  my (%modusado, $CAJASm,$nummod);
  my $refcircv = $_[0]; my $coderr = '';
  impr_datos(__LINE__.' Ampl',['DATOS','PARAMETROS','INICIALES'],$refcircv); 
  my @listaobj = grep($codlista->[$_] eq 'T', 
                   @{$refcircv->{lisobjelemTs}});
  return if @listaobj == 0;
  my $basearchv = $refcircv->{BASEARCH};
  foreach my $objmod (@listaobj){#tiene la lista de objetos que son modelos
      my $ilayer = $laylista->[$objmod]; 
      my $comodinv = $codlista->[$objmod] . $textolista->[$objmod];   
      my $plantillacshape 
        = $plantillalista->[$objmod] . 'c' . $shapelista->[$objmod];
      my $refiden = $refcircv->{DATOS}->{$comodinv} or do {
          avgrav("Sin datos para el modelo $comodinv");
	  next
      };
      #impr_debug(__LINE__.' Ampl despl_mod $refiden ',$refiden);
      $refiden =~ s/listalis\((.+)\)/$1/;
      my @listargv = split /\s*,\s*/, $refiden;
      ($coderr,@listargv) = juntar_por_paren_cur(',',@listargv);
      my $nombrev = uc(shift(@listargv));
      #impr_debug(__LINE__.' Ampl despl_mod @listargv $nombrev'
      #            ,[@listargv, $nombrev]);
      $refcircv->{USAMODELOS}->{$plantillacshape}->{$nombrev} = 1;
      my $refcircm; 
      if (defined $DEFIMOD->{$plantillacshape}->{$nombrev}) { 
          $refcircm = $DEFIMOD->{$plantillacshape}->{$nombrev};
          explic("          Modelo - $nombrev ya definido");
      } else {
          error_progr($refcircm,__LINE__." Ampl No debe llegar aqui; "
           ."ahora nota la falta del modelo $nombrev");
      };
      my $VAR1;
      my @keysmod = keys %$refcircm; 
      #impr_debug(__LINE__.' Ampl despl_mod ',Dumper \@keysmod);     
      #impr_debug(__LINE__.' Ampl despl_mod ',Dumper $refcircm);
      my $refdespl = eval(Dumper $refcircm);
      $refcircm->{topeind}+2  > length($comodinv) or do{
          avgrav(
           " Iidentificador propio demasiado largo para el uso del modelo 
             $nombrev;    $textolista->[$objmod]
                   no debe tener más de $refcircm->{topeind} caracteres");
          return;
      };
      $refdespl->{nombrecirc} .= " Auxiliar para $nombrev";
      $refdespl->{comodinv} = $comodinv;
      my @listargm = @{$refdespl->{listaarg}};
      @listargm == @listargv or do{
          avgrav("Diferente cantidad de argumentos para $comodinv, $nombrev
           @listargm
           @listargv");
          return -1;
      };

      sust_argus($refdespl,$refcircv,$comodinv);#en desplegar_mod
      my $comodinm = $refcircm->{comodin};
      impr_ARCHIVOS(__LINE__.' Ampl ');
      push @{$modusado{$refcircm->{CORTO} }}, $comodinv;
      $refcircv->{USAMOD}->{$refcircm->{ABSOLUTO}} = 1;
      my @eliminables = keys %{$refdespl->{PARAMETROS}};
      @eliminables = grep(do{defined $refdespl->{TIPPARAMETROS}->{$_}
                             and $refdespl->{TIPPARAMETROS}->{$_} ne ','
	                     and  $_ !~ /^D/}
                          ,@eliminables);
      eliminar_pars($refdespl,'modelo',@eliminables);
      #sust_par_nap($refdespl,'[nap]'); # en desplegar_mod
      #impr_datos(__LINE__.' Ampl refdespl',['PARAMETROS','DATOS']
      #           , $refdespl);
      #impr_hash('Ampl reempl_mod ',%{$refcircv->{PARAMETROS}});
      reempl_mod( ['DATOS','PARAMETROS','INICIALES'],$comodinm, $comodinv,
                    $refdespl,$refcircv);
      #impr_hash('Ampl reempl_mod ',%{$refcircv->{PARAMETROS}});
      despl2circv($refdespl,$refcircv,'modelo','desplegar_mos');
      delete $refcircv->{DATOS}->{$comodinv};
      foreach my $obj (@{$refcircm->{lisobjtodos}}) {
          next unless  $codlista->[$obj] =~ /[RCJELMN]/ ;
          # no he intentado modelos dentro de modelos; REVISAR
	  my ($cualobjrep,$cod,$texto) = 
         	replicar_objeto($obj,$objmod,$comodinm,$comodinv);
          next  unless  $cualobjrep; 

	  if ($cod eq 'N') {
               $refcircv->{NODOSPLANT}->{$texto} 
                  = $plantillalista->[$cualobjrep];
          } else {
              $refcircv->{ELESPLANT}->{"$cod$texto"} 
                = $plantillalista->[$cualobjrep];
              my $uni = 
	        $refcircm->{uni}->{"$codlista->[$obj]$textolista->[$obj]"};
              my @listuni = split '-',$uni;
          };
      }; #my $obj
  }; # foreach $objmod
  my $pwd = `pwd`;chomp $pwd;
  foreach $_ (sort keys %modusado) {# solo para que facil.  comparar
      my $cual = $_; # se necesita recordar el original
      $cual !~ /^\// and $cual = "$pwd/$cual"; 
      $cual =~ s/$basearchv//;
      $CAJASm .= "#usado $cual para = (" . join(',', @{$modusado{$_}}) . ")\n";
      $CAJASm .= '..'x 20 . "\n";
  };
  $CAJAS->{$refcircv->{CORTO}} .= $CAJASm;
  $debug = $debug1;
  comfin('finm desplegar_mod', ['DATOS','PARAMETROS'], $refcircv);
}#desplegar_mod
# ----------------------------------------------------------------------------
sub contr_argus{
  comfin('comm contr_argus',@_);
  my ($refdespl,$refcircv,$argv99,$stringargv,$iden) = @_; 
  my @listargm = @{$refdespl->{listaarg}};
  my @listargv = split /\s*,\s*/,$stringargv;
  (my $coderr,@listargv) = juntar_por_paren_cur('',@listargv);
  #impr_debug(__LINE__.' Ampl @listargm',\@listargm);
  @listargv == @listargm or do {
      parar1(32,$refcircv
          ,"Dif. cantidad de arg. en datos para $iden, con fórmula $argv99
          @listargm (". scalar @listargm . ")
          @listargv (".scalar @listargv .')');
  }; # do
  #impr_debug(__LINE__.' Ampl $arg99 @listargv',[$argv99,'   ',@listargv]);
  my $conctipargv = $refcircv->{TIPARGDATOS}->{$iden};
  $conctipargv =~ s/^.//;  my @tipos = split '',$conctipargv;

  if (@{$refdespl->{parnombrearchivotabla}}) {
      sust_argus_especial($refdespl, $refcircv, 
        \@listargm, \@listargv, \@tipos, $iden);
  };
  #impr_debug(__LINE__.' Ampl @listargm', Dumper \@listargm);

  for (my $i = 0; $i < @listargm; $i ++) {
      next unless defined $listargm[$i];
       cargar_datos($refdespl, 'arg', $listargm[$i]
           , $listargv[$i],$tipos[$i],'',0); 
  };
  #impr_debug(__LINE__.' Ampl CONDICION', Dumper $refdespl->{condicion});
  $refdespl ->{nombrecirc} .= "\n     Auxiliar para $iden";

  comfin('finm contr_argus',@_);
}# contr_argus 
# ----------------------------------------------------------------------------
sub sust_argus_especial{
  comfin('comm sust_argus_special',@_);
  my ($refdespl, $refcircv, $refargm, $refargv, $reftipos,$iden)= @_;
  my ($refpar,$archivoele) = @$refdespl{'parnombrearchivotabla','archivoele'}; 
  my %hash; my ($archm,$tablm,$archv,$tablv);
  foreach my $par (@$refpar) {
      my($arch,$tabl) = split ',',$par;
      for(my $i = 0; $i < @$refargm; $i ++) {
          if ($refargm->[$i] eq $arch) {
              $archv = $refargv->[$i];
              delete $refargm->[$i]; delete $refargv->[$i]; 
              delete $reftipos->[$i];
          } elsif ($refargm->[$i] eq $tabl) {
              $tablv = $refargv->[$i];
          };              
      };
      #impr_debug(__LINE__.' Ampl', {$archv,$tablv});
      my @posibles = Desdexml::conseguir_nombres_ele_mod($refcircv,$archv,'');
      @posibles and $archv = $posibles[0];
      #impr_debug(__LINE__.' Ampl', {$archv,$tablv});
      defined $tablv and $tablv =~ /^T/i and defined $archv and -e $archv or 
      do { parar1(66, $refcircv,
           "Problemas con los argumentos para el cálculo de valor de $iden")
      }; 
#FALTA TRABAJAR CON LA TABLA
#los otros argumentos quedan actualizados salvo ano arg.
         };
  comfin('finm sust_argus_especial');
}
# ----------------------------------------------------------------------------
sub sust_argus{
  comfin('comm sust_argus',@_);
  my ($refdespl,$refcircv,$iden) = @_; my $coderr = '';
  my $sepai = '[\s\+\-\*\/,\,\(,\']';
  my $sepad = '[\s\+\-\*\/,\,\),\']';
  my @listargm = @{$refdespl->{listaarg}};
  #impr_debug(__LINE__.' Ampl @listargm', Dumper \@listargm);
  (my $listargv = $refcircv->{DATOS}->{$iden}) =~ s/^listalis\((.*)\)$/$1/;
  my @listargv = split ',', $listargv;
  ($coderr,@listargv) = juntar_por_paren_cur(',',@listargv); 
  my $nombrev = shift @listargv;
  my $conctipargv = $refcircv->{TIPARGDATOS}->{$iden};
  $conctipargv =~ s/^.//;   
  my @tipos = split '',$conctipargv;
  my $mens;
  for(my $i = 0; $i < @listargv; $i ++) {
      $mens .= "$i     $listargm[$i]  => $listargv[$i]\n";
      if ($tipos[$i] eq 'p') {
	  if ($listargv[$i] eq $listargm[$i]) {$listargv[$i] = ''
	  };    
      };
  };
  my @lisque = ('DATOS','PARAMETROS','INICIALES');
  impr_datos(__LINE__.' Ampl $refdespl ',\@lisque,$refdespl);   
  @lisque = grep (defined $refdespl->{"$_"},@lisque);
  #impr_debug(__LINE__.' Ampl @lisque ',\@lisque);  my $VAR1;
  foreach my $que (@lisque) {
      my $todo = Dumper $refdespl->{"$que"};
      for (my $i=0; $i < @listargv; $i ++) {
          #impr_debug(__LINE__.' Ampl $listargv[$i] ',[$i,$listargv[$i]]);
          $listargv[$i] =~ s/^X\w+\((.+)\)$/$1/;   
          #impr_debug(__LINE__.' Ampl $listargv[$i] ',[$i,$listargv[$i]]);
          my ($ori,$sust,$tipo) 
               = ($listargm[$i], "$listargv[$i]", $tipos[$i]);
	  #impr_debug(__LINE__.' Ampl $ori,$sust,$tipo', [$ori,$sust,$tipo]);
          # se marca para evitar ciclos
          $sust =~ s/(\w+)/&$1&/;
          #impr_debug(__LINE__.' Ampl $ori $sust $tipo '
          #      , [$i,$ori,$sust,$tipo]);
          next if $listargv[$i] eq ''; # es que no es necesario cambiar
          if ($tipo eq 'x' # se le saco el X.. y los parentesis
                or ($tipo eq 'n' and $sust =~ /^[\-\.]/)) {$sust = "($sust)"}; 
	  next if $ori eq $sust;
          # no se necesita marca adicional
 	  while ($todo =~ s/($sepai)$ori($sepad)/$1$sust$2/) {};
      }; #for 
      $todo =~ s/\&//g;    
      $todo =~ s/\$VAR1/\$refdespl->{"$que"}/;
      eval($todo); 
      #impr_debug(__LINE__.' Ampl $todo ', [$que,' ',$todo]);
      my $refque = $refdespl->{$que};
      foreach my $key (keys %{$refque}) {
          my $valor = $refque->{$key};
          ($valor,my $coderror) = 
               estandarizar_expresion($valor,$que);# en s_argus
          #impr_debug(__LINE__.' Ampl $key $valor',"$key $valor");
          my ($tipo,$argus,$func,$listatiparg,$nvalor,$reflistaargus)
             = tipear($valor, 1, 1); #tercer argumento para no redondear 
          cargar_datos($refdespl,$que,$key,$nvalor,$tipo,$listatiparg
                  ,$reflistaargus ,__LINE__. " Ampl sust_argus" );
      }#foreach $key 
  };#foreach $que
  my $dumperCONDICION = Dumper $refdespl->{condicion};
  #impr_debug(__LINE__.' Ampl $refdespl->{arg} ',Dumper $refdespl->{arg});   
  #impr_debug(__LINE__.' Ampl $dumperCONDICION '
  #           , $dumperCONDICION);         
  comfin('finm sust_argus',['DATOS','PARAMETROS','INICIALES'],$refdespl);
}# sust_argus
# ----------------------------------------------------------------------------
sub preparar_abreviaturas{
#la llama asignar_ele y asignar_mod
#deja nombres de nodos y elementos, en los valores para el circuito
# (como argumentos de abreviatura)
# con un prefijo, sin parentesis y _. 
  comfin('comm preparar_abreviaturas', @_);
  my ($ref,$refelems, $refnodos, $clase) = @_;
  #impr_debug(__LINE__.' Ampl $ref',Dumper $ref);
  #impr_debug(__LINE__.' Ampl $refelems',Dumper $refelems);
  #impr_debug(__LINE__.' Ampl $refnodos', Dumper $refnodos);
  $clase = uc($clase);
  my @pre = ('NODO','ELEM');
  for my $j (1,2) { 
      my $pre = $pre[$j - 1];
     foreach my $palabra (keys %{$_[$j]}) {
          foreach my $que ('DATOS','PARAMETROS') {
              foreach my $key (keys %{$ref->{$que}}) {
	          my $valor = $ref->{$que}->{$key}; my $hay ='';
                  while ( $valor =~ 
	       s/(\W)$palabra\s*\(\s*(\w+)\s*\)/$1$palabra\_$pre$clase$2/ ) { 
		      $hay = 1;
                      my $cosa = uc($2);
                      ($pre eq 'NODO' and $refnodos->{$cosa})  
                      or ($pre eq 'ELEM' and $refelems->{$cosa})    
		      or do {
                          avgrav("No corresponde $palabra($2)");
                          return 66; 
                      };
	          };
                  $hay and do{
                         $ref->{$que}->{$key} = $valor;  
		  };
              };
          };
      };
  };
  comfin('finm preparar_abreviaturas');
  return '';
}
# ---------------------------------------------------------------------------
sub sustituir_nodos_ele{
    my ($refdespl,$refconversion,$expresion) = @_; 
    #impr_debug(__LINE__.' Ampl $refconversion ',Dumper $refconversion);
    #impr_debug(__LINE__.' Ampl $expresion ',$expresion);
    while ($expresion =~ /\((NODOELEM\w+)\)/) {
	my $sust = $refconversion->{$1};
        $expresion =~ s/\(NODOELEM\w+\)/\($sust\)/;
    };
    return $expresion;
}
# ---------------------------------------------------------------------------
sub reempl_ele{
  comfin('comm reempl_ele', @_);
  # reemplaza, en $refdespl, las menciones (tal cual o con V,I,D) a $idenm 
  # por $iden; y tambien trae los nodos de conexion  
  #controla que el número de conexiones sea el correcto
  my ($lisque,$idenm,$idenv,$refdespl,$refcircv) = @_;
  my @listuniv = split '-', $refcircv->{uni}->{$idenv};
  my @listunim = split '-', $refdespl->{uni}->{$idenm};
  #impr_debug(__LINE__.' Ampl  @listuniv', \@listuniv); 
  #impr_debug(__LINE__.' Ampl @listunim', \@listunim); 
  #impr_debug(__LINE__.' Ampl refcircv uni', Dumper $refcircv->{uni});
  #impr_debug(__LINE__.' Ampl refdespl', Dumper $refdespl->{uni});
  @listuniv == @listunim or
  do {  
      my $obj = $refcircv->{cualobjele}->{$idenv}->[0];
      my $reflay = $reflayers[$laylista->[$obj]];
      parar1(93, $refcircv,"Cantidad diferente de conexiones  para elemento: 
                 $idenv  tiene \"@listuniv\"
		 y debiera haber " . scalar @listunim);  
      return 93;
  };# do
  my %conversion; 
  for (my $i = 0; $i < @listuniv; $i++) {
      my $nodo = 'NODOELEM'.uc($listunim[$i]);
      $conversion{$nodo} = uc($listuniv[$i]);
  };
  # reemplazo de nodos y menciones al elemento
  foreach my $que (@$lisque) {
      foreach my $key (keys %{$refdespl->{$que}}) {#no importa el orden
          next unless defined $refdespl->{$que}->{$key};
          next if $refdespl->{"TIP$que"}->{$key} =~ /[nap]/;
          my $valor = "($refdespl->{$que}->{$key})";
          $valor = sustituir_nodos_ele($refdespl,\%conversion,$valor);
          if ($idenm ne $idenv) {
              while ($valor =~ s/(\W)$idenm(\W)/$1$idenv$2/) {};
              while ($valor =~ s/(\W[VID])$idenm(\W)/$1$idenv$2/) {};
          };
          $valor =~ s/^\((.*)\)$/$1/;
          $refdespl->{$que}->{$key} = $valor;
          if (defined $refdespl->{"REFARG$que"}->{$key} and 
              $idenm ne $idenv) {
              my @lista = @{$refdespl->{"REFARG$que"}->{$key}}; 
              foreach my $cosa (@lista) {
                  $cosa eq $idenm and $cosa = $idenv
                    or $cosa =~ s/^([VID])$idenm$/$1$idenv/;
              };
              $refdespl->{"REFARG$que"}->{$key} = \@lista;
          };

     };
  };
  $refdespl->{uni}->{$idenv} = $refcircv->{uni}->{$idenv};
  foreach my $cual ('DATOS','TIPDATOS','TIPARGDATOS','REFARGDATOS') {
      $refdespl->{$cual}->{$idenv} = $refdespl->{$cual}->{$idenm};
      delete $refdespl->{$cual}->{$idenm} if $idenv ne $idenm;
  };
  delete $refdespl->{uni}->{$idenm};
  comfin('finm reempl_ele', $lisque,$refdespl);
}# reempl_ele
# ---------------------------------------------------------------------------
sub reempl_mod{
  comfin('comm reempl_mod',@_);
# lo usa desplegar_mod para dar nombres específicos a componentes 
# y variables del modelo incluidas variables que dependen de nodos 
# 
# trabaja sobre refdespl; no modifica a refcircv (solo toma datos de el
# salvo que detecte errores)
  my ($lisque,$comodinm,$comodinv,$refdespl,$refcircv) =@_;
  my (@listuniv,@listunim);
  @listuniv = split '-', $refcircv->{uni}->{$comodinv}
     if $refcircv->{uni}->{$comodinv}; 
  @listunim = split '-', $refdespl->{uni}->{$comodinm}
     if $refdespl->{uni}->{$comodinm}; 
  @listunim == @listuniv or do{
              avgrav('Cantidad diferente de conexiones  para modulo '
                . $comodinv . "
		    debiera haber " . scalar (@listunim) 
	        . " y hay ".scalar(@listuniv));

                $refcircv->{TIPDATOS}->{$comodinv} = 'u';
	        $refcircv->{DATOS}->{$comodinv} .= ' qerror: cant. conex.';
                $refcircv->{ERRDATOS}->{$comodinv} = 1;  
                 return;
  };
  my %conversion;
  for (my $i = 0; $i < @listuniv; $i++) {
     $conversion{uc($listunim[$i])} = uc($listuniv[$i])
  };
  #impr_debug(__LINE__.' Ampl $conversion', Dumper \%conversion);
  foreach my $keym (keys %{$refdespl->{uni}}) {#no importa el orden
     my $value = $refdespl->{uni}->{$keym};
     defined $value or next; # 
     my @listita = split '-', $refdespl->{uni}->{$keym};
     #impr_debug(__LINE__.' Ampl $keym @listita', [$keym,@listita]);
     my @listitanueva;
     foreach my $conviejo (@listita) {
        my $connuevo = $conversion{uc($conviejo)};
	defined $connuevo or do {
	  ($connuevo = $conviejo) =~ s/$comodinm$/$comodinv/;
          $conversion{uc($conviejo)} = uc($connuevo);
	};   
        push @listitanueva, $conversion{uc($conviejo)}       
     }; #conviejo
     #impr_debug(__LINE__.' Ampl $keym @listita aaa @listitanueva'
     #        , [$keym,'aaa',@listitanueva]);
     #impr_hash('Ampl ' . __LINE__ . ' %conversion ',%conversion);
     (my $keyv = uc($keym)) =~ s/$comodinm$/$comodinv/;
     $refdespl->{uni}->{$keyv} = join '-', @listitanueva;
     #impr_debug(__LINE__.' Ampl uni',$refdespl->{uni});
     delete $refdespl->{uni}->{$keym} if $comodinm ne $comodinv;  
  }; #keym    
  # tambien puede haber menciones a nodos en los valores de datos y/o param
  if ($comodinm ne $comodinv) {
    foreach my $que (@$lisque) {
     foreach my $keym (keys %{$refdespl->{$que}}) {#no importa el orden
       my $keyv = $keym; $keyv =~ s/$comodinm$/$comodinv/;
       next if not defined $refdespl->{$que}->{$keym};
       my $valor = "($refdespl->{$que}->{$keym})"; 
       $valor =~ s/\(NODOMOD(\w+)\)/\($conversion{$1}\)/g;
       $valor =~ s/$comodinm(\W)/$comodinv$1/g; 
       $valor =~ s/^.(.*).$/$1/;
       #podrian aparecer nombres nuevos de nodos cruzados con nombres viejos
       $refdespl->{$que}->{$keyv} = $valor;  
       if ($que ne 'temp') { 
         $refdespl->{"TIP$que"}->{$keyv} = $refdespl->{"TIP$que"}->{$keym};
         $refdespl->{"TIPARG$que"}->{$keyv} 
                       = $refdespl->{"TIPARG$que"}->{$keym};
       };
       if ($que eq 'PARAMETROS') {
          $refcircv->{parscreados}->{$keyv} = 1; 
       }; 
      if ($keym ne $keyv) {
	 borrar_datos($refdespl, $que, $keym, 1
                       ,__LINE__.' Ampl reempl. mod');
       }; 
     }; #keyv
    }; #$que
  };   
  comfin('finm reempl_mod',['DATOS','PARAMETROS'], $refdespl);
  return '';
} #reempl_mod     
# ---------------------------------------------------------------------------
sub procesar_ele{
  #trabaja sobre puntero auxiliar $refdespl que crea
  #puede haber sido necesario completar lectura de archivos .ele
  # luego devuelve $refcircm,$refdespl si es que no hay errores 
  # devuelve nada si no hay elemento $iden
  # o para la ejecucion con errores graves
  # solo si no encuentra errores graves modifica $refcircv
  comfin('comm procesar_ele',@_); 
  my ($refcircv,$iden,$CAJASPOR) =@_; 
  my $refobj = $refcircv->{cualobjele}->{$iden}; #sera referencia a lista
  defined $refobj or 
  do {avnograv("Hay datos para elemento inexistente $iden; Se ignorarán"); 
     borrar_datos($refcircv, 'DATOS', $iden, 1, __LINE__.' Ampl datoori');
     return;
  }; 
  impr_debug(__LINE__.' Ampl $refobj',$refobj);
  my $obj = $refobj->[0];  
  explic(" Procesando ".descripcion_objeto($obj));
  my  ($codvalor,$plantilla,$shape) 
     = ($codvalorlista->[$obj],$plantillalista->[$obj],$shapelista->[$obj]);
  my $plantillacshape = $plantilla . 'c' . $shape; 
  my $nombre = $nombre_menu_Dia->{$plantillacshape};
  $iden =~ /^\s*(\w)(\w+)\s*/; 
  my ($cod,$texto) = ($1,$2);
  next if $cod !~ /$codelemTs/;
  #lo anterior puede ocurrir si se le da valor a elementos inexistentes
  my $datoori = $refcircv->{DATOS}->{$iden};
  my ($argv99,$stringargv) = ($datoori =~ /^listalis\((\w+)\,(.*)\)$/);
  my ($refcircm,$refdespl);
  #impr_debug(__LINE__.' Ampl ',$datoori);    
  if (defined $argv99) {
      $argv99 =~ /^$codvalor/ or
      do {parar1(66,$refcircv,"$iden no puede pedir una formula $argv99;
          debe empezar con $codvalor");
          #return 66;
      }; 
      $refcircv->{pcsf}->{"$plantillacshape-$argv99"} = 1;
      $refcircm = $DEFIELE->{nombre}->{$nombre}->{formula}->{$argv99};
      #impr_debug(__LINE__.' Ampl ',Dumper $refcircm );
      #impr_debug(__LINE__.' Ampl parnombrearchivotabla' 
      #		 , Dumper $refcircm->{parnombrearchivotabla});
      #impr_debug(__LINE__.' Ampl ',Dumper $refcircm );
      if (not scalar keys %$refcircm) {
          my ($tipo, $nvalor) = tipear($argv99,0);
          my $cuantoscono = 0;
          my @cono 
               = sort keys %{$DEFIELE->{nombre}->{$nombre}->{formula}};  
          $cuantoscono = @cono if  @cono;
          my $mens0 = "Si usted quiere repetir cálculos
              dándole a $iden varios valores debe utilizar un parámetro"; 
          my $mens1 = "Como código de fórmula de datos, 
	         $argv99 es desconocida  para $cod$texto \n"           
	      . "       Fórmulas conocidas para $cod,"
	      . "    de clase $codvalor, hay $cuantoscono: 
	      @cono";
          if ($tipo =~ /[n]/) {$mens1 = $mens0;
          }
          parar1(31,$refcircv,$mens1);
      };# do   
      my $VAR1; 
      $refdespl = eval(Dumper $refcircm); 
      contr_argus($refdespl, $refcircv, $argv99, $stringargv, $iden);

      #impr_debug(__LINE__.' Ampl $refdespl', Dumper $refdespl);
      sust_argus($refdespl,$refcircv,$iden); #en procesar_ele
      my $nomplant = $nombreplantilla->[$plantilla];
      my $comodin = $refcircm->{comodin};
      defined $refcircm->{usado}  
      or cajear_ele($refcircm, $refcircv,$nomplant, $comodin);
      my $archivoele = $refcircm->{archivoele};
        my ($basearch,$propio,$cortor) 
            = relativizar($archivoele,$refcircv->{BASEARCH});
      push @{$CAJASPOR->{"$nomplant $comodin, $argv99, $cortor"}}, $iden;
      impr_dat(__LINE__.' Ampl procesar_ele',$comodin,$refdespl,'pe');
      $refcircv->{ELESPLANT}->{$iden} = $plantillalista->[$obj];
  }; #if sefined $arg99
  comfin('finm procesar_ele'); 
  return $refcircm,$refdespl;
};#procesar_ele
# ---------------------------------------------------------------------------
sub cajear_ele{
  comfin('comm cajear_ele',@_);
#para agregar al .caj del circuito lo que convenga del .ele
  my ($refcircm,$refcircv,$nomplant,$comodin) = @_;
  $CAJAS->{$refcircv->{CORTO}} .= "#uso $nomplant $refcircm->{uso}\n";
  my $defi = $refcircm->{definicion};
  #impr_debug(__LINE__.' Ampl $defi ',Dumper $defi);
  my $defitod;
  foreach my $def (@$defi) {
      $def =~ s/(funcionesdenodos)/$1 $comodin/; # en cajear
      $def !~ /=/ and $def =  "$comodin = $def";
      $defitod .= "#def $nomplant $def\n";
      #impr_debug(__LINE__.' Ampl $defitod ', $defitod);
  }; 
  $CAJAS->{$refcircv->{CORTO}} .= "$defitod";
  $CAJAS->{$refcircv->{CORTO}} .= "#def $nomplant nodos $comodin ="
	                       . lc($refcircm->{uni}->{$comodin})
                               . "\n"; 
  $CAJAS->{$refcircv->{CORTO}} .= '#'.'..'x 20 . "\n";
  $refcircm->{usado}  = 1;
  comfin('finm cajear_ele');
};
# ---------------------------------------------------------------------------
sub replicar_objeto{
  comfin('comm replicar_objeto', @_);
  my ($obj, $objv,$comodinm,$comodinrep) = @_;

  #    solo se replican los objetos cuya identi. termina en $comodinm

  # $obj objeto a replicar
  # $objv objeto que da el lugar
  # $comodinm, $comodinrep para modificar $texto para el replicado
  #impr_debug(__LINE__. ' Ampl replicar_objeto argumentos'
  #          ,   [$obj, $objv,$comodinm,$comodinrep]); 
  #impr_debug(__LINE__. ' Ampl replicar_objeto codigo de objeto:'
  #          , $codlista->[$obj]);
  my ($cualobjrep,$codm);
  my $ilayer = $laylista->[$objv];
  #impr_debug(__LINE__.'Ampl $reflayers[$reflayers[$ilayer]'
  #,$reflayers[$ilayer]);
  #impr_debug(__LINE__.' Ampl  rep a '
  #    ,"$obj---$codlista->[$obj]+++$textolista->[$obj]");
  my $texto = $textolista->[$obj];
  if ($texto =~ s/$comodinm$/$comodinrep/) {
      #impr_debug(__LINE__. ' Ampl'
      #           ," $textolista->[$obj] >> $texto $comodinm $comodinrep");
      #impr_debug(__LINE__ . ' Ampl  replicar_objeto'
      #, "obj $obj objv $objv comodines $comodinm $comodinrep texto $texto");
      if ($codlista->[$obj] =~ /$codnodos/ 
          or $codlista->[$obj] =~ /$codelemTs/) {
          ($cualobjrep,$codm,$texto) = 
            crear_objeto($ilayer, $codlista->[$obj], $shapelista->[$obj]
                        ,$plantillalista->[$obj], $lugarlista->[$objv]
                        ,$codvalorlista->[$obj],$texto); 
      };
  } else {$cualobjrep  = 0;
  }
  comfin('finm replicar_objeto');
   return($cualobjrep,$codm,$texto); 
} #replicar_objeto
# ---------------------------------------------------------------------------
sub crear_objeto{
  comfin('comm crear_objeto',@_);
  my ($il,$codigo,$shape,$plantilla,$lug,@param) = @_;
  # $il numero de capa; $codigo: nxRE...$lug el lugar; @param lista de
  # parametros; para no rama: codigovalor,  y  texto o "". 
  my $reflay = $reflayers[$il];
  my $refarch = $refarchers[$reflay->{numfile}];
  my $ij = scalar @$codlista;
  $shape = $cualshape->{'Auxiliarshape'} unless $shape;
  $plantilla = $cualplantilla->{'Auxiliar'} unless $plantilla;
  cargar_listas($ij,$codigo,'inv', $codigo, $plantilla, $shape, $il, $lug);
  push(@{$reflay->{lisobjtodos}},$ij);
  my $texto;
  #nunca crearemos ramas usando  puntos de conexion
  if ($codigo =~ /$codramas/) {
      llenar_rama($reflay,$ij,@param);
      $refarch->{hashramascreadas}->{$ij} = 1;
      $texto = $ij;
  } elsif ($codigo =~ /$codnodos/) { 
      $texto = llenar_conect($reflay,$ij,$codigo,@param);
      push @{$refarch->{lisnodoscreados}}, $texto;
      $refarch->{NODOSPLANT}->{$texto}= 100;
      $refarch->{hashnodoscreados}->{$texto} = 1;
      $reflay->{hashnodoscreados}->{$texto} = 1;
  } elsif ($codigo =~ /$codelemTs/) {
        $texto = llenar_conect($reflay,$ij,$codigo,@param);
      $refarch->{hashelescreados}->{"$codigo$texto"} = 1;
      $refarch->{ELESPLANT}->{"$codigo$texto"}= $plantilla;
  } else {
      error_progr($refarch, __LINE__. 
                   " Ampl codigo $codigo inesperado en crear_objeto");
  };
   # el completar {cualobjtextonodo} y poner bien $textolista
   #  ...  esta en llenar_conect     
   comfin('finm crear_objeto');
   return $ij,$codigo,$texto;
}#crear_objeto
# ---------------------------------------------------------------------------
sub llenar_conect{ # REVISAR #cerofuentear 
  comfin('comm llenar_conect',@_);
  my ($reflay,$ij,$cod,$codvalor,$texto)=@_;
#  my $refarch = $refarchers[$reflay->{numfile}]; 
  # consigue un nombre
  #impr_debug(__LINE__ . ' Ampl llenar_conect', \@_);
  #impr_cualobjref(__LINE__.'Ampl llenarconect reflay',$reflay);
  my $refcual; my $pre;
  if ($cod =~/[Nn]/) {
      $refcual = $reflay->{cualobjtextonodo};
      $pre = '';
  } else { 
      $refcual = $reflay->{cualobjele};
      $pre = uc($cod);
  };
  if (not $texto){
      $texto = 1;
      while (defined $refcual->{"$pre$texto"}) {
          $texto++;
      };
  };
  $reflay->{cualobjnoigno}->{uc($cod) . $texto} = [$ij];
#  $refarch->{cualobjnoigno}->{uc($cod) . $texto} = [$ij];
  $textolista->[$ij] = uc($texto);
  $codvalorlista->[$ij] = $codvalor;
  #como son objetos recien creados no es necesario usar los push 
  if ($cod =~ /[Nn]/) { # REVISAR
#      push @{$refarch->{lisobjnodos}}, $ij;
      $reflay->{cualobjtextonodo}->{$texto}=[$ij];
#      $refarch->{cualobjtextonodo}->{$texto}=[$ij];
  } else {
      $reflay->{cualobjele}->{uc($cod) . $texto}=[$ij];
#      $refarch->{cualobjele}->{uc($cod) . $texto}=[$ij];
#      push @{$refarch->{lisobjelemTs}}, $ij;
#      push @{$refarch->{listaDATOS}}, uc($cod) . $texto; #llenar_conect
  }
  comfin('finm llenar_conect', $cod,$codvalor,$texto);
  return $texto;  
}#llenar_conect
# ---------------------------------------------------------------------------
sub llenar_rama{
  #llena los valores para los dos enganches de la rama nueva 
  my ($refgraf,$ij,$lug0,$lug1,$pa0,$cone0,$pa1,$cone1)=@_;
  $textolista->[$ij] = $ij;$codvalorlista->[$ij] = 'x';
  push(@{$refgraf->{lisramas}},$ij);
  push(@{$refgraf->{lisramas}},$ij);
  my ($cod0,$cod1) = @$codlista[$pa0,$pa1];
  my @hashesengan = ({'rama'=>$ij,'handle'=>0,'to'=>$pa0,'connection'=>$cone0,
                      'lugar'=>$lug0,'cod'=>$cod0}
                      ,{'rama'=>$ij,'handle'=>1,'to'=>$pa1,'connection'=>$cone1,
                      'lugar'=>$lug1, 'cod'=>$cod1});
  #   push(@{$refgraf->{listahashesenganches}},@hashesengan); 
  $refgraf->{conexiones}->{$ij}=\@hashesengan;
  return 1; #se necesita dentro de un and;
}#llenar_rama
# ---------------------------------------------------------------------------
sub completar_nodos{
  comfin('comm completar_nodos', @_);
  #agrega nodo tierra (por ahora) conect. a los elementos que lo requieren
  my $refarch=$_[0];
  my $uniuni = $refarch->{uniuni};    
  impr_debug(__LINE__.' Ampl reffarch uniuni',$refarch->{uniuni});
  my @eles = grep(do {/^[cejlr]/ },keys %{$refarch->{cualobjele}});
  @eles = union_conjunto(@eles);
  impr_debug(__LINE__.' Ampl @eles necesitados de completar_nodos',\@eles);
  foreach my $ele (@eles) {#no importa el orden
      my $ucele = uc($ele);
      my $obj = $refarch->{cualobjele}->{$ucele}->[-1];
      my $pcs = $plantillalista->[$obj] . 'c' . $shapelista->[$obj];
      next if $pcs eq '0c0'; #elementos ficticios que seguro no hay que ..
      impr_debug(__LINE__.' Ampl $_ $pcs'
                 , "($obj,$pcs,$codlista->[$obj],$textolista->[$obj])");
      my @lista = ($obj,$pcs,$codlista->[$obj],$textolista->[$obj]);
      my $valoresotrosnodos = $refglobal->{OTROSNODOS}->{$pcs};
      impr_debug(__LINE__.' Ampl $valoresotrosnodos', $valoresotrosnodos);
      if ($valoresotrosnodos =~ /^(.*)\-\?/) { 
          $uniuni->{$ele} = "$1-" . $uniuni->{$ele};
      } elsif ($valoresotrosnodos =~ /\?\-(.*)/) { 
          $uniuni->{$ele}  = $uniuni->{$ele} . "-$1";
      }; 
      impr_debug(__LINE__.' Ampl $uniuni->{$ele}',$uniuni->{$ele}); 
      $uniuni->{uc($ele)} = $uniuni->{$ele};
  };#foreach (keys  ) 
  impr_debug(__LINE__.' Ampl refall uniuni',$refarch->{uniuni});
  comfin('finm completar_nodos equiv',%{$refarch->{uniuni}});
  return '';
}#completar_nodos
1
