#Controles.pm
# Tiene rutinas de control para simusol1.pl
package Simusol::Controles;
use Simusol::GlobalesSimusol;
use Simusol::Termicos;
use Simusol::Auxiliares;
use Simusol::Evaluaciones;
use Simusol::Evaluaciones2;
use Simusol::Ayudas; 

use warnings;
use strict;
use Data::Dumper;
use Scalar::Util qw(looks_like_number);
BEGIN {
     use Exporter ();
     our ($VERSION,@ISA,@EXPORT,@EXPORT_OK,%EXPORT_TAGS);
     @ISA=qw(Exporter);
     @EXPORT=qw(&completar_guardarref_pedido
                &controlar_cadena_par_el
                &controlar_cadena_param 
                &cantrolar_circ
                &controlar_circ
                &controlar_conex
                &controlar_conex_ramas
                &controlar_con_sin
                &controlar_def_funciones_propias
                &controlar_def_funciones_todas
                &controlar_def_funciones_final 
                &controlar_dpar_tiempos
                &controlar_dependencias
                &controlar_elementos
                &controlar_iniciales_il_vc
                &controlar_iniciales_integr 
                &controlar_keys_iniciales
		&controlar_largos
                &controlar_conex_nodos_eles
                &controlar_modelo 
                &controlar_pedidos_resultados
                &controlar_pertinencia_pars
                &controlar_repetidos_datos_pars_inis
                &controlar_repeticiones_FUNCIONES
                &controlar_tiempos
                &controlar_uso_funciones
                &controlar_uso_def_argumentos 
                &controlar_uso_def_parametros 
                &controlar_uso_def_TABLAS
                &controlar_valorespar
                &controlar_var
                &depurar_dependencias
                &impr_dependencias
	       );
};
END();
#---------------------------------------------------------------------------
sub completar_guardarref_pedido{
  comfin('comc completar_guardarref',@_) ;
  my ($ref, $tipo,$plantilla,$sceptre,$palequiv ,$pala,$propio,$dentro)
     = @_;
  my %equi = ('V' => 'E', 'I' => 'J');
  my $comp;
  if ($dentro =~/^.*\,.*\,.*$/) { 
  } else {
      #impr_debug(__LINE__.' Cont $propio $nombreplantilla->[$plantilla]'
      #		 ,[$propio, $nombreplantilla->[$plantilla]]);
      if ($palequiv ne '') {
          $comp = $ref->{DEFIcomp}->{$plantilla}->{$equi{$palequiv}};
          if (not defined $comp) {
	     my $pl = substr($nombreplantilla->[$plantilla],0, 2);
             $comp = "$pala??,$pala??";
	 };
      } else {
          if ($tipo eq 'a') { # por ejemplo un resultado de Resist.
	      $sceptre =~ /^(.)/ ;  my $cod = $1;  
              $comp = $ref->{DEFIcomp}->{$plantilla}->{$cod};
              if (not defined $comp) {
                  my $pl = substr($nombreplantilla->[$plantilla],0, 2);
                  $comp ="$cod??,$cod??";
              };
          } elsif ($tipo eq 't') {
              $comp = 'tiempo,s';
          } else {
              $comp or $comp ='??,??';
          };
      };
      $dentro .=  ",$comp";
  };
  #impr_debug(__LINE__.' Cont  comp_guard $sceptre $dentro $tipo'
  #   , [$sceptre, $dentro, $tipo]);
  if ($tipo ne 'e') {  
     push @{$ref->{listapedidos}} ,"$sceptre($dentro)";
     push @{$ref->{listasceptre}}, $sceptre;  
  } else {
     push @{$ref->{listapedidos}}, "??($dentro)";  
  };
  $ref->{tiparg} .= $tipo;
  comfin('finc completar_guardarref');
}#completar_guardarref_pedido
# ---------------------------------------------------------------------------
sub controlar_con_sin{
  comfin('comc controlar_con_sin',@_);
  my $reflista = $_[0]; 
  my $juntos = ''; my ($coderr,$mensaje)  = ('',''); my $reflistasin = [];
  my @lista = @$reflista; my @listasin;
  my @listamala = grep (do{/[\*\?\s]/},@lista);
  if (@listamala and @lista >1) {
      $mensaje = "No es posible atender 
      @lista
      porque hay elementos como \'$listamala[0]\'";
      $coderr = 250;
      parar0($coderr,$mensaje);
  } else {
     my $archmalo = $listamala[0];
     if ($archmalo !~ /[\*\?]/) { # solo hay espacios
         @lista = split /\s+/, $archmalo;
         $juntos = 'juntos';
     } else {
         $mensaje = " $archmalo es demasiado complicado"; $coderr = 250;
         parar0($coderr,$mensaje);
     };
  };
  foreach my $arch (@lista) {
      (my $archsin = $arch) =~ s/\.[\/]*$//;
      push @listasin, $archsin;
      my $archcon = "$archsin.dia";
      if (-e $archsin and -e $archcon) {
          my $mensaje = " Existen archivos $archsin y $archcon;
          Asi no puede trabajar Simusol"; $coderr = 250;
          parar0($coderr,$mensaje);
      } elsif (-e $archsin) {
          $arch = $archsin;
      } elsif (-e $archcon) {
          $arch = $archcon;
      } else {
          $arch = undef; pop @listasin;
      };
  };
  @lista = grep (defined $_,@lista);      
  @$reflista = @lista;         
  comfin('finc controlar_con_sin',$juntos,@lista,'||',@listasin);
  return $juntos,$reflista,$reflistasin;
}#controlar_con_sin;
# ---------------------------------------------------------------------------
sub controlar_dependencias{
  my ($ref,$listaque) = @_;
  # los parameros que marcan rerun no deben molestar aqui
  comfin('comc controlar_dependencias',@_);my $coderr = '';
  my @reruns = grep ($ref->{TIPOTOK}->{$_} eq 'b',sort keys %{$ref->{TIPOTOK}});
  impr_datos(__LINE__.' Cont',['TODOS'],$ref);
  my (%yaesta,%defque);
  foreach my $que (@$listaque) {
      if ($ref->{"lista$que"}) {
          my @posinuevos = @{$ref->{"lista$que"}};
 #         $que eq 'PEDIDOS' and map ($_ = $ref->{VALOR}->{$_},@posinuevos);
          foreach (@posinuevos) {
              next if $yaesta{$_};
              $yaesta{$_} = 1;
              $defque{$_} = $que; 
          };
      };
  };
  impr_debug(__LINE__.' Cont %defque',Dumper \%defque);
  $ref->{USA} = {};$ref->{USAb} = {};$ref->{NOUSAP} = [];
  foreach (@reruns) {
      /^P/ and $ref->{USA}->{$_} = 2;
      $yaesta{$_} = 1;
      $defque{$_} = 'PPARAMETROS'; 
  };
  foreach my $key (keys %defque) {
      my $dedonde = $defque{$key};
      impr_debug(__LINE__.' Cont $key,$dedonde',[$key,$dedonde]);
      if ($dedonde eq 'DATOS)') {
          $ref->{USA}->{$key} = 2;
      } elsif ($dedonde eq 'PEDIDOS') {
          my $usado = $ref->{VALOR}->{$key};
          if ($usado ne 'TIEMPO') {
             $ref->{USA}->{$usado} = 2; 
          };
      };
  };
  impr_dependencias(__LINE__.' Cont primarias',$ref);
  impr_debug(__LINE__.' Cont TIPOTOK',$ref->{TIPOTOK}); 
  impr_debug(__LINE__.' Cont USA', $ref->{USA});
  my @nuevos = sort keys %{$ref->{USA}};
  impr_debug(__LINE__.' Cont TIPOTOK',$ref->{TIPOTOK});  
  while (@nuevos) {
      impr_debug(__LINE__.' Cont @nuevos',\@nuevos);
      my @nuetokens;
      my $key = shift @nuevos; 
      impr_debug(__LINE__.' Cont $key USA->{$key}',[$key,$ref->{USA}->{$key}]);
#      impr_debug(__LINE__.' Cont USA',Dumper $ref->{USA});
      my $valortipotok = valor($ref,'TIPOTOK',$key);
      my $valortipo = valor($ref,'TIPO',$key);
      if ($valortipotok eq 's' and valor($ref,'TIPOTOK',"D$key") eq 'd') {
          $ref->{USA}->{"INICIAL$key"} += 2; # deben llegar al sceptre
          $ref->{USA}->{"D$key"} += 2;
          push @nuetokens,"D$key";
      } elsif ($valortipotok =~ /[adp]/) {
          my @tokens = @{$ref->{REFARG}->{$key}}; 
          impr_debug(__LINE__.' Cont @tokens',\@tokens);
          @tokens = grep(do {valor($ref,'TIPOTOK',$_)
            and valor($ref,'TIPOTOK',$_) ne 'S'}
           ,@tokens);
          impr_debug(__LINE__.' Cont @tokens',\@tokens);
          push @nuetokens,@tokens;
          impr_debug(__LINE__.' Cont @nuetokens',\@nuetokens);
          if ($valortipo =~ /[gqt]/) {
              map(do{$ref->{USA}->{$_}+=2},@tokens);
          } else {
              map(do{$ref->{USA}->{$_} ++},@tokens);
          };
      } elsif (lc($valortipotok) =~ /[gkq]/) {
	  $ref->{USAFUN}->{$key}++;
          lc($valortipotok) eq 'q' and push @nuetokens,$key;
      } elsif ($valortipotok eq 'T') {
          $ref->{USATAB}->{$key}++
      } elsif ($valortipotok eq 'b') {
          $ref->{USAb}->{$key} += 2;
          my @tokens = @{$ref->{REFARG}->{$key}}; 
          impr_debug(__LINE__.' Cont @tokens',\@tokens);
          @nuetokens = grep(do {valor($ref,'TIPOTOK',$_) and 
             valor($ref,'TIPOTOK',$_) ne 'S'},@tokens);
          impr_debug(__LINE__.' Cont @tokens',\@tokens);
          map (do{$ref->{USA}->{$_} += 2},@nuetokens); 
      } elsif ($valortipotok eq '' or $valortipotok =~ /[sSf]/) {
      } elsif ($valortipotok eq 'P') { 
          my $valor = $ref->{VALOR}->{$key};
          my $tipotok = valor($ref,'TIPOTOK',$valor);
          if (not $ref->{parscreados}->{$valor} and $tipotok =~ /[apd]/) {
	      $ref->{USA}->{$valor}++;
              push @nuetokens,$valor;
          };
      } else {
          error_progr($ref,__LINE__." Cont tipotok de $key desconocido $valortipotok");
      };
      impr_debug(__LINE__.' Cont @nuetokens',\@nuetokens);

      @nuetokens = grep (do{not $yaesta{$_}},@nuetokens);
      map($yaesta{$_} = 1, @nuetokens);
      push @nuevos,@nuetokens;
      impr_debug(__LINE__.' Cont $ref->{USA}',Dumper $ref->{USA}); 
  }; #while @nuevos
  impr_debug(__LINE__.' Cont $ref->{USA}',Dumper $ref->{USA}); 
  impr_listas_que(__LINE__.' Cont',$ref
    ,['PARAMETROS','PPARAMETROS','DPARAMETROS'],'lista');
  foreach (@{$ref->{listaPPARAMETROS}},@{$ref->{listaDPARAMETROS}}) { 
      if (not $ref->{USA}->{$_} and not $ref->{USAb}->{$_}
          and not $ref->{TIPO}->{$_} eq '0') {
          push @{$ref->{NOUSAP}},$_; $ref->{TIPOTOK}->{$_} = 'P';
      };
  };  
  impr_dependencias(__LINE__.' Cont',$ref);
  impr_datos(__LINE__.' Cont',['TODOS'],$ref);
  my @usados1 = grep (do{$ref->{USA}->{$_} < 2}, keys %{$ref->{USA}}); 
  impr_debug(__LINE__.' Cont @usados1',\@usados1);
  my @xsustit = grep(do {valor($ref,'TIPOTOK',$_) =~/[dp]/
                        },@usados1);
  my @nsustit = grep(do {valor($ref,'TIPO',$_) =~/[no]/ and
                         valor($ref,'TIPOTOK',$_) ne 'b'
                        }, @usados1); 
  my @Ssustit = grep(valor($ref,'TIPO',$_) eq 'S', @usados1);
  impr_datos(__LINE__.' Cont contr_dependencias',['TODOS'],$ref);
  impr_debug(__LINE__.' Cont @xsustit,||,@nsustit,||,@Ssustit'
     ,[@xsustit,'||',@nsustit,'||',@Ssustit]);
  if (@xsustit or @nsustit or @Ssustit) { 
      $coderr = depurar_dependencias($ref,\@xsustit,\@nsustit,\@Ssustit); 
      if ($coderr) { 
          comfin('finc controlar_dependencias',$coderr);
          return $coderr;
      } else {
      impr_debug(__LINE__.' Cont @xsustit,||,@nsustit,||,@Ssustit'
     ,[@xsustit,'||',@nsustit,'||',@Ssustit]);
          foreach my $par (@xsustit,@nsustit,@Ssustit) {
	      delete $ref->{USA}->{$par};
              push @{$ref->{NOUSAP}},$par; $ref->{TIPOTOK}->{$par} = 'P';
          };
      };
  };
  impr_dependencias(__LINE__.' Cont',$ref);
#  pars_archivo($ref);
 # impr_datos(__LINE__.' Cont',['PARAMETROS'],$ref);
  impr_datos(__LINE__.' Cont contr_dependencias',['TODOS'],$ref);
#  pro_controlar_def($ref) if scalar keys %{$ref->{USA}};
#  map(do{$ref->{TIPOTOK
  comfin('finc controlar_dependencias',$coderr);
  return $coderr;
}#controlar_dependencias
# ---------------------------------------------------------------------------
sub controlar_keys_iniciales{
  comfin('comc controlar_keys_iniciales', @_);
  my $refarch = $_[0]; my $ref = $refarch->{INICIALES};
  my @listainicialesori = @{$refarch->{listaINICIALES}};
  #impr_debug(__LINE__.' Cont listaINICIALES', $refarch->{listaINICIALES});
  my @lisini =();
  #impr_datos(__LINE__.' Cont keys_inic', ['TEMP','temp'], $refarch);
  # se ignoran errores provenientes de haber modificado el diagrama
  # eliminando partes
  my @lisnoborrada;
  foreach my $key (@listainicialesori) {
      $key =~ /^;/ and do{push @lisini, $key; push @lisnoborrada, $key; next}; 
      my ($pal1,$numpar,$reflista) 
           = controlar_sintaxis_simple('INICIALES',$key); 
      if ($numpar > 1) {
           parar1(85,$refarch,
             "Más de un par de paréntesis en $key para  (INICIALES)"); 
      }; 
      my ($cont1) = (@$reflista,'');
      my @octeto  = buscar_abreviaturas( #controlar_keys_iniciales
                   $refarch, $pal1,$cont1,'INICIALES');
      #impr_debug(__LINE__.' Cont octeto para '. "$pal1 $cont1", \@octeto);
      my ($tipo, $plantilla, $eleparnodo, $cont0, $palequiv
                     ,$pala,$propio,$cont00) 
          = @octeto; 
      $tipo eq 'e' and do{
	  avnoseent("dar un valor inicial relacionado con algo inexistente
                     $key");
          borrar_datos($refarch,'INICIALES',$key,''
               ,__LINE__.' Cont keys_ini');
          next;
      };
      $tipo eq 'p' and not defined $refarch->{PARAMETROS}->{"D$key"} and do{
	  avnoseent("dar valor inicial a un parametro que no hay que integrar
                   $key");
          borrar_datos($refarch,'INICIALES',$key,1
               ,__LINE__.' Cont keys_ini');
          next;
      };
      #impr_debug(__LINE__.' Cont octeto para '. "$pal1 $cont1", \@octeto);
      $cont00 eq '' or 
          parar1(86,$refarch,"Error de sintaxis en $key (INICIALES)");
      if ($tipo eq 'a') {
           if ($eleparnodo =~ /^E/ and $palequiv eq 'V'    
                or $eleparnodo =~ /^J/ and $palequiv eq 'I') {
                        parar1(87, $refarch
                 , "A las fuentes no se le pueden asignar valores iniciales;
                      dato incorrecto: $key");
           } else {
                  $eleparnodo = "$palequiv$eleparnodo";
           };
       } elsif  ($palequiv eq 'V' and $tipo eq 'm') {
	   my $listaC = $refarch->{cualesEC}->{"$eleparnodo-0"}; my @listaC;
           my $listaC1 = $refarch->{cualesEC}->{$eleparnodo};
           defined $listaC and @listaC = @$listaC;
           defined $listaC1 and push @listaC, @$listaC1;
           if (defined $listaC) {
	       my @listaC = grep (/^C/, @$listaC);
	    };
	    @listaC  or do {
	         avnoseent
                    ("asignar valor inicial para un nodo si no está asociado 
                    a un acumulador a tierra (INICIALES)");
                 borrar_datos($refarch,'INICIALES',$key,''
                      ,__LINE__.' Cont keys_ini');
		 next; 	    };
            $eleparnodo = "V$listaC[0]";  
       } elsif ($tipo eq 't') {
             parar1(88,$refarch
	    ,"No asigne valor inicial para el tiempo en el cuadro INICIALES");
       };
       if ($eleparnodo) { 
           if ($eleparnodo =~ /^VE/i or $eleparnodo =~ /^IJ/i) {
                        parar1(83, $refarch
                 , "$key se refiere a $eleparnodo; y a las fuentes 
             no se le pueden asignar valores iniciales");
	   }; 
           push @lisini, $eleparnodo;
           push @lisnoborrada, $key; 
           mover_datos($refarch,'INICIALES',$key
                       ,$refarch,'INICIALES',$eleparnodo
                   , __LINE__.' Cont contr.inikey');
           if ($key ne $eleparnodo) {
                $refarch->{INIoriginal}->{$eleparnodo} = $key;
           };
      } else {
            parar1(89,$refarch,"$key no indica ningún valor inicial");
      };  
  }; #foreach
  my @listainiciales = union_conorden (@lisini);
  @listainicialesori = union_conorden (@listainicialesori);
  #my @depulisiniori = grep ($_ !~ /^;/, @listainicialesori);
  @listainiciales ==  @lisnoborrada or do{
     my $cualesori = join ' , ',  @lisnoborrada;
     my $cuales = join ' , ', @listainiciales;
     parar1(84, $refarch
        ,"Hay más de un valor inicial para una misma variable del Sceptre
        datos para: $cualesori
        se refieren a   $cuales");
  };    
  #impr_debug(__LINE__.' Cont listaINICIALES', $refarch->{listaINICIALES});
  #impr_debug(__LINE__.' Cont INICIALES', $refarch->{INICIALES});
  $refarch->{listaINICIALES} = \@lisini;
  #impr_debug(__LINE__.' Cont listaINICIALES', $refarch->{listaINICIALES});

  comfin('finc controlar_keys_iniciales',@lisini
           , ['INICIALES'],$refarch);
}#controlar_keys_iniciales  
#----------------------------------------------------------------------------
sub controlar_pedidos_resultados{
  comfin('comc controlar_pedidos_resultados',@_);
  my ($ref, @listapedidos) = @_;
  $ref->{talcualmalos} = [];
  #detecta posibles ambigüedades y prepara pedido de resultados
  #impr_datos(__LINE__.' Cont c_ped._resultados', ['TEMP','temp'], $ref);
  foreach my $pedido (@listapedidos) {
      impr_debug(__LINE__.' Cont $pedido', $pedido);
      my ($tipo,$plantilla,$sceptre, $palequiv,$pala, $propio,$dentro ) 
           = controlar_pedido($ref,$pedido); 
      #si hizo falta, ya paró     
      $dentro ne '' or $dentro = $propio;
      my @listadentro = split /\s*\,\s*/, $dentro;
      my $cuantos = scalar @listadentro;
      if ($cuantos !~ /^[13]$/) { 
           @listadentro = ($listadentro[0]); 
          avnograv("Pedido de resultado incorrecto; lo interpretamos:
              $pedido   =>    $sceptre($listadentro[0])"); 
      };
      $dentro = join ',',@listadentro;
      #impr_debug(__LINE__.' Cont $sceptre $dentro $tipo $palequiv'
      #       , [$sceptre,$dentro,$tipo,$palequiv]);
      completar_guardarref_pedido($ref
            ,$tipo,$plantilla,$sceptre, $palequiv,$pala, $propio,$dentro); 
  };
  @{$ref->{talcualmalos}} and 
      avnoseent("los pedidos de resultados
          @{$ref->{talcualmalos}}");
  comfin('finc controlar_pedidos_resultados',@{$ref->{listapedidos}}
      ,' sceptre: ' ,@{$ref->{listasceptre}},' tiparg: ',$ref->{tiparg});
  return ''; 
} #controlar_pedidos_resultados
#----------------------------------------------------------------------------
sub controlar_sintaxis_simple{
#se usa para pedido de resultados y keys de iniciales
# debe ser una palabra y uno o dos parentesis
#devuelve codigo de error (numera>0 0 '') y
#una cuaterna con '', la palabra, núm de parentesis, y referencia a  
#lista de contenidos de parentesis
  my ($quien,$pedido) = @_;
  my ($palabra,$numpar,$reflista);
  $pedido !~ /[\(\)]/  and return ($pedido,0,[]);
  my $pedidoori = $pedido;
  $pedido =~ s/\)\s*$// or do{
     parar1(70,$refglobal,"Debiera terminar con paréntesis: $pedidoori ($quien)"
                 , $CORTO);
  };
  if ($pedido !~ s/^\s*(\w[^\(\)]*)//){
     parar1(71,$refglobal,"No empieza con variable: $pedido ($quien)", $CORTO);
  };
  $palabra = $1;
  $palabra =~ /^\D/ or do {parar1(72
    , $refglobal,"Debiera comenzar con letra $pedidoori ($quien)",$CORTO);
  };
  $palabra =~ s/\s*$//;
  $pedido =~ s/^\(\s*//  or do {parar1(73
    ,$refglobal,"Paréntesis mal apareados en  $pedidoori ($quien)",$CORTO);
      #juntar por paren controla esto?
  };
  my @lista = split /\)\s*\(/, $pedido;
  my @listamal = grep (/[\(\)]/, @lista);
  @listamal and do {parar1(74
    ,$refglobal,"Paréntesis incorrectos en $pedidoori ($quien)".$CORTO);
  };
  return ($palabra,scalar @lista,\@lista);
}#controlar sintaxis
#---------------------------------------------------------------------------
sub controlar_pedido{ 
  comfin('comc controlar_pedido',@_ );
  my ($ref, $pedido) = @_; 
  #impr_debug(__LINE__.' Cont $pedido (oori)', $pedido);
  #se admite una palabra y uno o dos pares de parentesis 
  #devuelve un codigo de error o 
  my ($pal1,$numpar,$reflista)
      = controlar_sintaxis_simple('RESULTADOS', $pedido); 
  #ya paro si hubo errores de sintaxis
  #impr_debug(__LINE__.' Cont $cod_err,$pal1,$numpar'
  #          , [$pal1,$numpar]);
  if ($numpar >2) {
      parar1(75,$ref,"Más de dos pares de paréntesis en $pedido (RESULTADOS)");
  }; 
  my ($cont1,$cont2) = (@$reflista,'',''); #para que no queden indefinidos

  my @octeto = buscar_abreviaturas(   #controlar_pedido
				      $ref, $pal1,$cont1,'RESULTADOS');
  @octeto == 1 and do{#ambigÜedad
      explic("(en el pedido de RESULTADOS  $pedido)");
      parar1($octeto[0],$ref);
  };
  #impr_debug(__LINE__.' Cont @octeto' ,\@octeto);
  my ($tipo, $plantilla, $eleparnodo, $cont0, $palequiv,$pala,$propio,$cont00) 
          = @octeto; 
  $tipo eq 'e'  and do{
        push @{$ref->{talcualmalos}}, $pedido;
        return 'e',0,'??','??','??',$pedido,$pal1.',??,??';
  }; 
  my $dentro;
  if ($cont00 ne '' and $cont2 eq '') {
      $dentro = $cont00;
  } elsif ($cont00 eq '') {
      $dentro = $cont2;
  } elsif ($cont2 ne '') {
      avnoseent("$pedido (RESULTADOS)");
           return 'e',0,'??','','',$pedido,,$pal1.',??,??';
  };
  my $sceptre ;
  if ($tipo eq 'a') {
      if ($eleparnodo =~ /^E/ and $palequiv eq 'V' 
          or $eleparnodo =~ /^J/ and $palequiv eq 'I') {
          $sceptre = $eleparnodo; 
      } elsif ($palequiv eq 'V') { 
         my $ped1 = $ref->{TEMP}->{$eleparnodo};
         defined $ped1 and $sceptre = $ped1  or $sceptre = "V$eleparnodo";
     } elsif ($palequiv eq 'I') {
         $sceptre = "$palequiv$eleparnodo";
     } else {
         $sceptre = $eleparnodo;
     }; 
  } elsif  ($tipo eq 'm')  { #esta es 'n' de nodo 
      my $ped1 = $ref->{TEMP}->{$eleparnodo};
      if (defined $ped1) {
          $sceptre = $ped1;
      } else {
          $sceptre = cerofuentear($ref, $eleparnodo) 
      };             
  } elsif ($tipo eq 'p') {
      my $ntipo = $ref->{TIPPARAMETROS}->{$eleparnodo};
      $sceptre = $eleparnodo; 
      #impr_debug(__LINE__.' Cont $tipo,$ntipo,$plantilla,$eleparnodo '
      #		 ,[$tipo,$ntipo,$plantilla,$eleparnodo]);
      #seguro está definido, salvo que el parametro este dado por su derivada
      if (not defined $ntipo) {
      } elsif (lc($ntipo) =~ /[pa]/) {
          #impr_dat_que($eleparnodo,'PARAMETROS',
          #            __LINE__.' Cont se cambia para sceptre', $ref,'cp'); 
	  $sceptre  = $ref->{PARAMETROS}->{$eleparnodo};
      } elsif (lc($ntipo) eq 'm') {
	  #impr_debug(__LINE__.' Cont VIEJOPARAMETROS '
          #     ,Dumper $ref->{VIEJOPARAMETROS});
	  #impr_debug(__LINE__.' Cont TIPVIEJOPARAMETROS '
          #     ,Dumper $ref->{TIPVIEJOPARAMETROS});
	  my $viejo = $ref->{VIEJOPARAMETROS}->{$eleparnodo};
	  my $tipviejo = $ref->{TIPVIEJOPARAMETROS}->{$eleparnodo};
          defined $viejo and $tipviejo =~ /[pa]/ and $sceptre = $viejo;
      #} else {
      #    $sceptre = $eleparnodo;
      };
  } elsif ($tipo eq 't') {
      $sceptre = 'TIME';   
  };
  comfin('finc controlar_pedido','
       "",$tipo,$plantilla,$sceptre,$palequiv,$pala,$propio,$dentro
    ', '',$tipo,$plantilla,$sceptre,$palequiv,$pala,$propio,$dentro );
  #impr_debug(__LINE__.' Cont  cont_p_resultado retorno'
  #       ,[$tipo,$plantilla,$sceptre,$palequiv ,$pala,$propio,$dentro]);
  return $tipo,$plantilla,$sceptre,$palequiv ,$pala,$propio,$dentro;
} # controlar_pedido
#---------------------------------------------------------------------------
sub controlar_conex_ramas{#controla enganches ramas
  comfin('comc controlar_conex_ramas',@_);
  my $refgraf = $_[0];
  my ($lisramas, $lisramasuna, $lisramassueltas,
        $lisramasquerepiten, $lisramasauxiliares) =
     @$refgraf{'lisramas','lisramasuna', 'lisramassueltas',
              'lisramasquerepiten', 'lisramasauxiliares'};
  if (@$lisramasquerepiten) {
      my $puntos ='';
      foreach my $rama (@$lisramasquerepiten) {
         foreach (@{$refgraf->{conexiones}->{$rama}}) {
	     $puntos .= $_->{lugar};
         };
         $puntos .= "\n";
      };         
      parar1(66,$refgraf->{refcirc}
       ,"Hay ramas repetidas entre los puntos de coordenadas:\n    $puntos");
  };
  if (@$lisramasuna + @$lisramassueltas) {
      do{
         explic(
	     "\nHay ramas no bien conectados (o conectados a algo inútil,
          en $refgraf->{archivo}");
          if (@$lisramasuna) { 
              my $mens10 = scalar @$lisramasuna; 
              my (@mens11, $mens11); 
              foreach my $rama (@$lisramasuna) { 
                 push (@mens11, $refgraf->{lugpuntos}->{$rama}->[0] .
		       $refgraf->{lugpuntos}->{$rama}->[-1]."
                        sólo bien conectado en " .
                        "$refgraf->{conexiones}->{$rama}->[0]->{lugar}"), 
              };               
              $mens11 = join "\n  ",@mens11 ;  
	      parar1(66,$refgraf->{refcirc}
               ,"$mens10  ramas con un solo enganche bueno:\n    $mens11");
	  };
          my $cuantas = scalar @$lisramassueltas; my $mens0 ;
           if ($cuantas) { 
              $mens0 = scalar @$lisramassueltas . 
		          ' con ningún enganche bueno;' . "\n";
              foreach my $rama (@$lisramassueltas) {
                  $mens0 .= 
                  "Puntos de la rama en   @{$refgraf->{lugpuntos}->{$rama}}\n";
              };
              avnograv('Hay ramas inútiles: ' . $mens0);
          };      
      }; #do
  };
  comfin('finc controlar_conex_ramas');
}#controlar_conex_ramas
# ---------------------------------------------------------------------------
sub controlar_pertinencia_pars{ return;
  comfin('comc controlar_pertinencia_pars',@_);
  my $ref = $_[0];
  my (@dpars,%esdpar,@ipars);
  if (@{$ref->{val}->{DPARAMETROS}}) {
      foreach my $refterna (@{$ref->{val}->{DPARAMETROS}}) {
          push @dpars,@{$refterna->[1]};
          foreach my $dpar (@{$refterna->[1]}) {
              (my $parreal = $dpar) =~ s/^.//;
              $esdpar{$parreal} = 1;
          };
      };
  };
  if (@dpars == 0 and @{$ref->{val}->{DINICIALES}}) {
    mensajear(" No hay parametros a integrar; no se necesitan valores iniciales;
     se ignoran");
      $ref->{DINICIALES} = [];
      comfin('finc controlar_pertinencia_pars');
    return;
  };
  if (@dpars and @{$ref->{val}->{DINICIALES}}) {
      my @ternasnue;
      my @refiniciales = @{$ref->{val}->{DINICIALES}};
      foreach my $refterna (@refiniciales) {
          my @listanue;
          foreach my $ipar (@{$refterna->[1]}) {
              (my $parreal = $ipar) =~ s/^INICIAL//;
              if ($esdpar{$parreal}) {push @listanue,$ipar;
              } else {
                  my $mensaje
                     = " No se entiende asignar un valor inicial a $parreal
                  se ignora";
	          mensajear($mensaje);
                  push @{$refboxes{$refterna->[2]}->{ERRORES}},$mensaje;
              };
          };
          @listanue and push @ternasnue
	      ,[$refterna->[0],\@listanue,$refterna->[2]];
      };
      @{$ref->{val}->{DINICIALES}} = @ternasnue;
  };
  impr_campo(__LINE__.' Cont $ref',$ref,'val','DINICIALES');
  if (@dpars and @{$ref->{val}->{RESTOS}}) {
      my @refternas = @{$ref->{val}->{RESTOS}};     
      my (@ternasnueRESTOS,@ternasnueDINICIALES);
      foreach my $refterna (@refternas) {
          impr_debug(__LINE__.' Cont $refterna',Dumper $refterna);
          my (@listanueRESTOS,@listanueDINICIALES); 
          foreach my $parreal  (@{$refterna->[1]}) {
              impr_debug(__LINE__.' Cont $parreal',$parreal);
              if ($esdpar{$parreal}) {
        	  mensajear
                   (" Simusol no esperaba $parreal en un cuadro PARAMETROS");
                   push @listanueDINICIALES,"INICIAL$parreal";
              } else {
                   push @listanueRESTOS, $parreal;
              };
              impr_debug(__LINE__.' Cont'
                ,[@listanueDINICIALES,'||',@listanueRESTOS]); 
         };
         @listanueRESTOS and push @ternasnueRESTOS
           ,[$refterna->[0],\@listanueRESTOS,$refterna->[2]];
         @listanueDINICIALES and push @ternasnueDINICIALES
           ,[$refterna->[0],\@listanueDINICIALES,$refterna->[2]];
      };
      impr_debug(__LINE__.' Cont'
		 ,Dumper [@ternasnueDINICIALES,'||', @ternasnueRESTOS]);
      @ternasnueDINICIALES and 
	push @{$ref->{val}->{DINICIALES}},@ternasnueDINICIALES;   
      $ref->{val}->{RESTOS} = \@ternasnueRESTOS;
  }; 
  impr_campo(__LINE__.' Cont $ref',$ref,'val','DPARAMETROS'); 
  impr_campo(__LINE__.' Cont $ref',$ref,'val','DINICIALES'); 
  impr_campo(__LINE__.' Cont $ref',$ref,'val','RESTOS'); 
  comfin('finc controlar_pertinencia_pars');
  return;
}#controlar_pertinencia_pars;
# ---------------------------------------------------------------------------
sub controlor_repetidos_datos_pars_inis{
  comfin('comc controlar_repetidos_datos_par_inis',@_);
  my $ref = $_[0]; my $coderr= '';
  my (@listarepes,%hashrepe);
  my $refhashvar = $ref->{cualnumvar};
  foreach my $cosa (sort keys %{$refhashvar}) {
      if (@{$refhashvar->{$cosa}}>1) {
          push @listarepes, $cosa;
          $hashrepe{$cosa} = 1;
      };
  };
  impr_debug(__LINE__.' Cont %hashrepe',Dumper \%hashrepe);
  @listarepes = union_conorden(@listarepes);
  my %hashnum;
  if (@listarepes) {
      mensajear (" Hay definiciones repetidas:");
      foreach my $cosa (@listarepes) {
          my @valores;
          my $mensaje = "          $cosa en      ";
          my @cuadros = @{$refhashvar->{$cosa}};
          @valores = union_conjunto @valores;
          map ($_ = descripcion_cuadro($_),@cuadros);
          my $cuadros = join "\n     ", ('',@cuadros);
          $mensaje .= "\n    ".$cuadros;
          if (@valores == 1) {
              $mensaje .= "pero todas asignan el mismo valor $valores[0]";
          } else {
              $ref->{repetidosnose}->{$cosa} = \@valores;
          };
          mensajear($mensaje);
      };
      impr_debug(__LINE__.' Cont repetidosnose',Dumper $ref->{repetidonose});
#  } else {
#     impr_debug(__LINE__.' Cont',' Sin repetidos');
     comfin('finc controlar_repetidos_datos_par_inis',$coderr);
     impr_debug(__LINE__.' Cont repetidosmalos', $ref->{repetidosmalos});
     return $coderr; 
  };

  foreach my $pal (qw (DATOS VIINICIALES DPARAMETROS DINICIALES RESTOS)) {
      my @reffnose;
      @{$ref->{val}->{$pal}} or next;
      my @todos = @{$ref->{val}->{$pal}};
      my @todosnue = @todos; my $reftodosnue = \@todosnue; 
      impr_campo(__LINE__.' Cont $ref',$ref,'val',$pal);
      my (%valores,%nums,@totalcosas);  
#      impr_debug(__LINE__.' Cont @todos',Dumper \@todos);
      my (@reffquedan);
      foreach my $reff (@todos) {
          my ($numobj,$reflista,$valor)  = @$reff;
          if (not $hashnum{$numobj}) {#no parece haberse llenado numca REVISAR
              push @reffquedan,$reff;
          } else {
              my @listacosas = grep (do{$hashrepe{$_}},@$reflista);
              my @listanocosas = grep (do{not $hashrepe{$_}},@$reflista);
              @listanocosas and
                  push @reffquedan,[$numobj,\@listanocosas,$valor];
              @listacosas and 
                  push @reffnose,[$numobj,\@listacosas,$valor]; 
	  };
      };
      @{$ref->{val}->{$pal}} = @reffquedan;
      if (@todos == @reffquedan) {
          next;
      }; 
      impr_campo(__LINE__.' Cont $ref permanecen',$ref,'val',$pal);
      $coderr = depurar_repetidos_par_ini($ref,$pal,\@reffnose);
      $coderr and last;
  }#$pal
  impr_campo(__LINE__.' Cont $ref',$ref,'val');
  comfin('finc controlar_repetidos_par_ini',$coderr);
  return $coderr;
}#controlar_repetidos_datos_pars_inis
#---------------------------------------------------------------------------
sub controlar_uso_def_argumentos{# solo carga $ref->{USAFUN},etc
  comfin('comc controlar_uso_def_argumentos', @_);
  my ($ref,$lisque) = @_;
  my $listarg = $ref->{listaarg}; my $sonarg;
  # impr_debug(__LINE__.' Cont argumentos',$listaarg);
  map($sonarg->{$_} = 1,@{$ref->{listaarg}});
  # impr_debug(__LINE__.' Cont sonarg',$sonarg);
  ($ref->{USAFUN}, $ref->{USAPAR} , $ref->{USATAB}, $ref->{USAVAR},
  $ref->{USAFUNX}) = Tablasfuncq::usados($lisque,$ref,$sonarg);
  impr_debug(__LINE__.' Cont USAFUN',$ref->{USAFUN});
  comfin('finc controlar_uso_def_argumentos');
}#controlar_uso_def_argumentos 
# --------------------------------------------------------------------------
sub controlar_modelo{ # sin sustituir nada;
  #se controla un modelo cuando es el principal o cuando es "bueno"
  # para el circuito 
  comfin('comc controlar_modelo', @_);
  my $refcirc = $_[0];
  my %nodext;my %nod;my %aignorar;
  my @nodos = sort keys %{$refcirc->{cualobjtextonodo}};
  my($comodin,@nodostot,@nodosext,@nodosint,@nodosint_rep,@nodosext_nousados
     ,@eles);
  $comodin = $refcirc->{comodin};
  if (@nodos) {
      @eles =  sort keys %{$refcirc->{cualobjele}};
      @nodostot = split ('-',$refcirc->{uni}->{$comodin})
	  if $refcirc->{uni}->{$comodin};
      @nodosext = grep( $_ !~ /^$comodin\s*$/,@nodostot);
      @nodosint = grep(do{$_ =~ /^$comodin\s*$/ and $_ ne '0'},@nodostot);
      #impr_debug(__LINE__.' Cont @nodosext ',  \@nodosext);  
      map(do{$nod{$_} = scalar @{$refcirc->{cualobjtextonodo}->{$_}}},@nodos);
      #impr_debug(__LINE__.' Cont %nod ',  \%nod);  
      @nodosext_nousados = grep(do{$nod{$_} != 2},@nodosext);
      @nodosint_rep = grep($nod{$_}>1,@nodosint);
  };
  foreach (@nodosint_rep) { 
     my @codigos; my @lista = @{$refcirc->{cualobjtextonodo}->{$_}};
     map($_ = $codlista->[$_],@lista);
     #impr_debug(__LINE__.' Cont ',\@lista);
     my @lisN = grep(/N/,@lista);
     @lisN and do{
	 porparar1(91,$refcirc, "$_ es un nodo repetido no anunciado");
         return 91;
     };     
  };
  if (@nodosext_nousados) {
      my $cuales = join ' ',@nodosext_nousados;
      porparar1(92,$refcirc
        ,"Hay nodos exteriores no usados en el modelo (o internos 
               que no terminan en $comodin): $cuales");
	       return 92;
  };
  $nodext{0} = 1;
  map($aignorar{"TEMP_$_"} = 1, @nodos);
  map($aignorar{$_} = 1, keys %{$refcirc->{ARGUS}});
  map($aignorar{$_} = 1, keys %{$refcirc->{PARAMETROS}});
  #impr_debug(__LINE__.' Cont argus',  $refcirc->{ARGUS});
  #impr_debug(__LINE__.' Cont parametros',  $refcirc->{PARAMETROS});
  #impr_debug(__LINE__.' Cont cualobjele',  Dumper $refcirc->{cualobjele});
  foreach (keys %{$refcirc->{cualobjele}}) {
      /$comodin$/  or do{
          porparar1(94,$refcirc
              ,"El nombre $_ no es bueno para un elemento en el modelo;  
                    debe terminar en $comodin");
          return 94  
      };
  };
  #print 'Cont '. __LINE__ .' @nodos',join(' ',@nodos),"\n"; 
  #impr_hash('Cont ' . __LINE__ . ' %nodext ',%nodext); 

  #impr_debug(__LINE__.' Cont ', \@nodosext);
  #impr_debug(__LINE__.' Cont',Dumper $refcirc->{nodorepe});
  controlar_uso_def_argumentos(  #en controlar_modelo
        $refcirc,['DATOS','PARAMETROS','RESULTADOS']);
  #impr_debug(__LINE__.' Cont aignorar',  \%aignorar);
  controlar_var($refcirc, \%aignorar);#en controlar_modelo
  if ($avisosgrav) {
      porparar1(90, $refcirc);
      return 90;
  };
  comfin('finc controlar_modelo' ); 
  return '';
}#controlar_modelo
# --------------------------------------------------------------------------
sub controlar_circ{ # sin sustituir nada; no para elementos
  comfin('comc controlar_circ', @_);
  my ($ref,$codcirc) = @_;
  impr_campo(__LINE__.' Cont $ref',$ref,'cualobjele');
  my $cualobjele = $ref->{cualobjele};
  my (@valorsinelemdef,@elemsinvalor,@valorconraro);
  if ($ref->{listaDATOS}) {
      foreach my $keydato (@{$ref->{listaDATOS}}) {
          next if $ref->{TIPOTOK}->{$keydato};
          #impr_debug(__LINE__.' Cont $keydato', $keydato);
          my $lisobj = $cualobjele->{$keydato};
          if ($lisobj and @$lisobj) {
              my $obj = $lisobj->[0]; 
#              $ref->{ELESPLANT}->{$keydato} = $plantillalista->[$obj];
#ya lo hace deszetar
              next;
          };
          next if $keydato =~ /^D([EJ].*)/ and defined $cualobjele->{$1};
          # lo anterior no puede ocurrir
          $keydato =~ /^(.)(.+)$/;
          my ($cod,$texto) = ($1,$2);
          if (defined $ref->{cualobjnoigno}->{"Z$texto"}  ) {
              my @cuales = @{$ref->{cualobjnoigno}->{"Z$texto"}};
              @cuales = grep ($codlista->[$_] !~ /[RLECJnN]/, @cuales);
              map($_ = $lugarlista->[$_],@cuales);
              push @valorsinelemdef, @cuales;
          } elsif ($keydato =~ /^M/) {#no tienen un objeto grafico asociado 
              push @valorconraro, $keydato;
          };    
      };
  };
  if (defined $ref->{NODOSPLANT} and scalar keys %{$ref->{NODOSPLANT}}) {
      foreach my $nodo (keys %{$ref->{NODOSPLANT}}) {
          if (defined $ref->{ELESPLANT}->{$nodo}) {
               porparar1(74,$ref,
            "Hay un elemento con igual nombre completo que el nodo $nodo"); 
              return 74;
          }; 
      };
  };
  #{VALOR} lo llena cargar_datos o cargar_datos_tipotok;
  my $codm;
  foreach (keys %$cualobjele) {
      /^(.)/;  $codm = uc($1);
      next if $codm eq 'T';
      if (not defined $ref->{VALOR}->{$_}) {
         push(@elemsinvalor,$_);
      };  
  };
  impr_debug(__LINE__.' Cont',\@elemsinvalor) if @elemsinvalor;
  my $j = 0; 
  impr_debug(__LINE__.' Cont listacortocircuitados'
             ,$ref->{listacortocircuitados});
  foreach my $ele (@elemsinvalor) {
      next if $plantillalista->[$cualobjele->{$ele}->[0]];
      #la plantilla Auxiliar tiene numero 0
#      cargar_datos($ref,'DATOS',$ele,0,'n',[0]);
#      delete $elemsinvalor[$j]; $j++;
  };
  #impr_debug(__LINE__.' Cont @elemsinvalor', scalar @elemsinvalor);
  #impr_debug(__LINE__.' Cont @valorsinelemdef',\@valorsinelemdef);

  if (@elemsinvalor or @valorsinelemdef) {
      if (@elemsinvalor) {
          avgrav(" Hay elementos que no recibieron valor:");
          map(mensajear(descripcion_iden_ref($_,$ref)),@elemsinvalor);
          
      };
      if (@valorsinelemdef) { #esto ya no puede ocurrir
          avgrav(
          " Iconos no definidos para Simusol (@valorsinelemdef), con valor");
      };
      impr_debug(__LINE__.' Cont $ref->{clasearch}',$ref->{clasearch});
      $ref->{clasearch} eq 'circuito' and parar1(75,$ref) or
          do{porparar1(75,$ref); return 75};
  }; 
  if (@valorconraro) {
      avnograv("Objetos no identificados que recibieron valor;"
                . " se ignorarán" );# Que es esto?
      map(do{ /^(.)/;mensajear(" $quenombre{$1}  $_: $ref->{VALOR}->{$_}");
            delete $ref->{VALOR}->{$_};
          } ,@valorconraro); 
  };
  comfin('finc controlar_circ','');
  return '';
}#controlar_circ
# --------------------------------------------------------------------------
sub controlar_cadena_par_el{
  comfin('comc controlar_cadena_par_el',@_);
  my ($ref,$lisque) = @_;
  our $msgno = ' no';
  $opt_hash{cadena} and $msgno = '';
  our $recur = '';
  impr_listas_que('Cuadros para controlar_cadena '.__LINE__.' Cont ',$ref
      ,$lisque,'lista');
  #recursividad
  # si detecta cadena recursiva de parametros y/o datos, termina
  my @paramdats;
  foreach my $que (@$lisque) {
      push @paramdats, @{$ref->{"lista$que"}} if defined $ref->{"lista$que"};
  };
  # estoy anulando el calculo de @paramdats anterior
  @paramdats = sort (union_conjunto(@paramdats)); #en controlar_cadena_par_el
  impr_debug(__LINE__.' Cont @paramdats',\@paramdats);
  our (%hashinme,%libre); 
  #$hashinme contendra los que influyen, inmediatos, de cada elemento
        # ------------------------------------
        sub depurar_cadena{
          comfin('comc depurar_cadena', @_);
          my (@cadena) = @_;
          my $npar = pop @cadena;
          while ($npar ne $cadena[0]) {
              shift @cadena;
          };
          comfin('comc depurar_cadena');
          return @cadena,$npar;
        }#depurar_cadena
        # ------------------------------------
        sub prolongar_cadena{
          comfin('comc prolongar_cadena',@_);
          my ($refcadena,$refinme,$refhashcadena) = @_;
          #devuelva $cod,$refncadena,$refnhashcadena
          # $cod: 0: sin recursion; 182; con recursion; 
          my @cadena = @$refcadena; 
          my @inme = @$refinme; my %hash = %$refhashcadena;
          my ($refncad,$refnhash); 
          my $ultimo;
          my $recurprop = '';
          foreach my $npar (@inme) {
              ($libre{$npar} or not defined $hashinme{$npar}) and next;
              if ($hash{$npar}) {
                  my @redcadena = depurar_cadena(@cadena,$npar);
                  mensajear(
             "Se forma cadena recursiva,$msgno permitida, de asignaciones:
        ". join ('<=',@redcadena)
        ."\n  Si es aceptable la recursion utilice opcion -cadena");
                  $recur = 182; next;
              };
              $ultimo = $npar;
              push @cadena, $ultimo; $hash{$ultimo} = 1;
              ($recurprop,$refncad,$refnhash) 
                = prolongar_cadena(\@cadena,$hashinme{$ultimo},\%hash);
              if ($recurprop) {
                  $recur= $recurprop;
              } else {
                  $libre{$ultimo} = 1;
                  pop @cadena; delete $hash{$ultimo};
              };
          };
          if(defined $ultimo) {
              impr_debug(__LINE__.' Cont $ultimo',$ultimo);
              push @$refcadena, $ultimo; $hash{$ultimo} = 1;
              $libre{$ultimo} = 1;
          };
          comfin('finc prolongar_cadena');
          return $recur, $refcadena,\%hash; 
        }#prolongar_cadena
        # ----------------------------------------
  foreach my $par (@paramdats) {
      next if $par =~ /^;/; 
      next if valor($ref,'{TIPOTOK',$par) =~ /[Wij]/;
      $hashinme{$par} = [];
      my ($valor,$tipo,$tiparg,$refarg) = tomar_cua_datos($ref,$par);
      impr_dat(__LINE__.' Cont',$par,$ref,'cad');
      if ($tipo) {
          if ($tipo  =~ /^[onw]/) {
              $libre{$par} = 1;
              next;
          } else {
              impr_par(__LINE__.' Cont $par '.$par ,$tiparg,$refarg);
              my @esquema = split /\W+/, $tiparg;
              my @refarg = @$refarg;
              @esquema = grep do{$_ ne ''}, @esquema;
              impr_debug(__LINE__.' Cont $par,@esquema,$refarg'
                  ,[$par,'aaa',@esquema,'bbb',@$refarg]); 
             while (@refarg) {
                  my $sigpar = shift @refarg;
                  my $tipito = shift @esquema;
              impr_debug(__LINE__.' Cont $par,@esquema,@refarg'
                  ,[$par,'||',@esquema,'||',@refarg]); 
                  next if $tipito !~ /^[apd]/;
                  push @{$hashinme{$par}}, $sigpar;
              };
          };
      };
      @{$hashinme{$par}} = union_conjunto(@{$hashinme{$par}});
      @{$hashinme{$par}} or $libre{$par} = 1;
  }; # foreach
  impr_debug(__LINE__.' Cont hashinme',Dumper \%hashinme);
  impr_debug(__LINE__.' Cont %libre',Dumper \%libre);
  #impr_datos(__LINE__.' Cont',['PARAMETROS'],$ref);
  my ($cod,$refncad,$refnhash) = prolongar_cadena([],\@paramdats,{});
  #impr_debug(__LINE__.' Cont %libre',Dumper \%libre);
  impr_debug(__LINE__.' Cont $cod',$cod);
  #impr_debug(__LINE__.' Cont',$refncad);
  #impr_debug(__LINE__.' Cont $refnhash',Dumper $refnhash);
#  impr_listas_que('Cuadros para controlar_cadena '.__LINE__.' Cont ',$ref
#      ,$lisque,'lista');
  impr_datos(__LINE__.' Cont',['DATOS','PPARAMETROS','DPARAMETROS'],$ref);
  comfin('finc  controlar_cadena_par_el', $cod);
  parar1($cod, $ref,' se interrumpe la traducción') if $cod;
  return $cod;  
}#controlor_cadena_par_el    
# --------------------------------------------------------------------------
sub controlar_cadena_param{# para modelos o elementos??
  comfin('comc controlar_cadena_param', @_);
  # si detecta cadena recursiva de parametros y/o datos
  # termina luego de llamar a porparar
  my $refarch=$_[0];
#  impr_datos(__LINE__.' Cont',['DATOS','PARAMETROS','INICIALES'],$refarch);
  my @params = (keys %{$refarch->{PARAMETROS}}, keys %{$refarch->{DATOS}});
  @params = sort @params; #en controlar_cadena_param
 impr_debug(__LINE__.' Cont @params',\@params);
  my $hashinme = {}; #contendra los sigientes inmediatos de cada elemento
  foreach my $par (@params) {
      my %hashanterela;
      my ($valor,$tipvalor) = tomar_datos($refarch,'PARAMETROS',$par);
#      my $valor = $refarch->{PARAMETROS}->{$par} ;
#      my $tipvalor = $refarch->{TIPPARAMETROS}->{$par};
	  impr_debug(__LINE__.' Cont $valor,$tipvalor',[$valor,$tipvalor]);
      defined $valor 
        or do{
            $valor =  $refarch->{DATOS}->{$par};
            $tipvalor = $refarch->{TIPDATOS}->{$par};
            $valor =~ s/listalis\(\w+\,//;   
      };
      defined $valor or next; 
      next if $tipvalor  eq 'n';
      $valor = '(' . $valor .')';
      #impr_debug(__LINE__.' Cont $par $valor',[$par,$valor]);
      my $npar = $par;
      my $seguir = 1; 

      # @listita contiene parametros o datos que se va sabiendo hay 
      # que revisar
      # @listita pierde al primero luego de encontrados sus inmediatos
      # $hashinme: registra los siguientes inmediatos de cada elemento
      # %hashanterela, los anteriores relativos a la posible recurrencia 
      # desde $par 
      # %hash : los siguientes en general de $par
      my @listita = ();
      my %hash=();
      
      while ($seguir) {
#          if($par eq 'PDM2') {
#              print STDERR "seguimos?"; my $resp = <STDIN>;
#          };
            my @yacalculados = sort keys %$hashinme;
          if (not defined $hashinme->{$npar}) {
              $hashinme->{$npar} = [];
              while ($valor =~ s/\W\s*(([PRLCEJ])\w+)(\W)/$3/) {
                  $3 eq '(' and next;
                  my $pare = $1; my $tipo;
                  my $tippare = $refarch->{TIPPARAMETROS}->{$pare};
                  if (not defined $tippare) {
                      $tippare = $refarch->{TIPDATOS}->{$pare};
                      defined $tippare or $tippare = '?';
	          };
                  if ($tippare !~ /[n]/i
       # puede ser una variable de la simulacion o un parametro integrado 
                      and not defined $refarch->{PARAMETROS}->{"D$pare"}) {
                      push @{$hashinme->{$npar}},$pare; 
	          };              
              }; # while valor        
          };
          my @inmediatosrela = grep(do {not defined $hash{$_}}
                                    , @{$hashinme->{$npar}}); 
          # @inmediatosrela contiene los siguientes inmediatos
          #  que no han sido anteriores
          if (@inmediatosrela == 0) {
              delete $hash{$npar}
          } else {
              foreach my $pare (@inmediatosrela) {
                  not defined $hashanterela{$pare} and
                              $hashanterela{$pare} = $npar; 
                  $pare eq $par and 
		      do {my @listota = ($pare); my $ante = $npar;

                      while ($ante ne $par) {
			  unshift @listota, $ante;
                          $npar = $ante;
                          $ante = $hashanterela{$npar};
                      };
                      parar1(182,$refarch,
                      "Se forma cadena recursiva de parámetros y/o datos:
                      desde $par se llega a @listota");
                      return 182; 
		  };
              }; 
              push @listita, @inmediatosrela;
              map(do{$hash{$_} = 1}, @inmediatosrela);
          };  
          if (@listita)  {# hay que sacar de @listita paraseguir
	      $npar = shift(@listita);
              defined  $refarch->{PARAMETROS}->{$npar} and
	        $valor = "($refarch->{PARAMETROS}->{$npar})"
	      or defined  $refarch->{DATOS}->{$npar} and do{
		    $valor = "($refarch->{DATOS}->{$npar})";
                    $valor =~ s/listalis\(\w+\,//;   
              }
	      or $seguir ='';	 
          } else {
	      $seguir = '';
	  };   #if else defined $pare
      };#while seguir
  };#foreach $par @params
  comfin('finc  controlar_cadena_parametros');
  return ''; 
}# controlar_cadena_parametros    
# --------------------------------------------------------------------------
sub controlar_iniciales_il_vc{#puede producir avisos
  comfin('comc controlar_iniciales_il_vc', @_);
  my $refarch = $_[0]; my @sininicial; my $coderr = '';
  my @listaself = grep (/^L/,keys %{$refarch->{cualobjele}});
  my @lista;
  foreach my $ele (@listaself) {
      if (not defined $refarch->{INICIALES}->{"INICIALI$ele"}) {
          push @sininicial, "I$ele";
      } else {
          push @lista, "I$ele";        
      }
  };
  my @listacap = grep (/^C/,keys %{$refarch->{cualobjele}});
  impr_debug(__LINE__.' Cont',\@listacap);
  impr_datos(__LINE__.' Cont',['INICIALES'],$refarch);
  foreach my $cap (@listacap) {
      if (not defined $refarch->{VALOR}->{"INICIALV$cap"}) {
          push @sininicial, "V$cap";
      } else {
          push @lista,"V$cap";
      };
  };
  impr_debug(__LINE__.' Cont @lista',\@lista);
  if (@sininicial) {
      mensajear("Sin valores iniciales para:
          @sininicial
        Sceptre tomaria valor 0");
      $coderr = 70;
       comfin('finc controlar_iniciales_il_vc',$coderr,['INICIALES'],$refarch);
       return $coderr;
  };
  my (@nonum,@tipoQ);
  foreach my $cosa (@lista) {
      my ($valor,$tipo,$tiparg,$refarg) 
        = tomar_cua_datos($refarch,"INICIAL$cosa");
      next if $tipo =~ /^[no]$/;
      push @nonum, $cosa;
  };
  impr_debug(__LINE__.' Cont @nonum',\@nonum);
  @tipoQ = grep($refarch->{TIPO}->{"INICIAL$_"} eq 'Q', @nonum);
  if (@tipoQ) { 
      $coderr = Tablasfuncq::evaluar_q_n($refarch,'INICIALES',@tipoQ);
      if (not $coderr) { 
          @nonum = grep(do{$refarch->{TIPO}->{"INICIAL$_"} =~ /^[no]$/
                           ; $_ = "INICIAL$_"}, @nonum);
      };
  }; 
  if (@nonum) {
      avgrav("Hay valores iniciales no numéricos para 
              @nonum");
      $coderr = 66;
  };
  comfin('finc controlar_iniciales_il_vc',$coderr,['INICIALES'],$refarch);
  return $coderr;
}#controlar_iniciales_il
# --------------------------------------------------------------------------
sub controlar_dpar_tiempos{
  comfin('comc controlar_dpar_tiempos',@_);
  my $ref = $_[0];
  my @dpars = grep (/^D/i,keys %{$ref->{PARAMETROS}});
  return unless @dpars;
  #impr_debug(__LINE__.' Cont CONTROLES ', Dumper $ref->{CONTROLES}); 
  my $stop = $ref->{CONTROLES}->{'STOP TIME'};
  return unless $stop =~ /\,/;
  parar1(229,$ref,"Al reiniciar una ejecución con tiempo tartido, 
       los parámetros a integrar vuelven a su valor inicial; 
       sería erróneo continuar el procesamiento");
} #controlar_dpar_tiempos
# --------------------------------------------------------------------------
sub controlar_iniciales_integr{#puede producir avisos graves
  comfin('comc controlar_iniciales_integr', @_);
  my ($ref,@lisparD) = @_;
  #en contr. integrables
  # los valores iniciales para parámetros a integrar no deben sustituirse
  # se pasan a INICIALES, si estaban en PARAMETROS
  my (@lisparDsinI);
  #impr_datos(__LINE__.' Cont', ['PARAMETROS','INICIALES'], $ref); 
  #impr_debug(__LINE__.' Cont' ,$ref->{listaPARAMETROS});
  #impr_debug(__LINE__.' Cont'  ,$ref->{listaINICIALES});
  foreach my $pard (@lisparD) {
      my $parverd = substr($pard,1);
      if (defined $ref->{PARAMETROS}->{$parverd}) {
          mover_datos($ref,'PARAMETROS',$parverd,$ref,'INICIALES'
                ,"INICIAL$parverd",__LINE__.' Cont contr.inic.integ');
          push @{$ref->{listaINICIALES}}, "INICIAL$parverd";
          @{$ref->{listaPARAMETROS}} 
            = grep ($_ ne $parverd, @{$ref->{listaPARAMETROS}});
      };
      # impr_datos(__LINE__.' Cont', ['PARAMETROS','INICIALES'], $ref); 
      # impr_debug(__LINE__.' Cont' ,$ref->{listaPARAMETROS});
      # impr_debug(__LINE__.' Cont'  ,$ref->{listaINICIALES});
      if (not defined $ref->{INICIALES}->{"INICIAL$parverd"}) {
          push @lisparDsinI, $parverd;
      };
  };#foreach $pard   
  @lisparDsinI and do {
      parar1(31,$ref,"Falta indicar valor inicial para;  @lisparDsinI");
  };     
  # los DP... no deben aparecer en los values;
  # hay que sustituirlos; si aparece recursion avgrav y porparar
  # primer ciclo se sustituye; segundo ciclo si sigue habiendo se corta.
  # busqueda de DP 
  my %DPusados;
  foreach my $dpar (@lisparD) {
      my $valor = '(' . $ref->{PARAMETROS}->{$dpar} . ')';
      my @listita = ($valor =~ /\W(D\w+)/g);
      map($DPusados{$1} ++,@listita);
  };
  my @DPusados = keys %DPusados;
  #@DPusados and do{
  #    parar1(32,$ref
  #    ,"No es aceptable utilizar derivadas para asignar valores;
  #    @DPusados: no deben aparecer a la derecha de signo de igual");
  # };
  comfin('finc controlar_iniciales_integr', 'integ.:'
         , 'sin inc:', @lisparDsinI);
  return '';
}#controlar_iniciales_integr
# --------------------------------------------------------------------------
sub controlar_conex_nodos_eles{#puede haber avisos y porparar; devuelve codigo
  comfin("comc controlar_conex_nodos_eles",  @_,descripcion_capa($_[0]));
  my $coderr= 0;
  my $il=$_[0];
  my $avisos=$avisosgrav+$avisosnograv+$avisosnoseent; 
  my $reflay=$reflayers[$il];
  #impr_hash('en controlar_conex_nodos_eles',%$reflay);
  my ($cualobjele,  $cualobjtextonodo
      , $listextonodosuna, $listextonodoscero, $elemmenos, $sintexto)
           = @{$reflay}{'cualobjele',  'cualobjtextonodo',
	               'listextonodosuna', 'listextonodoscero',
	               'elemmenos','sintexto'};
  do{ avgrav("Texto de los nodos no bien conectados:");
      map(mensajear("$_  "),@$listextonodosuna,@$listextonodoscero)
  } if $listextonodosuna or $listextonodoscero;
  do{ avgrav( "Elementos no bien conectados: ");
      map (mensajear(descripcion_objeto($_)),@$elemmenos)
  } if $elemmenos;
  if ($avisosgrav) {
      $coderr = 40;
  };
  comfin('finc controlar_conex_nodos_eles', " coderr = $coderr"); 
  return $coderr;
}#controlar_conex_nodos_eles 
#---------------------------------------------------------------------------
sub controlar_uso_def_parametras{#produce avisos y marca errores
  comfin('comc controlar_uso_def_parametras', @_);
  my $ref = $_[0];
  #my @lisvar = keys %{$ref->{USAVAR}};
  my (@parusanodef,@parusasinini);
  my (@parnousados,@parusados);
  foreach my $par (keys %{$ref->{PARAMETROS}}) {
      next if $ref->{TIPPARAMETROS}->{$par} eq 'I' or $par =~ /^D/i
	  or $par eq 'coment';
      if (not (defined $ref->{parscreados}->{$par} or
               defined $ref->{parssustituidos}->{$par} or
               defined $ref->{USAPAR}->{$par} or 
               defined $ref->{USAPARCONTROLES}->{$par}
               )) {
	       #impr_dat_que($par,'PARAMETROS'
               #          ,__LINE__.' Cont parametros no usa',$ref,'pnu');
          push @parnousados, $par; 
      } else {
          push @parusados, $par;
      };
      next if (defined $ref->{USAPAR}->{$par}
               );
      borrar_datos($ref,'PARAMETROS',$par,'',__LINE__.' Cont c_u_d_param.');
      delete $ref->{rerun}->{PARAMETROS}->{$par}
          if defined $ref->{rerun}->{PARAMETROS}->{$par};
      if (defined $ref->{INICIALES}->{$par}) {
	      borrar_datos($ref, 'INICIALES',$par,''
              ,__LINE__.' Cont c_u_d_parametros');
      }; 	  
  };  
  @parnousados 
        = grep(do{not defined $ref->{dearchivo}->{$_}}, @parnousados); 
  if (@parnousados) {
      my $coderr = Tablasfuncq::resumir_fun_par_tab_var_funx($ref, 
'circuito');
      #impr_debug(__LINE__.' Cont', Dumper $ref->{USAPAR});
      map (do {not $ref->{USAPAR}->{$_} and  
       borrar_datos($ref,'PARAMETROS',$_,'',__LINE__.' Cont c_u_d_param.')}
	   , @parusados);
  }
  @parusanodef and do {
      my $cuales = join ' ', @parusanodef;
      avgrav( "Hay parámetros no definidos: $cuales");
      map(cargar_datos($ref, 'PARAMETROS',$_,'no definido','e','',0
            ,__LINE__.' Cont c_u_d_parametros')
          , @parusanodef); 	  
  };#do 

  my @lispar = sort keys %{$ref->{PARAMETROS}};# controlar_uso_def_parametros
  my $lisque = [];
  defined $ref->{listaPARAMETROS} or $ref->{listaPARAMETROS} = [];  
  my $reflispar = $ref->{listaPARAMETROS};
  for (my $ip = 0; $ip < @$reflispar; $ip ++) {
      my $par = $reflispar->[$ip];
      next unless defined $par and defined $ref->{PARAMETROS}->{$par};
      next if $ref->{PARAMETROS}->{$par} eq 'no definido';
      next if length($par)<7; # en controlar_uso_def_parametros
      avgrav("Debe cambiar el nombre a $par;
   no pueden llegar a Sceptre parámetros de nombres de más de 6 símbolos");
  };#for $ip
  # a Sceptre no le gusta que las derivadas se presenten como constantes
# pero se encarga para_sceptre_expr....
#  for my $par (keys %{$ref->{PARAMETROS}}) {
#      if ($par =~ /^D/ and $ref->{TIPPARAMETROS}->{"$par"} eq 'n') {
#          my $valor = $ref->{PARAMETROS}->{$par}; 
#	  cargar_datos($ref, 'PARAMETROS', "$par","XXX($valor)", 'x', 'n'
#                  ,[$valor]
#               ,__LINE__.' Cont c_u_d_parametros');
#      };	        
#  };#for $par

  comfin('finc controlar_uso_def_parametras');
  return '';
} #controlar_uso_def_parametras
# ---------------------------------------------------------------------------
sub controlar_uso_def_TABLAS{ 
  comfin('comc controlar_uso_def_TABLAS',@_);
  #aqui llega todo explotado; solo hay que controlar calidad de argumentos
  my $ref = $_[0];
  #impr_debug(__LINE__.' Cont {USATAB}', Dumper $ref->{USATAB});
  impr_campo(__LINE__.' Cont $ref',$ref,'USAELE');
  #impr_debug(__LINE__.' Cont %reffi', \%reffi);
  my @eles = keys %{$ref->{USAELE}};
  foreach my $elearch (@eles) {
      my $refele = $reftrabajo->{$elearch}; my $coderr = '';
      $coderr = depurar_TABLAS_ARCHIVOS($refele) # elim 21/agosto/2012
          if $refele->{refvalores}->{TABLAS_ARCHIVOS};
      $coderr and parar1(66,$ref,"Errores en tabla definida junto con elementos
          TABLAS_ARCHIVOS de $elearch");   
  };
  impr_campo(__LINE__.' Cont $ref',$ref,'USA');
  map(do{uc(valor($ref,'TIPOTOK',$_)) eq 'T' and 
        $ref->{USATAB}->{$_} = $ref->{USA}->{$_}},keys %{$ref->{USA}});
  my @tablasnodefinidas;
  foreach my $id (keys %{$ref->{USATAB}}) {#no importa el orden
      $id =~ s/^.//; 
      if (not defined $hash_TABLAS_definidas{$id}) {  
          push @tablasnodefinidas, "Tabla $id (T$id)  ";
          explic(
            "Tabla(s) no definidas o las expresiones no se refieren a tablas:
        @tablasnodefinidas");
      };
  }; 
  #impr_debug(__LINE__.' Cont %hash_TABLAS_definidas'
  #          , "$ref->{ABSOLUTO} ".Dumper \%hash_TABLAS_definidas);
  my @tablasnousadas;
  foreach my $Tidtabla (keys %hash_TABLAS_definidas) {
      if (not defined $ref->{USATAB}->{"$Tidtabla"} 
	  and $hash_TABLAS_definidas{$Tidtabla} ->{$ref->{ABSOLUTO}}) {
          push @tablasnousadas, "   Tabla $Tidtabla"; 
          delete $hash_TABLAS_definidas{$Tidtabla}; 
      }
  };
  avnograv("Tabla(s) no usada(s):\n @tablasnousadas") if @tablasnousadas;
  comfin('finc controlar_uso_def_TABLAS');
  return '';
}#controlar_uso_def_TABLAS
# ---------------------------------------------------------------------------
sub controlar_def_funciones_propias{
  #solo guarda en el propio $ref 
  comfin('comc controlar_def_funciones_propias', @_);
  my ($ref)=@_;
  my $op = '[\+\-\*\/\(\)]';
  foreach my $nombre (keys %{$ref->{FUNCIONES}}) {
     next if $ref->{TIPFUNCIONES}->{$nombre} eq ';'; 
     my ($nombrefun,$stringarg) = ($nombre =~ /^(Q\w+)\((.+)\)$/);
      my @listaarg =  split '\s*,\s*', $stringarg;
      scalar @listaarg == scalar union_conjunto(@listaarg) or
      do{ porparar1(75,$ref
         ,"Argumentos repetidos en la definición de $nombre");
	  return 75;
      };
      my @malos = grep (do{/\W/ or /^\d/} ,@listaarg);
      if (@malos) {
          porparar1(76,$ref,"En $nombre hay argumentos no válidos: @malos");
          return 76;
      }; 
      @{$ref->{listaargFUNCION}->{$nombrefun}} = @listaarg;
      #para evitar cocientes de enteros
      my $valor = $ref->{FUNCIONES}->{$nombre};
      while ($valor=~ s/(\/\d+)($op)/$1\.$2/) {}; 
      my $tipo = $ref->{TIPFUNCIONES}->{$nombre};
      $tipo eq 'x' and $valor =~ s/^X\w+//
          or $valor ="($valor)"; 
      while ($valor =~  s/(\W)(TIEMPO)(\W)/$1TIME$3/i) {};
      $ref->{FUNCIONES}->{$nombre} = $valor;
      $ref->{definicionFUNCIONES}->{$nombrefun} = "$nombre = $valor";
  };
  comfin('finc controlar_def_funciones_propias');
  return '';
}#controlar_def_funciones_propias
# ---------------------------------------------------------------------------
sub controlar_def_funciones_todas{
  comfin('comc controlar_def_funciones_todas', @_);
  my ($refc)=@_;
  my $coderr= '';
  my %funcusafunq;
  $refc->{no_formales} = {};
  #aceptamos que en las funciones_Q aparezcan argumentos no_formales: 
  # variables de la simulacion (además del posible TIME)
  #impr_debug(__LINE__.' Cont %hash_FUNCIONES_definidas'
  #     , Dumper \%hash_FUNCIONES_definidas);
  #impr_debug(__LINE__.' Cont definicionFUNCIONES'
  #     , Dumper $refc->{definicionFUNCIONES);
  foreach my $qfunori (sort keys %{$refc->{definicionFUNCIONES}}) {
      my %funcusavar;
      my $defi = $refc->{definicionFUNCIONES}->{$qfunori};
      my ($izquierda,$derecha) = $defi =~ /^(\S+)\s*=\s*(\S+)$/;
      my $dere = $derecha;
      my @listarg = @{$refc->{listaargFUNCIONES}->{$qfunori}};
      my %argesta;
      map($argesta{$_}= 1, @listarg);
      my @vars;
      # para detectar uso de tablas:
      # if ($texto =~ /\WT[\s\w]+\(/ ) {}; 
      # para 'eliminar' nombres de funciones:
      while ($dere =~ s/(\W)(\w+)\(/$1\&\(/) {
          my $func = $2;
          $funcusafunq{$qfunori}->{$func} = 1 if $func =~ /^Q/i;
      };
      #@{$funcusafunq{$qfunori}} funciones que inciden en definición
      while ($dere =~ s/^(\W+)(\w+)(\W)/$1$3/) {
          my $vari = $2;
          $funcusavar{$vari} = 1 if $vari !~ /^\d/; 

          #los signos y puntos se perdieron
      };
      #@vars variables que inciden en definición
      #a veces, Sceptre, trabajando con circuitos grandes, 
      # no acepta argumentos con un solo caracter : a, x, w
      # por las dudas aviso para todos
      #en {$refc->{no_formales} apunta a un hash: 
         #key: nombre de parametro o variable no argmento formal 
               #de una funcion y distinto de TIME;
         #value:  lista de funciones que lo usan.
      # si la key es un parametro que varia durante la simulacion, 
      # pero no esta entre los outputs, Sceptre no lo tiene en cuenta  
      foreach (keys %funcusavar) {
	  if (not defined $argesta{$_} and $_ ne 'TIEMPO' and $_ ne 'TIME') {
	      push @{$refc->{no_formales}->{$_}},$qfunori;
          };    
      };# marca variables que inciden sin ser argumentos formales 
      my (%argusde1,@argnous);
      foreach (@listarg) {
	  not defined $funcusavar{$_} and  push @argnous, $_;
          length($_) == 1 and $argusde1{$_} = 1; 
          #para no modificar si no influye
      };#foreach @listarg 
      #impr_debug(__LINE__.' Cont %argusde1 ' , Dumper \%argusde1);
      if (keys %argusde1) {
         avnograv("$izquierda tiene argumentos de una sola letra:
                  en $izquierda = $derecha
             pueden traer problemas; las cambiaremos");
          my $defi = $refc->{definicionFUNCIONES}->{$qfunori};
          foreach my $uno (@listarg) {
              next unless $argusde1{$uno};
              my $sust = $uno.'1';
              while ($funcusavar{$sust}) {$sust++};
              delete $funcusavar{$uno}; $funcusavar{$sust} = 1;
              while ($defi =~ s/(\W)$uno(\W)/$1$sust$2/) {};
              $uno = $sust;          
          };
         $refc->{definicionFUNCIONES}->{$qfunori} = $defi;
	 $refc->{listaargFUNCION}->{$qfunori} = \@listarg;
#impr_debug(__LINE__.' Cont listaarg ', Dumper $refc->{listaargFUNCIONES});
#impr_debug(__LINE__.' Cont definicion ',Dumper $refc->{definicionFUNCIONES});
      };
      @argnous and avnograv("Hay agumentos no usados
              @argnous
           en la definición $izquierda = $derecha");  
      #impr_debug(__LINE__.' Cont  valor que define funcion', $valor); 
  };#foreach qfunori
  #impr_hash(__LINE__. ' Cont ',%$refc);
  #impr_debug(__LINE__. ' Cont FUNCIONES',Dumper $refc->{FUNCIONES});
  #impr_debug(__LINE__. ' Cont REFARGFUNCIONES'
  #    , Dumper $refc->{REFARGFUNCIONES});
  comfin('finc controlar_def_funciones_todas');
  return '';
}#controlar_def_funciones_todas
# ---------------------------------------------------------------------------
sub controlar_def_funciones_final{
  comfin('comc controlar_def_funciones_final',@_);
  my ($refc)=@_;
  my @cosas = keys %{$refc->{no_formales}};
  #aceptamos que en las funciones_Q aparezcan argumentos no_formales: 
  # variables de la simulacion (además del posible TIME)
  #impr_debug(__LINE__.' Cont no_formales ',\@cosas);
  foreach my $cosa (@cosas) {
      my $que = '';
      #no sirve nombre de nodo
      if ($cosa =~ /^P/ and defined $refc->{PARAMETROS}->{$cosa}) {
          $que = 'PARAMETROS';
      } elsif ($cosa =~ /^[RCLEJ]/ and defined $refc->{DATOS}->{$cosa}) {
          $que = 'DATOS';
      } elsif ($cosa =~ /^V([RCLJ].+)$/ and defined $refc->{DATOS}->{$1}) {
      } elsif ($cosa =~ /^I([RCLE].+)$/ and defined $refc->{DATOS}->{$1}) {
      } else {
          avgrav("No se reconoce variable que interviene en funcion(es):
           $cosa en @{$refc->{no_formales}->{$cosa}};
         Puede ser que Sceptre tome un valor 0 para $cosa");
      };
      next unless defined $que;
      if (defined $refc->{"TIP$que"}->{$cosa} 
          and $refc->{"TIP$que"}->{$cosa} eq 'n') {
          my $sust = $refc->{$que}->{$cosa};
          my @funcs = @{$refc->{no_formales}->{$cosa}};
          foreach my $func (@funcs) {
              my $defi = $refc->{definicionFUNCIONES}->{$func};
              while ($defi =~ s/(\W)$cosa(\W)/$1$sust$2/) {};
          };
      } else {
          if ($que eq 'PARAMETROS') {
	      my $texto = Dumper($refc->{lisoutputssceptre})
                          . Dumper($refc->{DATOS});
              #my $stringsceptre = join ';',@{$refc->{lisoutptssceptre}}; 
	      #impr_debug(__LINE__.' Cont $texto ', $texto);
              $texto =~ /\W$cosa\W/ or do{
               # ";$stringsceptre;" =~ /\;$cosa\;/  or do{
                    push @{$refc->{lisoutputssceptre}},$cosa; 
                    push @{$refc->{lispropias}},$cosa; 
                    push @{$refc->{lisunidades}},'??'; 
                    push @{$refc->{lismagnitudes}},'??'; 
                    push @{$refc->{listacomeRESU}}
		      , "; $cosa agregado por Simusol porque afecta funciones";
                    #algo sobre {indicebueno}?
              }; 
          };
      };    
      impr_resultados(__LINE__.' Cont contr_def_fun', $refc);
  }
  comfin('finc controlar_def_funciones_final');
}#controlar_def_funciones_final
# ---------------------------------------------------------------------------
sub controlar_uso_funciones{#puede producir mensajes de error
  #como las funciones_Q no pueden ser invocadas ni en expresiones,
  #ni en tablas ni en otras funciones, y al sceptre llegan con 
  #argumentos simples es mas facil controlar luego de explotar
  #se controla que las funciones usadas hayan sido definidas
  #y se esten usando con los argumentos necesarios
  # y avisa si hay funciones definidas en el principal que no se esten usando
  comfin('comc controlar_uso_funciones', @_);
  my ($refc)=@_; my $coderr = '';
  my @lisque = ('DATOS','PARAMETROS');
  my %funcnodef; 
  foreach my $que (@lisque) {
      foreach my $key (keys %{$refc->{$que}}) {
          my $value = ";$refc->{$que}->{$key}";
          next unless $value =~ /\WQ\w+\s*\(/i;
          $value =~ s/(\WQ\w+)\s*\(/$1&\(/ig;
          while ($value =~ s/(.*\W)(Q\w+)&\s*(\(.+)/$1$2$3/) {
              my $func = $2; my $stringarg = $3;  
              next if $func eq 'QPRODUCTO' or $func eq 'QSUMA';
              next if $func =~ /^Q\d+P$/ or $func =~ /^Q\d+S$/;
              my @listarg = split ',', $stringarg;    
              defined $refc->{definicionFUNCIONES}->{$func}
                or do {
                  $funcnodef{$func} = 1;next
                };
                @listarg = split ',', $stringarg;
                ($coderr,@listarg) = juntar_por_paren_cur(',',@listarg);
                $listarg[0] =~ s/^\((.+)\)/$1/;
	        @listarg = split ',',$listarg[0];
	        ($coderr,@listarg) = juntar_por_paren_cur(',',@listarg); 
                @listarg == @{$refc->{listaargFUNCION}->{$func}}
	            or avgrav(
              "Se está usando una función con cantidad de argumentos 
              distinta de la cantida necesaria. $func requiere  " 
              .scalar @{$refc->{listaargFUNCION}->{$func}} ." argumentos
        pero se esta usando con " . scalar @listarg . " en
        $func(" .  join(',',@listarg). ')');
          };#while
      };#foreach key
  };#foreach que
  scalar keys %funcnodef and avnograv(
     "Hay funciones con nombre que empieza con \"Q\" no definidas aquí;
                  salvo que haya un programa en FORTRAN ...
                   Sceptre no funcionará: 
         " . join ("\n         ", keys %funcnodef) );
  #impr_debug(__LINE__.' Cont USAFUN', Dumper $refc->{USAFUN});
  #impr_debug(__LINE__.' Cont FUNCIONES', Dumper $refc->{FUNCIONES}); 
  my @funcionesnousadas;
  foreach my $key (keys %{$refc->{FUNCIONES}}) {
      (my $fu = $key) =~ s/^(\w+).*/$1/;
      defined $refc->{USAFUN}->{$fu} or push @funcionesnousadas, $fu;  
  };
  avnograv("Hay funciones que no se están usando:\n  @funcionesnousadas")
      if @funcionesnousadas;
  comfin('finc controlar_uso_funciones');
  return '';
}#controlar_uso_funciones
# --------------------------------------------------------------------------
sub controlar_var{ #puede producir mensajes de error
  comfin('comc controlar_var', @_);
  my ($ref, $aignorar) = @_;
  defined $aignorar or $aignorar = {};
  my @noesperadas;
  foreach my $var (keys %{$ref->{USAVAR}}){#
      #fue calculadp en base a DATOS,PARAMETROS,RESULTADOS,CONTROLES 
      # pero las que provienen de CONTROLES no influyen
      #contiene las variables no clasificadas como parametros o  nodos
      my ($cod,$resto) = ($var =~ /^(.)(.*)$/);
      defined $ref->{DATOS}->{$var}
        or (defined $ref->{DATOS}->{$resto} and $cod =~ /[VI]/)
	or (defined $ref->{cualobjtextonodo}->{$resto} and $cod eq 'V')
        or $var eq 'TIEMPO'
        or $var eq 'TIME'
        or defined $aignorar->{$var} 
        or $var =~ /\_nodomod/i
        or push @noesperadas, $var;
  };
  if (@noesperadas) {
      #impr_debug(__LINE__.' Cont @noesperadas ',\@noesperadas);
      my %defini = (%{$ref->{DATOS}},%{$ref->{PARAMETROS}});
      my @usan;
      foreach my $noesp (@noesperadas) {
          push (@usan, grep(";$defini{$_};" =~ /\W$noesp\W/
			    , keys %defini));
          my ($clase,$idenpro) = ($noesp =~ /^(.)(.+)$/);
          if (defined $clase) {
              explic("No hay un elemento apropiado con esa identificaión:
                variable $noesp;  clase $clase;  identificación $idenpro");
          } else {
              explic("Variable no esperada $noesp");
          }; 
     };
      @usan = union_conorden(@usan);
      avgrav("No se reconoce: la(s) variable(s) 
      @noesperadas  usada(s) por   @usan")  if @usan;     
  };
  comfin('finc controlar_var');
}#controlar_var
# --------------------------------------------------------------------------
sub controlar_valorespar{
#parametros no de rerun, ya con TIPOTOK 'P', o  que tengan igual valor
# que un dato no pasaran a Sceptre
#aunque se pidan como output (se tienen en cuenta en el .paraplot
#de los demas, (POR ORDEN DE LLEGADA) si hay varios con igual valor, solo pasan 
# los que no pasaran se asigna TIPOTOK 'P' 
  comfin('comc controlar_valorespar', @_);
  my ($ref) = @_;
  impr_datos(__LINE__.' Cont',['TODOS'],$ref);
  impr_campo(__LINE__.' Cont $ref',$ref,'valor2cual');
  my @receptores = keys %{$ref->{REFARG}}; 
  impr_debug(__LINE__.' Cont ref->{$refvalores}->{RESULTADOS}'
	     , Dumper $ref->{refvalores}->{RESULTADOS}) if $ref->{refvalores};
  impr_campo(__LINE__.' Cont $ref',$ref,'valor2cual');
  foreach my $este (@{$ref->{listaPPARAMETROS}}) {
      impr_debug(__LINE__.' Cont $este',$este);
      next if $ref->{TIPOTOK}->{$este} eq 'P' or $ref->{TIPO}->{$este} eq '0';
      my $valor = $ref->{VALOR}->{$este};my $tipo = $ref->{TIPO}->{$este};
      next if $tipo =~ /[noSsw]/;
      my $ant = $ref->{valor2cual}->{$valor}->[0];
      if ($ant) {
          if ($ant ne $este) {
              impr_debug(__LINE__.' Cont $valor,$este,$ant'
              ,[$valor,$este,$ant]);
              impr_dat(__LINE__.' Cont',$este,$ref,'cvp');
              my $tipo = $ref->{TIPOTOK}->{$ant};
              $ref->{VALOR}->{$este} = $ant;
              $ref->{TIPO}->{$este} = $ref->{TIPARG}->{$este} = $tipo; 
              @{$ref->{REFARG}->{$este}} = ($ant);
#       agregar_comentarios($ref,$este,"igual valor que $ant",'Cont '.__LINE__);
              agregar_comentarios($ref,$este,$valor,'Cont '.__LINE__);
              $ref->{igualvalorque}->{$este} = $ant;
              my @recp;
              foreach my $key (@receptores) {
                  if (grep ($este eq $_, @{$ref->{REFARG}->{$key}})) {
                      Simusol::Evaluaciones::sust_tokear($ref,[$key],[$este]);
                  };
              };
	      $ref->{TIPOTOK}->{$este} = 'P';
              impr_dat(__LINE__.' Cont',$este,$ref,'cvp');
	  };
      };
  };
  impr_datos(__LINE__.' Cont',['TODOS'],$ref);
  comfin('finc controlar_valorespar',keys %{$ref->{igualvalorque}});
  return;
}#controlar_valorespar 
# ---------------------------------------------------------------------------
sub controlar_largos{#de nombres de: 
       #nodos, elementos, parametros, funciones, tablas
    my $refc = $_[0];
    foreach my $il (@{$refc->{capas}}) {
        my $reflay = $reflayers[$il];
        my @nombresl 
             = grep(length($_) > 6, keys %{$reflay->{cualobjtextonodo}});
        if (@nombresl) {
            avgrav("Identificadores demasiado largos para nodos:
            @nombresl");
	    my @valores= keys %{$refc->{uni}};my @valoresl;
            foreach my $nodo (@nombresl) {
                push @valoresl, grep(do{";$refc->{uni}->{$_};" =~ /\W$nodo\W/}
				     , @valores);
            };
            foreach (@valoresl) {
                $refc->{uni}->{$_} .= "; nodo demasiado largo";
            };
        }; 
        @nombresl = grep(do{/[^T]/ and length($_) > 5}
             , keys %{$reflay->{cualobjele}});
        if (@nombresl) {
            avgrav("Identificadores demasiado largos para  elementos:
            @nombresl");
            foreach (@nombresl) {
                $refc->{DATOS}->{$_} .= "; $_ es demasiado largo";
            };
        }; 
    };
  comfin('finc controlar_tiempos');
};
#---------------------------------------------------------------------------
sub depurar_dependencias{
  comfin('comc depurar_dependencias',@_);
  my ($ref,$refxs,$refns,$refSs) = @_;my ($coderr,$cambiado)= ('','');
  impr_debug(__LINE__.' Cont USA', $ref->{USA});
  impr_debug(__LINE__.' Cont',$refSs);
  impr_datos(__LINE__.' Cont',['TODOS'], $ref);
  my $cali = '';
  if ($ref->{clasearch} eq 'elementos') {
      $cali = '_USO_DEF';
  };
  map ($ref->{hashs}->{$_} = 1,(@$refxs,@$refns,@$refSs));
  impr_debug(__LINE__.' Cont son expresiones', Dumper $ref->{hashs});
  my @receptores;
  for my $pal ('DATOS','PPARAMETROS','DPARAMETROS','PEDIDOS') { 
     $ref->{"lista$pal$cali"} and push @receptores,@{$ref->{"lista$pal$cali"}}; 
  };
  @receptores = grep ($ref->{TIPOTOK}->{$_} !~/[bP]/,@receptores);
  impr_debug(__LINE__.' Cont @receptores',\@receptores);
  foreach my $receptor (@receptores) {
  #    next if $ref->{hashs}->{$receptor}; 
      impr_dat(__LINE__.' Cont',$receptor,$ref,'rrr');
      my ($valor,$tipo,$tiparg,$refarg) = tomar_cua_datos($ref,$receptor);
      my @lista = grep (do {$ref->{hashs}->{$_}},@{$refarg});
      impr_debug(__LINE__.' Cont @lista '.$receptor,\@lista);
      next unless @lista;
      ($coderr,$cambiado)
        = Simusol::Evaluaciones::sust_token_SUST( # en depurar_dep.
           $ref,$receptor,'hashs');
      $coderr and last;
#      depurar_comentarios($ref,$receptor);
  }; #foreach $receptor 
  impr_datos(__LINE__.' Cont',['PARAMETROS'],$ref);
  comfin('finc depurar_dependencias',$coderr);
  return $coderr;
} #depurar_dependencias
# ---------------------------------------------------------------------------
sub impr_dependencias{
  return unless $debug;
  return if $noverb;
  # comfin('comc impr_dependencias',@_):
  my ($mensaje,$ref) = @_;
  $mensaje or $mensaje =  __LINE__.' Cont';
  print STDERR ' 'x20, "impr_dependencias, $mensaje:\n";
  impr_campo(__LINE__.' Cont $ref',$ref,'USA');
  impr_campo(__LINE__.' Cont $ref',$ref,'NOUSAP');
  impr_campo(__LINE__.' Cont $ref',$ref,'USAb');
  return;
} #impr_dependencias
# ---------------------------------------------------------------------------
sub pars_archivo{
  comfin('comc pars_archivo',@_); return;
  my $ref = $_[0]; 
  impr_debug(__LINE__.' Cont keys %$ref',[keys %$ref]); 
  impr_campo(__LINE__.' Cont $ref',$ref,'USA');
  impr_campo(__LINE__.' Cont $ref',$ref,'USAb');
  impr_datos(__LINE__.' Cont',['TODOS'],$ref); 
  my @reruns = grep ($ref->{TIPOTOK}->{$_} eq 'b',sort keys %{$ref->{TIPOTOK}});
  my @noreruns
    = grep (do{not $ref->{USAb}->{$_}},@reruns);
  @noreruns = grep ($_ !~ /INTEGRATIONROUTINE/,@noreruns);
  impr_debug(__LINE__.' Cont @reruns @noreruns',[@reruns,'||',@noreruns]);
  if (@noreruns) {
      mensajear("No se entiende pedir rerun por @noreruns;
                 no influyen en la simulación; se ignora esos pedidos");
      foreach my $cosa (@noreruns) {
          $ref->{TIPOTOK}->{$cosa} = 'P';
          borrar_datos($ref,'PARAMETROS',"rerun$cosa");
      };
  };

  my @parnousados = grep (do {not /^rerun/ and
                          $ref->{TIPOTOK}->{$_} =~ /[dpi]/
                               and not $ref->{USA}->{$_}
                             and not $ref->{parscreados}->{$_}}
                          ,keys %{$ref->{TIPOTOK}});
  map($ref->{TIPOTOK}->{$_} ='P',@parnousados);
  impr_debug(__LINE__.' Cont @parnousados',\@parnousados);
  @parnousados 
        = grep(do{not defined $ref->{dearchivo}->{$_}}, @parnousados); 
  @{$ref->{listaarchPARAMETROS}} = grep (do {valor($ref,'TIPOTOK',$_) eq 'P'}
     , (@{$ref->{listaPARAMETROS}},@{$ref->{listaDINICIALES}}));
  comfin('finc pars_archivo',@{$ref->{listaarchPARAMETROS}});
  return;
} #pars_archivo

1;
