package Simusol::Prograf;
use Simusol::Ayudas;
use Simusol::GlobalesSimusol;
use Simusol::Auxiliares;
use Simusol::Algebraico;
use Simusol::TraAbrev;

use warnings;
use strict;
use Data::Dumper;
$Data::Dumper::Sortkeys= 1;
our ($ref_arch,$ref_graf) = ({},{});
our ($refcrudo0,$refcrudo1,$refcrudo2,$refcrudo3,$ref_selecciones)
      = ({},{},{},{},{}); 
my $reg_delarch = '(archivo|arch_var|variacion|unipri'
  .'|variable|magn|indice|sceptre|unidad)';
my $reg_grafdecor= '(titulo|eje|eco|rangox|rangoy)';
# todo para poner algo tal cual para gnuplot
my $reg_grafesen = '(punto|linea|fun|todo|guardar)';
my $reg_obsoletos = '(crear|extension)';
my $reg_mostrar = '(nomostrar|mostrarj)';
my $reg_selecciones = 'selec';
BEGIN {
     use Exporter ();
     our ($VERSION,@ISA,@EXPORT,@EXPORT_OK,%EXPORT_TAGS);
     @ISA=qw(Exporter);
     @EXPORT = qw(&calcular_UNIDADES
                  &completar_UNIDADES
                  &contr_graf
                  &impr_grafo
                  &interpretar_hconblanco
                  &interpretar_hconparen 
                  &llenar_grafdecor
                  &llevar_UNIDADES_refarch
                  &paraplotear
                  &prograficar
                  $ref_arch
                  $ref_graf
                  $ref_selecciones
                  &tratar_UNIDADES &tratar_1UNIDADES
     );
};
END();
 
our %nombreshash = ('TIME'=>1,'TIEMPO'=>1);
# aqui se guardan referencias a las variables propias

# abril 2006 en el paraplot los numeros se refieren a las variables propias
# si no se indican indices es porque son los naturales
# -----------------------------------------------------------------------------
sub ajustar_delarch{# de refcrudo3 a $ref_arch para un archivo simbolico
  comfin('comP ajustar_delarch',@_);
#  impr_debug(__LINE__.' Prog  $refcrudo3->{delarch} '.'delarch'
#	     ,Dumper $refcrudo3->{delarch});
  foreach my $SIMBARCH (sort keys %{$refcrudo3->{delarch}}) {
      my $ref3pS = $refcrudo3->{delarch}->{$SIMBARCH};
      foreach my $palabrita (sort keys %$ref3pS) {
	  $ref_arch->{$SIMBARCH}->{$palabrita} 
	  = $ref3pS->{$palabrita};
      };#foreach
#      impr_debug(__LINE__.' Prog $ref_arch->{$SIMBARCH} para '.$SIMBARCH
#		 ,Dumper $ref_arch->{$SIMBARCH});
#      delete $refcrudo3->{delarch}->{$SIMBARCH};
      my $refaS = $ref_arch->{$SIMBARCH};
      if ($refaS->{arch_var} and not $refaS->{variacion} or
          $refaS->{variacion} and not $refaS->{arch_var} or
          $refaS->{arch_var} and $refaS->{variacion} and
          @{$refaS->{arch_var}} != @{$refaS->{variacion}}) {
          mensajear(
           "Inconsistencia entre 'variaciones' y 'arch_var' para $SIMBARCH
             se ignoran ");
          delete $refaS->{arch_var}; delete $refaS->{variacion};
      };
#  impr_debug(__LINE__.' Prog $refaS',Dumper $refaS);
      if (not $refaS->{arch_var}) {
          $refaS->{arch_var} = [$refaS->{archivo}];
          $refaS->{variacion} = [''];
      };
      purgar_ref_arch($SIMBARCH);
  };
  delete $refcrudo3->{delarch};
#  impr_debug(__LINE__.' Prog $ref_arch',Dumper $ref_arch);
  comfin('finP ajustar_delarch');
}#ajustar_delarch
#---------------------------------------------------------------------------
sub ajustar_grafdecor{#trabaja a apartir de $refcrudo3
  comfin('comP ajustar_grafdecor',@_); 
#  impr_debug(__LINE__.' Prog  $refcrudo3->{grafdecor} '.'grafdecor'
#	     ,Dumper $refcrudo3->{grafdecor});
  my @lissimbgrafs = sort keys %{$refcrudo3->{grafdecor}};
  foreach my $simbgraf (@lissimbgrafs) {
      my @lispals = sort keys %{$refcrudo3->{grafdecor}->{$simbgraf}};
      foreach my $palabrita (@lispals) {
	  $ref_graf->{$simbgraf}->{decor}->{$palabrita}
	    = $refcrudo3->{grafdecor}->{$simbgraf}->{$palabrita};
          delete $refcrudo3->{grafdecor}->{$simbgraf}->{$palabrita};
      };
      delete $refcrudo3->{grafdecor}->{$simbgraf} 
  };
  delete $refcrudo3->{grafdecor};
  comfin('finP ajustar_grafdecor',@_); 
}#ajustar_grafdecor',@_); 
#---------------------------------------------------------------------------
sub ajustar_grafesen{#trabaja a apartir de $refcrudo3
  comfin('comP ajustar_grafesen',@_); 
#  impr_debug(__LINE__.' Prog  $refcrudo3->{grafesen} '.'grafesen'
#	     ,Dumper $refcrudo3->{grafesen});
  foreach my $simbgraf (sort keys %{$refcrudo3->{grafesen}}) {
      my $ref3pS = $refcrudo3->{grafesen}->{$simbgraf};
#  impr_debug(__LINE__.' Prog $refcrudo3->{grafesen}->{$simbgraf} '.$simbgraf
#	     , Dumper $refcrudo3->{grafesen}->{$simbgraf});
#  impr_debug(__LINE__.' Prog $ref_graf->{$simbgraf} '.$simbgraf
#             , Dumper $ref_graf->{$simbgraf});
      my @lispals = sort keys %$ref3pS;
      foreach my $palabrita ('linea','punto','fun') {
          my $coderr = '';
          if ($palabrita =~ /^(linea|punto)$/) {
              my $coderr = '';my ($SIMBARCH,$reflista,$cosa);my $renglonori;
  	      foreach $reflista (@{$ref3pS->{$palabrita}}) {
                  $renglonori = pop @$reflista;
#                  $SIMBARCH = shift $reflista;
                  my @listaref = @$reflista; $SIMBARCH = shift @listaref;
                  $reflista = \@listaref;
                  $SIMBARCH = uc($SIMBARCH);
                  my $SIMBARCHP = $ref_arch->{$SIMBARCH}->{archivopadre};
                  if (defined $SIMBARCHP) {# si no, no es bueno $SIMBARCH 
                      my @nuelista = controlar_lista_pl
                       ($SIMBARCHP,$reflista,$renglonori,'pl'); 
                      if (@nuelista >1) {
                          my $absc = shift @nuelista;
                          @$reflista = ($absc,\@nuelista);
                          unshift @$reflista,$SIMBARCH;
                          unshift @$reflista,$palabrita;
                          push @{$ref_graf->{$simbgraf}->{pl}},$reflista;
                      }; 
	          }  else {
                      mensajear(" No esta bien definido el archivo $SIMBARCH");
                      next
                  };
              };
          } elsif ($palabrita eq 'fun') {
 	      foreach my $reflista (@{$ref3pS->{$palabrita}}) {
                  my $fun = $reflista->[0];
                  my $coderr = revisar_fun($fun);
                  if (not $coderr) {
                      if (@$reflista == 3) {
                          push @{$ref_graf->{$simbgraf}->{fun}}
                            ,"$fun title \'$reflista->[1]\'";
                      } elsif (@$reflista == 2){
                          push @{$ref_graf->{$simbgraf}->{fun}},$fun;
                      };
                  };
              };
          }
          delete $refcrudo3->{grafesen}->{$simbgraf}->{$palabrita};
      };#$palabrita 
      next unless $ref_graf->{$simbgraf};
      my $palabrita = 'guardar';
      if ($ref3pS->{$palabrita}) {  
#          impr_debug(__LINE__.' Prog $ref_graf{$simbgraf '.$simbgraf
#          ,Dumper $ref_graf->{$simbgraf}) if $simbgraf eq 'grafico'; 
          foreach my $reflista (@{$ref3pS->{$palabrita}}) {
              my $archi = $reflista->[0];
              my $coderr = ''; #revisar_guardar($archi);
              if (not $coderr) {
                  if ($archi and ($archi =~ /\// or $archi =~ /\.w+$/)) {
                      mensajear(
        " Debe indicar solo el nombre propio sin extension,
          y se guardaran en $dirsal{gnu} con las extensiones previstas
          no tendremos en cuenta     $archi"); $coderr = 30;
                  };
              };
              if (not $coderr) {
                 push @{$ref_graf->{$simbgraf}->{guardar}},$reflista->[0];
              };
          };
#          impr_debug(__LINE__.' Prog $ref_graf{$simbgraf '.$simbgraf
#            ,Dumper $ref_graf->{$simbgraf}) if $simbgraf eq 'grafico'; 
      };
      delete $refcrudo3->{grafesen}->{$simbgraf}->{guardar};
  };#$simbgraf
  delete $refcrudo3->{grafesen};
#  impr_debug(__LINE__.' Prog $refcrudo3',Dumper $refcrudo3);
#  impr_debug(__LINE__.' Prog $ref_graf', Dumper $ref_graf);
  comfin('finP ajustar_grafesen');
}#ajustar_grafesen
# -----------------------------------------------------------------------------
sub ajustar_selecciones{ 
  comfin('comP ajustar_selecciones',@_);
  my @lisSIMBARCHs = sort keys %{$refcrudo3->{selecciones}};
  foreach my $SIMBARCH (@lisSIMBARCHs) {
      my $ref3pS = $refcrudo3->{selecciones}->{$SIMBARCH};
      @{$ref_arch->{$SIMBARCH}}{'SIMBARCH_ORI','archivo','archivopadre'
        ,'seleccion'}
	  =  @{$ref3pS->{hash}}{'SIMBARCH_ORI','archivo','archivopadre'
        ,'seleccion'};
      @{$ref_selecciones->{$SIMBARCH}}{'colu','rango'}
      =  @{$ref3pS->{hash}}{'colu','rango'};
      delete $refcrudo3->{selecciones}->{$SIMBARCH}; 
  };
  keys %{$refcrudo3->{selecciones}}
    or delete $refcrudo3->{selecciones};
#  impr_debug(__LINE__.' Prog $refcrudo3->{selecciones}'
#    ,Dumper $refcrudo3->{selecciones});
#  impr_debug(__LINE__.' Prog $ref_selecciones',Dumper $ref_selecciones);
#  impr_debug(__LINE__.' Prog $ref_arch',Dumper $ref_arch);
  comfin('finP ajustar_selecciones');
}#ajustar_selecciones
# -----------------------------------------------------------------------------
sub armar_eje{ 
  comfin('comP armar_eje',@_);
  my ($simbgraf,$mag,$uni) = @_;
#  impr_grafo(__LINE__.' Prog',$simbgraf);
  my $uno = $ref_graf->{$simbgraf}->{decor}->{$mag};
  my $dos = $ref_graf->{$simbgraf}->{decor}->{$uni};
#  impr_debug(__LINE__.' Prog $uno,$dos',[$uno,$dos]);
  my $eje = '';
  $uno and $uno ne '??' and $eje = $uno;
  $dos =~ /\?\?/ and length($dos) == 3 and $dos = substr($dos,1);
  $dos ne '??' and $eje .= "($dos)";
  $eje =~ s/^\s//;
  comfin('finP armar_eje,$eje',$eje);
#  impr_debug(__LINE__.' Prog $eje',$eje); 
  return $eje;
}#armar_eje
# -----------------------------------------------------------------------------
sub buscar_unipri{#devuelve $unipri (puede ser no definido),$refabsc,$reford
  comfin('comP buscar_unipri',@_);
  my $refpl = $_[0];
  my @pls = @$refpl;
  my $refsimbarch = {};
  foreach my $pl (@pls) {
      my (@abscs,@ords);
      my $SIMBARCH = $pl->[1];
      my $unipri = $ref_arch->{$SIMBARCH}->{unipri};
      push @abscs,$pl->[2];
      push @ords,@{$pl->[3]};
      $refsimbarch->{$SIMBARCH}->{absc} = \@abscs;
      $refsimbarch->{$SIMBARCH}->{ords} = \@ords;
      $refsimbarch->{$SIMBARCH}->{unipri} = $unipri;
  }; 
#  impr_debug(__LINE__.' Prog $refsimbarch',Dumper $refsimbarch);
  comfin('finP buscar_unipri');
  return $refsimbarch;
}#buscar_unipri
#---------------------------------------------------------------------------
sub calcular_UNIDADES{
  comfin('comP calcular_UNIDADES',@_); 
  my $refarch = $_[0];
  $refarch->{DEFIcalculo} = {};
  my @lisnumpl;
  @lisnumpl  = sort keys %{$refarch->{DEFIuni}};
#  impr_debug(__LINE__.' Prog @lisnumpl',\@lisnumpl);
  foreach my $numpl (@lisnumpl) {
      my $refacalc = $refarch->{DEFIcalculo}->{$numpl} = {};
      my @clases = qw(C E J L M R); $numpl == 0 and @clases = ('T');
      foreach my $claseel (@clases) {
          my $par = $refarch->{DEFIuni}->{$numpl}->{$claseel};
          next unless $par;
          my (@lista,$abr);
          @lista = split /\s*,\s*/,$par;
#          impr_debug(__LINE__.' Prog $numpl $claseel @lista'
#            ,[$numpl,$claseel,@lista]);
          $refacalc->{DEFIcomp}->{$claseel} = "$lista[1],$lista[0]";
          my $cosaabr = 'V'; $claseel eq 'J' and $cosaabr = 'I'; 
          if ($claseel =~ /[EJ]/ and $numpl > 0) {
              if (defined $lista[2]) {
                   $refacalc->{DEFIabrev}->{$cosaabr} = $lista[2];
              } else {
                  $refacalc->{DEFIabrev}->{$cosaabr} = $refglobal
                    ->{DEFIcalculo}->{$numpl}->{DEFIabrev}->{$cosaabr};
              };  
          };
      };#for $claseel
      if ($refacalc->{DEFIabrev}) {
          my $abrV = $refacalc->{DEFIabrev}->{V};
          $abrV and $refacalc->{DEFIequiv}->{$abrV} = 'V';
          my $abrI = $refacalc->{DEFIabrev}->{I};
          $abrI and $refacalc->{DEFIequiv}->{$abrI} = 'I';
      };
#      impr_debug(__LINE__.' Prog $refarch->{DEFIcalculo}->{$nump}'
#		 , Dumper $refarch->{DEFIcalculo}->{$numpl});
  };# for $numpl
  impr_UNIDADES(__LINE__.' Prog $refarch',$refarch);
  comfin('finP calcular_UNIDADES');
  return;
}#calcular_UNIDADES 
# -----------------------------------------------------------------------------
sub comando_selec{
#selec simulado indica que el archivo simbolico SIMULADO, de nombre real
# por ejempplo algo.simul dara origen a otro selec_algo.simul
#  , misma carpeta
# selec es un prefijo, en minuscula, para el archivo real;
# el correspondiente simbolico es SELEC_SIMULADO
# si se necesitan varios, se puede pedir 'selec simulado = 2,...' etc
# luego se controlara existencia de los archivos simbolicos
  comfin('comP comando_selec',@_);
#  impr_debug(__LINE__.' Prog $ref_arch',Dumper $ref_arch);
  foreach my $comando (@{$refcrudo1->{selecciones}}) {
      my $coderr = '';
      my ($SIMBARCH,$SIMBARCHP,$SIMBARCH_ORI,$archivo,$seleccion);
      if ($comando =~ /^(selec)\w*\s+(\S+)\s*=\s*(.+)/i) {
          my ($rango,$colu) = ([],'');
          $SIMBARCH_ORI = $2; $SIMBARCH = uc($SIMBARCH_ORI);
          my @listacols = split /\s*[,:]\s*/,$3;
          if (@listacols != 4) {
              mensajear("No se entiende $comando; se ignora");
              next; 
          };
          $SIMBARCHP = shift @listacols; $SIMBARCHP = uc($SIMBARCHP);
#          impr_debug(__LINE__.' Prog $SIMBARCHP',$SIMBARCHP);
          my $archivop = $ref_arch->{$SIMBARCHP}->{archivo};
          if (not $archivop) {
              mensajear("No esta bien definido $SIMBARCHP; se ignora el comando
              $comando"); $comando = undef; next;
          };
          my $archivopsin = $archivop;my $punext = '';
          if ($archivopsin =~ s/(\.)(\w*)$//) {
	      $punext = "$1$2";
	  };
#          impr_debug(__LINE__.' Prog $archivop,$archivopsin'
#		     ,[$archivop,$archivopsin]);
          my ($base,$archivopsinbasesin) = ('',$archivopsin);
#          impr_debug(__LINE__.' Prog $base,$archivopsinbasesin,$punext',
#		     [$base,$archivopsinbasesin,$punext]);
          if ($archivopsinbasesin =~ s/^(.+\/)([^\/]+)$/$2/) {
              $base = $1;
              impr_debug(__LINE__.' Prog $base,$archivopsinbasesin'
	         	     ,[$base,$archivopsinbasesin]);
          };
#          impr_debug(__LINE__.' Prog $base,$archivopsinbasesin,$punext',
#		     [$base,$archivopsinbasesin,$punext]);
          my $cosa = $colu = shift @listacols;
          @$rango = rango_seleccion(@listacols); 
#          impr_debug(__LINE__.' Prog $col,$rango',[$colu,$rango]);
          @listacols = ($colu);
	  my @nuelista
            = controlar_lista_pl($SIMBARCHP,\@listacols,$comando,'selec');
          if (@nuelista != 1) {
              mensajear(" No se entiende, se ignora 
                 $comando");next;  
	  };
          $colu = $nuelista[0];
          $cosa !~ /^\d+$/ or $cosa
             = $ref_arch->{$SIMBARCHP}->{sceptre}->{$colu+1};
          $seleccion = "$cosa,$rango->[0]:$rango->[1]";
          my %hash = ('archivopadre'=>$SIMBARCHP
            ,'SIMBARCH_ORI' => $SIMBARCH_ORI
            ,'archivo'=>"$base$archivopsinbasesin".'_'.lc($SIMBARCH_ORI).$punext
            ,'comando_ori'=>$comando
            ,'colu'=>$colu,'rango'=>$rango,'seleccion'=> $seleccion);
#          impr_debug(__LINE__.' Prog %hash',Dumper \%hash);
          push @{$refcrudo2->{selecciones}->{uc($SIMBARCH)}->{hash}}
              ,\%hash;
       };
  };
  delete $refcrudo1->{selecciones};
#  impr_debug(__LINE__.' Prog $refcrudo2->{selecciones}'
#    ,Dumper $refcrudo2->{selecciones});
  comfin('finP comando_selec');
  return;
}#comando_selec
# -----------------------------------------------------------------------------
sub completar_UNIDADES{
  comfin('comP completar_UNIDADES',@_);
  my ($refarch,@numpls) = @_;
  my %hequivale;
  foreach my $numpl (@numpls) {
      my $origen = $refglobal->{DEFIcalculo}->{$numpl};
#      impr_debug(__LINE__.' Prog $refarch->{DEFIcalculo}'
#        ,Dumper $refarch->{DEFIcalculo});
#      impr_debug(__LINE__.' Prog $origen',Dumper $origen);
      $refarch->{DEFIcalculo} or $refarch->{DEFIcalculo} = {};
      $refarch->{DEFIcalculo}->{$numpl}
        or $refarch->{DEFIcalculo}->{$numpl} ={};
      my $destino = $refarch->{DEFIcalculo}->{$numpl};
#      impr_debug(__LINE__.' Prog $destino',Dumper $destino);
      foreach my $key (sort keys %$origen) {
          foreach my $cosa (keys %{$origen->{$key}}) {
              not $destino->{$key}->{$cosa} and
                $destino->{$key}->{$cosa} = $origen->{$key}->{$cosa};
          };   
      };
      foreach my $key 
             (sort keys %{$refarch->{DEFIcalculo}->{$numpl}->{DEFIequiv}}) {
          push @{$hequivale{$key}}
              ,$refarch->{DEFIcalculo}->{$numpl}->{DEFIequiv}->{$key}; 
          $refarch->{TIPOTOK}->{$key} = 'h';
      };
       $refarch->{hequivale} = \%hequivale;
   };
  $refarch->{TIPOTOK}->{V} = 'h'; $refarch->{TIPOTOK}->{I} = 'h';
#  impr_debug(__LINE__.' Prog $refarch->{DEFIcalculo}'
#    ,Dumper $refarch->{DEFIcalculo});
#  impr_debug(__LINE__.' Prog TIPOTOK',Dumper $refarch->{TIPOTOK});
#  impr_debug(__LINE__.' Prog hequivale',Dumper $refarch->{hequivale});
#  impr_debug(__LINE__.' Prog TIPOTOK',Dumper $refglobal->{TIPOTOK});

  impr_UNIDADES(__LINE__.' Prog $refarch',$refarch);
  comfin('finP completar_UNIDADES');
}#completar_UNIDADES
# -----------------------------------------------------------------------------
sub consistencia_minima{
  comfin('comP consistencia_minima',@_);
  my ($reflista,$archivo,$SIMBARCH)= @_; my $coderr = '';
  my @renglones = `head $archivo`; my $para = '';my @listacosas;
  while (@renglones) {
      my $renglon = shift @renglones;
      if ( $renglon =~ s/^\#\s*para Simusol\s*:\s*//i) {
          $para = $renglon;last;
      };
  };
  not $para and return;
  @listacosas = split /\s*,\s*/,$para;
  while (@listacosas) {
      my $cosa = shift @listacosas;
      if ($cosa =~ /sceptre/) {last;
      } else { shift @renglones};
  };
  my $lista = shift @renglones;
  $lista =~ s/^\#\s*//;
  my @lista =split /\s+/,$lista;
  for (my $i= 0; $i <@$reflista; $i ++) {
      if ($reflista->[$i] ne $lista[$i]) {
          $coderr = 1; last;
      };
  };
  if ($coderr) {
      mensajear(
       " Inconsistencia entre variables(sceptre) anunciadas para $SIMBARCH
         y las indicadas en el archivo real $archivo;
         @{$reflista}
         @lista");
  };
  comfin('finP consistencia_minima');
  return
}#consistencia_minima
# -----------------------------------------------------------------------------
sub controlar_lista_pl{
  comfin('comP controlar_lista_pl',@_);
  my ($SIMBARCHP,$reflista,$renglonori,$palabrita)= @_;
  my $coderr = '';
#  impr_debug(__LINE__.' Prog keys %$ref_arch',[keys %$ref_arch]);
  my ($absc, $refcols,$refnuelista) = ('',[],[]);
  my $cuantos = -1; my $sininf= ''; my $agre = '';
  if (not $ref_arch->{$SIMBARCHP}->{variable}) {
      $sininf = 1; $agre = '; No hay inf. sobre variables del archivo'; 
  } else {
      $cuantos = @{$ref_arch->{$SIMBARCHP}->{variable}};
  };
  for (my $i = 0; $i < @$reflista; $i ++) {
      my $cosa = $reflista->[$i];my $numero;
#      impr_debug(__LINE__.' Prog $cosa',$cosa); 
      if ($cosa =~ /^[\d]+$/) {
          if ($cosa < 0) {
          } else {
              $numero = $cosa;
          };
      } else {
#          impr_debug(__LINE__.' Prog nombre2num'
#           ,Dumper $ref_arch->{$SIMBARCHP}->{nombre2num});
          $numero = $ref_arch->{$SIMBARCHP}->{nombre2num}->{$cosa};
#          impr_debug(__LINE__.' Prog $cosa,$numero',[$cosa,$numero]);
          not defined $numero and
            $numero = $ref_arch->{$SIMBARCHP}->{nombre2num}->{uc($cosa)};
#          impr_debug(__LINE__.' Prog $cosa,$numero',[$cosa,$numero]);
      };
      if (not defined $numero) {
          $coderr = 2;
          mensajear(" No se reconoce variable $cosa;$agre
               se elimina del pedido
                $renglonori");next;
      } else {
           push @$refcols,$numero;
      }; 
#      impr_debug(__LINE__.' Prog',Dumper $refcols);
  }#reflista;
  comfin('finP controlar_lista_pl',@$refcols);
  return @$refcols
}#controlar_lista_pl
# -----------------------------------------------------------------------------
sub evaluar_funcion_h{
  comfin('comP evaluar_funcion_h', @_);
  my ($ref,$pre0,$elenodo) = @_;my ($coderr,$valor,$tipovalor) = ('','','');
#  impr_debug(__LINE__.' Progr TIPOTOK',Dumper $ref->{TIPOTOK});
  my $tipotok = valor($ref,'TIPOTOK',$elenodo);   
  impr_debug(__LINE__.' Prog equivpre',Dumper $ref->{equivpre});
  if (not $ref->{equivpre}->{$pre0}) {
      $coderr = 50;
      comfin('finP evaluar_funcion_h',$coderr);
      return $coderr;
  };
  if ($tipotok eq 'm' and grep (do{$_ eq 'V'},@{$ref->{equivpre}->{$pre0}})) {
      (my($coder,$val),$tipovalor) = nodo2sceptre($ref,'V',$elenodo);
      not $coder and $valor = $val;
  } elsif (@{$ref->{equivpre}->{$pre0}} == 1) {# solo puede valer 1 o 2
       #puede ser 2 si hay mas de una plantilla involucrada 
      my $numplant = $ref->{ELESPLANT}->{$elenodo}
        if $ref->{ELESPLANT} and $ref->{ELESPLANT}->{$elenodo};
      my $pre = $ref->{equivpre}->{$pre0}->[0]; 
      impr_debug(__LINE__.' Prog $elenodo,$numplant,$tipotok,$pre'
        ,[$elenodo,$numplant,$tipotok,$pre]);
      if ($numplant) { 
          $valor = "$pre$elenodo"; $tipovalor = 's';
          ($valor =~ s/^VE/E/ or $valor =~ s/^IJ/J/)  and $tipovalor = 'a';
          my $pre1 = $ref->{DEFICALCULO}->{$numplant}->{DEFiequiv}->{$pre0};
          if (defined $pre1) { 
              $valor = "$pre1$elenodo"; $tipovalor = 's';
              ($valor =~ s/^VE/E/ or $valor =~ s/^IJ/J/)
                 and $tipovalor = 'a';
           };
      }; 
  }
  not $tipovalor and $coderr = 50;
  comfin('finP evaluar_funcion_h', $coderr,$valor,$tipovalor);
  return $coderr,$valor,$tipovalor;
}#evaluar_funcion_h
# -----------------------------------------------------------------------------
sub existencia_archivo{
  comfin('comP existencia_archivo', @_);
  my $renglon = $_[0];
  my $presimul = "\.\.\/($dirsalida{simul}\/)";# preparado para busqueda
  my $predata = "\.\.\/($dirsalida{dat}\/)";
  if ($renglon =~ /^(archivo|arch_var)\w*\s+(\S+)\s*=\s*(.+)/i) {
      my ($palabrita,$ori,$SIMBARCH,$cosa) = ($1,$2,uc($2),$3);
      my @lista = split ',',$cosa;
#      impr_debug(__LINE__.' Prog \@lista',\@lista);
      map(s/^$presimul/$1/, @lista);
      map(s/^$predata/$1/, @lista); 
#      impr_debug(__LINE__.' Prog \@lista',\@lista);
      if ($progr{$progname} ne 's') {       
          foreach my $file (@lista) {
              if (not -e $file) {
                  mensajear(
      " No existe un archivo $file; se ignora el comando 
            $renglon
          y  todo lo que se refiera a $ori");
                  comfin('finP existencia_archivo');
                  return ;
              };
          };
      };
      if ($palabrita eq 'archivo') {
          push @{$refcrudo2->{delarch}->{uc($SIMBARCH)}->{archivo}}
            , $lista[0];
        } else {
          push @{$refcrudo2->{delarch}->{uc($SIMBARCH)}->{lc($palabrita)}}
           , \@lista;
      }; 
      push @{$refcrudo2->{delarch}->{uc($SIMBARCH)}->{SIMBARCH_ORI}}
        , $ori;
      push @{$refcrudo2->{delarch}->{uc($SIMBARCH)}->{archivopadre}},$SIMBARCH;
  } else {
      mensajear(" No se entiende y se ignora:
       $renglon");
  };
  comfin('finP existencia_archivo');
#  impr_debug(__LINE__.' Prog $refcrudo2',Dumper $refcrudo2);
  return ;
}#existencia_archivo @_);
# -----------------------------------------------------------------------------
sub extraer_unidad{
   my $texto = $_[0];my @listita = ();
   if ($texto =~ /(.*)\(\s*(\S.*)\s*\)/) {
       my $unidad = $2; my $var = $1; $var =~ s/^\s*//;$var =~ s/\s*$//;
       $unidad = $unis_tiempo{lc($unidad)}
         if defined $unis_tiempo{lc($unidad)};# %unis_tiempo, solo para tiempo
       return $var,$unidad;
   } else {
       return '??','??';
   }    
}#extraer_unidad
# ----------------------------------------------------------------------------
sub graf_usa_SIMBARCH{
  comfin('comP graf_usa_simbarch',@_);
  my @graf_usa_SIMBARCH = (grep /^(punto|linea)/,@{$refcrudo1->{grafesen}});
  comfin('finP graf_usa_simbarch',@_);
}#graf_usa_simbarch;
# ----------------------------------------------------------------------------
sub guardar_plant_UNIDADES{
  comfin('comP guardar_plant_UNIDADES',@_);
  my ($refplantillas,$refcuadro,$refgraf) = @_; my $coderr = ''; 
  my (@repeplants,@malasplants,@mensajes);
  foreach my $numplant (@$refplantillas) {
      my (%stringhash,%equivhash);my $malaplant = '';
      if (defined $refcuadro->{defiuni}->{comp}->{$numplant}) {
#          mensajear(" Hay definici
          push @repeplants, $numplant; next;
      }; 
      impr_debug(__LINE__.' Prog $refcuadro',Dumper $refcuadro);
      foreach my $clase (sort keys %$refcuadro) {
	  my @listita = split /\s*,\s*/,$refcuadro->{$clase};
          my $cuantos = scalar @listita; 
          if ($clase =~ /^[CLRT]$/ and $cuantos == 2) {
          } elsif ($clase =~ /^[EJ]$/ and $cuantos =~ /^[23]$/) {
              if ($cuantos == 2) {
		  my $cosa = 'V'; $clase eq 'J' and $cosa = 'I';
                  push @mensajes,
                     " Recuerde que puede agregar a \'$refcuadro->{$clase}\', separado por ','
            una palabra para que sea equivalente a \'$cosa\'";
	      };
          } elsif ($clase eq 'M') {
          } else {
              $malaplant = 1;
          };
          $stringhash{$clase} = "$listita[1],$listita[0]";
          if ($cuantos == 3) {
             $equivhash{$clase} = $listita[3];
          };  
      };
      if ($malaplant) {
         push @malasplants, $numplant;
      } else {
	  %{$refcuadro->{defiuni}->{comp}->{$numplant}} = %stringhash;
          scalar keys %equivhash and
              %{$refcuadro->{defiuni}->{$numplant}->{equiv}} = %equivhash;  
      };
  };
  impr_debug(__LINE__.' Prog @repeplants',\@repeplants);
  impr_debug(__LINE__.' Prog @malasplants',\@malasplants);
  impr_debug(__LINE__.' Prog @mensajes',join ("\n",@mensajes));
  comfin('finP guardar_plant_UNIDADES',$coderr);
  return \@repeplants,\@malasplants,\@mensajes;
}#guardar_plant_UNIDADES  
# ----------------------------------------------------------------------------
sub ident_simulado{
  comfin('comP ident_simulado',@_);
  my $ref = $_[0]; 
  my ($sceptrevars,$unidades,$propias,$magnitudes) = ('','','','');
  my $paraplotSIMULADO = '';
  foreach my $pal (qw(magnitudes unidades)) {
      map(do {$_ or $_ = '??'}, @{$ref->{"lis$pal"}});
  };
  foreach my $palabra (qw(sceptres propias magnitudes unidades)) {
#     impr_debug(__LINE__.' Prog $ref->{lis$palabra}', $ref->{"lis$palabra"});
  };  
  $sceptrevars = join ',',@{$ref->{lissceptres}};
  # en {lissceptres} sigue TIEMPO en cuenta de TIME
  $propias = join ',',@{$ref->{lispropias}};
  $unidades =  join ',',@{$ref->{lisunidades}};
  $magnitudes =  join ',',@{$ref->{lismagnitudes}}; 
#  impr_debug(__LINE__.' Prog $magnitudes',$magnitudes);
  my @indicebueno = @{$ref->{lisindicebueno}};
  my @lista =  @{$ref->{lispropias}};
  for (my $i = 0; $i < @lista; $i ++) {
      $lista[$i] =~ s/\s//g;
          $nombreshash{uc($lista[$i])} = $i+1;
  };
  my $archguardar = "$refnombres[$NUMPRINCIPAL]->{PROPIOSINGUARDAR}.simul";
  $paraplotSIMULADO =  
        "archivo SIMULADO = $mutuodir$dirsal{simul}$archguardar\n"
      . "sceptrevars SIMULADO = $sceptrevars\n" 
      . "variables SIMULADO = $propias\n" 
      . "unidades SIMULADO = $unidades\n" 
      . "magnitudes SIMULADO = $magnitudes\n";
  #sceptrevars  lo usa simusol2.pl;  pero no simusol3.pl salvo que se deje 
  #indices SIMULADO = 1,...
  my $referencia = '';
  if (not grep('??',@lista)) {$referencia = 1; 
      # significa que hay errores en los pedidos
  } else { 
      for(my $i = 0; $i < @indicebueno; $i ++) {
          $indicebueno[$i] ne $i+1 and $referencia = 1;
      };
  };
  if ($referencia) {
      my $tira = join ', ', @indicebueno;
      $paraplotSIMULADO .= "indices SIMULADO = $tira\n";  
  };
  #impr_campo(__LINE__.' Prog $ref',$ref,'rerun');
  if (scalar keys %{$ref->{rerun}} and
          $ref->{rerun}->{marcasrerun}) {
      impr_campo(__LINE__.' Prog  $ref',$ref,'rerun','archrerun');
      $paraplotSIMULADO .= "arch_var SIMULADO = $ref->{rerun}->{archrerun}\n";
      $paraplotSIMULADO
          .= "variaciones SIMULADO = $ref->{rerun}->{marcasrerun}\n"
  };
  comfin('finP ident_simulado',$paraplotSIMULADO);
  return $paraplotSIMULADO;  
}#ident_simulado
# -----------------------------------------------------------------------------
sub interpretar_hconparen{#aqui todo viene en mayusculas
  comfin('comP interpretar_hconparen',@_);
  my($ref,$pre,$elenodo) = @_;
  my ($coderr,$valor) = evaluar_funcion_h($ref,$pre,$elenodo);
  comfin('finP interpretar_hconparen',$coderr,$valor);
  return $coderr,$valor;
}#interpretar_hconparen'
# -----------------------------------------------------------------------------
sub interpretar_hconblanco{#sirve para expresion con una o mas apariciones
  comfin('comP interpretar_hconblanco',@_);
  my($ref,$valor) = @_;my ($coderr,$ya,$tipotok) = ('','','');
  $valor = ";$valor;";
  while ($valor =~ /\W(\w+) (\w+)\W/) {
      my ($pre,$elenodo) = (uc($1),uc($2));
      $elenodo =~ s/^\((.+)\)/$1/;
      my ($coder,$val,$tipovalor) = evaluar_funcion_h($ref,$pre,$elenodo);
      if (not $coder) {
          $valor =~ s/(\W\w+) (\w+\W)/$val/;
      } else {
          $valor =~ s/(\W\w+) (\w+\W)/$1&&$2/;
          $coderr = 50;
      };
  };#while
  $valor =~ s/;(.+);/$1/; $valor =~ s/\&\&/ /g;
#  if (not $coderr) { 
#      $valor =~ s/^VE/E/; $valor =~ s/^IJ/J/; #ya se encargo evaluar_funcion_h
#  }; 
 comfin('finP interpretar_hconblanco',$coderr,$valor);
 return $coderr,$valor;
}#interpretar_hconblanco',@_);
# -----------------------------------------------------------------------------
sub impr_grafo{
  return unless $debug;
  return if $opt_hash{noverb};
  my ($mensaje,$grafo) = @_;
  print STDERR " Comienza impr_grafo: $mensaje  $grafo\n";
  print STDERR '$ref_graf->{'.$grafo.'} ',Dumper $ref_graf->{$grafo};
  print STDERR "Termina impr_grafo $grafo\n";
  return;
}#impr_grafo
# -----------------------------------------------------------------------------
sub impr_ref_arch_grafdecor_selecciones{
  return unless $debug;
  my $mensaje = $_[0];
  print STDERR "Empieza impr_ref_arch_grafdecor_selecciones $mensaje\n";
  print STDERR ". . . \$ref_arch ",Dumper $ref_arch if scalar keys %$ref_arch;
  print STDERR ". . . \$ref_graf ",Dumper $ref_graf if scalar keys %$ref_graf;
  print STDERR ". . . \$ref_selecciones "
    ,Dumper $ref_selecciones if scalar keys %$ref_selecciones;
  print STDERR "Termina impr_ref_arch_grafdecor $mensaje\n";
  return;
}#impr_ref_arch_grafdecor_selecciones
# -----------------------------------------------------------------------------
sub incluir_cuadro_grafico{
  comfin('comP incluir_cuadro_grafico',@_);
  my ($ref,$cual) = @_; my $coderr = '';
  my ($parcialparaplot, $parcialhaysimulado, @parcialuniprilista) = ('',0);
  my %todos = %{$ref->{refvalores}->{$cual}}; 
  foreach (sort keys %todos) {
      my $graficolista = $todos{$_};
      ($coderr, my @graficolista)
         = juntar_por_signos_y_paren(',', @$graficolista);
      if ($coderr) {
          porparar1(88,$ref);
          $coderr = '';
          next;
      };
      impr_debug(__LINE__.' Prog @graficolista', \@graficolista);
      my @pegados = grep (/=.*=/,@graficolista);
      if (@pegados) { 
          avnoseent("Los \"renglones\" del cuadro $cual\n" .
                    join ("\n", @pegados) . "
              quizás un renglón terminado por error con coma 
                  se pegó al siguiente");
      };                     
      @graficolista = grep($_!~ /=.*=/,@graficolista);
      impr_debug(__LINE__.' Prog @graficolista', \@graficolista);
      foreach my $renglon (@graficolista) {
          if ($renglon =~ /^\s*archivo\s+\S+\s*=\s*(\S+)\s*$/i) {
              my ($coderr,$archivo)
                = administrar_archivo($1,$dirsalida{dat},'copiar');
	      impr_debug(__LINE__.' Prog $archivo',$archivo);
              if ($coderr) {
                  $renglon = '';
              } else { 
                  $renglon
                     =~ s/^(\s*archivo\s+\S+\s*=\s*)(.+)\s*$/$1$archivo/;
              };
          } elsif ($renglon =~ /^\s*guardar\s+\S+\s*=\s*(\S+)\s*$/i) {
              my $archivo = $1;
              my ($coderr,$archivoabs)= administrar_archivo($archivo,'','nombrar');
              if ($coderr) {
                  mensajear(" No es posible atender\n    $renglon");
                  $renglon = '';
              } else {
                  $renglon
                    =~ s/^\s*(guardar\s+\S+)\s*=\s*(\S+)\s*$/$1=$archivoabs/i; 
              };                        
          };
      };  
      @graficolista = grep (do{$_ ne ''},@graficolista);
      @graficolista and do{
          $parcialparaplot = join("\n",@graficolista). "\n"; 
      };
      $parcialhaysimulado += scalar (grep(/=\s*SIMULADO\s*\,/i,@graficolista));
      push @parcialuniprilista, grep(/unipri\s*SIMULADO/,@graficolista);   
  }; #foreach 
  comfin('finP incluir_cuadro_grafico');
  return $parcialparaplot,$parcialhaysimulado,@parcialuniprilista;
}#incluir_cuadro_grafico
# ----------------------------------------------------------------------------
sub interpretar_mostrar{# sin argumentos
  comfin('comP interpretar_mostrar',@_);
  my @nolistatotal;
  foreach my $renglonori (@{$refcrudo1->{grafmostrar}}) {
      my $renglon = $renglonori;
      if ($renglon =~ s/^\s*nomostrar\s+([^=]+)$/$1/i) {
          $renglon =~ s/\s*$//;
          if ($renglon) {
             push @nolistatotal,split(/\s*,\s*/,$renglon);
          };          
      } elsif ($renglon =~ s/^\s*mostrarj\w*\s+(\w+)\s*=\s*(.+)$/$2/i) {
          my $simbolo_ori = $1; my $simbolo = lc($simbolo_ori);
          $renglon =~ s/\s*$//; $renglon = lc($renglon);
          impr_debug(__LINE__.' Prog $simbolo,$renglon'
		     ,[$simbolo,$renglon]);
          push @{$refcrudo3->{grafmostrar}->{$simbolo}->{mostrarj}}
           ,[split(/\s*,\s*/,$renglon)];
          push @{$ref_graf->{$simbolo}->{simbgraf_ori}}, $simbolo_ori;
          push @{$refcrudo3->{grafmostrar}->{$simbolo}->{comando}}
	  ,$renglonori;
      }; 
  }; #$renglonori
  my @nolistatotalunion = union_conjunto(@nolistatotal);
  @nolistatotalunion == @nolistatotal or 
     mensajear("Hay pedidos reiterados de no mostrar graficos:
         @nolistatotal");
  impr_debug(__LINE__.' Prog @listatotalunion', Dumper \@nolistatotalunion);
  map($refcrudo3->{grafmostrar}->{lc($_)}->{nomostrar} = 1,@nolistatotalunion);
  map(do{push @{$ref_graf->{lc($_)}->{simbgraf_ori}},$_}
     ,@nolistatotalunion);
  foreach my $simbgraf (sort keys %{$refcrudo3->{grafmostrar}}) {
      if ($refcrudo3->{grafmostrar}->{$simbgraf}->{decor}) {
          if (scalar keys %{$refcrudo3->{grafmostrar}->{$simbgraf}} >1) {
              mensajear(
              " Hay indicaciones de 'mostrarjunto' y 'nomostrar' para $simbgraf;
              se ignoran todas");
              delete $refcrudo3->{grafmostrar}->{$simbgraf}; next;
          };  
          if (@{$refcrudo3->{grafmostrar}->{$simbgraf}->{mostrarj}} >1) {
              mensajear(
                  " Hay mas de una definicion con 'mostrarjunto' para $simbgraf;
                  se ignoran todas");
              delete $refcrudo3->{grafmostrar}->{$simbgraf}->{decor}->{mostrarj};
          } else {
               $refcrudo3->{grafmostrar}->{$simbgraf}->{mostrarj}
	         = $refcrudo3->{grafmostrar}->{$simbgraf}->{mostrarj}->[0];
          };
      };
      impr_debug(__LINE__.' Prog  $refcrudo3->{grafmostrar}->{$simbgraf} '
        .$simbgraf, Dumper $refcrudo3->{grafmostrar}->{$simbgraf});
  };   
  delete $refcrudo1->{grafmostrar};
  scalar keys %{$refcrudo3->{grafmostrar}} or delete $refcrudo3->{grafmostrar};
  comfin('finP interpretar_mostrar');
  return
}#interpretar_mostrar
# ----------------------------------------------------------------------------
sub inventar_graficos{
  comfin('comP inventar_graficos',@_);
  my $ref = $_[0];
  my @estalista;
  impr_resultados(__LINE__.' Prog',$ref);
#  my $PROPIO = $refnomb->{PROPIO};
#  my $date = $refnomb->{DATE};
  my $ngraf = 'graf00';
  my ($NGRAF,%textos,$todotextos, @simbograf,$textojuntos);
  $textojuntos = '';
  my $mens_sincuadro = "---- Recuerde que puede:
               pedir gráficos en un cuadro GRAFICOS 
               o pedir gráficos en forma interactiva ejecutando
                    simusol -graf 1 $PROPIO" ;
  our @mens = split "\n", $mens_sincuadro;                   
  foreach my $key (@{$ref->{lispares}}) {
      next unless $ref->{hashdeparnum}->{$key} and 
                @{$ref->{hashdeparnum}->{$key}};
      if ($key =~ /\?\?,\?\?/) {
          foreach my $nnn (@{$ref->{hashdeparnum}->{$key}}  ) {
              $ngraf ++;
              $NGRAF = uc($ngraf);
              push @simbograf, $NGRAF;
              $textos{$key} = "lineas $NGRAF = SIMULADO, 1 : $nnn\n"; 
              push @estalista, "lineas $NGRAF = SIMULADO, 1 : $nnn";
              $todotextos .= $textos{$key}; 
          };
      } else {
          $ngraf ++;
          $NGRAF = uc($ngraf);
          my $listita = join ',', @{$ref->{hashdeparnum}->{$key}};
          push @simbograf, $NGRAF;
          $textos{$key} = "lineas $NGRAF = SIMULADO, 1 : $listita\n"; 
          push @estalista, "lineas $NGRAF = SIMULADO, 1 : $listita";
          $todotextos .= $textos{$key}; 
      };
  }; #$key 
  my $juntotextos='';
  for (my $gg= 0; $gg< @simbograf; $gg += 2) {
      last if $gg+1 == @simbograf;
      $ngraf ++; $NGRAF = uc($ngraf);
      $textojuntos .=
            "mostrarjuntos $NGRAF = $simbograf[$gg], $simbograf[$gg+1]\n"
           . "nomostrar $simbograf[$gg], $simbograf[$gg+1]\n";
  push @estalista, "mostrarjuntos $NGRAF = $simbograf[$gg], $simbograf[$gg+1]";
  push @estalista, "nomostrar $simbograf[$gg], $simbograf[$gg+1]"; 
  }; 
  map ($juntotextos .= "echo $NGRAF = $_\n", @mens); 
  comfin('finP inventar_graficos',@estalista);
  return "$textojuntos$todotextos",\@estalista;
  #va primero $textojuntos para mostrar primero los dobles graficos
}#inventar_graficos
# ----------------------------------------------------------------------------
sub inventar_titulos{# con datos de archivos
  comfin('comP inventar_titulos',@_);
  my $simbgraf = $_[0];
  my $ref_graf_graf = $ref_graf->{$simbgraf};
  my $ref_graf_grafdecor = $ref_graf_graf->{decor};
  impr_debug(__LINE__.' Prog $ref_graf_grafdecor antes inventar '.$simbgraf
	     ,Dumper  $ref_graf_grafdecor);
  impr_debug(__LINE__.' Prog $ref_graf_graf '.$simbgraf, Dumper $ref_graf_graf);
  my @reflistas = @{$ref_graf_graf->{pl}};
  my %datosto = ('abss'=>{},'ords'=>{});
  $datosto{abss}->{variable} = [];$datosto{abss}->{unidad} = [];
  $datosto{abss}->{unipri} = [];
  $datosto{ords}->{magn} = [];$datosto{ords}->{unidad} = [];
  impr_debug(__LINE__.' Prog @reflistas',Dumper \@reflistas);
  my %datos = ('magn'=>{},'unidad'=>{},'variable'=>{});
  impr_debug(__LINE__.' Prog %$ref_arch',Dumper $ref_arch);
  foreach my $reflista (@reflistas) {      
      my ($comando,$SIMBARCH,$col1,$refcols) = @$reflista;
      impr_debug(__LINE__.' Prog $SIMBARCH,$col1',[$SIMBARCH,$col1]);
      my @listacols = @$refcols;
      my $SIMBARCHP = $ref_arch->{$SIMBARCH}->{archivopadre};
      my $ref_arch_arch = $ref_arch->{$SIMBARCH};
      impr_debug(__LINE__.' Prog $SIMBARCH,$SIMBARCHP',[$SIMBARCH,$SIMBARCHP]);
      my $ref_arch_archp = $ref_arch->{$SIMBARCHP};
      if ($col1 == 0) {
          $SIMBARCH eq 'SIMULADO'
            and unshift @{$datosto{abss}->{variable}},'numero'
            or push @{$datosto{abss}->{variable}},'numero';
      } else {
          for my $pal ('variable','unidad') {
              my $valor = $ref_arch_archp->{$pal}->[$col1-1];
#              if ($valor and $valor ne '??') {
                  $SIMBARCH eq 'SIMULADO'
                    and unshift @{$datosto{abss}->{$pal}},$valor
                    or push @{$datosto{abss}->{$pal}},$valor;
#              };
          };
      };
      foreach my $col (@listacols) {
          foreach my $pal ('magn', 'unidad') {
              my $valor = $ref_arch_archp->{$pal}->[$col-1];
#              if ($valor and $valor ne '??') {
                  $SIMBARCH eq 'SIMULADO'
                    and unshift @{$datosto{ords}->{$pal}},$valor
		    or push @{$datosto{ords}->{$pal}},$valor;
#              };
          };
      };
      if (defined $ref_arch_archp->{unipri} and $col1 == 1) {
          push @{$datosto{abss}->{unipri}},$ref_arch_archp->{unipri}->[0];
      };
  };#$reflista
  impr_debug(__LINE__.' Prog %datosto',Dumper \%datosto);
  @{$ref_graf_grafdecor->{varabsc}} =  @{$datosto{abss}->{variable}};
  @{$ref_graf_grafdecor->{uniabsc}} =  @{$datosto{abss}->{unidad}};
  @{$ref_graf_grafdecor->{unipri}} =  @{$datosto{abss}->{unipri}};
  @{$ref_graf_grafdecor->{magord}} =  @{$datosto{ords}->{magn}};
  @{$ref_graf_grafdecor->{uniord}} =  @{$datosto{ords}->{unidad}};
  impr_debug(__LINE__.' Prog $ref_arch',Dumper  $ref_arch);
  foreach my $pal ('uniabsc','uniord','unipri','varabsc','magord') {
      my @unigrafico = union_conjunto(@{$ref_graf_grafdecor->{$pal}});
      @unigrafico == 0 and $pal ne 'unipri' and @unigrafico = ('??');
      @unigrafico > 1 and mensajear(
      " Varias posibilidades para $pal de $simbgraf: @unigrafico");
      $ref_graf_grafdecor->{$pal} = $unigrafico[0];
  };
  if ($ref_graf_grafdecor->{unipri} ) {
      $ref_graf_grafdecor->{uniabsc} = $ref_graf_grafdecor->{unipri};
  };
#  impr_debug(__LINE__.' Prog $ref_graf_grafdecor despues inventar'
#	     ,Dumper  $ref_graf_grafdecor);
  comfin('finP inventar_titulos');
  return;
}#inventar_titulos
# ---------------------------------------------------------------------------
sub llenar_grafdecor{# sin argumentos 
  comfin('comP llenar_grafdecor',@_);
  # a partir de $refcrudo2
  impr_debug(__LINE__.' Prog $ref_graf ',Dumper $ref_graf);
  my @lista = union_conjunto(keys %$ref_graf);
  impr_debug(__LINE__.' Prog @lista',\@lista);
  foreach my $simbgraf (sort @lista) {
      my $ref_graf_graf = $ref_graf->{$simbgraf};
      $ref_graf_graf->{decor} or $ref_graf_graf->{decor} = {};
      my $comsimb = $ref_graf_graf->{decor};
      next if $ref_graf_graf->{mostrarj};
      $comsimb or $comsimb = {};
      my ($titx,$tity,$varabsc,$uniabsc,$magord,$uniord) = ('','',[],[],[],[]); 
      if ($comsimb->{eje}) {
          my ($coderr,@lisd) = juntar_por_paren_cur(',',@{$comsimb->{eje}});
          if ($coderr or @lisd != 2) {
              mensajear(' No se entiende '. join(',',@lisd)
                . ' como parte de indicación para ejes;
                   pueden resultar gráficos erroneos; se ignoran.
          Se espera, por ej.,  \"ejes xxxx = tiempo(seg), temp(grados C)\"');
          } else {
              $titx =  $lisd[0];# por eje 
              $tity =  $lisd[1];# por eje 
              ($varabsc,$uniabsc) = extraer_unidad($lisd[0]); # por eje 
              ($magord,$uniord) = extraer_unidad($lisd[1]);#por eje
          };
          delete $comsimb->{eje};
          @$comsimb{'titx','tity','varabsc','uniabsc','magord'
            ,'uniord'} = ($titx,$tity,$varabsc,$uniabsc,$magord,$uniord);
      };
      $comsimb->{rangos} = '' unless $comsimb->{mostrarj};
      if ($comsimb->{rangox} or $comsimb->{rangoy}) {
          my $rangox='['.$comsimb->{rangox}->[0].']' if $comsimb->{rangox}->[0];
          my $rangoy='['.$comsimb->{rangoy}->[0].']' if $comsimb->{rangoy}->[0];
          my $rangos = "[] []";
          my $rangosdado='';
          if ($rangox and $rangoy) {
              $rangosdado = $rangox .' '. $rangoy; 
          } elsif ($rangoy) {
              $rangosdado = "[] $rangoy";
          } elsif ($rangox) {
              $rangosdado = "$rangox []";
          };
          $rangosdado and $comsimb->{rangos} = $rangosdado;
      };
#      impr_debug(__LINE__.' Prog $ref_graf->{$simbgraf}->{decor}'
#		 ,Dumper $comsimb);
      if (defined $ref_graf_graf->{pl}) { 
          if (not $comsimb->{titx}) {
              inventar_titulos($simbgraf);
              impr_debug(__LINE__.' Prog $ref_graf_graf',Dumper $ref_graf_graf);
              if ($comsimb->{unipri}) {
                  $titx = armar_eje($simbgraf,'varabsc','unipri');
              } else { 
                  $titx = armar_eje($simbgraf,'varabsc','uniabsc');
              };
              $tity = armar_eje($simbgraf,'magord','uniord');
              @$comsimb{'titx','tity'} = ($titx,$tity);
          };
      };
  };#$simbgraf
  impr_debug(__LINE__.' Prog $ref_graf',Dumper $ref_graf);
  comfin('finP llenar_grafdecor');
  return;
}#llenar_grafdecor
# ---------------------------------------------------------------------------
sub llevar_UNIDADES_refarch{
  comfin('comP llevar_UNIDADES_refarch',@_); 
  impr_debug(__LINE__.' Prog $NUMPRINCIPAL',$NUMPRINCIPAL);
  my $refarch = $refarchers[$NUMPRINCIPAL] ;
  impr_debug(__LINE__.' Prog $refall->{capas}',$refall->{capas});
  my $refauni = $refarch->{DEFIuni} = {};
  my %hash;
  @{$refall->{capas}} = union_conjunto(@{$refall->{capas}});
  if (@{$refall->{capas}} >= 1) { 
      foreach my $numcapa (@{$refall->{capas}}) {
          my $reflay = $reflayers[$numcapa];
          next unless $reflay->{DEFIuni} and scalar keys %{$reflay->{DEFIuni}};
          foreach my $numpl (sort keys %{$reflay->{DEFIuni}}) {
              foreach my $claseel (sort keys %{$reflay->{DEFIuni}->{$numpl}}) {
                  push @{$hash{$numpl}->{$claseel}}
                   ,$reflay->{DEFIuni}->{$numpl}->{$claseel};
              };
          };
      };
      impr_debug(__LINE__.' Prog %hash',Dumper \%hash); 
      foreach my $numpl (sort keys %hash) {
          foreach my $claseel (sort keys %{$hash{$numpl}}) {
              if (@{$hash{$numpl}->{$claseel}}== 1) {
                  my @lista = sort keys %{$hash{$numpl}->{$claseel}->[0]};
                  $refauni->{$numpl}->{$claseel} = $lista[0];
                  push @{$refauni->{$numpl}->{numobjs}}
                    , @{$hash{$numpl}->{$claseel}->[0]->{$lista[0]}}; 
             } else {# scalar es >1
                  mensajear
                   (" Hay declaraciones para $claseel en diferentes capas
                   @{$hash{$numpl}->{$claseel}}
                   se ignoran todos");
              };   
          };
          @{$refauni->{$numpl}->{numobjs}} = union_conjunto
          impr_debug(__LINE__.' Prog $refauni->{$numpl}'
            ,Dumper $refauni->{$numpl});
      };
  };# else {
  if (keys %{$refarch->{DEFIuni}} == 0) {
      if ($refarch->{clasearch} eq 'unidades') {
          $refarch->{clasearch} = 'nada';
      };
      delete $refarch->{DEFIuni};
  };
  comfin('finP llevar_UNIDADES_refarch');
  return;
}#llevar_UNIDADES_refarch
# ---------------------------------------------------------------------------
sub llevar_UNIDADES_reflay{
  comfin('comP llevar_UNIDADES_reflay',@_);
  my $reflay = $_[0]; my ($numcapa,$numfile) = @$reflay{'numcapa','numfile'};
  my $refarch = $refarchers[$numfile];
  impr_debug(__LINE__.' Prog $reflay->{cualnumclasenum}->{unidades}'
	     ,$reflay->{cualnumclasenum}->{unidades});
  my (@listaplantillas,@listapl);my $textoplantillas = '';
  foreach my $numobj (@{$reflay->{cualnumclasenum}->{unidades}}) {
      my $refcuadro = $refboxes{$numobj};
#      impr_debug(__LINE__.' Progr $refcuadro',Dumper $refcuadro);
#      impr_debug(__LINE__.' Prog $refcuadro->{stringnumpl}'
#         ,Dumper $refcuadro->{stringnumpl}); 
      foreach my $listapl (sort keys %{$refcuadro->{stringnumpl}}) {
          next if $listapl eq 'numobj';
          my $refcpl = $refcuadro->{stringnumpl}->{$listapl};
          my @listapl = split ',',$listapl;
          if (@listapl == 0) {
              @listapl = @listaplantillas;
#              unshift @{$refcuadro->{renglones}},$textoplantillas
#		  if $textoplantillas ne '';
          };    
#          impr_debug(__LINE__.' Prog @listapl',Dumper \@listapl);
          if (@listapl == 0) {
              my $error =
 "Falta indicacion valida de plantilla (y no hay iconos de ninguna plantilla)";
	      push @{$refboxes{$numobj}->{errores}}," $error";
              mensajear("$error en\n".descripcion_cuadro($numobj));
	      next;
          };
          foreach my $numpl (@listapl) {
#              impr_debug(__LINE__.' Prog $refcpl->{DEFIuni}'
#			 ,Dumper $refcpl->{DEFIuni});
              foreach my $claseel (sort keys %{$refcpl->{DEFIuni}}) {
                  my $val = $refcpl->{DEFIuni}->{$claseel}->[0];
                  push @{$reflay->{DEFIuni}->{$numpl}->{$claseel}->{$val}}
                    ,$numobj;
                  push @{$refall->{sobreUNIDADES}},$numobj;
              };
          };
      };#$listapl
  };#$numobj
  @{$refall->{sobreUNIDADES}} = union_conjunto(@{$refall->{sobreUNIDADES}});
  if (@{$reflay->{cualnumclasenum}->{unidades}} > 1) {
#      impr_campo(__LINE__.' Prog $reflay',$reflay,'DEFIuni');
      foreach my $numpl (sort keys %{$reflay->{DEFIuni}}) {
          my $refDEFI = $reflay->{DEFIuni}->{$numpl};
          foreach my $claseel (sort keys %$refDEFI) {
              my @vals = keys %{$refDEFI->{$claseel}}; 
              if (@vals > 1 ) {
                  my $mensaje
                    = "$claseel para $numpl aparece en mas de un cuadro";
                  @vals = union_conjunto(@vals);
                  my  @numobjs = sort values %{$refDEFI->{$claseel}};
                  if (@vals == 1 ) {
                      my $error
                        = "Reiteraccion de valor para $claseel en otro cuadro";
                      foreach my $numobj
                             (sort keys %{$reflay->{complem}->{UNIDADES}}) {
		          push @{$refboxes{$numobj}->{errores}},"; $error";
              	      };
                      $mensaje .= "\n      con igual valor; no hay problema";
                      mensajear
                        ("$mensaje en". descripcion_capa($reflay->{numcapa}));
                      $refDEFI->{$claseel}->{$vals[0]} = [@numobjs];
                  } else {
                      $mensaje .= "\n   @{$refDEFI->{$claseel}}";
                      my $error
                        = "valor diferente en otro cuadro para $claseel";
                      foreach my $numobj(@numobjs) {
		          push @{$refboxes{$numobj}->{errores}},"; $error";
		      };
                      delete $refDEFI->{$claseel};
                  };   
                  mensajear(
                    "$mensaje en". descripcion_capa($reflay->{numcapa}));
              };
          };
      };
  };
  if (not keys %{$reflay->{DEFIuni}}) {
      delete $reflay->{hashclase}->{unidades};
      if ($reflay->{clasecapa} eq 'unidades') {
          $reflay->{clasecapa} = 'nada';
          impr_debug(__LINE__.' Prog $reflay',Dumper $reflay);
      }; 
  };   
  comfin('finP llevar_UNIDADES_reflay');
  return;
}#llevar_UNIDADES_reflay
# -----------------------------------------------------------------------
sub nodo2sceptre{
  comfin('comP nodo2sceptre',@_);
  my ($ref,$pre,$nodo) = @_;my ($coderr,$sceptre,$tipovalor) = ('','','s');
  my $refhash = $ref->{cero_conectado};
  impr_debug(__LINE__.' Resu $ref->{cero_conectado}'
	     ,Dumper $refhash);
  if ($refhash->{directo}->{$nodo}) {
      $sceptre = $refhash->{directo}->{$nodo};
      $sceptre =~ /^E/ and $tipovalor = 'a'
  } elsif ($refhash->{aislado}->{$nodo}) {
      mensajear(" No tiene sentido $pre$nodo");$coderr = 55;
  } else {
      $sceptre = Simusol::Termicos::cerofuentear($ref,$nodo);
  };
  $sceptre =~ /^E/ and $tipovalor = 'a';
  comfin('finP nodo2sceptre',$coderr,$sceptre,$tipovalor);
  return $coderr,$sceptre,$tipovalor;
}#nodo2sceptre',@_);
# ----------------------------------------------------------------------------
sub nompl2numpl{
  my ($numobj,$renglon,$modo) = @_; my @lista;
  if ($renglon =~ /^\s*plantilla[\s=]+(\w.+)/i) {
      my @listaplants = split (/\s*,\s*/,$1);
      impr_debug(__LINE__.' Prog',\@listaplants);
      foreach my $nomplant (@listaplants) {
          my $numplant = $refglobal->{cualplantilla}->{$nomplant};
          if (defined $numplant) {
               push @lista,$numplant;
          } elsif ($modo) {
   #COMPLETAR
          } else {     
               mensajear(" No se reconoce la plantilla $nomplant; se ignora");
          };
      };
      if (scalar @lista != scalar union_conjunto(@lista)) {
         mensajear("Plantillas repetidas;
              @lista
            se ignora todo el cuadro ".descripcion_cuadro($numobj));
         @lista = ();
      };
  }; 
  return join ',',@lista;
}#nompl2numpl 
# ---------------------------------------------------------------------------
sub paraplotear{
  comfin('comP paraplotear',@_);
  my $archpar = $_[0];my $coderr= '';
  ($coderr,my $refpedidos) = preparar_paraplot($archpar);
  not $coderr and 
  $coderr = partir_paraplot($refpedidos); #inicializa $ref_arch

#  impr_debug(__LINE__.' Prog $ref_arch',Dumper $ref_arch);
#  impr_debug(__LINE__.' Prog $ref_graf',Dumper $ref_graf);
#  impr_debug(__LINE__.' Prog $ref_selecciones',Dumper $ref_selecciones);

  if ($progr{$progname} eq 's' or $opt_hash{graf} eq 1) {
      comfin('finP paraplotear linea $coderr',__LINE__,$coderr);  
      return $coderr;
  };
#  impr_debug(__LINE__.' Prog $ref_arch',Dumper $ref_arch);
  llenar_grafdecor();# completa $ref_graf
  $refcrudo0->{noseentienden} and  mensajear(
    " Hay renglones de $archpar que no se entienden, se ignorarán:\n     "
      . join ("    \n",@{$refcrudo0->{noseentienden}}));
  $refcrudo0->{obsoletos} and  mensajear(
    " Hay renglones  con pedidos 'crear' o 'extension' que son obsoletos,
  se ignorarán:\n     "
      . join ("    \n",@{$refcrudo0->{noseentienden}}));
  comfin('finP paraplotear linea $coderr',__LINE__,$coderr);
  return  $coderr;
}#paraplotear
# ---------------------------------------------------------------------------
sub partir_paraplot{
# reparte lo util entre  $refcrudo1->{grafdecor,grafesen,nomostrar}  y luego
# reparte $refcrudo1
# lo inutil queda en $refcrudo0
  comfin('comP partir_paraplot',@_);
#  impr_debug(__LINE__.' Prog @_ en partir_paraplot',Dumper \@_);
  my $refpedidos = $_[0]; my $coderr = '';
#  impr_debug(__LINE__.' Prog @pedidos en .paraplot'
#    ,"\n".join "\n",@$refpedidos);
  my @SIMULADOs; map(do{/\W(SIMULADO\w+)/ and
      push(@SIMULADOs,$1)},@$refpedidos);
  my $i = 0;
  foreach  (@$refpedidos) {
      if (/^(archivo|arch_var)/i) {existencia_archivo($_); 
      } elsif (/^$reg_selecciones/i) {push @{$refcrudo1->{selecciones}},$_;
      } elsif (/^$reg_delarch/i) {push @{$refcrudo1->{delarch}},$_;
      } elsif ($progr{$progname} ne 's') {
          if (/^$reg_grafdecor/i) {push @{$refcrudo1->{grafdecor}},$_;
          } elsif (/^$reg_grafesen/i) {push @{$refcrudo1->{grafesen}},$_;
          } elsif (/^$reg_obsoletos/i) {push @{$refcrudo0->{obsoletos}},$_;
          } elsif (/^$reg_mostrar/i) {push @{$refcrudo1->{grafmostrar}},lc($_);
          } else {push @{$refcrudo0->{noseentienden}},$_;
          };
      };
  };#@$refpedidos
  #{decor} va para un $simbgraf; {grafdecor} para $refcrudo1
  revisar_repeticiones_basicas_delarch();
  interpretar_mostrar() if $refcrudo1->{grafmostrar};
  tratar_delarch() if $refcrudo1->{delarch};
  tratar_selecciones() if $refcrudo1->{selecciones};
  if ($progr{$progname} ne 's') {  
      tratar_grafesen() if $refcrudo1->{grafesen};
      tratar_grafdecor() if $refcrudo1->{grafdecor};
      tratar_grafmostrar() if $refcrudo3->{grafmostrar};
      my @listagrafs = sort keys %$ref_graf;
      foreach my $simbgraf (@listagrafs) {
          scalar keys %{$ref_graf->{$simbgraf}} > 1#siempre esta el simbgraf_ori
            or delete $ref_graf->{$simbgraf};
      };  
      impr_debug(__LINE__.' Prog $ref_graf',Dumper $ref_graf);
  }; 
  comfin('finP partir_paraplot',$coderr);
  return $coderr;
}#partir_paraplot
# ---------------------------------------------------------------------------
sub preparar_paraplot{
  comfin('comP preparar_paraplot',@_);
  my $archpar = $_[0];my $coderr = '';
  open ENTRADAparaplot, $archpar or do{
      mensajear(" No existe el archivo $archpar");
      comfin('finP preparar_paraplot linea'.__LINE__); 
      return 12;
  };
  my @renglones = <ENTRADAparaplot>; chomp @renglones;
  map(s/\#.*//, @renglones); 
  @renglones = grep (/\S/,@renglones);
  map(s/(\W)CALCULADO/$1SIMULADO/,@renglones);
  if ($progname  =~ /^simusol_sceptre/) {
     @renglones = grep (/\sSIMULADO/,@renglones);
  };
  my @renglonespegados;  
  while (@renglones) {
      my $renglon = shift @renglones; 
      next unless $renglon =~ /\S/;
      $renglon =~ s/^\s+//; $renglon =~ s/\s+$//; $renglon =~ s/\s+=\s+/=/;
      my $pega =' ';
      $pega = "\n" if $renglon =~ /^\s*eco/;
      while (@renglones and $renglones[0] !~ /^[\s\w]+=/ 
             and $renglones[0] !~ /^\s*nomostrar/i
             and $renglones[0] !~ /^\s*crear/i   #obsoleto
             and $renglones[0] !~ /^\s*extensi/i #obsoleto
            ) {
          $renglon .= "$pega$renglones[0]";
          shift @renglones;
      }; 
      push @renglonespegados, $renglon;
  };      
#  impr_debug(__LINE__.' Prog @renglonespegados',"\n".join "\n",@renglonespegados);
  comfin('finP preparar_paraplot');
  return $coderr,\@renglonespegados;
}#preparar_paraplot
# ---------------------------------------------------------------------------
sub presimul{
  comfin('comP presimul',@_);
  my ($combSIMB) = @_;
  impr_debug(__LINE__.' Prog $combSIMB',Dumper $combSIMB);
  my $archreal = $combSIMB->{archivo};
  $archreal =~ /^\w/ and $archreal = $dirsalida{simul} .'/'. $archreal; 
  impr_debug(__LINE__.' Prog $archreal',$archreal);
#simusol_sceptre aun no ha creado el   .simul      
  if (not -e $archreal or -d $archreal or not -s $archreal) {
      mensajear("    $archreal no es nombre de un buen archivo
              para $combSIMB->{simbarch_ori}");
#       delete $ref_arch->{$SIMBARCH};
       $combSIMB = {};return;
  };
  my @lista = @{$combSIMB->{arch_var}};
  if (@lista) {
      foreach my $archreal (@lista){
          $archreal =~ /^\w/ and $archreal = $dirsalida{simul} .'/'. $archreal; 
          impr_debug(__LINE__.' Prog $archreal',$archreal);
          if (not -e $archreal or -d $archreal or not -s $archreal) {
              mensajear("    $archreal no es nombre de un buen archivo
              para $combSIMB->{simbarch_ori}");
#              delete $ref_arch->{$SIMBARCH};
              $combSIMB = {};return;
          };
      };
  };
  comfin('comP presimul');
  return
}#presimul
# ----------------------------------------------------------------------------
sub prograficar{#lo usa simusol1.pl
  comfin('comP prograficar',@_);
  # prepara contenido de archivo .paraplot con información para gráficos.
  my $ref = $_[0]; my $coderr = '';
  my $numfile = $ref->{numfile};
  my $refnomb = $refnombres[$numfile];
#  impr_ARCHIVOS(__LINE__.' Prog',$ref);
  my $date = $refnomb->{DATE};
  if ($opt_hash{todas}) {
#      $archguardar = "$archguardar"."_$opt_hash{todas}";
#      $archguardar=~ s/\s+/_/g;
#      $archguardarcongnus =~ s/([^\/]+)$/gnus\/$1/;
      $ref->{refvalores}->{GRAFICOS} = undef;
  };
  # en el hash apuntado por $ref espera encontrar varias keys:
  my ($paraplotSIMULADO,$paraplot) = ('','');
  impr_debug(__LINE__.' Prog keys $ref->{clasearch}',$ref->{clasearch});
  if ($ref->{clasearch} eq 'circuito') {
      $paraplotSIMULADO = ident_simulado($ref);
  };
  impr_debug(__LINE__.' Prog $paraplotSIMULADO',"\n$paraplotSIMULADO");
  my ($paraplottextos, $haysimulado, @uniprilista) = ('',0);
  if (defined $ref->{refvalores}->{GRAFICOS}) {
      ($paraplottextos,$haysimulado,@uniprilista)
             = incluir_cuadro_grafico($ref,'GRAFICOS');
  } elsif ($ref->{clasearch} eq 'circuito') {
      ($paraplottextos,$haysimulado)
        = inventar_graficos($ref);
  };
  impr_debug(__LINE__.' Prog $paraplottextos',"\n$paraplottextos");
  my ($extraparaplot,$extrahaysimulado,@extrauniprilista) = ('',0);
  if ($ref->{refvalores}->{AGREGAR_GRAFICOS}) {
      ($extraparaplot,$extrahaysimulado,@extrauniprilista)
          = incluir_cuadro_grafico($ref,'AGREGAR_GRAFICOS');
  };
  impr_debug(__LINE__.' Prog $extraparaplot',"\n$extraparaplot");
  if ($extraparaplot) {
      $paraplottextos .= $extraparaplot;
      $haysimulado = $haysimulado + $extrahaysimulado;
      push @uniprilista,@extrauniprilista;
  }; 
  $paraplot = $paraplotSIMULADO.$paraplottextos;
  impr_debug(__LINE__.'Prog $ref DEFItiempos',Dumper $ref->{DEFItiempos});
  impr_debug(__LINE__.'Prog $refglobal->DEFItiempos'
    ,Dumper $refglobal->{DEFItiempos});
  my $unipri = $ref->{DEFItiempos}->{unipri};
  impr_debug(__LINE__.' Prog $unipri',$unipri);
  $paraplot .= "unipri SIMULADO = $unipri\n";  
         impr_debug(__LINE__.' Prog $paraplot', $paraplot); 
  comfin('finP prograficar',$coderr,$paraplot);
  return $coderr,$paraplot;
}#prograficar
# ---------------------------------------------------------------------------
sub purgar_ref_arch{#mejora $ref_arch  
  comfin('comP purgar_ref_arch',@_);
  my $SIMBARCH = $_[0];
#  impr_debug(__LINE__.' Prog $ref_arch',Dumper $ref_arch);
  my $comSIMB = $ref_arch->{$SIMBARCH};
#  impr_debug(__LINE__.' Prog $comSIMB '.$SIMBARCH,Dumper $comSIMB);
  my $SIMBARCHP = $SIMBARCH;
  $comSIMB->{archivopadre} and $SIMBARCHP =  $comSIMB->{archivopadre}; 
  my $comSIMBP = $ref_arch->{$SIMBARCHP};
#  impr_debug(__LINE__.' Prog $comSIMBP '.$SIMBARCHP,Dumper $comSIMBP) 
#      if $SIMBARCHP ne $SIMBARCH;
  my (@magnscep,@unidadscep,@variablescep);
  if ($SIMBARCHP eq $SIMBARCH) {
      if ($comSIMBP->{sceptre}) {
          $comSIMBP->{variable} or 
            @{$comSIMBP->{variable}} = @{$comSIMBP->{sceptre}};
          for (my $k = 0; $k < @{$comSIMBP->{sceptre}}; $k ++) {
              my $cosa = $comSIMBP->{sceptre}->[$k];
              $comSIMBP->{sceptre2num}->{$cosa} = $k + 1;
              my $j = $k;
              if ($comSIMBP->{indice}) {
                  while ($comSIMBP->{indice}->[$j] < $k+1) {$j++};
#                  impr_debug(__LINE__.' Prog $k,$j,$comSIMB->{indice}->[$j]'
#                   ,[$k,$j,$comSIMBP->{indice}->[$j]]);
              };
              push @variablescep,$comSIMB->{variable}->[$j];
              push @magnscep,$comSIMB->{magn}->[$j];
              push @unidadscep,$comSIMB->{unidad}->[$j];
              $comSIMBP->{nombre2num}->{$cosa} = $j+1;
              $cosa .=",$comSIMBP->{variable}->[$j]"
                if $cosa ne $comSIMBP->{variable}->[$j];
              push @{$comSIMB->{varcomp}},$cosa;
          };
          $comSIMB->{variablescep} = \@variablescep;
          $comSIMB->{magnscep} = \@magnscep;
          $comSIMB->{unidadscep} = \@unidadscep;
          for (my $k = 0; $k < @{$comSIMBP->{variable}}; $k ++) {
              my $cosa = $comSIMBP->{variable}->[$k];
              $comSIMBP->{nombre2num}->{$cosa} = $k+1;
              $comSIMBP->{nombre2num}->{uc($cosa)} = $k+1;
          };
      }
#      impr_debug(__LINE__.' Prog $comSIMBP '.$SIMBARCHP, Dumper $comSIMB);
  };
  comfin('finP purgar_ref_arch');
  return;
}#purgar_ref_arch
# ----------------------------------------------------------------------------
sub rango_seleccion{
  use warnings  FATAL => qw(numeric uninitialized);
  comfin('comP rango_seleccion',@_);
  my ($uno,$dos) = @_;
  $uno = eval($uno); $dos = eval($dos);
  $uno > $dos and ($uno,$dos) = ($dos,$uno);
  comfin('finP rango_seleccion',$uno,$dos);
  return $uno,$dos;
}#rango_seleccion';
# ----------------------------------------------------------------------------
sub repartir_refcrudo1_delarch{# a $refcrudo2
  comfin('comP repartir_refcrudo1_delarch',@_);
  my($renglonori,$palabrita,$simboloori,$reflistad) = @_;
  my $simbolo = lc($simboloori);
  $simbolo = uc($simbolo);
  $refcrudo2->{delarch}->{$simbolo} or return;
  $palabrita =~ s/^\w*($reg_delarch)\w*/$1/i;
  if ($palabrita eq 'sceptre' and $progname !~/^simusol_sceptre/) {
      impr_debug(__LINE__.' Prog $refcrudo2->{delarch}'
       ,Dumper $refcrudo2->{delarch});
      consistencia_minima($reflistad,$refcrudo2->{delarch}
		        ->{uc($simbolo)}->{archivo}->[0],uc($simbolo));
  };
  push @{$refcrudo2->{delarch}->{$simbolo}->{$palabrita}}, $reflistad;
  comfin('finP repartir_refcrudo1_delarch');
  return;
}#repartir refcrudo1_delarch
# ----------------------------------------------------------------------------
sub repartir_refcrudo1_grafdecor{# a $refcrudo3; no molestan repeticiones???
  comfin('comP repartir_refcrudo1_grafdecor',@_);
  my($renglonori,$palabra,$simbolo,$reflistad) = @_;
  impr_debug(__LINE__.' Prog $palabra,$simbolo',[$palabra,$simbolo]);
  $simbolo = lc($simbolo);
  $palabra =~ s/^\w*($reg_grafdecor)\w*/$1/i;
  if ($ref_graf->{lc($simbolo)}) {
      push @{$refcrudo2->{grafdecor}->{$simbolo}->{$palabra}},$reflistad;
  } else {
      mensajear(" No se ha definido grafico $simbolo; se ignora el comando
         $renglonori");
  };
  comfin('finP repartir refcrudo1_grafdecor',@_);
}#repartir refcrudo1_grafdecor;
# ----------------------------------------------------------------------------
sub repartir_refcrudo1_grafesen{# a $refcrudo3; no molestan repeticiones
  comfin('comP repartir_refcrudo1_grafesen',@_);
  my($renglonori,$palabrita,$simboloori,$reflistad) = @_;
  my $simbolo = lc($simboloori);
#   impr_debug(__LINE__.' Prog $refcrudo1->{grafesen}'
#    , Dumper $refcrudo1->{grafesen});
  $palabrita =~ s/^\w*($reg_grafesen)\w*/$1/i;
  if ($palabrita =~ /^(punto|linea)$/) {
      my $coderr = '';
      impr_debug(__LINE__.' Prog $reflistad',$reflistad);
      if (@$reflistad < 3) {
          mensajear(" Error de sintaxis en el pedido; se ignora:
            $renglonori");return;
      } else {
          if (not $ref_arch->{uc($reflistad->[0])}) { 
              mensajear(
          " Falta definicion para archivo $reflistad->[0]; se ignora pedido: 
            $renglonori");
              return;  
          };
      };
  };
  $simbolo = lc($simbolo);
  $palabrita = substr($palabrita,0,8);
  push @$reflistad,$renglonori;
  push @{$refcrudo3->{grafesen}->{$simbolo}->{$palabrita}} ,$reflistad;
  impr_debug(__LINE__.' Prog $ref_graf->{$simbolo} '.$simbolo
    ,Dumper $ref_graf->{$simbolo});
  push @{$ref_graf->{$simbolo}->{simbgraf_ori}},$simboloori;
  comfin('finP repartir refcrudo1_grafesen');
  return
}#repartir refcrudo1_grafesen
# ----------------------------------------------------------------------------
sub revisar_repeticiones_basicas_delarch{#sin argumentos 
  comfin('comP revisar_repeticiones_basicas_delarch',@_); 
#  impr_debug(__LINE__.' Prog $refcrudo2->{delarch}'
#    ,Dumper $refcrudo2->{delarch});
  foreach my $SIMBARCH (sort keys %{$refcrudo2->{delarch}}) {
      foreach my $palabrita ('archivo','archivopadre') {
          my @cosas = union_conjunto(
           @{$refcrudo2->{delarch}->{$SIMBARCH}->{$palabrita}});
          if (@cosas >1) { 
              mensajear(
              ' Mas de una definicion para $refcrudo2->{delarch}->{$SIMBARCH}->
              {$palabrita} '."$palabrita;
           se ignora todo lo referido a 
              $refcrudo2->{delarch}->{$SIMBARCH}->{SIMBARCH_ORI}");
              delete $refcrudo2->{delarch}->{$SIMBARCH}; 
          } elsif (@cosas == 0) {
              mensajear(
                ' No hay definicion para $refcrudo2->{delarch}->{$SIMBARCH}->
              {$palabrita} '."$palabrita;             
           se ignora todo lo referido a 
              $refcrudo2->{delarch}->{$SIMBARCH}->{SIMBARCH_ORI}");
              delete $refcrudo2->{delarch}->{$SIMBARCH};
          };
      };
      # se dejan como conjunto hasta detectar_repeticiones_refcrudo2
  };
#  impr_debug(__LINE__.' Prog refcrudo2->{delarch}'
#    ,Dumper $refcrudo2->{delarch});
  comfin('finP revisar_repeticiones_basicas_delarch'); 
}#revisar_repeticiones_basicas_delarch; 
# -----------------------------------------------------------------------------
sub revisar_fun{
  comfin('com3 revisar_fun',@_);
  my $simbgraf = $_[0]; my $coderr = '';
  return;
  comfin('fin3 revisar_fun');
}#revisar_fun
# ----------------------------------------------------------------------------
sub detectar_repeticiones_refcrudo2{ 
  comfin('comP detectar_repeticiones_refcrudo2',@_);
  my $reflispalabra = $_[0]; 
  foreach my $palabra (@$reflispalabra) {
      next unless scalar keys %{$refcrudo2->{$palabra}};
#      eco ("Ahora  con \$refcrudo2 para detectar y descartar repeticiones
#       con lo de $palabra; lo bueno pasa a \$refcrudo3 que,  va (engordando) a
#         a \$ref_arch y a \$ref_graf");
#      impr_debug(__LINE__.' Prog $refcrudo2->{$palabra} '.$palabra
#		 ,Dumper $refcrudo2->{$palabra});
      foreach my $SIMBOLO (sort keys %{$refcrudo2->{$palabra}}) {
          my $ref2pS = $refcrudo2->{$palabra}->{$SIMBOLO};
          my @lispalabri = sort keys %$ref2pS;
#          impr_debug(__LINE__.' Prog $palabra,$SIMBOLO,@lispalabri'
#               ,[$palabra,$SIMBOLO,'||',@lispalabri]);
          foreach my $palabrita (@lispalabri) {
              if (scalar union_conjunto(@{$ref2pS->{$palabrita}}) > 1) {
                  mensajear("Hay más de un renglon para
                  $palabrita $SIMBOLO; se ignoran todos");next;
              } else {
                  $refcrudo3->{$palabra}->{$SIMBOLO}->{$palabrita}
                     = $ref2pS->{$palabrita}->[0];
              };
              delete $ref2pS->{$palabrita}; 
          };#$palabrita
      };
      delete $refcrudo2->{$palabra};
  };
#  impr_debug(__LINE__.' Prog $refcrudo3',Dumper $refcrudo3);
  comfin('finP detectar_repeticiones_refcrudo2');
}#detectar_repeticiones_refcrudo2
# ----------------------------------------------------------------------------
sub parser_renglon{
  comfin('comP parser_renglon',@_);
  my $renglon = $_[0]; my $coderr = '';
  my ($palabrita,$simbolo,$reflistad);
  my @separadores =  (' +','=','\s*[,:]\s*');
  # @separadores tiene exactamente tres elementos: inicial ,medio, final
  #que son identif. para patrones
  (my ($reflistai,$sepa),$reflistad) = parser(@separadores,$renglon);
#  impr_debug(__LINE__.' Prog $reflistad',$reflistad);
  if ($reflistai eq 'error' or @$reflistai != 2) {
      push @{$refcrudo0->{noseentienden}},$renglon; $coderr = 30;
  } else {
      ($palabrita,$simbolo) = (lc($reflistai->[0]),$reflistai->[1]);     
  };
  comfin('finP parser_renglon',$palabrita,$simbolo,@$reflistad);
  return $coderr,$palabrita,$simbolo,$reflistad;
}#parser_renglon;
# ----------------------------------------------------------------------------
sub tratar_delarch{#sin argumentos
  comfin('comP tratar_delarch',@_);
#  impr_debug(__LINE__.' Prog $refcrudo1->{delarch} '.'delarch'
#    ,Dumper $refcrudo1->{delarch});
#  impr_debug(__LINE__.' Prog $refcrudo2->{delarch} '.'delarch'
#    ,Dumper $refcrudo2->{delarch});
#  impr_debug(__LINE__.' Prog $ref_arch',Dumper $ref_arch);
  while (@{$refcrudo1->{delarch}}) {
      my $renglonori = shift @{$refcrudo1->{delarch}};
      my $renglon = $renglonori; $renglon =~ s/^\s+//;
      my ($coderr,$palabrita,$simbolo,$reflistad) = parser_renglon($renglon);
      if (not $coderr and $refcrudo2->{delarch}->{uc($simbolo)}) {
         repartir_refcrudo1_delarch($renglonori,$palabrita,$simbolo,$reflistad);
      }; 
  };
  delete $refcrudo1->{delarch};
  detectar_repeticiones_refcrudo2(['delarch']);
  ajustar_delarch();
#  impr_debug(__LINE__.' Prog $ref_arch',Dumper $ref_arch);
  comfin('finP tratar_delarch');
}#tratar_delarch;
# ----------------------------------------------------------------------------
sub tratar_grafdecor{#sin argumentos
  comfin('comP tratar_grafdecor',@_);
  while (@{$refcrudo1->{grafdecor}}) {
      my $renglonori = shift @{$refcrudo1->{grafdecor}};
      my $renglon = $renglonori; $renglon =~ s/^\s+//;
      my ($coderr,$palabrita,$simbolo,$reflistad) = parser_renglon($renglon);
      not $coderr and 
         repartir_refcrudo1_grafdecor
           ($renglonori,$palabrita,$simbolo,$reflistad);
  };
  delete $refcrudo1->{grafdecor};
  detectar_repeticiones_refcrudo2(['grafdecor']);
  ajustar_grafdecor();
  impr_debug(__LINE__.' Prog $ref_graf',Dumper $ref_graf);  
  comfin('finP tratar_grafdecor');
}#tratar_grafdecor
# ----------------------------------------------------------------------------
sub tratar_grafesen{#sin argumentos
  comfin('comP tratar_grafesen',@_);
  impr_debug(__LINE__.' Prog $refcrudo1->{delarch} '.'delarch'
    ,Dumper $refcrudo1->{delarch});  
  while (@{$refcrudo1->{grafesen}}) {
      my $renglonori = shift @{$refcrudo1->{grafesen}};
      my $renglon = $renglonori; $renglon =~ s/^\s+//;
      my ($coderr,$palabrita,$simbolo,$reflistad) = parser_renglon($renglon);
      not $coderr and 
         repartir_refcrudo1_grafesen
           ($renglonori,$palabrita,$simbolo,$reflistad);
  };
  delete $refcrudo1->{grafesen};
  impr_debug(__LINE__.' Prog $refcrudo3',Dumper $refcrudo3);
  ajustar_grafesen();
  impr_debug(__LINE__.' Prog $ref_graf',Dumper $ref_graf);
  comfin('finP tratar_grafesen');
}#tratar_grafesen;
# ----------------------------------------------------------------------------
sub tratar_grafmostrar{#sin argumentos
  comfin('comP tratar_grafmostrar',@_);
  my %nonomostrar;
  impr_debug(__LINE__.' Prog $refcrudo3', Dumper $refcrudo3); 
  impr_debug(__LINE__.' Prog $ref_graf', Dumper $ref_graf); 
  foreach my $simbgraf (sort keys %{$refcrudo3->{grafmostrar}}) {
      if ($refcrudo3->{grafmostrar}->{$simbgraf}->{mostrarj}) {
          my $comando_ori
            = $refcrudo3->{grafmostrar}->{$simbgraf}->{comando}->[0];
          my @mostrarjuntos;
          my @keys = keys %{$ref_graf->{$simbgraf}};
          @keys = grep(do{$_!~/simbgraf_ori|decor/},@keys);
          impr_debug(__LINE__.' Prog',Dumper \@keys);
          if (@keys > 1) { mensajear(
       " Hay otra definicion para $ref_graf->{$simbgraf}->{simbgraf_ori}->[0];
       se ignora: $comando_ori");
          } else {
              $ref_graf->{$simbgraf}->{decor}->{mostrarj}
	      = $refcrudo3->{grafmostrar}->{$simbgraf}->{mostrarj}->[0];
          };
      };
  };
  foreach my $simbgraf (sort keys %{$refcrudo3->{grafmostrar}}) {
      next unless $refcrudo3->{grafmostrar}->{$simbgraf}->{nomostrar};
      $nonomostrar{$simbgraf} or
        $ref_graf->{$simbgraf}->{decor}->{nomostrar} = 1;
  };
  impr_debug(__LINE__.' Prog $ref_graf',Dumper $ref_graf);
  comfin('finP tratar_grafmostrar');
}#tratar_grafmostrar',@_);
# ----------------------------------------------------------------------------
sub tratar_selecciones{#sin argumentos
  comfin('comP tratar_selecciones',@_);
  foreach (@{$refcrudo1->{selecciones}}) {
      impr_debug(__LINE__.' Prog $_',$_);
      comando_selec($_); 
  };
  detectar_repeticiones_refcrudo2(['selecciones']);
  ajustar_selecciones();
  impr_debug(__LINE__.' Prog $ref_arch',Dumper $ref_arch);
  impr_debug(__LINE__.' Prog $ref_selecciones',Dumper $ref_selecciones);
  comfin('finP tratar_selecciones',@_);
}#tratar_seleccion);
# ----------------------------------------------------------------------------
sub tratar_1UNIDADES{
  comfin('comP tratar_1UNIDADES',@_);
  my ($refcuadro,@renglones) = @_; my $modo;
  my $refgrf = $refgrafers[$refcuadro->{numcapa}];
#  impr_debug(__LINE__.' Prog $refgrf',Dumper $refgrf);
  my $reflay = $reflayers[$refcuadro->{numcapa}];
#  my $refarch = $refarchers[$reflay->{numfile}];
  my $numobj = $refcuadro->{numobj};
#  impr_debug(__LINE__.' Prog $refcuadro',Dumper $refcuadro);
  my(@malasplantillas, @malosrenglones,@repeclases,@repeplants);
  my $refplantillas = [];
  impr_debug(__LINE__.' Prog',\@renglones);
  my $refcpl =   $refcuadro->{stringnumpl} = {};
  $refcpl->{numobj} = $numobj;
  $refcuadro->{errores} =[];
#  $refcuadro->{renglones} =[@renglones];
  my $renglon = $renglones[0];
  my $refcplstr;
  if ($renglon !~ /^\s*plantilla[\s=]+\w.+/i) {
      if ($modo) {
          mensajear(" Falta renglon Plantilla = .. en
          ". descripcion_cuadro($numobj). "; se ignora todo el cuadro");
          return;         
      } elsif ($refgrf->{tieneplantilla} ) { 
          my @keysplantillas = sort keys %{$refgrf->{tieneplantilla}};
          impr_debug(__LINE__.' Prog @keysplantillas',\@keysplantillas);
          my $string = join ',',@keysplantillas;
          $refcpl->{$string}= {};
          $refcplstr = $refcpl->{$string};
          my @nomsplantillas = @keysplantillas;
          map($_ = $nombreplantilla->[$_],@nomsplantillas);
          my $nomstring = join ',',@nomsplantillas; 
          mensajear(' Simusol ha incorporado "Plantilla = '. $nomstring .'"'
          ."\n      al comienzo del ". descripcion_cuadro($numobj));  
      };
  };
  impr_debug(__LINE__.' Progr $refcuadro', Dumper $refcuadro);
  while (@renglones) {
      my $renglon = shift @renglones;
#      impr_debug(__LINE__.' Prog $renglon', $renglon);
      if ($renglon =~ /^\s*plantilla[\s=]+(\w.+)/i) {
          my $stringnum = nompl2numpl($numobj,$renglon,$modo);
#          impr_debug(__LINE__.' Prog $stringnum', $stringnum);
          if ($stringnum eq '') {
             my $error = " No quedaron plantillas conocidas a partir de 
;                $renglon; se ignora todo lo que sigue;";
             push @{$refcuadro->{errores}},"; $error";
             mensajear("$error\n       en".descripcion_cuadro($numobj));
             comfin('finP tratar_cuadro_UNIDADES linea '.__LINE__);
	     return;
          } else {
	      $refcplstr = $refcpl->{$stringnum} = {};
              $refcpl->{$stringnum}->{DEFIuni} = {};
          };
#          impr_debug(__LINE__.' Prog $refcpl cuadro',Dumper $refcpl);
      } elsif ($renglon =~ /^\s*([CEJLMRcejlrmT])\s*:\s*(.+,.+)$/) {
          my $claseel = uc($1); my $valor = $2;
          my $cuantascomas = ($valor =~ tr/\,//);
          if ($claseel =~ /[CLMRT]/ and $cuantascomas == 1
              or $claseel =~ /^[EJ]$/ and $cuantascomas =~ /[12]/) {
              my ($abr,$que) = ('','');
              if ($claseel =~ /^[EJ]$/) {
                  $claseel eq 'E' and $que = 'V' or $que = 'I'; 
                  if ($cuantascomas == 1) {
                      $claseel eq 'E' and $abr = 'V' or $abr = 'I';
                      my $mensaje = 
                        " Puede elegir una abreviatura para $claseel";
                      $mensaje .= "          de otro modo solo tendra $abr";
                      mensajear("$mensaje en:\n  ".descripcion_cuadro($numobj));
                  };
 	      };
              push @{$refcplstr->{DEFIuni}->{$claseel}},$valor;
              push @{$refall->{sobreUNIDADES}},$numobj;
              push @{$reflay->{sobreUNIDADES}},$numobj;  
         } else {
              my $error = 
                "  No se entiende $renglon; demasiadas comas; se ignora"; 
              push @{$refcuadro->{errores}},";  $error";
              mensajear ("$error en".descripcion_cuadro($numobj));
          };
      } else {
	  my $error = "  No se entiende $renglon; se ignora";
          push @{$refcuadro->{errores}},";  $error";
          mensajear ("$error en:\n    ".descripcion_cuadro($numobj));
      };
  };#@renglones
  @{$refall->{sobreUNIDADES}} = union_conjunto(@{$refall->{sobreUNIDADES}});  
  @{$reflay->{sobreUNIDADES}} = union_conjunto(@{$reflay->{sobreUNIDADES}});  
  foreach my $plantilla (sort keys %{$refcuadro->{stringnumpl}}) {
      next if $plantilla eq 'numobj';# RVISAR puede ser?
      my $refcpl = $refcuadro->{stringnumpl}->{$plantilla};
      if (scalar keys %{$refcpl->{DEFIuni}} == 0) {
          if ($plantilla eq '') {
              delete $refcuadro->{stringnumpl}->{$plantilla};
          } else {
              push @{$refcuadro->{errores}}
		     , "No hay definiciones para plantilla $plantilla";
	  };
      };
      foreach my $claseel   (sort keys %{$refcpl->{DEFIuni}}) {
          my @todos = @{$refcpl->{DEFIuni}->{$claseel}};
#          impr_debug(__LINE__.' Prog @todos',Dumper \@todos);
          if (@todos >1) {
              my $error = " Mas de un renglon para clase $claseel";
              @todos = union_conjunto(@todos);
              if (@todos ==1) {
		  $error .= " pero son iguales";
                  @{$refcpl->{DEFIuni}->{$claseel}}
		  = ($refcpl->{DEFIuni}->{$claseel}->[0])
              } else {
                  $error .= " ignoramos a todos ellos";
                  delete $refcpl->{DEFIuni}->{$claseel};
              };
              push @{$refcuadro->{errores}},"; $error";
              mensajear ("$error en".descripcion_cuadro($numobj)); 
          };
      };
  };
  my @concoma = grep($_ =~ /,/,sort keys %{$refcuadro->{stringnumpl}});
  impr_debug(__LINE__.' Progr @concoma',\@concoma);
  foreach my $string (@concoma) {
      my @listita = split ',',$string;
      foreach my $numpl (@listita) {
	  %{$refcuadro->{stringnumpl}->{$numpl}}
	  =  %{$refcuadro->{stringnumpl}->{$string}};
      };
      delete $refcuadro->{stringnumpl}->{$string};
  };
  comfin('finP tratar_1UNIDADES');
  return ''
}#tratar_1UNIDADES  
# --------------------------------------------------------------------------
sub tratar_UNIDADES{#$refall para todas las capas, sin argumentos
  comfin('comP tratar_UNIDADES',@_);
#  impr_debug(__LINE__.' Prog $refall',Dumper $refall);
  $refall->{sobreUNIDADES} = [];
  impr_debug(__LINE__.' Prog $refboxes',Dumper \%refboxes);
  my @numobjs = union_conjunto(@{$refall->{cualnumclasenum}->{unidades}});
  impr_debug(__LINE__.' Prog @numobjs',\@numobjs);
  foreach my $numobj (@numobjs) {
      impr_debug(__LINE__.' Prog $numobj',$numobj);
      my $refcuadro = $refboxes{$numobj};
      my $numcapa = $refcuadro->{numcapa}; my $reflay = $reflayers[$numcapa];
      my $numfile = $reflay->{numfile};
      my @renglones =  @{$reflay->{complem}->{UNIDADES}->{$numobj}};
      my $clasecapa = $reflay->{clasecapa};
      impr_debug(__LINE__.' Prog $numcapa,$clasecapa,$numfile'
       ,[$numcapa,$clasecapa, $refnombres[$numfile]->{CORTO}]);  
      tratar_1UNIDADES($refcuadro,@renglones);
          #0 porque no debe aumentar plantillas
#     impr_debug(__LINE__.' Prog $reflay->{hashclase}',$reflay->{hashclase}); 
     if (scalar keys %{$refcuadro->{stringnumpl}} <= 1 ) { # 1 por numobj;
         $reflay->{DEFIuni} = {};
         delete $reflay->{cualnumclasenum}->{unidades}; 
     } else {
          llevar_UNIDADES_reflay($reflay);
#          impr_debug(__LINE__.' Prog', Dumper $reflay);
          if (not $reflay->{DEFIuni}) {
              delete $reflay->{cualnumclasenum}->{unidades};
          } else {
              impr_debug(__LINE__.' Prog',Dumper $reflay->{DEFIuni}); 
         }; 
    };
 #    };
      impr_refall(__LINE__.' Prog');
  };#$numobj
  comfin('finP tratar_UNIDADES');
  return;
}#tratar_UNIDADES 
# -----------------------------------------------------------------------
1
