package Simusol::Tablasfuncq;
use Simusol::Auxiliares;
use Simusol::GlobalesSimusol;
use Simusol::Algebraico;
use Simusol::Ayudas;
use Simusol::Controles;
use Simusol::Evaluaciones2;
use Simusol::Prograf;

use warnings;
use strict;
use Data::Dumper;
$Data::Dumper::Indent = 1; 
our (%refTABLAes,%refARCHIVOes);
BEGIN {
     use Exporter ();
     our ($VERSION,@ISA,@EXPORT,@EXPORT_OK,%EXPORT_TAGS);
     @ISA=qw(Exporter);
     @EXPORT=qw(&ovaluar_q_n
                &calcular_pendientes
                &completar_FUNCIONES
                &completar_TABLA
                &depurar_w
                &eliminar_tablas_fuera
                &partir_TABLAS
                &registrar_tiempos_tablas
                &sust_num_en_TABLAS 
                &tipear &tokensep
                &tipear_TABLA
                &tratar_FUNCIONES
                &tratar_TABLAS_CUALQ
                &tratar_1cuadro_compl
                &tratar_1FUNCIONES
                &usados &resumir_fun_par_tab_var_funx &fun_par_tab_var
       );  
};
END();
# ---------------------------------------------------------------------------
sub analizar{
  # supone no recibir lista
  # supone que no hay grandes errores de sintaxis y que esta estandarizado
  # devuelve $dentro, $func , $pretipo y $valor
  # $func es '' y $pretipo es '' si la expresion es atomica (tipos p n a)
  # $pretipo es 'x para indicar expresion 
  # si hay un solo X.. donde corresponde, lo respeta
  my $expre = $_[0]; my $coderr; 
  #impr_debug(__LINE__.' Tabl $expre',"nnn$expre");
  $expre =~ /^\s*$/ and return '','','z',''; 
  use warnings  FATAL => qw(numeric uninitialized syntax);
  my $valor = ';' . lc($expre);
  if ($valor =~ /^(.*)(\W)0\d/) {
      $2 ne '.' and  "$1$2" !~ /e[\+\-]$/  and do{avgrav(
          "\" $valor \" no es aceptable (número que empieza con 0 sin . ");
          return '','','e',$valor;
      };
  };
  $valor =~ /\:/ and return $valor,'','y',$valor; 
  my $posi_num = 1;
  # si en $valor hay : devuelve el eval de la parte final
  while ($valor ne '' and $valor =~ s/(\W)(\w+)\(/$1\(/) {
      unless ($acep_fun{lc($2)}) {
	  $posi_num ='';
	  last;
      };
  };
  if ($posi_num) {
      $valor = lc($expre);
      $valor =~ s/\*(\w)/\* $1/g; #para evitar ambiguedades  
      my $nuevovalor = eval($valor);
      if ((not $@ and  defined $nuevovalor)
            and ($nuevovalor =~ /^\d/ or $nuevovalor =~ /^\-\d/)) {
          $valor = $nuevovalor; 
          $valor =~ s/^(\W*\d+)(E[+-]\d+)$/$1\.$2/; 
          $valor =~ s/e/E/;
          #a sceptre le molesta en las expresiones 5E-4 pero no 5.E-4 
          return ($valor,'','n',$valor);
      } else {
      };
  };
  my ($num,$dat,$resto) = sacar_paren_ext($expre);
  $num == -1 and do{
      avgrav("hay parentesis sin cerrar en $expre");
        return '','','e',$expre;
  };
  $dat  =~ /^\s*$/ and return '','','z',''; 

  $expre = $dat if $resto eq '';
   
  ($expre =~ tr/(//) ==  ($expre =~ tr/)//) or do { 
      avgrav("Paréntesis no balanceados en $expre");
      return '','','e',$expre;
  };
  $expre =~ s/(\W)(\w+\()/$1&$2&/g;#aqui g es mejor que un while
  $expre =~ s/^(\w+\()/$1&/;
  $expre =~ s/(\))/&$1&/ig;  #REVISAR
  my ($expresion,$func,$pretipo) = ('','','');
  ($coderr,my @listaamper) = juntar_por_paren_cur('',(split(/&+/,$expre)));

  my $dentro='';
  if (@listaamper >1) {
      $pretipo = 'x';
      $listaamper[0] =~ s/^X\w+\(//i; #este tambien era interior
      $func = "XXX";
      $dentro =  join ('', @listaamper);
  } elsif ($listaamper[0] =~ /^(\w)(\w*)\((.*)\)/) {
      $func = "$1$2"; $dentro = $3; $pretipo = 'f';
      if (uc($1) eq 'X' and $2 ne '') {
          $pretipo = 'x';
      };
  } elsif ($listaamper[0] =~ /[\+\-\*\/]/) {
      $pretipo = 'x'; # no tenia el X.. habra que ponerlo
      $func = 'XXX';$dentro = $listaamper[0];
 } else {
      $pretipo ='a';
      $dentro = $listaamper[0];
  };
  $valor = $dentro;
  $func ne '' and $valor = "$func($dentro)";
  return $dentro, $func, $pretipo, $valor;
} # analizar
# ---------------------------------------------------------------------------
sub asignar_TABLAS{
  comfin('coma asignar_TABLAS',@_);
  my ($ref) = $_[0]; # es un reflay
  my ($coderr,$mensaje) = ('','');
  impr_debug(__LINE__.' Tabl refall sobreTABLAS',Dumper $refall->{sobreTABLAS});
  my @cosastablas = @{$ref->{listaTABLAS}};
  impr_datos(__LINE__.' Tabl comienzo asignar ',['TABLAS'],$ref);
  my @listaTABLAS;
  foreach my $cosa (@cosastablas) {
      my ($Tidtabla,$comando);
      if ($cosa =~ /^(.+)_(.+)$/) {
          ($Tidtabla,$comando) = ($1,$2)
      } else {
          push @listaTABLAS,$cosa;
          next;
      };
      impr_debug(__LINE__.' Tabl $cosa,$comando',[$cosa,$comando]);
      impr_debug(__LINE__.' Tabl $ref->{REFLISTAVALOR}->{$cosa}'
           ,Dumper $ref->{REFLISTAVALOR}->{$cosa});
      my @lista = @{$ref->{REFLISTAVALOR}->{$cosa}}; 
      impr_debug(__LINE__.' Tabl @lista',\@lista);
      if ($comando =~ /^(ARC|ORD)$/) {
          my $valor = $lista[0];
          cargar_datos($ref,'TABLAS',$Tidtabla."_$comando"
            ,$valor,'c','c',[$valor]);
          next;
      };        
      my ($coderr,$mensaje,$valor,$tiparg,$refarg)
        = limpiar_lista($ref,'TABLAS','Z',$cosa,\@lista);
      if ($coderr) {
         if ($comando =~ /LIS|COl|ARC/) {
             $mensaje .="\n      Nos quedamos sin informacion para $cosa";
             eliminar_TABLA($ref,$Tidtabla,$mensaje);
             @listaTABLAS = grep(do{$_ ne $Tidtabla}, @listaTABLAS);
         } else {
             $mensaje .= " ignoramos la informacion para $cosa";
         };        
      } elsif (not $coderr) {
          cargar_datos($ref,'TABLAS',$Tidtabla."_$comando"
            ,$valor,',',$tiparg,$refarg);
      };
  };
  @{$ref->{listaTABLAS}}
  = grep(do{defined $ref->{VALOR}->{$_}},@{$ref->{listaTABLAS}});
  impr_datos(__LINE__.' Tabl',['TABLAS'],$ref);
#  impr_debug(__LINE__.' Tabl sobreTABLAS',Dumper $ref->{sobreTABLAS});
  comfin('fina asignar_TABLAS');
  return @listaTABLAS;
}#asignar_TABLAS
# ---------------------------------------------------------------------------
sub atender_COL_ORD{
  comfin('coma atender_COL_ORD',@_);
  my ($ref,$Aidarchivo,$col,$ord) = @_; my $coderr = ''; my $mensaje= '';
  my ($c1,$c2) = @$col;
  foreach my $cc ($c1,$c2) {
      if (substr($_,0,1) =~ /[\-\.0]/) {
          $mensaje = " $cc no sirve para designar una columna;
          debe ser un número positivo";
          $coderr = 150;
          comfin('fina atender_COL',$coderr,$mensaje);
          return $coderr,$mensaje; 
      };
  }; 
  impr_debug(__LINE__.' Tabl columnas',$col);
  impr_debug(__LINE__.' Tabl $refall->{sobreARCHS}->{$Aidarchivo}'
	     ,Dumper $refall->{sobreARCHS}->{$Aidarchivo});
  my $archivocompl = $refall->{sobreARCHS}->{$Aidarchivo}->{archivocompl};
  impr_debug(__LINE__.' Tabl $archivocompl',$archivocompl);
  if (not $archivocompl) {
      $coderr = 152; 
      $mensaje
         = "No hay informacion valida para archivo simbolico $Aidarchivo";
      comfin('fina atender_COL_ORD linea,$coderr,$mensaje'
         ,__LINE__,$coderr,$mensaje);
      return $coderr,$mensaje;
  }; 
  open ARCHIVOTABLA,$archivocompl;
  my $cmax = $c2; $cmax = $c1 if $c1 > $c2;
  my $numfila = -1; 
  my (@abscisas,@ordenadas);
  my $ordenf;
  my $mensaje0 = "para la tabla, en archivo $Aidarchivo
           Si quiere, puede anular todo el renglon del archivo 
           anteponiendo #";
  while (my $linea = <ARCHIVOTABLA>) {
      my ($uno,$dos);
      $numfila ++;
      chomp($linea);
      $linea =~ s/[\#\*].*//;
      $linea =~ s/^\s*//;
      $linea =~ s/\s*$//;
      next if $linea eq  '';
      impr_debug(__LINE__.' Tabl $linea',$linea);
      my @listi = split (/\s*[,\s]\s*/,$linea);
      impr_debug(__LINE__.' Tabl @listi',\@listi);
      if ($cmax > @listi) {
          $mensaje = " No hay suficientes columnas en archivo 
          $Aidarchivo        para la tabla ";
          $coderr = 151;
          comfin('fina atender_COL',$coderr);
          return $coderr,$mensaje; 
      };
      my @buenos;
      foreach my $atom ($listi[$c1-1], $listi[$c2-1]) {
          impr_debug(__LINE__.' Tabl $atom',$atom);
          ($coderr,$mensaje,my $valor) = evaluar_numero($atom); 
          if ($coderr) {
              $mensaje =" En $Aidarchivo, fila $numfila: $mensaje"; 
              comfin('fina atender_COL',@_);
              return $coderr,$mensaje; 
          };
          push @buenos, $valor;
      };
      ($uno,$dos) = @buenos;
      impr_debug(__LINE__.' Tabl @buenos',\@buenos);
      if ($ord =~ /INV/) {#invertido
          unshift @abscisas, $uno; unshift @ordenadas, $dos;
      } else {          
          push @abscisas, $uno; push @ordenadas, $dos;
      };          
  }; #while
  my ($refabscisas,$refcolumnas) = (\@abscisas,\@ordenadas);
  ($coderr,$mensaje) = atender_ORD($refabscisas,$refcolumnas,$ord);
  impr_debug(__LINE__.' Tabl @abscisas,@ordenadas'
     , [@abscisas,'|||',@ordenadas]);
  comfin('fina atender_COL_ORD',$coderr);
  return $coderr,$mensaje,$refabscisas,$refcolumnas;
}#atender_COL_ORD
# ---------------------------------------------------------------------------
sub atender_FAC{
  comfin('coma atender_FAC',@_);
  my($Tidtabla,$fac,$refabscisas,$refordenadas) = @_; my $coderr = '';
  my ($fac1,$fac2) = @{$fac};
  impr_debug(__LINE__.' Tabl $fac1,$fac2',[$fac1,$fac2]);
  if ($fac1 <= 0) {
      $coderr = 53;
      mensajear ("Se ignora el comando FACTORES=$fac1,$fac2 para $Tidtabla;
          se estropearía el orden de las abscisas");
  } else {
      map ($_ *= $fac1,@$refabscisas);
      map ($_ *= $fac2,@$refordenadas);
      impr_debug(__LINE__.' Tabl $refabscisas',$refabscisas);
      impr_debug(__LINE__.' Tabl $refordenadas',$refordenadas);
  };
  comfin('fina atender_FAC',$coderr);
  return $coderr; 
}#atender_FAC'
# ---------------------------------------------------------------------------
sub atender_LIS_ORD{
  comfin('coma atender_LIS_ORD',@_);
  my ($lis,$ord) = @_;my $coderr = '';my @mensajes;
  my $agre = '';
  $ord ne '' and $agre = ", luego de tener en cuenta $ord,";  
  my ($refabscisas,$refordenadas) = ([],[]);
  my @lista = @$lis;
  impr_debug(__LINE__.' Tabl @lista',Dumper \@lista);
  impr_debug(__LINE__.' Tabl @lista',Dumper \@lista);
  while (@lista >= 2) {
     my ($uno,$dos) = (shift @lista,shift @lista);  
     impr_debug(__LINE__.' Tabl $uno,$dos',[$uno,$dos]);
     if ($ord eq 'INV') {
         unshift @$refabscisas,$uno; unshift @$refordenadas,$dos;
     } else {
         push @$refabscisas,$uno; push @$refordenadas, $dos;
     };
  };
  if (@lista) {
      push @mensajes
        , "La lista tiene un numero impar de elementos; se ignora el ultimo";
  };
  impr_debug(__LINE__.' Tabl $refabscisas',$refabscisas);
  impr_debug(__LINE__.' Tabl $refordenadas',$refordenadas);
  ($coderr,my $mensajeORD) = atender_ORD($refabscisas,$refordenadas,$ord);
  impr_debug(__LINE__.' Tabl $mensajeORD',$mensajeORD);
  push @mensajes, $mensajeORD;
  my $mensaje = join "\n                ",@mensajes; 
  comfin('fina atender_LIS_ORD',$coderr,$mensaje,$refabscisas,$refordenadas);
  return $coderr,$mensaje,$refabscisas,$refordenadas;
}#atender_LIS_ORD
# ---------------------------------------------------------------------------
sub atender_ORD{
  comfin('coma atender_ORD',@_);
  my ($refabscisas,$refordenadas,$ord) = @_;
  my ($coderr,$last,$mensaje) = ('','','');
  if ($ord eq 'ORD') {
      my %hash; my $mal =''; my ($absc0,$absc1,$ord0,$ord1);
      for (my $i = 0; $i < @$refabscisas; $i ++) {
          $absc0 = $refabscisas->[$i];$ord0 = $refordenadas->[$i];
          if (defined $hash{$absc0}) {
              $ord1 = $hash{$absc0};
              impr_debug(__LINE__.' Tabl $absc0,$ord0,$ord1'
                ,[$absc0,$ord0,$ord1]);
              if ($ord0 != $ord1) {
                  $last = 1; last;
              } else {
                  $refabscisas->[$i] = undef;
              };
          } else {
              $hash{$absc0} = $ord0;
          };
      };#$i
      impr_debug(__LINE__.' Tabl %hash',Dumper \%hash);
      if ($last) {
          $mensaje = "No se puede atender la opcion 'ordenfilas = ordenado';
          hay abscisas repetidas con ordenadas distintas:
             $absc0,$ord0       $absc0,$ord1";
          $coderr = 65;
          comfin('fina atender_ORD',$coderr);
          return ($coderr,$mensaje);
      } else  {
          @$refabscisas = grep($_,@$refabscisas);
          @$refabscisas = sort {$a<=>$b} @$refabscisas; 
          @$refordenadas = ();
          map (push (@$refordenadas,$hash{$_}), @$refabscisas);
      };
  };
  for (my $i = 0; $i < @$refabscisas - 1; $i ++) {
      if ($refabscisas->[$i] > $refabscisas->[$i+1]) {
          $mensaje = " Abscisas decrecientes:"
           ." $refabscisas->[$i]  $refabscisas->[$i+1]"; $coderr = 67; last;
      };
   };
  impr_debug(__LINE__.' Tabl $refabscisas',$refabscisas);
  impr_debug(__LINE__.' Tabl $refordenadas',$refordenadas);
  comfin('fina atender_ORD',$coderr,$mensaje);
  return ($coderr,$mensaje);
}#atender_ORD
# ---------------------------------------------------------------------------
sub atender_RAN{
  comfin('coma atender_RAN',@_);
  my ($Tidtabla,$ran,$refabscisas,$refordenadas) = @_;
  my @lista = @$ran;
  if ($lista[1]<$lista[0]) {
      mensajear("Interpretamos rangox como $lista[1],$lista[0] para $Tidtabla");
      ($lista[0],$lista[1]) = ($lista[1],$lista[0]);
  }; 
  my ($prii,$ulti) = (0, @$refabscisas -1);
  if ($lista[0] < $refabscisas->[0]) {
      mensajear(" extremo inferior para RANGOX de $Tidtabla
        menor que abscisa inicial");
  } else {
      for (my $i = 0; $i < @$refabscisas; $i ++) {
          my $absc = $refabscisas->[$i];              
          if ($absc >= $lista[0]) {
              last; # anterior es $prii
          } else {
              $prii = $i;
          };
      }; #for
  };
  if ($lista[1] > $refabscisas->[-1]) {
      mensajear(" extremo superior para RANGOX de $Tidtabla
             mayor que abscisa final");
      $ulti = @$refabscisas-1;        
  } else {
      for (my $i = @$refabscisas-1; $i > 0; $i --) {
           my $absc = $refabscisas->[$i];              
          if ($absc <= $lista[1]) {
              last;# anterior es $ulti
          } else {
              $ulti = $i;
          };
      }; #for
  };
  impr_debug(__LINE__.' Tabl $prii,$ulti'
    ,[$lista[0],'['.$prii.']',$refabscisas->[$prii]
    ,'['.$ulti.']',$refabscisas->[$ulti],$lista[1]]);
  my (@abscisas,@ordenadas);
  for (my $i = $prii; $i<= $ulti; $i++) {
      push @abscisas, $refabscisas->[$i];
      push @ordenadas, $refordenadas->[$i];
  };
  @$refabscisas = @abscisas; @$refordenadas = @ordenadas;
  impr_debug(__LINE__.' Tabl $refabscisas',$refabscisas);
  impr_debug(__LINE__.' Tabl $refordenadas',$refordenadas);
  comfin('fina atender_RAN');
  return \@lista;
}#atender_RAN
# ---------------------------------------------------------------------------
sub atender_REP{
  comfin('coma atender_REP',@_);
  my ($Tidtabla,$rep,$refabscisas,$refordenadas) = @_;
  if ($rep >= 2) {
      my @abscisasori = @$refabscisas;
      my @increabscisas; my @nueabscisas = @abscisasori;
      map (do {push @increabscisas, $_-$abscisasori[0]},@abscisasori);
      my @ordenadasori = @$refordenadas;
      impr_debug(__LINE__.' Tabl $refabscisas',$refabscisas);
      impr_debug(__LINE__.' Tabl $refordenadas',$refordenadas);
      impr_debug(__LINE__.' Tabl @increabscisas',\@increabscisas);
      impr_debug(__LINE__.' Tabl @nueabscisas',\@nueabscisas);
      for (my $i = 1; $i < $rep; $i++) {
          my $delta = $nueabscisas[-1]; @nueabscisas = ();
          map (push(@nueabscisas, $_ + $delta),@increabscisas);
          push @$refabscisas, @nueabscisas; 
          push @$refordenadas, @ordenadasori;
          impr_debug(__LINE__.' Tabl @abscisas',$refabscisas);
	  impr_debug(__LINE__.' Tabl @ordenadas',$refordenadas);
          impr_debug(__LINE__.' Tabl @nueabscisas',\@nueabscisas);
     };
     impr_debug(__LINE__.' Tabl @abscisas',$refabscisas);
     impr_debug(__LINE__.' Tabl @ordenadas',$refordenadas);
   } else {
       mensajear (
         " Se ignora el valor de repeticiones ($rep) para $Tidtabla");
  };
  comfin('fina atender_REP');
  return '';
}
# ---------------------------------------------------------------------------
sub calcular_abs_ord_TABLA{# a partir de comandos ya asignados en $ref
  comfin('coma calcular_abs_ord_TABLA',@_);
  my ($ref,$Tidtabla) = @_; my ($coderr,$mensaje) = ('','');
  impr_debug(__LINE__.' Tabl REFLISTAVALOR',Dumper $ref->{REFLISTAVALOR});
  my $lis = valor($ref,'VALOR',$Tidtabla.'_LIS'); 
  my $col = valor($ref,'VALOR',$Tidtabla.'_COL');
  my $ord = valor($ref,'VALOR',$Tidtabla.'_ORD');
  $ord = uc(substr($ord,0,3));  
  my ($refabscisas,$refordenadas) = ([],[]); 
  my (%primero,%ultimo);
  if ($lis) {
      my @lista = @{$ref->{REFLISTAVALOR}->{$Tidtabla.'_LIS'}};
      my @lismalos = grep(do{$_ =~ /^[^\+\-\.\d]/},@lista);
      impr_debug(__LINE__.' Tabl @lismalos',\@lismalos); 
      ($coderr,$mensaje,$refabscisas,$refordenadas)
         = atender_LIS_ORD(\@lista,$ord);
      if ($coderr) {
          comfin('fina calcular_abs_ord_TABLA linea',__LINE__,$coderr,$mensaje);
          return $coderr,$mensaje;
      } elsif ($mensaje) {
          mensajear(" Lista $Tidtabla: $mensaje");
      };
      impr_datos(__LINE__.' Tabl',['TABLAS'],$ref);
  } elsif ($col) {
      my @lista =  @{$ref->{REFLISTAVALOR}->{$Tidtabla.'_COL'}};
      my $Aidarchivo = valor($ref,'VALOR',$Tidtabla.'_ARC');  
      ($coderr,$mensaje,$refabscisas,$refordenadas)
        = atender_COL_ORD($ref,$Aidarchivo,\@lista,$ord);
  };
  if ($coderr) {
      comfin('fina cacular_abs_ord_TABLA linea',__LINE__,$coderr,$mensaje);
      return $coderr,$mensaje;
  };
  my $rep = valor($ref,'VALOR',$Tidtabla.'_REP');  
  impr_debug(__LINE__.' Tabl $rep',$rep);
  $rep and  atender_REP($Tidtabla,$rep,$refabscisas,$refordenadas);
  my $ran = $ref->{REFLISTAVALOR}->{$Tidtabla.'_RAN'};  
  impr_debug(__LINE__.' Tabl $ran',$ran);
  if ($ran) {
       my $buenran = atender_RAN($Tidtabla,$ran,$refabscisas,$refordenadas); 
       if ($ran->[0] ne $buenran->[0]) {
            $ref->{LISTAVALOR}->{$Tidtabla ."_RAN"} = $buenran;
       };
  }; 
  my $fac = $ref->{REFLISTAVALOR}->{$Tidtabla.'_FAC'};
  $fac and atender_FAC($Tidtabla,$fac,$refabscisas,$refordenadas); 
 
  impr_debug(__LINE__.' Tabl $fac',$fac);
  @{$ref->{sobreTABLAS}->{$Tidtabla}->{absTABLAS}} = @$refabscisas;
  @{$ref->{sobreTABLAS}->{$Tidtabla}->{ordTABLAS}} = @$refordenadas;
  $ref->{sobreTABLAS}->{$Tidtabla}->{priTABLAS} = [0]; # para los rerun
  $ref->{sobreTABLAS}->{$Tidtabla}->{ultTABLAS} = [@$refabscisas-1];
  $ref->{TIPOTOK}->{$Tidtabla} = 'T';$ref->{TIPO}->{$Tidtabla} = '3';
  impr_TABLAS(__LINE__.' Tabl',$ref);
  impr_datos(__LINE__.' Tabl',['TABLAS'],$ref);
  comfin('fina calcular_abs_ord_TABLA linea',__LINE__,$coderr,$mensaje);
  return $coderr,$mensaje;
}#calcular_abs_ord_TABLA
# ---------------------------------------------------------------------------
sub calcular_pendientes{
  comfin('coma calcular_pendientes',@_);
  my $ref = $_[0]; my $coderr = '';
  impr_debug(__LINE__.' Tabl pendientes_t_def'
    ,Dumper $ref->{pendientes}->{t_def});
  impr_debug(__LINE__.'Tabl pendientes',Dumper $ref->{pendientes});
  foreach my $letra (qw (f g q t)) {
      impr_debug(__LINE__." Tabl pendientes $letra".'_num'
		 ,Dumper $ref->{pendientes}->{$letra.'_num'});
  };
  calcular_pendientes_t_def($ref) if $ref->{pendientes}->{t_def};
  calcular_pendientes_t_num($ref) if $ref->{pendientes}->{t_num};
  impr_listas_que(__LINE__.' Tabl',$ref,['TODOS'],'lista'); 
  impr_datos(__LINE__.' Tabl',['DADOS'],$ref);
  comfin('fina calcular_pendientes',$coderr);
  return $coderr;
}#calcular_pendientes',@_);
# ---------------------------------------------------------------------------
sub calcular_pendientes_t_def{
  comfin('coma calcular_pendientes_t_def',@_);
  my $ref = $_[0];
  my @pendientes = @{$ref->{pendientes}->{t_def}};
  delete $ref->{pendientes}->{t_def}; my @tablas;
  foreach my $cosa (@pendientes) {
      impr_dat(__LINE__.' Tabl',$cosa,$ref,'cpc');
      $cosa =~ /^([^_]+)/ and push @tablas,$1; 
      my ($valor,$tipo,$tiparg,$refarg) = tomar_cua_datos($ref,$cosa);
      if ($ref->{TIPO}->{$cosa} eq ',') {
          my @lista = @{$ref->{REFLISTAVALOR}->{$cosa}};
          my @listiparg = split (',',$tiparg);
          impr_debug(__LINE__.' Tabl @lista,@listiparg'
            ,[@lista,'||',@listiparg]);
          my (@nuelista,@nuelistiparg,@nuerefarg);
          while  (@lista) {
              my $par = shift @lista;
              my $tipargcito = shift @listiparg;
              if ($tipargcito =~ /^[no]/) {
                  push @nuelistiparg,$tipargcito;
                  push @nuerefarg,abs($par);
                  push @nuelista,$par;
              } elsif ($tipargcito =~ /^[apd]/) {
                  my ($nuevalor,$nuetipo,$nuetiparg,$nuerefarg)
                    = tomar_cua_datos($ref,$par);
                  push @nuelistiparg,$nuetiparg;
                  push @nuerefarg,@$nuerefarg;
                  push @nuelista,$nuevalor;
              };
          };
          cargar_datos($ref,'',$cosa,join(',',@nuelista),','
             ,join(',',@nuelistiparg),\@nuerefarg);
          if (grep(do{$_ !~ /[no,]/},@nuelistiparg) ) {
              push @{$ref->{pendientes}->{t_def}},$cosa;
          };        
      };
  };
  @tablas = union_conjunto(@tablas);
  impr_debug(__LINE__.' Tabl @tablas',\@tablas);
  foreach my $Tidtabla (@tablas) {
      my $coderr = tipear_TABLA($ref,$Tidtabla); my $mensaje= '';
      not $coderr and $ref->{TIPO}->{$Tidtabla} eq '1' 
       and ($coderr,$mensaje) = completar_TABLA($ref,$Tidtabla);
       
  }; 
  comfin('fina calcular_pendientes_t_def');
}#calcular_pendientes_t_def
# ---------------------------------------------------------------------------
sub completar_FUNCIONES{
  comfin('coma completar_FUNCIONES',@_);
  my ($ref) = @_; my $coderr = '';

  my @funciones_pendientes = grep($ref->{TIPOTOK}->{$_} eq 'q'
                                  ,keys %{$ref->{listaFUNCIONES}});
  impr_debug(__LINE__.' Tabl @funciones_pendientes',\@funciones_pendientes);
  foreach my $qfun (@funciones_pendientes) {
      my $tiparg = $ref->{TIPARG}->{$qfun};
      if ($tiparg =~ /w/) {
          error_progr($ref,__LINE__.' Tabl Si hay w no debería llegar aqui'); 
      } elsif ($tiparg =~ /[ap]/) { 
          @{$ref->{listaeleparFUNCION}->{$qfun}}
          = grep ($ref->{TIPO}->{$_} =~ /[ap]/,@{$ref->{REFARG}->{$qfun}});
      } elsif ($tiparg =~ /[sS]/) {
          @{$ref->{listasSFUNCION}->{$qfun}}
          = grep (valor($ref,'TIPO',$_) =~ /[sS]/,@{$ref->{REFARG}->{$qfun}});
      };# else {
 #         $ref->{TIPOTOK}->{$qfun} = 'Q';
 #     };
      $ref->{listawFUNCION}->{$qfun} = undef;
  }; 
  comfin('fina completar_FUNCIONES',$coderr); 
  return '';
}#completar_FUNCIONES
# ---------------------------------------------------------------------------
sub completar_TABLA{# se llega aqui cuando esta todo pronto
  comfin('coma completar_TABLA',@_);
  my ($ref,$Tidtabla) = @_; my ($coderr,$mensaje) = ('','');
  ($coderr,$mensaje) = calcular_abs_ord_TABLA($ref,$Tidtabla); 
  impr_datos(__LINE__.' Tabl',['TABLAS'],$ref);
  comfin('fina completar_TABLA',$coderr,$mensaje);
  return $coderr,$mensaje;
}#completar_TABLA
# ---------------------------------------------------------------------------
sub descripcion_TABLA{#no se esta usando
  comfin('coma descripcion_TABLA',@_);
  my ($refarch,$Tidtabla,$talcual) = @_;
  my $descr = "Tabla $Tidtabla: ";
  return $descr unless defined $refarch->{sobreTABLAS};
  comfin('fina descripcion_TABLA');
}#descripcion_TABLA
# ---------------------------------------------------------------------------
sub desdoblarCOL{
  comfin('coma desdoblarCOL',@_);
  my $Tidtabla = $_[0];
  impr_debug(__LINE__.' Tabl',Dumper $refall->{sobreTABLAS}->{$Tidtabla});
  my $rpares = $refall->{sobreTABLAS}->{$Tidtabla}->{refpares};
  my $numobj = $rpares->{COL}->[0];  
  my ($archivo,$reflis) = @{$rpares->{COL}->[1]};
  $rpares->{COL} = [$numobj,$reflis];
  $rpares->{ARC} = [$numobj,[$archivo]]; 
  impr_debug(__LINE__.' Tabl refall->{sobreTABLAS}'
    ,Dumper $refall->{sobreTABLAS});
  comfin('fina desdoblarCOL');
}#desdoblarCOL
# ---------------------------------------------------------------------------
sub depurar_refARCHIVOS{#sin argumentos
  comfin('coma depurar_refARCHIVOS',@_);my $coderr= '';my @mensajes;
  foreach my $Aidarchivo (keys %refARCHIVOes) {
      my $refARCHIVO = $refARCHIVOes{$Aidarchivo};
      my $simbarchori = $refall->{sobreARCHS}->{$Aidarchivo}->{simbarchori}
        = $refARCHIVO->{simbarchori}->[0];
      impr_debug(__LINE__.' Tabl $refARCHIVO',Dumper $refARCHIVO); 
      impr_debug(__LINE__.' Tabl $refall->{sobreARCHS}'
		 ,Dumper $refall->{sobreARCHS});
      my %refcomandos = %{$refARCHIVO->{refpares}};
      foreach my $comando (keys %refcomandos) {
          my $refpar = $refcomandos{$comando};my $coderrcomando= '';
          my @strings;
#          impr_debug(__LINE__.' Tabl $refpar',Dumper $refpar);
          foreach my $par (@$refpar) {
#              impr_debug(__LINE__.' Tabl $par',Dumper $par);
              push @strings,$par->[1]->[0];
#              impr_debug(__LINE__.' Tabl @strings',\@strings);      
          };
          if (@$refpar >1) {
              @strings = union_conjunto(@strings);
#              impr_debug(__LINE__.' Tabl @strings',\@strings);
              if (@strings >1) {
                  $coderrcomando = 1;
              };
          };
           if ($coderrcomando) {
              push @mensajes
                , " Problemas con comando $comando para $Aidarchivo";
          } else {
              my $numobj = $refARCHIVO->{refpares}->{$comando}->[0]->[0];    
#             impr_debug(__LINE__.' Tabl $numobj,@strings
#              ',[$numobj,'||',$strings[0]]);
             $refall->{sobreARCHS}->{$Aidarchivo}->{$comando}
	      = [$numobj,$strings[0]];
          };
      };
      impr_debug(__LINE__.' Tabl $refall->{sobreARCHS}'
        ,Dumper $refall->{sobreARCHS});  

      my $archreal = $refall->{sobreARCHS}->{$Aidarchivo}->{ARC}->[1];
      my $numobj = $refall->{sobreARCHS}->{$Aidarchivo}->{ARC}->[0];
      my $numfile = $reflayers[$refboxes{$numobj}->{numcapa}]->{numfile};
      impr_debug(__LINE__.' Tabl',Dumper $refnombres[$numfile]); 
      my $BASEARCH = $refnombres[$numfile]->{BASEARCH};
      my ($coderr,$archcompl) = compl_archivo($archreal,$BASEARCH); 
      impr_debug(__LINE__.' Tabl $archreal,$archcompl'
         ,[$archreal,$archcompl]);
      if (not defined $archreal) {
	  push @mensajes," No esta definido cual archivo es $simbarchori";
	  $coderr = 150;
      } elsif (not -e $archcompl) {
	  push @mensajes," No existe el archivo $archreal";
          $coderr = 151;
      };
      if ($coderr) {
          delete $refall->{sobreARCHS}->{$Aidarchivo};
      } else {
          $refall->{sobreARCHS}->{$Aidarchivo}->{archivocompl} = $archcompl
      };
  };
  my $mensaje = join "\n",@mensajes;
  impr_debug(__LINE__.' Tabl sobreARCHS' ,Dumper $refall->{sobreARCHS});
  comfin('fina depurar_refARCHIVOS',$mensaje);
  return $mensaje;
}#depurar_refARCHIVOS
# ---------------------------------------------------------------------------
sub depurar_refTABLAS{#sin argumentos
  comfin('coma depurar_refTABLAS',@_);
  impr_debug(__LINE__.' Tabl %refTABLAes',Dumper \%refTABLAes);
  foreach my $Tidtabla (keys %refTABLAes) {
      my $refTABLA = $refTABLAes{$Tidtabla};
      my @clasecapas =  @{$refTABLA->{numcapas}}; my $coderrcapas = '';
      if (@clasecapas > 1) {
          map(do {$_ = $reflayers[$_]->{clasecapa}},@clasecapas);
          @clasecapas = union_conjunto(@clasecapas);
          if (@clasecapas > 1) {
              my @capaselemod = grep (do{$_ =~ /elementos|modelo/},@clasecapas);
              if (@capaselemod > 1) {
                  $coderrcapas = 1;  
	           mensajear("problemas de capas @{$refTABLA->{numcapas}}");
              };
          };
          impr_debug(__LINE__.' Tabl $coderrcapas',$coderrcapas);
      };
      not $coderrcapas and $refall->{sobreTABLAS}->{$Tidtabla}->{numcapa}
        = $refTABLA->{numcapas}->[0];
      @{$refTABLA->{tipos}} = union_conjunto(@{$refTABLA->{tipos}});    
      my @tipos = @{$refTABLA->{tipos}};
      if (@tipos >1) {
          mensajear("problemas con los tipos @tipos");
          next;
      } else {
          $refall->{sobreTABLAS}->{$Tidtabla}->{tipo} = $tipos[0];
      };
      my %refcomandos = %{$refTABLA->{refpares}};
      foreach my $comando ((qw (LIS COL ORD REP RAN FAC))) { 
          next unless $refcomandos{$comando};
          my $refpar = $refcomandos{$comando};
          if (@$refpar >1) {
              mensajear(" Repeticion del comando $comando; se ignora");
              delete $refTABLA->{refpares}->{$comando};
              if ($comando =~ /COL|LIS/) {
                  mensajear(
                   " Nos quedamos sin informacion esencial para $Tidtabla");
                  delete $refall->{sobreTABLAS}->{$Tidtabla};
		  last;
              };
          } else {
	      foreach my $par (@$refpar) {
#                  impr_debug(__LINE__.' Tabl $par '.$comando,Dumper $par);
                  @{$refall->{sobreTABLAS}->{$Tidtabla}->{refpares}->{$comando}}
		  = @{$refpar->[0]};
              };
          };
      };
      impr_debug(__LINE__.' Tabl',Dumper $refTABLA->{refpares});       
      desdoblarCOL($Tidtabla) if $refTABLA->{refpares}->{COL};
  };
  impr_debug(__LINE__.' Tabl $refall->{sobreTABLAS}'
    ,Dumper $refall->{sobreTABLAS});
  comfin('fina depurar_refTABLAS');
  return;
}#depurar_refTABLAS
# ---------------------------------------------------------------------------
sub depurar_w{
  comfin('coma depurar_w',@_);
  my($ref,@varconws) = @_; my $coderr = '';
  my ($refpparconws,$refdparconws,$refeleconws,$reftablaconws) = ([],[],[],[]);
  my @todos = keys %{$ref->{TIPARG}};my @ws;
  my @nuevarconws; my $hayrerun= '';
  while (@varconws) {
      my $cosa = shift @varconws;
      impr_dat(__LINE__.' Tabl',$cosa,$ref,'dw');
      my($tiparg,$refarg) = tomar_tiparg_refarg($ref,$cosa);
      $refarg and @$refarg or next;
      my @refarg = @$refarg;
      impr_par(__LINE__.' Tabl',$tiparg,$refarg);
      my $nuetiparg = '';my @nuerefarg;
      my $coderr1 = '';
      while ($tiparg =~ s/^(\W*)(\w)//) {
          impr_par(__LINE__.' Tabl',$nuetiparg,\@nuerefarg);  
          my $var = shift @refarg;
          impr_debug(__LINE__.' Tabl $1 $2',[$1, $2]);
          if ($2 eq 'w') {
              impr_dat(__LINE__.' Tabl depe',$var,$ref,'dw');
              my $nuew = $ref->{TIPOTOK}->{$var};
              impr_debug(__LINE__.' Tabl $var,$1,$2,$nuew',[$var,$1,$2,$nuew]);
              if (defined $nuew and $nuew ne 'w') {
                  my ($tipargcito,$refargcito)
                    = tomar_tiparg_refarg($ref,$var);
                  if (length($tipargcito) <= 2) {
                      $nuetiparg .= $1.$tipargcito;
		      push @nuerefarg,$refargcito->[0];
                   impr_par(__LINE__.' Tabl',$nuetiparg,\@nuerefarg);  
                  } else {
                      if ($ref->{TIPO}->{$var} eq ',') {
		          my $que = $ref->{que}->{$cosa};
		          impr_debug(__LINE__.' Tabl $que',$que);
		          $hayrerun = 1;
                          (my $tipargcitocito = $tipargcito)
                             =~ s/^(.+),(.+)/$1/;
                          my $reflista = $ref->{REFLISTAVALOR}->{$var};     
                          $nuetiparg .= ','.$tipargcitocito;
                          push @nuerefarg,$reflista->[0];
                          impr_par(__LINE__.' Tabl',$nuetiparg,\@nuerefarg);  
                      } else {
                          $coderr1 .= " $cosa"."_60";
                          $nuetiparg .= $1.$2;
                          push @nuerefarg,$var;
                          impr_par(__LINE__.' Tabl',$nuetiparg,\@nuerefarg);  
                      };
	          };
	      } else {
                  $nuetiparg .= $1.$2;
                  push @nuerefarg,$var;
                  impr_par(__LINE__.' Tabl',$nuetiparg,\@nuerefarg);  
              };
          } else {
              $nuetiparg .= $1.$2;
              push @nuerefarg,$var;
              impr_par(__LINE__.' Tabl',$nuetiparg,\@nuerefarg);
          }; 
      };
      $tiparg and $nuetiparg .= $tiparg;
      impr_par(__LINE__.' Tabl',$nuetiparg,\@nuerefarg);  
      if (not $coderr1 and $nuetiparg !~ /w/) {
          impr_par(__LINE__.' Tabl',$nuetiparg,\@nuerefarg);  
          (my $coderr2,$tiparg,$refarg)
            = mejorar_tiparg_refarg($ref,'',$nuetiparg,\@nuerefarg,__LINE__.' Tabl');
#          $mensaje and mensajear($mensaje);  
          if (not $coderr2) {
              cargar_tiparg_refarg($ref,$cosa,$tiparg,$refarg);
              next;
          } else {
              push @MENSAJES, " Error en definicion de $cosa;
              Quedamos sin informacion util para $cosa";
	      $ref->{TIPOTOK}->{$cosa} = 'w';
              push @nuevarconws,$cosa; $coderr .= " $coderr1";
	  };
      } else {
          $ref->{TIPOTOK}->{$cosa} = 'w'; 
	  push @nuevarconws,$cosa; $coderr .= " $coderr1";
      };
  };
  comfin('fina depurar_w',$coderr,@nuevarconws);
  return $coderr,@nuevarconws; 
}#depurar_w
# ---------------------------------------------------------------------------
sub eliminar_TABLA{#REVISAR
  # la tabla ya esta registrada en $ref->{sobreTABLAS}
  #salvo con $ref igual a 0 y puede o no 
  # haber sido cargada en $ref->{TIPOTOK}, etc 
  # se eliminan los parametros que usan esa tabla con argumento TIEMPO
  comfin('coma eliminar_TABLA',@_);
  my($ref,$Tidtabla,$mensaje) = @_;
  impr_debug(__LINE__.' Tabl listaTABLAS',$ref->{listaTABLAS});
  delete $refall->{sobreTABLAS}->{$Tidtabla};
  mensajear(" Eliminamos $Tidtabla: $mensaje");
#  impr_debug(__LINE__.' Tabl TIPO',$ref->{TIPO});
#  $ref->{TIPO}->{$Tidtabla} = '0' if $ref->{TIPO};
  if ($ref and $ref->{listaDATOS} and @{$ref->{listaDATOS}}) {
      my $comi = $Tidtabla .'_';
      @{$ref->{listaTABLAS}}= grep(do{not ($_ =~ /^$comi/ or $_ eq $Tidtabla)}
         , @{$ref->{listaTABLAS}});
  };
  impr_debug(__LINE__.' Tabl listaTABLAS',$ref->{listaTABLAS});
  impr_datos(__LINE__.' Tabl',['TABLAS'],$ref);
  comfin('fina eliminar_TABLA');
  return;
}#eliminar_TABLA
# ---------------------------------------------------------------------------
sub eliminar_comando_TABLA_cuadro{
  comfin('coma eliminar_comando_TABLA',@_);
  my ($refcuadro,$Tidtabla,$comando,$mensaje) = @_;
  delete $refcuadro->{sobreTABLAS}->{$Tidtabla}->{comandos}->{$comando};
  comfin('fina eliminar_comando_TABLA');
  return;
}#eliminar_comando_TABLA;
# ---------------------------------------------------------------------------
sub eliminar_tablas_fuera{# ya no las elimino; solo aviso
  comfin('coma eliminar_tablas_fuera',@_);
  my $ref = $_[0];
  my @tablaspendientes = grep (do {$ref->{TIPOTOK}->{$_} eq 'T' and
                                   $ref->{tablatiempo}->{$_}}
                               , keys %{$ref->{TIPOTOK}});
  impr_debug(__LINE__.' Tabl @tablaspendientes',\@tablaspendientes);
  impr_datos(__LINE__.' Tabl',['TIEMPOS','TABLAS'],$ref);
  my $STOPTIEMPO = valor($ref,'VALOR','STOPTIEMPO');
  my $STARTTIEMPO = valor($ref,'VALOR','STARTTIEMPO');
  impr_debug(__LINE__.' Tabl $STARTTIEMPO,$STOPTIEMPO'
    ,[$STARTTIEMPO,$STOPTIEMPO]);
  if (defined $STOPTIEMPO and defined $STARTTIEMPO) {
      foreach my $Tidtabla (@tablaspendientes) {
          (my $idtabla = $Tidtabla) =~ s/^T//;
          my $comienzo = $ref->{sobreTABLAS}->{$Tidtabla}->{absTABLAS}->[0];
          my $final =  $ref->{sobreTABLAS}->{$Tidtabla}->{absTABLAS}->[-1];
          impr_debug(__LINE__.' Tabl $comienzo,$final'
		     ,[$comienzo,$final]);
          if ($comienzo > $STARTTIEMPO or $final > $STOPTIEMPO) {
              my $previsto = "$STARTTIEMPO - $STOPTIEMPO";
              my $cubierto = "$comienzo - $final";
              mensajear(
            " La tabla $idtabla no cubre todo el tiempo de simulacion previsto;
              previsto: $previsto     cubierto: $cubierto;
                se producira extrapolacion");
          };
      };
  };
  comfin('fina eliminar_tablas_fuera');
}#eliminar_tablas_fuera
#----------------------------------------------------------------------------
sub fun_par_tab_var{
  comfin('coma fun_par_tab_var',@_);
  my ($expresion, $ref,$aignorar) = @_;
  #devuelve referencias a hashes para fun, par,tab, var, funx, arg 
  # hashes de las funciones, parametros, tablas, variables, funciones
  # que comienzan con x que aparecen en expresion, y cantidad de argumentos
  # de todas las funciones
  # funciones, variables, listalis o listaresu, prohibidas
  # variables 'e' o 'E' prohibidas
  # tampoco pueden comenzar con digito 
  # y las funciones no empiezan con X
  #      SI pueden empezar con X; de hecho las XTABLE ....
  # los parametros deben estar definidos como tales; de otro modo 
  # se clasifican como variables
  #nodos y elementos se clasifican como variables? 
  my (%param_incorr,%noderivada);
  my %prohibidas = ('LISTALIS' => 1, 'LISTARESU' => 1,
                    'e' => 1, 'E' => 1); # no se contabilizaran; 
      #números tampoco
  $expresion =";$expresion;"; 
  #impr_debug(__LINE__.' Tabl $expresion',$expresion);
  #impr_datos(__LINE__. ' Tabl fun_par_tab', ['DATOS','PARAMETROS'], $ref);
  # las "funciones" listalis se distinguen un poco por su primer argumento; 
  # pero aun asi pueden tener igual primer argumento y diferente numero de
  # argumentos: de todos modos el primer "argumento puede ser ...
  $expresion =~ s/(\W)listalis\((\w+)\,/$1listalis_$2\(/ig;
  my @listamezcla = $expresion =~ /([\w\.]+)/g; #lista de palabras 
  my @listasepa = split /[\w\.]+/, $expresion; #lista de separadores
  #impr_debug(__LINE__.' Tabl palabras',\@listamezcla);
  #impr_debug(__LINE__.' Tabl separadores',\@listasepa);
  if (@listamezcla + 1 != @listasepa) {
           error_progr($ref,"No se esperaba una expresión así
                  $expresion
            ". __LINE__.' Tabl')};
  my ($reffun, $refpar, $reftab, $refvar, $reffunx,$refarg,$refnodo) 
       = ({},{},{},{},{},{},{}); 
  #impr_debug(__LINE__.' Tabl $aignorar',$aignorar);
  for (my $i = 0; $i < @listamezcla; $i++) {
      my $palabra = uc($listamezcla[$i]);
      next if $prohibidas{$palabra}  or $palabra =~ /^[\d\.]/
            or $aignorar->{$palabra} or $acep_fun{lc($palabra)};
      if ($listasepa[$i+1] =~ /^\s*\(/) {
          #corresponde a funcion de algun tipo
	  my $abre = 1; my $j = $i+2; my $comas = 0;
          while ($j < @listasepa and $abre >0) {
              my $signo = $listasepa[$j];
              my @signos = split '',$signo; my $k = 0;
              while ($k < @signos) {
	          $_ = $signos[$k];
                  if ( /\s*\)/) {$abre --
                  } elsif  (/\s*\(/) {$abre ++        
                  } elsif (/\,/ and $abre == 1) {$comas ++
                  };$k++;
	      }; $j++;
          };
          if ($abre>0) {
              avgrav("abre $abre i $i j $j Expresion mal apareada
                $expresion ")
          }; 
          push @{$refarg->{$palabra}}, $comas +1;
          if ($palabra =~ /^X/) {
              $reffunx->{$palabra}++; 
          } elsif ($palabra =~ /^T/) {
              $reftab->{$palabra}++;
          } elsif (not defined $acep_fun{$palabra}) {
              $reffun->{$palabra}++;
          };
      } elsif (defined $ref->{cualobjtextonodo}->{$palabra}) { 
          $refnodo->{$palabra} ++;
      } elsif ($palabra =~ /^P/) {
           if (defined $ref->{PARAMETROS}->{$palabra}) {
              $refpar->{$palabra}++;
               if (defined $ref->{PARAMETROS}->{"D$palabra"}) {
                   $refpar->{$palabra}++;
                   $refpar->{"D$palabra"} = 2;
                    #solo importa que sea mayor que 1
               };
           } elsif (defined $ref->{PARAMETROS}->{"D$palabra"}) {
               $refpar->{$palabra}++;
               $refpar->{"D$palabra"} = 2;
           } else {
               $param_incorr{$palabra} = 1;
           };
   
      } elsif ($palabra =~ /^D(.+)/ 
	       and defined $ref->{PARAMETROS}->{$palabra}) {
           $noderivada{$palabra} = 1;   
      } elsif ($aignorar->{$palabra}) {
      } else {
	  $refvar->{$palabra}++; 
          #se controla despues que realmente sea variable para sceptre
      };   
  }; #listamezcla
  #impr_debug(__LINE__.' Tabl %param_incorr ', Dumper \%param_incorr);
  if (scalar %param_incorr) {
      my %defini = (%{$ref->{DATOS}},%{$ref->{PARAMETROS}});
      my @usan;
      foreach my $noesp (keys %param_incorr) {
          push (@usan, grep(";$defini{$_};" =~ /\W$noesp\W/
			    , keys %defini));
      };
      my $donde = join (' ', keys %param_incorr) . " usado(s) por @usan";
      porparar1(190,$ref,
        "Uso incorrecto de posible(s)  parámetro(s) (definición?)
        "  . $donde);
       return 190; 
  };
  if (scalar %noderivada) {
      my $donde = join ' ', keys %noderivada;
      porparar1(191,$ref,"Sceptre no calcula derivadas: 
         " . $donde);
      return 191; 
  };
  foreach my $key (keys %$refarg) {
      my @lista = union_conjunto(@{$refarg->{$key}});
      $refarg->{$key} = \@lista;
  };
  my @cosas = keys %{$ref->{no_formales}};
  foreach my $cosa (@cosas) {
      if ($cosa =~ /^P/) {
          $refpar->{$cosa}++
      } else {
          $refvar->{$cosa}++
      };
  };
  #impr_debug(__LINE__.' Tabl reffun ', $reffun) if scalar %$reffun;  
  #impr_debug(__LINE__.' Tabl refpar ', $refpar) if scalar %$refpar;  
  #impr_debug(__LINE__.' Tabl reftab ', $reftab) if scalar %$reftab;  
  #impr_debug(__LINE__.' Tabl refvar ', $refvar) if scalar %$refvar;  
  #impr_debug(__LINE__.' Tabl reffunx ',$reffunx) if scalar %$reffunx;  
  #impr_debug(__LINE__.' Tabl refarg ', Dumper $refarg) if scalar %$refarg;  
  comfin('fina fun_par_tab_var');
  return '',$reffun, $refpar, $reftab, $refvar, $reffunx, $refarg,$refnodo;
}# fun_par_tab_var 
# ---------------------------------------------------------------------------
sub impr_TABLAS{ 
  return unless $debug;
  comfin('coma impr_TABLAS',@_);
  my ($mensaje,$ref) = @_;
  my $quees='';
  if (defined $ref->{numobj}) {
      $quees= "cuadro $ref->{numobj}";
  } elsif (defined $ref->{numcapa}) {
      $quees = "capa $ref->{numcapa}"
  } else {
      $quees = 'archivo';
  };
  print STDERR "Empieza ____________     impr_TABLAS $mensaje para $quees\n";
  print STDERR 'sobreTABLAS ',Dumper $ref->{sobreTABLAS};
  if ($quees =~ / ^cuadro/) {
      print STDERR Dumper $ref;
  } else {
      if ($ref->{sobreTABLAS} and $ref->{sobreTABLAS}->{numobjs}) {
          my @numobjs = @{$ref->{sobreTABLAS}->{numobjs}};
          if (@numobjs) {
              print STDERR "    Cuadros involucrados para $quees \n";
              foreach my $numobj (@numobjs) {
                  my $refcuadro = $refboxes{$numobj};
                  print STDERR Dumper $refcuadro;
              }; 
          };
      };
      print STDERR "Termina ____________        impr_TABLAS  ($mensaje)\n";
  };
  comfin('fina impr_TABLAS');
  return '';
}#impr_TABLAS
# ---------------------------------------------------------------------------
sub interpretar_1refpar_TABLA{ 
  comfin('coma interpretar_1refpar_TABLA',@_);
  my($Tidtabla,$comando,$refpar) = @_; my ($coderr,$mensaje) = ('','');
  my $ign = " se ignora";
  impr_debug(__LINE__.' Tabl',Dumper $refpar);
  my $numobj = $refpar->[0];
  my @lista = @{$refpar->[1]};
  impr_debug(__LINE__.' Tabl',Dumper \@lista);
  my $referrores = $refboxes{$numobj}->{errores};
  impr_debug(__LINE__.' Tabl $referrores',Dumper $referrores);
  $referrores->{$comando} = [];
  impr_debug(__LINE__.' Tabl comando,$numobj,@lista'
     ,[$comando,$numobj,'||',@lista]);
  my $cosacomando = "comando $comando";
  if (($comando =~ /^COL/ and @lista == 2) or
      ($comando =~ /^LIS/ and @lista >= 4) or 
      ($comando =~ /^(FAC|RAN)/ and @lista ==2) or
      ($comando =~ /^(ARC|ORD|REP)/ and @lista ==1) ) {
      if ($comando =~ /COL|LIS|FAC|RAN|ARC|REP/) {
      } elsif ($comando eq 'ORD') {
          if ($lista[0] =~ /^(inv|ord|talc)/i) {
          } else {
              push @{$referrores->{ORD}}
               , " solo son admisibles para ordenfilas
            'invertido', 'ordenado' y 'talcual'";
          };
      };
  } elsif ($comando =~ /^(ARC|COL|LIS|FAC|ORD|RAN|REP)$/) {
  ## pero lista no bien
      push @{$referrores->{$comando}}
        , " Lista $Tidtabla: Error de sintaxis en $comando = " 
        . join(',',@lista) ."; se ignora";
  } else {
      push @{$referrores->{$comando}}, " no se reconoce $comando";
  };
  if (@{$referrores->{$comando}}) {
      $coderr = 40; $mensaje = join "\n",@{$referrores->{$comando}};
  };
  comfin('fina interpretar_1refpar_TABLA',$coderr,$mensaje);
  return $coderr,$mensaje;
}#interpretar_1refpar_TABLA
# ---------------------------------------------------------------------------
sub interpretar_archivos{
  comfin('coma interpretar_archivos',@_);
  my ($reflay,$numobj,@refarchivos) = @_;
  my $refcuadro = $refboxes{$numobj};
  my $error = ''; my $referrores = $refcuadro->{errores} = {};
  my $refsobrearchs = $refcuadro->{sobrearchs};
  foreach my $refarc (@refarchivos) { 
      my ($comando,$simbarch,$reflista)  = @$refarc;
      my $refsobrearc = $refsobrearchs->{$simbarch};
      $refsobrearc or $refsobrearc = {};
      if ($comando eq 'ARC') {
          if (@$reflista == 1) {
              push @{$refsobrearc->{$simbarch}->{ARC}},$reflista->[0];
           } else {
              push @$referrores, " Hay ',' en el nombre del archivo
              ".join ',',@$reflista;
          };
      } else {
          push @{$refsobrearc->{$simbarch}->{$comando}},$reflista;
      };
  };
  foreach my $simbarch (keys %$refsobrearchs) {
      foreach my $comando (qw(ARC VAR MAG UNI)) {
	  if (@{$refsobrearchs->{$simbarch}->{$comando}} == 1) {
              push @{$reflay->{sobrearchs}->{$simbarch}->{$comando}},$numobj;
          } else {
              push @$referrores," Hay mas de un definicion para el comando
                 se ignoran todas";
          };
      };
  };   
  comfin('fina interpretar_archivos');
  return;
};#interpretar_archivos  
# ---------------------------------------------------------------------------
sub interpretar_comandos_ARCHIVOS{# HAY QUE REPROGRAMAR
  comfin('coma interpretar_comandos_ARCHIVOS',@_);
  my $ign = "se ignora"; my $coderr = '';
#  foreach my $SIMBARCH (keys %refownerchs) {
#      next unless $SIMBARCH =~ /^ARCH/;
#      if (@{$refownerchs{$SIMBARCH}} > 1) {
#         mensajear(
#     " Archivo simbolico $SIMBARCH con mas de un owner; $ign;
#        cambie nombres de archivos simbolicos");
#      };
#      if (not $refrefpares->{ARC}) {
#         mensajear(
#           " Falta indicacion de nombre real de archivo para $SIMBARCH; $ign");
#         delete $refownerchs{$SIMBARCH};next;
#      } else {   
#          @{$refrefpares->{ARC}}
#            = union_conjunto(@{$refrefpares->{ARC}});
#          if (@{$refrefpares->{ARC}} > 1) {
#              mensajear(
#                "Hay mas de un nombre de archivo real para $SIMBARCH; $ign"); 
#              delete $refownerchs{$SIMBARCH};next;
#          };
#          my $refparARC = $refrefpares->{ARC}->[0];
#          my $archivo = $refparARC->[1]->[0];
#          impr_debug(__LINE__.' Tabl $archivo',$archivo);
#      };
#      foreach my $comando (qw (MAG UNI VAR)) {
#          next unless $refrefpares->{$comando};
#          @{$refrefpares->{$comando}}
#	  = union_conjunto(@{$refrefpares->{$comando}});
#      if (@{$refrefpares->{$comando}} > 1) {
#              mensajear(
#            "Comando $comando para $SIMBARCH con mas de una definicion; $ign");
#              delete $refrefpares->{$comando};next;
#          };
#      };
#   }; 
  comfin('fina interpretar_comandos_ARCHIVOS');
  return
}#interpretar_comandos_ARCHIVOS
# ---------------------------------------------------------------------------
sub interpretar_TABLAS_en_reflays{# sin argumentos
  comfin('coma interpretar_TABLAS_en_reflays',@_);
  my @capas;
  impr_debug(__LINE__.' Tabl $refall',[sort keys %$refall]);
  impr_debug(__LINE__.' Tabl $refall->{sobreTABLAS}'
    ,[sort keys %{$refall->{sobreTABLAS}}]);
  my @listaTABLAS = sort keys %{$refall->{sobreTABLAS}};
  foreach my $Tidtabla (@listaTABLAS) {
      my $coderr = '';
      my $sobre = $refall->{sobreTABLAS}->{$Tidtabla};
      my $tipoTABLA = $sobre->{tipo};
      my $refparprinc;
      $tipoTABLA eq 'diagr' and $refparprinc = $sobre->{refpares}->{LIS}->[0]
	  or $refparprinc = $sobre->{refpares}->{COL}->[0];
      if (not $refparprinc) {
          $coderr = 50; 
          my $mensaje = " No tenemos informacion sobre $Tidtabla";
          eliminar_TABLA(0,$Tidtabla,$mensaje);  
          next;
      };
      my $numcapa = interpretar_TABLA($Tidtabla);
      push @capas,$numcapa; 
  };
  @capas = union_conjunto(@capas);
  foreach my $numcapa (@capas) {
      my $reflay = $reflayers[$numcapa];
      @listaTABLAS = asignar_TABLAS($reflay,__LINE__);
      impr_debug(__LINE__.' Tabl @listaTABLAS',\@listaTABLAS);
      foreach my $Tidtabla (@listaTABLAS) {
          my $coderr = tipear_TABLA($reflay,$Tidtabla);
          my $mensaje = '';
          if (not $coderr and valor($reflay,'TIPARG',$Tidtabla) eq '') {
              ($coderr,$mensaje) = calcular_abs_ord_TABLA($reflay,$Tidtabla);
          } else {
              push @{$reflay->{pendientes}->{t_def}},$Tidtabla;
          };
          if ($coderr) {
              impr_debug(__LINE__.' Tabl',"por eliminar $Tidtabla $mensaje");
              eliminar_TABLA($reflay,$Tidtabla,$mensaje);
          }; 
      };
  };
  comfin('fina interpretar_TABLAS_en_reflays');
}#interpretar_TABLAS_en_reflays
# ---------------------------------------------------------------------------
sub interpretar_TABLA{# opera desde los refall->{sobreTABLAS} para
  #  interpretar comandos
  comfin('coma interpretar_TABLA',@_);
  my $Tidtabla = $_[0];
  my $ign = "se ignora"; my ($coderr,$mensaje) = ('','');
  my $sobre = $refall->{sobreTABLAS}->{$Tidtabla};
  my $numcapa = $sobre->{numcapa};
  my $tipoTABLA = $sobre->{tipo};
  my $reflay = $reflayers[$numcapa];
  $reflay->{TIPOTOK}->{$Tidtabla} = 't';
  $reflay->{VALOR}->{$Tidtabla} = $tipoTABLA;
  push @{$reflay->{listaTABLAS}},$Tidtabla;
  impr_datos(__LINE__.' Tabl',['TABLAS'],$reflay);
  my $refrefpares = $sobre->{refpares};
  impr_debug(__LINE__.' Tabl $refrefpares',Dumper $refrefpares);
  foreach my $comando (sort keys %{$sobre->{refpares}}) {
      my $par = $sobre->{refpares}->{$comando};
      my ($numobj,$reflista) = @$par;  
      ($coderr,$mensaje)
        = interpretar_1refpar_TABLA($Tidtabla,$comando,$par);
      if ($coderr) {
          mensajear($mensaje); 
          next;
      } else {
          impr_debug(__LINE__." Tabl $comando",Dumper $par);
          impr_debug(__LINE__." Tabl $comando"
            ,[$par->[0],'||',@{$par->[1]}]);
          my $cosa = $Tidtabla.'_'.$comando;
          $reflay->{TIPOTOK}->{$cosa} = 't';
#          $reflay->{que}->{$cosa} = $refpar->[0];
          @{$reflay->{REFLISTAVALOR}->{$cosa}} = @{$par->[1]}; 
          push @{$reflay->{listaTABLAS}}, $cosa;
#          push @{$sobre->{$Tidtabla}},$numobj;
      };
  };#my $comando
  impr_datos(__LINE__.' Tabl',['TABLAS'],$reflay);
  impr_debug(__LINE__.' Tabl $reflay->{REFLISTAVALOR}'
   , Dumper $reflay->{REFLISTAVALOR});
  comfin('fina interpretar_TABLA',$numcapa);
  return $numcapa;
}#interpretar_TABLA
# ---------------------------------------------------------------------------
sub partir_TABLAS{
  comfin('com.  partir_TABLAS', @_);
  my ($ref,$cual,@quiebres) = @_;
  #impr_hash(__LINE__.' Tabl $ref ', %$ref);
  my $cualmin = $quiebres[0]; my $cualmax = $quiebres[-1];
  for(my $j = 0; $j < @quiebres -1; $j ++) {
      $quiebres[$j]<$quiebres[$j+1] or 
        parar1(222,$ref,"Los tiempos de interrupción del cálculo deben crecer;
          pero en @quiebres 
            $quiebres[$j] no es menor que $quiebres[$j+1]");   
 };
  my @amirar = (values %{$ref->{DATOS}},values %{$ref->{PARAMETROS}});
  my $amirar = join ';', @amirar;
  my @listatablas = ($amirar =~ /\WT(\w+)\($cual\)/g);
  push @listatablas,  ($amirar =~ /\WXTABLE\(T(\w+)\,$cual\)/g);
  @listatablas = union_conjunto @listatablas;
  my %hashtablas;
  map ( $hashtablas{$_} = 1, @listatablas);
  my $difmax = 1; #cualquier tabla debe tener al menos dos puntos
  #impr_debug(__LINE__.' Tabl @listatablas',\@listatablas);
  # en lo posible se pide que la ultima fila sea mayor por si al calcular
  # se va un poquito del rango calculado
  foreach my $Tidtabla (@listatablas) {
       my $difmax = 1; #cualquier tabla debe tener al menos dos puntos
      my $reft = $ref->{defiTABLAS}->{$Tidtabla};
      next unless defined $reft;
      #que el rango esta cubiero lo controla controlar_tiempos
      my $numfilas = @{$reft->{absTABLAS}->{$Tidtabla}}; 
      my @abscisas = @{$reft->{absTABLAS}->{$Tidtabla}};
      my @ordenadas = @{$reft->{ordTABLAS}->{$Tidtabla}}; 
      my $iant=0; my $i = 0;
      $reft->{priTABLAS}->{$Tidtabla} = [];
      $reft->{ultTABLAS}->{$Tidtabla} = [];
      my $ifila = 0;my ($menorigual,$mayorigual)= (0,-1); my (@ma,@me);
      for (my $j = 0; $j < @quiebres; $j++) {
          $ifila = $menorigual;
          $ifila = $me[$j-1] if $j >0; 
          $menorigual = $ifila;$mayorigual = -1;
          my $quieb = $quiebres[$j];
          while ($mayorigual == -1  and $ifila < $numfilas) { 
	      my $absc = $abscisas[$ifila];
	      #$absc = $abscisas[$ifila];
	      if ($absc <= $quieb) {
	          $menorigual = $ifila;
              } elsif ($absc > $quieb) {
                  $mayorigual = $ifila;
              };
              $ifila ++;
          }; #while
          $mayorigual == -1 and $abscisas[$ifila-1] == $quieb
               and $mayorigual = $ifila-1;  
         $me[$j] = $menorigual; $ma[$j] = $mayorigual;
      };#foreach $j
      #impr_debug(__LINE__.' Tabl $idtabla,@me @ma'
      #              , [$idtabla,';',@me,'---',@ma]);
      for (my $j= 0; $j <@quiebres-1;$j++) {
          my $menorigual = $me[$j]; my $mayorigual = $ma[$j+1];
          if ($menorigual == $mayorigual) {
              $menorigual > 0 and $menorigual --;
              $mayorigual < $numfilas - 1 and $mayorigual ++;
          };
          my $dif = $mayorigual-$menorigual;
          $difmax = $dif if $dif > $difmax; 
          push @{$reft->{priTABLAS}->{$Tidtabla}}, $menorigual;   
          push @{$reft->{ultTABLAS}->{$Tidtabla}}, $mayorigual;  
          push @{$reft->{difTABLAS}->{$Tidtabla}}, $dif;
          $reft->{difmaxTABLAS}->{$Tidtabla} = $difmax;
      };  
      my $j = -1;
      foreach my $dif (@{$reft->{difTABLAS}->{$Tidtabla}}) {
          $j ++;        
          next if $dif == $reft->{difmaxTABLAS}->{$Tidtabla};
          # en todos los rerun las tablas deben tener igual largo
          while ($dif<$difmax and $reft->{priTABLAS}->{$Tidtabla}->[$j]>0) {
              $dif ++; $reft->{priTABLAS}->{$Tidtabla}->[$j] --;
          };
          while ($dif<$difmax  and $reft->{ultTABLAS}->{$Tidtabla}->[$j]
                            < @{$reft->{absTABLAS}->{$Tidtabla}}) {
              $dif ++; $reft->{ultTABLAS}->{$Tidtabla}->[$j] ++;      
          };   
      };
      #seria posible no reiterar las tablas coincidentes en todos los rerun;
      #el archivo para sceptre seria mas chico; pero no necesita mas memoria
      # para ejecutarse
  }; #foreach $idtabla
  comfin('fina  partir_TABLAS');
} #partir_TABLAS
# ---------------------------------------------------------------------------
sub tipear{#($valor,$todo,$sustargus) $tipo,$dentro,$func,$tiparg,$nvalor,$ref
  comfin('coma tipear',@_);
  my ($valor, $todo,$sustargus) = @_; my $coderr = '';
  # aqui ya viene estandarizado y sin X.. interiores
  # $todo para calcular( con true)  o no tipos de argumentos
  # sustargus para redondear (con false) o no resultados numéricos
  # devuelve  ($tipo,$dentro,$func,$tiparg,$nvalor)
  # tipo puede ser
  #  'n' numérico
  #  'a' variable atómica con nombre que no empieza con 'P'
  #   o mas detallada con tipo su primer letra mayuscula ( que no sea P)
  #  'G' global; empieza con G; se declara en cuadro GLOBALES o directamente
  #      en FORTRAN
  #  'p' parametro (variable atómica con nombre que empieza con 'P'
  #  (no controla que haya sido declarada como parametro) 
  #  'e' error
  #  'f' función de nombre que no empieza con 'Q' ni con 'X' ni con 'T'
  #  'q' función de nombre que empieza con 'Q'
  #  't' tabla (funcion que empiez con t)
  #  'x' expresión
  #  'y' si es una lista con algun separador :
  # durante el proceso posterior pueden aparecer tipos nuevos para parámetros:
  #   'b' que no hara falta sustituirlo nunca más
  #   'r' que hubo pedido de rerun y no debe sustituirse 
  my ($dentro, $func, $pretipo,$nvalor) = analizar($valor);#en tipear 
  my $refarg;       
  my $tiparg ='';my ($tipo);my @listargus;
  $pretipo eq 'n' and return 'n',$nvalor,'','',$nvalor;
        
  if ($pretipo eq 'e') {
      return 'e','','','',$valor;
  } elsif ($pretipo eq 'y') {
     return 'y','','','',$valor;  
  };
  
  if ($func eq '') {                    
      $dentro =~ /^P\w+$/i and $tipo = 'p'
      or $dentro =~ /^\D\w*$/i and $tipo = 'a'
      or $dentro =~ /^\d.*$/i and do {
	   avgrav("Expresión que  no es aceptable como número;
               $valor");
           return 'e','','','',$valor # empieza con digito pero no fue 'n'
      }
      or do{avnograv("\" $valor \" no es aceptable como nombre de variable");
            return 'z','','','',$valor; 
      };
  } elsif ($pretipo eq 'f') {
      if (lc($func) eq 'listalis' or lc($func) eq 'listaresu') {
          $tipo = ','
      } elsif ($dentro !~ /\S/) {  
           avgrav("\" $valor \" no es aceptable como expresión");
           return 'e','','','',$valor; 
      } else {
          $func =~ /^(\w)(\w*)$/;
          $tipo = lc($1);
          $tipo =~ /[qt]/ or $tipo = 'f';
      };
  } else {
      $tipo = $pretipo;
  };
  if ($tipo =~ /[pna]/) {
      return $tipo,$dentro,'','',$dentro; 
  };
  if ($todo == 0) {
      my $valorpuro = $dentro;
      $tipo ne 'x' and $valorpuro = $nvalor;
      return $tipo,$valorpuro;
  };
  # continua con $todo true;
      ($coderr, @listargus) = juntar_por_paren_cur(',',split (',',$dentro));
      my (@tipito,@valorpurito,@tipargcito);
      for(my $i = 0; $i < @listargus; $i++) {
          ($tipito[$i],$valorpurito[$i]) = tipear($listargus[$i],0);
           #not $sustargus and $tipito[$i] eq 'n' and 
           #   $valorpurito[$i] = sprintf ("%G",$valorpurito[$i]);
           #$tipito[$i] eq 'n' and $valorpurito[$i] =~ s/e/E/;
         
      };#for $i
      $dentro = join ',',@valorpurito;
      $tiparg = join '',@tipito;
      $refarg = \@listargus;

  $func =~ /^X/i and $tiparg =~ /^[pna]$/ and do{ #no 'es' una expresion
      $func = ''; $tipo = $tiparg; $tiparg ='';   
  };     
  $nvalor = $dentro;
  $func ne '' and $nvalor = "$func($dentro)";
  if ($tipo =~/[xf]/) {
       ($tiparg, $refarg,$dentro) = tokensep($dentro);
      if ($tiparg eq 'n' and $valor =~ /^X\w*\(/) {
          $tipo = 'n'; $nvalor = $dentro; $tiparg = ''; $refarg = 0;
      }
  };
  #comfin('fina tipear $tipo, $dentro, $func, $tiparg, $nvalor, @$refarg'
  #         , $tipo, $dentro, $func, $tiparg, $nvalor, $refarg);
  return $tipo,$dentro,$func,$tiparg,$nvalor,$refarg;
}# tipear
#----------------------------------------------------------------------------
sub tokensep{
  # comfin('coma tokensep',@_);
  my ($expresion) = @_; 
  $expresion ='XXXXXXX(' .$expresion. ')'; 
  my @listamezcla = $expresion =~ /([\w\.]+)/g; #lista de pre-toquens 
  my @listasepa = split /[\w\.]+/, $expresion; #lista de separadores
  shift @listasepa;
  my @listameztotal; my $tips= '';
  my @listatokens;
  push @listameztotal, "$listamezcla[0]$listasepa[0]";
   for (my $i = 1; $i < @listamezcla; $i++) {
      my $palabra = $listamezcla[$i];my $palabran = $palabra;
      my $sepa = $listasepa[$i];
      #impr_debug(__LINE__.' Tabl $palabra',$palabra);
      #impr_debug(__LINE__.' Tabl $sepa',$sepa);
      if ($palabra =~ /^[\d\.]+E$/i) {
          if ($sepa =~/^[\+\-]/ and $listamezcla[$i+1]) {
              $palabra = "$palabra$listasepa[$i]$listamezcla[$i+1]";
              $sepa = $listasepa[$i+1]; 
	      $tips .= 'n';
 	      $i++;
 	  } else {
	      parar1(66, 0, "Error inesperado en $expresion", $CORTOA);
          };
      } elsif ($palabra =~ /^[\d\.]+$/) {
          $tips .= 'n';
      } else {
	  if ($palabra =~ /^X/ and $sepa =~ /^\(/){
              $tips .= 'x';
          } elsif ($palabra =~ /^\d/) {
              $tips .= 'n';
	  } elsif ($palabra =~ /^([PRCEJL]).+/ ) {#puede confundir funcion cos
                      # con capacitor
              $tips .= lc($1);
	  } elsif ($palabra =~ /^([VI])[RCEJL].+/) {
	      $tips .= lc($1);
          } elsif ($palabra =~ /^Q/i and $sepa =~ /^\(/) {
              $tips .= 'q';
          } elsif ($palabra =~ /^T/i and $sepa =~ /^\(/) {
              $tips .= 't';
          } else {
              $tips .= 'a'
          }
      }; 
      #impr_debug(__LINE__.' Tabl tokensep @listameztotal', \@listameztotal);
      push @listameztotal,"$palabra$sepa";
      push @listatokens, $palabra
  }; #for
  my ($coderr,@lista) = juntar_por_paren_cur('',@listameztotal);
  $coderr or @lista >1 and do{
      porparar1($coderr,$refglobal,"Paréntesis mal apareadps en $expresion",$CORTOA);
      # comfin('fina tokensep');
      return;
  };
  $listameztotal[0] =~ s/^XXXXXXX\(//;
  $listameztotal[-1] =~ s/\)$//;
  $tips =~ s/^x//;
  my $sepas = '/[\+\-\*\/\,]/';
  my $dentro = join '',@listameztotal;
  # comfin('fina tokensep', $tips, @listatokens,$dentro);
  return $tips, \@listatokens,$dentro;
}#tokensep
# ---------------------------------------------------------------------------
sub tratar_ARCHIVOS{#sin argumentos
  comfin('coma tratar_ARCHIVOS',@_);
  comfin('fina tratar_ARCHIVOS');
  return;
}#tratar_ARCHIVOS'
# ---------------------------------------------------------------------------
sub tratar_1FUNCIONES{
  comfin('coma tratar_1FUNCIONES',@_);
  my ($refcuadro,@renglones) = @_;
  my $reflay = $reflayers[$refcuadro->{numcapa}];
  my $clasecapa = $reflay->{clasecapa};
  my ($coderr,$mensaje) = ('','');
#  my $refarch = $refarchers[$refcuadro->{numfile}];
  foreach my $renglon (@renglones) {
      impr_debug(__LINE__.' Tabl $renglon',$renglon); 
      my $mensaje_rechazo
        = " $renglon no sirve para definir una funcion; se ignora";
      $renglon =~ s/^EQUATION/Q/; my $coment = '';
      $renglon =~ s/^([^;]*);\s*(\S.*)$/$1/; $coment = $2 if $2;
      impr_debug(__LINE__.' Tabl $renglon,$coment',[$renglon,'||',$coment]);
      $renglon =~ s/\s+//g; 
      impr_debug(__LINE__.' Tabl $renglon,$coment',[$renglon,'||',$coment]);
      $renglon or do {
         cargar_datos_tipotok($refcuadro,'cFUNCIONES',$coment,';','','','',[]);
        next;
      };
      my ($nombrefun,$derecha) = ($renglon =~ /^(\S+)\s*=(.+)$/);
      $nombrefun = uc($nombrefun);
      impr_debug(__LINE__.' Tabl $nombrefun,$derecha'
        ,[$nombrefun,$derecha]);
      my $stringargs;
      $nombrefun =~ s/\((.*)\)$// and $stringargs = $1;
      impr_debug(__LINE__.' Tabl',[$nombrefun,$stringargs]);
      my @listaargs = split/\s*,\s*/,$stringargs;
      map(do{ /^\w+$/ and $_ !~ /^\d/ and $refcuadro->{TIPOTOK}->{$_} = 'W' or 
	       do {
                   my $error
                   = " $_ no sirve como argumento formal en $renglon";
                   mensajear("$error;\n $mensaje_rechazo");
	           push @{$refcuadro->{errores}},$error;
                   next;
	       };
          },@listaargs); 
      impr_campo(__LINE__.' Tabl',$refcuadro,'TIPOTOK');
      if (length $nombrefun  == 1) {
          mensajear($mensaje_rechazo);
          next
      };
      $refcuadro->{TIPOTOK}->{$nombrefun} and do{
         my $mensaje = " Hay mas de una definicion para $nombrefun en\n       "
         . descripcion_cuadro($refcuadro->{numobj})."\n"
         ." nos quedamos con la primera del cuadro";
         mensajear ($mensaje); 
	 push @{$refcuadro->{errores}},$mensaje;
         next;
      };
      my $tipotok = '';
      $nombrefun =~ /^Q/i and $tipotok = 'q' or
	  $nombrefun =~ /^P/i and $tipotok = 'p';
      ($coderr,my($normal,$re)) = pre_limpiar(
          $refcuadro,'FUNCIONES',$derecha,$nombrefun);
      impr_debug(__LINE__.' Tabl $re',Dumper $re); 
      if ($coderr or $re->[2] eq ',') {
          mensajear(" $mensaje;\n $mensaje_rechazo");
          push @{$refcuadro->{errores}},"$mensaje en $renglon";
          return;
      } else {
          my($nvalorp,$tipop,$tipargp,$refargp) = @$re;
          impr_debug(__LINE__.' Tabl $tipargp',$tipargp); 
          if ($tipotok eq 'q') {
              (my $stringletras = $tipargp) =~ s/\W//g;
              if ($stringletras !~ /[wkhsS]/) {
                  $tipotok = 'Q';
#              impr_debug(__LINE__.' Tabl $stringletras',$stringletras); 
	      } elsif ($stringletras =~ /w/) {
		  $tipotok = 8;
                  my $mensaje
                    = "Hay argumentos no formales no reconocibles en $renglon";
                  push @{$refcuadro->{errores}},$mensaje;
	          mensajear($mensaje);
              } elsif ($stringletras =~/[apdhksS]/) {
                  $tipotok = '9';
                  my $mensaje
                    = "Hay argumentos no formales en $renglon";
	          mensajear($mensaje);
              };
          };
          cargar_datos_tipotok($refcuadro,'FUNCIONES',$nombrefun,$tipotok
	   , uc($normal),$tipop,$tipargp,$refargp,'','',$renglon,$coment);
          $refcuadro->{listaargFUNCION}->{$nombrefun} = \@listaargs;
          agregar_comentarios($refcuadro,$nombrefun,$coment,'Tabl '.__LINE__); 
          map(do{delete $refcuadro->{TIPOTOK}->{$_}},@listaargs);
      };
      impr_datos(__LINE__.' Tabl $refcuadro',['FUNCIONES'],$refcuadro);
  };
  comfin('fina tratar_1FUNCIONES');
  return $coderr;
}#tratar_1FUNCIONES
# ---------------------------------------------------------------------------
sub tratar_FUNCIONES{# sin argumentos
  comfin('coma tratar_FUNCIONES',@_);
  my @numobjs = union_conjunto(@{$refall->{cualnumclasenum}->{funciones}});
  impr_debug(__LINE__.' Tabl @numobjs',\@numobjs);
  # en un cuadro FUNCIONES pueden definirse varias funciones
  $refall->{sobreFUNCIONES} = {};
  foreach my $numobj (@numobjs) {
      impr_debug(__LINE__.' Tabl $numobj',$numobj);
      my $refcuadro = $refboxes{$numobj};
      my $numcapa = $refcuadro->{numcapa}; my $reflay = $reflayers[$numcapa];
      my @renglones =  @{$reflay->{complem}->{FUNCIONES}->{$numobj}};
      my $clasecapa = $reflay->{clasecapa};
      impr_debug(__LINE__.' Tabl $numcapa,$clasecapa',[$numcapa,$clasecapa]);  
      tratar_1FUNCIONES($refcuadro,@renglones);
      impr_debug(__LINE__.' Tabl $refcuadro->{listaFUNCIONES}'
        ,$refcuadro->{listaFUNCIONES});
      impr_datos(__LINE__.' Tabl',['FUNCIONES'],$refcuadro);
      impr_debug(__LINE__.' Tabl reflay->{sobreFUNCIONES}'
		 ,Dumper $reflay->{sobreFUNCIONES});
      impr_debug(__LINE__.' Tabl refall->{sobreFUNCIONES}'
		 ,Dumper $refall->{sobreFUNCIONES});
      foreach my $func (@{$refcuadro->{listaFUNCIONES}}) {
          my $reflay = $reflayers[$numcapa];
          push @{$reflay->{sobreFUNCIONES}->{$func}},$numobj;
          push @{$refall->{sobreFUNCIONES}->{$func}},$numobj;
      };
  };# $numobj
  my $refsobre =  $refall->{sobreFUNCIONES};
  my @numobjsquedan;
  impr_debug(__LINE__.' Tabl sobreFUNCIONES',Dumper $refsobre);
  if (scalar keys %$refsobre) {
      foreach my $func (sort keys %$refsobre) {
          my @numobjs = @{$refsobre->{$func}};
          if (@numobjs >1) {
              mensajear (" La funcion $func aparece en mas de 1 cuadro
         se ignoran todas esas definiciones");
              delete $refsobre->{$func};
          } else {
              push @numobjsquedan,$numobjs[0];
              my $refcuadro = $refboxes{$numobjs[0]};
              my $reflay = $reflayers[$refcuadro->{numcapa}];
              copiar_datos($refcuadro,'FUNCIONES',$func
                ,$reflay,'FUNCIONES',$func);
          };
      };    
  };
  impr_debug(__LINE__.' Tabl sobreFUNCIONES',Dumper $refsobre);
  comfin('fina tratar_FUNCIONES');
  return;
}#tratar_FUNCIONES
# ---------------------------------------------------------------------------
sub tratar_TABLAS_CUALQ{# sin argumentos
  #La definicion de una tabla, de TABLAS_ARCHIVOS puede estar repartida en 
  # varios cuadros de una o mas capas de un archivo; primero se analiza todo lo
  # pertinente del cuadro; y lo bueno se lleva, clasificado por comando, a 
  # $refTABLA que es $refTABLAes{$Tidtabla}
  # o a $refARCHIVO que es $refARCHIVOes{$Aidarchivo}
  # no se admite que una tabla este repartida en una 
  # capa clase elementos y en otras capas
  # no se permite que una tabla este repartida en un capa clase modelo
  # y otra de clase que no sea modelo, del mismo modelo
  # si la capa principal es de clase elementos, se descartan, al final,
  # todas las demas capas
  # si la capa principal es modelo se descartan, al final,
  # todas las capas que no sean del mismo modelo 
  comfin('coma tratar_TABLAS_CUALQ',@_);
  my @capasall = @{$refall->{capas}};
  impr_debug(__LINE__.' Tabl @capasall',\@capasall);
  my @numobjs;
  foreach my $capa (@capasall) {
      my $reflay = $reflayers[$capa];
      impr_campo(__LINE__.' Tabl $reflay',$reflay,'cualnumclase');
      if ($reflay->{cualnumclasenum}->{tablasd}) {
          push @numobjs, @{$reflay->{cualnumclasenum}->{tablasd}};
      };
      if ($reflay->{cualnumclasenum}->{tablasa}) {
          push @numobjs, @{$reflay->{cualnumclasenum}->{tablasa}};
      };
      if ($reflay->{cualnumclasenum}->{archivo}) {
          push @numobjs, @{$reflay->{cualnumclasenum}->{archivo}};
      };
  };
  @numobjs = union_conjunto(@numobjs);
  impr_debug(__LINE__.' Tabl @numobjs',\@numobjs);
  $refall->{sobreTABLAS} = {};
  $refall->{sobreARCHS} or $refall->{sobreARCHS} = {};
  foreach my $numobj (@numobjs) {
      my $refcuadro = $refboxes{$numobj};
      my $texto = $refcuadro->{texto};
      if ($texto eq 'TABLAS') {
         separar_TABLAS_modif($refcuadro);
      } else {
         separar_TABLAS_ARCHIVOS($refcuadro);
      };
  };#numobj
  depurar_refTABLAS();
  my $mensaje = depurar_refARCHIVOS();mensajear($mensaje) if $mensaje;
  interpretar_comandos_ARCHIVOS();
  interpretar_TABLAS_en_reflays();
  comfin('fina tratar_TABLAS');
     return; #PROVISORIO
  my $refarch = $refarchers[5]; ######## CAMBIAR
  impr_datos(__LINE__.' Tabl',['TABLAS'],$refarch);
  if ($refarch->{parametrosTABLAS}) {
      impr_debug(__LINE__.' Tabl $refarch->{parametrosTABLAS}'
		 ,Dumper  $refarch->{parametrosTABLAS});
      foreach my $comando (sort keys %{$refarch->{parametrosTABLAS}}) {
          foreach my $par
              (sort keys %{$refarch->{parametrosTABLAS}->{$comando}}) {
              my $valor
                = $refarch->{parametrosTABLAS}->{$comando}->{$par}->[0];
              my ($coderr1,$mensaje,$re,$uni)
                = pre_limpiar(
              $refarch,'PARAMETROS',$valor,$comando);
              if ($coderr1) {
                  mensajear(" error en $valor para $comando: $mensaje");
	          $refarch->{TIPOTOK}->{$comando}
                    = $refarch->{TIPO}->{$comando}='0';
	          last;
              } else {
                  my ($normal,$nvalor,$tipo,$tiparg,$refarg) = @$re;
                  cargar_datos_tipotok($refarch,'TABLAS',$par,'p',
                    ,$nvalor,$tipo,$tiparg,$refarg);
              };
          };
      };
  };        
  comfin('fina tratar_TABLAS_CUALQ');
  return;
}#tratar_TABLAS_CUALQ 
#----------------------------------------------------------------------------
sub usados{#pos. parada
  comfin('coma usados',@_); 
  # devuelve refer. a hashes de fun, par, tab y var usados y ref a hash de
  # parametros no definidos
  my ($porquienes,$ref,$aignorar) = @_;
  my $lisvalues = '';
  foreach my $quien (@$porquienes) {
      next unless defined $ref->{$quien};
      my @listavalues = values %{$ref->{$quien}};
      @listavalues = grep ($_ !~ /^\;/,@listavalues);
      $lisvalues .= ';' . join(';' ,@listavalues); 
  };
  $lisvalues .= ";"; 
  my ($coderr,$reffun, $refpar, $reftab, $refvar, $reffunx,$refarg,$refnodo) =
      fun_par_tab_var($lisvalues, $ref,$aignorar);# en usados 
  $coderr and porparar1($coderr,$ref);
  #impr_datos(__LINE__.' Tabl',['DATOS','PARAMETROS'],$ref); 
  #impr_debug(__LINE__.' Tabl $reff por USAVAR ', Dumper $refvar);  
  my @lisDP = grep(do{defined $ref->{TIPPARAMETROS}->{$_}
                      and $ref->{TIPPARAMETROS}->{$_} ne ','},keys %$refpar);
  @lisDP = grep (do{/^DP/ and $refpar->{$_} >1},@lisDP);
  foreach my $funcion (keys %$refarg) {
      next if $funcion eq 'QPRODUCTO' or $funcion eq 'QSUMA';
      my @listacuantos = union_conjunto(@{$refarg->{$funcion}});
      scalar @listacuantos == 1 or do{
          porparar1(192,$ref,"$funcion usada con números de argumentos:
                    @listacuantos" ); return 192; 
      }; 
      ($funcion =~ /^T/ and $listacuantos[0]!= 1) and do{
         porparar1(193,$ref,"Tabla $funcion usada con más de 1 argumento");
         return 193;
      };  
  };
  comfin('fina usados');
  return $reffun, $refpar, $reftab, $refvar, $reffunx, $refnodo;
}# usados
# ---------------------------------------------------------------------------
sub registrar_tiempos_tablas{
  #solo se destacan tablas con exactamente argumento TIEMPO
  comfin('coma registrar_tiempos_tablas');
  my ($ref) = @_; my $coderr = '';
  impr_TABLAS(__LINE__.' Tabl',$ref);
  # controla que las tablas dependientes del tiempo  cubran todo el rango
  impr_campo(__LINE__.' Tabl $ref',$ref,'USA'); 
  my (@usantablastiempo,@tablastiempo); 
  my @tablasusadas = grep (do{valor($ref,'TIPOTOK',$_) eq 'T'}
        ,keys %{$ref->{USA}} );
  impr_debug(__LINE__.' Tabl @tablasusadas', \@tablasusadas);
  impr_datos(__LINE__.' Tabl',['TABLAS','TIEMPOS'],$ref);
  @usantablastiempo = grep (do{$ref->{TIPARG}->{$_}=~ /t\(S\)/}
                            , keys %{$ref->{TIPARG}});
          
  impr_debug(__LINE__.' Tabl @usantablastiempo', \@usantablastiempo);
  if (@tablasusadas) {
      foreach my $par (@usantablastiempo) {
          my $tiparg = $ref->{TIPARG}->{$par};
          while ($tiparg =~ /t/) {
              my ($parte0,$parte1,$parte2)
                 = ($tiparg =~ /^([^t]*)(t)(\(S\).*)$/);
              my $refarg = $ref->{REFARG}->{$par}; 
              my ($refarg0,$refarg1,$refarg2)
                = partir_refarg(
                     $refarg,$parte0,$parte1,$parte2);
              my $tabla = $refarg1->[0];
              push @tablastiempo, $tabla if $ref->{USA}->{$tabla};
              $ref->{tablatiempo}->{$tabla} = 1;
              $parte2 =~ s/^\(S\)//;
              $tiparg = $parte2;
          };
      };
  };
  if (@tablastiempo) { 
      impr_debug(__LINE__.' Tabl @tablastiempo',\@tablastiempo);
      impr_debug(__LINE__.' Tabl @usantablastiempo',\@usantablastiempo);
      @tablastiempo = union_conjunto @tablastiempo;
      my $Tidtabla = shift @tablastiempo;
      my ($mayorcomienzo,$menorfinal)
   = ($ref->{absTABLAS}->{$Tidtabla}->[0],$ref->{absTABLAS}->{$Tidtabla}->[-1]);
      foreach my $Tidtabla (@tablastiempo) {
          next unless $ref->{TIPOTOK}->{$Tidtabla} eq 'T';
          my $startt = $ref->{absTABLAS}->{$Tidtabla}->[0]; 
          my $stopt = $ref->{absTABLAS}->{$Tidtabla}->[-1];
          $startt <= $mayorcomienzo or $mayorcomienzo = $startt;
          $stopt >= $menorfinal or $menorfinal = $stopt;
      };
      cargar_datos_tipotok($ref,'TIEMPOS','STARTTABLAS','D',$mayorcomienzo
            ,'n','n',[$mayorcomienzo],'','s');
      cargar_datos_tipotok($ref,'TIEMPOS','STOPTABLAS','D',$menorfinal
            ,'n','n',[$menorfinal],'','s');
      impr_datos(__LINE__.' Tabl',['TIEMPOS'],$ref); 
  };
  comfin('fina registrar_tiempos_tablas');
  $coderr and parar1($coderr,$ref);
  return $coderr;    
}#registrar_tiempos_tablas
# ---------------------------------------------------------------------------
sub registrar_archivo{
  comfin('coma registrar_archivo',@_);
  my ($ref,$sim_archivo) = @_;
  my ($abs_archivo,$pro_archivo,$cor_archivo); 
  my ($coderr,$mensaje) = ('','');
  # $coderr para errores: 230 no hay talcual; 232 hay mas de un $abs_archivo
  #                       234 nombre talcual erroneo 236 no existe el archivo
  #  $abs_ $pro_ $cor se refiera a los nombres 
  # simbolico talcual absoluto propio  y corto
  # simbolico y talcual los indica el usuario a partir del diagr. principal
  # absoluto y propio  los usuales
  # corto (este en relacion al diagrama principal)
  # se registran colgados de $ref->{sobrearchs}    
  # simbolico y talcual (este  puede ser mas de uno)   ya estan en  
  #    en  $ref->{sobrearchs}->{$sim_archivo}->{ARC} = 
  #    $ref_tales = [ ,$tal_archivo, ]
  # los restantes tienen que resultar_unicos y los registra esta rutina 
  # absoluto  $ref->{sobrearchs}->{$sim_archivo}->{ABSARC} = $abs_archivo
  # propio    $ref->{sobrearchs}->{$sim_archivo}->{PROARC} = $pro_archivo
  # corto     $ref->{sobrearchs}->{$simbarch}->{CORARC} = $cor_archivo
  my $numfile = $ref->{numfile}; my $BASE = $refnombres[$numfile]->{BASEARCH};
  impr_debug(__LINE__.' Tabl $numfile $BASE',[$numfile,$BASE]);
  my (@tales,@abses,@proes,@cores);
  @tales = @{$ref->{sobrearchs}->{$sim_archivo}->{ARC}};
  @tales or do {$coderr = 230; $mensaje = " No se ha definido $sim_archivo"};
  foreach my $tal (@tales) {
      ($coderr,my ($abs_archivo,$base,$pro_archivo))
        = compl_archivo($tal,$BASE);
      if ($coderr) {
          $coderr = 234; 
          $mensaje = " $tal no es buen nombre de archivo (para $sim_archivo)";
          last;
      };
      if (not -s $abs_archivo) {
          $coderr = 236;
          $mensaje = " No existe archivo $tal (para $sim_archivo)"; last;
      };
      push @abses, $abs_archivo;
      push @proes, $pro_archivo;
      ($cor_archivo = $abs_archivo) =~ s/^$BASE//;
      push @cores, $cor_archivo; 
  };#for  
  if ($coderr) {
      $ref->{sobrearchs}->{$sim_archivo}->{error} = $mensaje;
  } else {
      @abses = union_conjunto(@abses);
      if (@abses > 1) {
          $coderr = 232; 
          $mensaje = " Hay mas de un posible archivo para $sim_archivo\n";
          my @cuadros = @{$ref->{sobrearchs}->{cualobjcomando}->{ARC}};
          map ($mensaje .= descripcion_objeto($_),@cuadros);
      } elsif (@abses == 1) {
          @{$ref->{sobrearchs}->{$sim_archivo}}{'ABSARC','PROARC','CORARC'}
            = ($abses[0],$proes[0],$cores[0]);
      };
  };
  comfin('fina registrar_archivo',$coderr,$mensaje);
  return $coderr,$mensaje;  
}#registrar_archivo
# ---------------------------------------------------------------------------
sub sost_num_en_TABLAS{# no esta adaptado
  #sustituye parametros mumericos en tablas, cuadro CONTROLES, 
  #GRAFICOS (con precaucion)
  comfin('coma sost_num_en_TABLAS', @_);
  my $ref= $_[0];
  my @listap =  grep($ref->{TIPPARAMETROS}->{$_} =~ /[nb]/,
                     keys %{$ref->{PARAMETROS}});
  return unless @listap;
  my %hash;
  map ($hash{$_} = $ref->{PARAMETROS}->{$_}, @listap);
  foreach my $clase ('TABLAS_ARCHIVOS', 'TABLAS') {
      my $textodespl = Dumper $ref->{refvalores}->{$clase};
      if ($textodespl) {
          for my $key (keys %hash) { 
              my $valor = $hash{$key};
              while ($textodespl =~ s/(\W)$key(\W)/$1$valor$2/i) {
                  $ref->{parssustituidos}->{$key} = 1;   
              }; 
          };
          my $VAR1;
          $ref->{refvalores}->{$clase} = eval($textodespl);
      };
  };
  comfin('fina sost_num_en_TABLAS');
  return '';
}#sost_num_en_TABLAS
#---------------------------------------------------------------------------
sub resumir_fun_par_tab_var_funx{# calc. {USAPAR},etc; pos. parada por usados
  comfin('coma resumir_fun_par_tab_var',@_);
  my ($ref,$circmod) = @_;
  my ($reff,$refp,$reft,$refv,$refx,$refnodo) 
      =  usados(['DATOS','PARAMETROS','RESULTADOS'],$ref,{'LISTARESU' =>1});
    #en resumir_fun_par ...
  not defined $refp  and do{
     parar1($reff,$ref); #$reff es el código de error
  };
  $ref->{USAFUN} = $reff; 
  $ref->{USAPAR} = $refp; 
  $ref->{USATAB} = $reft; 
  $ref->{USAVAR} = $refv; 
  $ref->{USAFUNX} = $refx; 
  $ref->{USANODO} = $refnodo;
  impr_debug(__LINE__.' Tabl $ref',$ref,'USAFUN');
  my @terminate = grep (/^TERMINATE/
                 ,@{$ref->{listaCONTROLES}}); 
  my @listita; my $relacion = '\.(LT|GT|EQ|NE|LE|GE)\.';
  #impr_debug(__LINE__.' Tabl \@listita', \@listita);
  foreach (@terminate) {
      if (/^TERMINATE\s*IF\s*\(\s*(.+)$relacion(.+)\s*\)/) {
          push @listita, $1,$3;
      };
  };
  @listita = grep (/^P/i,@listita);
  #impr_debug(__LINE__.' Tabl \@listita', \@listita);
   map ($ref->{USAPAR}->{$_}++,@listita);
  comfin('fina resumir_fun_par_tab_var');
  return '';  
}#resumir_fun_par_tab_var_funx  
# ---------------------------------------------------------------------------
sub tipear_TABLA{#carga en TIPARG el tipo complexivo de la tabla,
# luego de sustituir lo sustituible en los comandoa
  comfin('coma tipear_TABLA',@_);
  my ($ref,$Tidtabla) = @_;
  my ($tipargcompl,$coderr) = ('','');
  if (valor($ref,'TIPO',$Tidtabla) =~ /[123]/) {
      comfin('fina tipear_TABLA');
      return;
  };
  foreach my $pal (qw(LIS COL REP RAN FAC)) {
      my $receptor = $Tidtabla ."_$pal";
      my $tiparg =  valor($ref,'TIPARG',$receptor);
      next if not $tiparg or $tiparg =~ /^[no,]+$/;
      impr_dat(__LINE__.' Tabl',$receptor,$ref,'tT');
      my @lista = @{$ref->{REFLISTAVALOR}->{$receptor}};
      if ($tiparg =~ /[KXSs]/) {
          my $valor = valor($ref,'VALOR',$receptor);
          eliminar_TABLA($ref,$Tidtabla
           ,"valor de $receptor no adecuado para tabla:
            $valor");
          $coderr = 60;
          comfin('fina tipear_TABLA',$coderr);
          return $coderr;
      };
      $tipargcompl .= $tiparg;
  };
  impr_debug(__LINE__.' Tabl $tipargcompl',$tipargcompl);
  $tipargcompl =~ s/\W+//g;$tipargcompl =~ s/[no]//g;
  my @letras = split '',$tipargcompl; @letras = union_conjunto (@letras);
  @letras = sort @letras;# juntar el sort y el union no funciona bien
  $tipargcompl = join '',@letras;
  impr_debug(__LINE__.' Tabl $tipargcompl',$tipargcompl);
  if (not $tipargcompl) {
      $ref->{TIPO}->{$Tidtabla} = 1;
  } else {
      length $tipargcompl == 1 and $ref->{TIPO}->{$Tidtabla} = $tipargcompl;
  };    
  $ref->{TIPARG}->{$Tidtabla} = $tipargcompl;
  impr_datos(__LINE__.' Tabl',['TABLAS'],$ref);
  comfin('fina tipear_TABLA $coderr,$tipargcompl',$coderr,$tipargcompl);
  return $coderr;
}#tipear_TABLA
# ---------------------------------------------------------------------------
sub separar_TABLAS_ARCHIVOS{# tambien separa cuadros ARCHIVOS
  comfin('coma separar_TABLAS_ARCHIVOS', @_);
  my ($refcuadro) = @_;
  my ($numcapa,$numcuadro,$numobj,$texto)
    = @$refcuadro{'numcapa','numcuadro','numobj','texto'};
  my $reflay = $reflayers[$numcapa];
  my $clasecapa = $reflay->{clasecapa};
  my ($coderr,$error,$coment) = ('','',''); my $ign = " se ignora el comando";
  my @listadatos = @{$reflay->{complem}->{TABLAS_ARCHIVOS}->{$numobj}}; 
  $texto eq 'ARCHIVOS' and 
    @listadatos = @{$reflay->{complem}->{ARCHIVOS}->{$numobj}};
  impr_debug(__LINE__.' Tabl @listadatos',\@listadatos);
  my (@avisos,@noseent); my $yanumobj = '';
  my $referrores = $refcuadro->{errores} = {}; 
  foreach my $renglonori (@listadatos) {
      $renglonori  =~ s/^([^;]+);(.*)/$1/ and $2 ne '' and $coment .= $2;
      if ($renglonori =~ /^(\D\S+)\s+(.+\S)\s*=\s*(.*\S)\s*/) {
          my ($comando,$cosa,$valor) = (uc(substr($1,0,3)), $2, $3);
          impr_debug(__LINE__.' Tabl ($comando,$cosa,$valor'
		     ,[$comando,$cosa,$valor]);
          if ("$comando$cosa" =~ /;/) {
              push @$referrores," No se reconoce ';' extra en $renglonori
              $ign";
              next;
          }; 
          $valor =~ s/,$// and 
          push @$referrores
             , " Se ignora la coma final en $renglonori";  
          (my $coderr, my @lista)
              = juntar_por_paren_cur(',',(split '\s*[,\s\:]\s*',$valor));
          if ($coderr) {
              push @$referrores,"Error de sintaxis en $renglonori; $ign";
              next;
          };
          my @blancos = grep(do{$_ eq ''},@lista);
          if (@blancos) {
              push @$referrores," Hay comas extras en $renglonori; se ignoran";
              next;
          };
          if ($comando =~ /(COL|FAC|ORD|REP|RAN)/) { 
              my $Tidtabla = '';
              if ($cosa =~ /^(TABLA|TABLE)\s*(.+)$/i or
                  $cosa =~ /^(T)\s*(\S+)$/i or $cosa =~ /^(TAB)\w*\s+(\S+)$/i) {
                  $Tidtabla = uc("T$2");
                  $refTABLAes{$Tidtabla} or $refTABLAes{$Tidtabla} = {};
                  my $refTABLA = $refTABLAes{$Tidtabla};
                  push @{$refTABLA->{tipos}},'arch';
                  push @{$refTABLA->{numcapas}},$numcapa;
                  if ($comando eq 'COL') {
                      if (@lista >= 3) {
		          my $arch = shift @lista;
                             push @{$refTABLA->{refpares}->{COL}}
                            , [$numobj,[uc($arch),\@lista]]  ;
		      } else {
                          push
                            @$referrores, "Error de sintaxis en $renglonori";
                          next;
                      };
                  };  
                   $comando ne 'COL' and
                   push @{$refTABLA->{refpares}->{$comando}},[$numobj,\@lista]; 
              } else {
                  push @$referrores, " No se entiende $renglonori; 
                falta identificacion de tabla?   $ign";
                  next;
              };
          } elsif ($comando =~ /(ARC|VAR|MAG|UNI)/) {
              my $simbarch = $cosa;
              my $SIMBARCH = uc($simbarch); 
              my $Aidarchivo = uc("$simbarch");
              $refARCHIVOes{$Aidarchivo} or $refARCHIVOes{$Aidarchivo} = {};
              my $refARCHIVO = $refARCHIVOes{$Aidarchivo};
              push @{$refARCHIVO->{simbarchori}},$simbarch;
              push @{$refARCHIVO->{refpares}->{$comando}},[$numobj,\@lista];
              impr_debug(__LINE__.' Tabl $comando,$cosa',[$comando,$cosa]);
              } else {
              push @$referrores, " No se entiende $renglonori; $ign"
          };
      };#if $renglonori
  };#$renglonori
  impr_debug(__LINE__.' Tabl %refTABLAes',Dumper \%refTABLAes);
  impr_debug(__LINE__.' Tabl %refARCHIVOes',Dumper \%refARCHIVOes);
  comfin('fina separar_TABLAS_ARCHIVOS');
  return '';
}#separar_TABLAS_ARCHIVOS
# ---------------------------------------------------------------------------
sub separar_TABLAS_modif{ # solo para tablas de diagrama; lleva al otro formato
  # completa la informacion de $refcuadro con la de $reflay->{complem}...
  # y lo guarda en $refTABLAes{$Tidtabla}
  comfin('coma separar_TABLAS_modif', @_);
  my ($refcuadro) = @_;
  my ($numcapa,$numobj,$Tidtabla)
    = @$refcuadro{'numcapa','numobj','Tidtabla'};
  # 'texto' es 'TABLAS'
  $refTABLAes{$Tidtabla} or $refTABLAes{$Tidtabla} = {};
  my $refTABLA = $refTABLAes{$Tidtabla};
  push @{$refTABLA->{tipos}},'diagr';
  push @{$refTABLA->{numcapas}},$numcapa;
  impr_debug(__LINE__.' Tabl $refcuadro',Dumper $refcuadro);
  my $reflay = $reflayers[$numcapa];
  my @listadatos = @{$reflay->{complem}->{TABLAS}->{$numobj}}; 
  impr_debug(__LINE__.' Tabl @listadatos',Dumper \@listadatos);
  my $referrores = $refcuadro->{errores} = {};
  #lo que sigue para poder independizarse del $texto TABLAS xx o TABLAS_ARCHIVOS
  #los datos sobre la lista vienen al final
  # se juntan renglones por , final
  my ($coment,$ya) = ('','');
  map (do {$_ =~ s/^([^;]*);(.*)/$1/ and $2 ne '' and $coment .= " $2"}
    ,@listadatos);
  if ($coment) {
      cargar_datos($reflay,'cTABLAS',";$coment",';','','','',[]);
  };
  impr_debug(__LINE__.' Tabl @listadatos sin comentarios',Dumper \@listadatos);
  my $last = ''; my $renglonori;
  my $error = ''; my $refnoseent;
  while (@listadatos and not $error) {
      $renglonori = shift @listadatos;
      next unless $renglonori;
      impr_debug(__LINE__.' .......... Tabl $renglonori comienzo',$renglonori);
      if (not $renglonori =~ /=/ and not $renglonori =~ /,$/) {
          $last = 1; last;
      };
      $renglonori =~ s/^fac.*=(.+),\s*fac.*=(.+)$/FAC=$1,$2/i;
      impr_debug(__LINE__.' Tabl $renglonori medio',$renglonori);
      # lo anterior, para juntar factores si es que estaban separdos
      if ($renglonori =~ /^(\D\w+)\s*([\,=])\s*(.+)$/i) { 
          my ($comando,$signo,$valor) = (uc(substr($1,0,3)),$2,$3);
          impr_debug(__LINE__.' Tabl $comando,$signo,$valor'
            ,[$comando,'||',$signo,'||',$valor]); 
          $signo ne '=' and mensajear(" \"$renglonori\" se interpreta como\n"
            . " \"$comando=$valor\"");
          impr_debug(__LINE__.' Tabl $comando',$comando);
          if ($comando =~ /^(FAC|ORD|REP|RAN)$/) {
              my @lista = split /\s*[\s,]+/,$valor;
              impr_debug(__LINE__.' Tabl @lista',\@lista); 
              push @{$refTABLA->{refpares}->{$comando}},[$numobj,\@lista];
           } else {
             mensajear(" No de entiende $renglonori para $Tidtabla; se ignora");
           }; 
      } else {
          if ($renglonori =~ /=/) {
              mensajear(
                " Error de sintaxis para $Tidtabla con\n  $renglonori");
          } else {
 	      $last = 1; last;
          };
      };
  };#while @listadatos 
  $last and unshift @listadatos, $renglonori; 
  impr_debug(__LINE__.' Tabl @listadatos',\@listadatos);
  if (not @listadatos) {
#      if (scalar keys %$referrores) {
#          my @cuales = sort keys %$referrores; 
#          impr_debug(__LINE__.' Tabl', Dumper $referrores); 
#          map (do {mensajear ($referrores->{$_})},@cuales);
#      };
      mensajear(" No hay datos esenciales para $Tidtabla");
      delete $refTABLAes{$Tidtabla};
  } else {
      my $valor = join ',',@listadatos;
      $valor =~ s/\s/,/g;
      @listadatos = split ',',$valor;
      # si habia coma final en $valor, se pierde; pero depurar ya las saco
      impr_debug(__LINE__.' Tabl @listadatos',\@listadatos);
      push @{$refTABLA->{refpares}->{LIS}},[$numobj,\@listadatos];
  }; 
  impr_TABLAS(__LINE__.' Tabl $refcuadro',$refcuadro);
  comfin('fina separar_TABLAS_modif',$Tidtabla); 
  return '';
}#separar_TABLAS_modif
# ---------------------------------------------------------------------------
1
