package Simusol::Tiempos;
#!/usr/bin/perl
use Simusol::Algebraico;
#use Simusol::Ampliaciones;
#use Simusol::Auxiliares;
use Simusol::Ayudas;
#use Simusol::Controles;
#use Simusol::Desdexml;
#use Simusol::Elementos;
#use Simusol::Evaluaciones;
use Simusol::GlobalesSimusol;
#use Simusol::Prograf;
use Simusol::Sceptre;
use Simusol::Tablasfuncq;
use strict;
use warnings;
use Data::Dumper;
$Data::Dumper::Sortkeys= 1;
BEGIN {
     use Exporter ();
     our ($VERSION,@ISA,@EXPORT,@EXPORT_OK,%EXPORT_TAGS);
     @ISA=qw(Exporter);
     @EXPORT=qw{
                &interpretar_TIEMPOS
                &interpretar_tiempos_extras
                &mirar_cuadro_TIEMPO
     }
}
# ---------------------------------------------------------------------------
sub compaginar_TIEMPOS{
  comfin('comi compaginar_TIEMPOS',@_);
  my ($ref,$refdato,$refuni) = @_; my $coderr = '';
  impr_debug(__LINE__.' Tiem $refdato',Dumper $refdato);
  impr_debug(__LINE__.' Tiem $refuni',Dumper $refuni);
  my ($comitiempo,$fintiempo,$unitiempo)
      = @{$ref->{DEFItiempos}}
     {'comitiempo','fintiempo','unitiempo'};
  impr_debug(__LINE__.' Tiem $comitiempo,$fintiempo,$unitiempo'
             ,[$comitiempo,$fintiempo,$unitiempo]);
  impr_datos(__LINE__.' Tiem',['TIEMPOS'],$ref);
     # ese valor se usa para unipri
  foreach my $pre ('STOP','START') {
      impr_debug(__LINE__.' Tiem $pre',$pre);
      next unless $refuni->{$pre}; 
      impr_debug(__LINE__.' Tiem $pre',$pre);
      my $uni = $unis_tiempo{lc($refuni->{$pre})};
      next if ($pre eq 'START' and $refdato->{START} eq '0');
      my $fac= $factort{$uni};
      my $valor = $refdato->{$pre}; my @lista;
      if (defined $ref->{REFLISTAVALOR}->{$pre . 'TIEMPO'}) {
          @lista = @{$ref->{REFLISTAVALOR}->{$pre . 'TIEMPO'}};
      } else {
          @lista = ($ref->{VALOR}->{$pre . 'TIEMPO'});
      };
      impr_debug(__LINE__.' Tiem @lista',Dumper \@lista);
      map(do {$_ *= $fac; $_ = para_sceptre_num($_)},@lista);
      $refdato->{$pre} = join ',',@lista;
      #no modifico la unidad dada pero queda todo en la unidad del calculo
      $ref->{VALOR}->{$pre .'TIEMPO'} = $refdato->{$pre};
      $ref->{REFARG}->{$pre .'TIEMPO'} = \@lista;
      my $coment ="$valor $ref->{uni}->{$pre.'TIEMPO'}";
      agregar_comentarios($ref,$pre.'TIEMPO',$coment,'Tiem '.__LINE__);
  }; 
  impr_datos(__LINE__.' Tiem',['TIEMPOS'],$ref);
  comfin('fini compaginar_TIEMPOS',$coderr);
  return $coderr;    
}#compaginar_TIEMPOS
# ----------------------------------------------------------------------------
sub conseguir_numeros{
  comfin('comi conseguir_numeros',@_);
  my ($ref,$que) = @_;
  my @receptores = @{$ref->{"lista$que"}};
  my $tipargt ='';
  map($tipargt .= $ref->{TIPARG}->{$_},@receptores);
  impr_debug(__LINE__.' Tiem $tipargt',$tipargt);
  impr_SUST(__LINE__.' Tiem',$ref);
  if ($tipargt !~  /^[-no,]+$/) {
      foreach my $receptor (@receptores) {
          impr_debug(__LINE__.' Tiem $receptor',$receptor);
          my($tiparg,$refarg) = tomar_tiparg_refarg($ref,$receptor);
          impr_par(__LINE__.' Tiem',$tiparg,$refarg); 
          if  ($tiparg =~  /[adp]/) {
              my ($coderr,$cambiado) = sust_token_SUST($ref,$receptor,'SUSTno');
              if ($coderr) {
                 descartar_valor_nonumerico($ref,$que,$receptor);next;
              };
              $cambiado and ($tiparg,$refarg)
	        = tomar_tiparg_refarg($ref,$receptor);
              if  ($tiparg =~  /[adp]/) {
                  descartar_valor_nonumerico($ref,$que,$receptor);next;
              };
          };
          if ($tiparg !~ /^[-no,]+$/) {
	      my $coderr =Simusol::Evaluaciones2::evaluar_numero($ref,[$que]);
              if ($coderr or 
                 $ref->{TIPARG}->{$receptor} !~  /^[no,]/ ) {
                  descartar_valor_nonumerico($ref,$que,$receptor); next;
 	       } else {
                   impr_par(__LINE__.' Tiem',$tiparg,$refarg);
                   ($coderr,my ($valor,$tipo),$tiparg,$refarg)
                     = tiparg_refarg_2_vttr_talcual($tiparg,$refarg,'Tiem '.__LINE__);
                   not $coderr and
		     cargar_datos($ref,$receptor,$valor,$tipo,$tiparg,$refarg);
               };
          };
          impr_par(__LINE__.' Tiem',$tiparg,$refarg);
      };
  };
  impr_datos(__LINE__.' Tiem',[$que],$ref);
  comfin('fini conseguir_numeros');
  return;
}#conseguir_numeros 
# ----------------------------------------------------------------------------
sub descartar_valor_nonumerico{
  comfin('comi descartar_valor_numerico',@_);
  my ($ref,$que,$receptor) = @_;
  mensajear(
    " No es aceptable $ref->{VALOR}->{$receptor} para $receptor"); 
  @{$ref->{"lista$que"}}
    = grep($_ ne 'RECEPTOR',@{$ref->{"lista$que"}});
  $ref->{VALOR}->{$receptor} = undef;
  comfin('fini descartar_valor_numerico');
}#descartar_valor_nonumerico                         
# ---------------------------------------------------------------------------
sub filtrar_rerun_tiempos{
  comfin('comi filtrar_rerun_tiempos', @_);
  # Si los pedidos de valores iniciales, parámetros o controles  son listas
  #   se deja el primero de la lista  y el resto irá a $rerun en su momento
  #  en filtrar_rerun_CIP?
  my $ref = $_[0];
  my @lista = @{$ref->{REFARG}->{tiempos}};
  impr_campo(__LINE__.' Tiem',$ref,'TIPOTOK');
  my $cuantos = scalar @lista;
  $ref->{rerun} = {};
  $ref->{nrerun} = $cuantos -1;
#  my $direrelsimul = "$dirsalida{simul}/";
#  my @listaarchs = ("$dirsalida{simul}/$PROPIOASIN.simul");
#  for (my $i=1; $i< $cuantos-1; $i++) {
#      push @listaarchs, "$dirsalida{simul}/$PROPIOASIN" . "_$i.simul";
#  };
#  impr_debug(__LINE__.' Tiem @listaarchs',\@listaarchs);
#  $ref->{archrerun} = join ',', @listaarchs;
  partir_TABLAS($ref,'TIEMPO',@lista)
      if $ref->{listaTABLAS} and @{$ref->{listaTABLAS}};
  cargar_datos_tipotok($ref,'CONTROLES','ICFORRERUNS','C','PRECEDING RESULTS'
               ,'a','a',['PRECEDING RESULTS']
             ,__LINE__.' sim1','','IC FOR RERUNS');
  impr_datos(__LINE__.' Tiem',['CONTROLES'],$ref);
  comfin('fini filtrar_rerun_tiempos');
  return '';
};#filtrar_rerun_tiempos                 
# ---------------------------------------------------------------------------
sub interpretar_lista_TIEMPOS{
  comfin('comi interpretar_lista_TIEMPOS',@_);
  # con $unitiempo
  my $ref = $_[0]; my $coderr = '';
  impr_datos(__LINE__.' Tiem',['TIEMPOS'],$ref);
  my (@listaSTART,@listaSTOP,@listatotal,@listaord
     ,@listaSTARTori,@listaSTOPori);
  @listaSTARTori = @listaSTART; @listaSTOPori = @listaSTOP;
  foreach my $pre ('START','STOP') {
      my $valor = $ref->{VALOR}->{$pre . 'TIEMPO'};
      next unless defined $valor; #podria ser 0
      my @lista = @{$ref->{REFARG}->{$pre.'TIEMPO'}};
      impr_debug(__LINE__.' Tiem $pre @lista',[$pre,$valor,'aaa',@lista]);
      @lista = sort {$a<=>$b}(@lista);
      impr_debug(__LINE__.' Tiem $pre @lista',[$pre,$valor,'aaa',@lista]);
#      $prim{$pre} = $lista[0];  
      my $listaev = join '<',@lista;
      for(my $i = 0; $i<@lista - 1; $i++) {
          $lista[$i] < $lista[$i+1] or
             mensajear("La lista de tiempos para $pre TIEMPO 
              no cumple: $listaev ; la ordenamos");
          last;
      };
      @lista = sort {$a<=>$b}(@lista);
      $pre eq 'START' and @listaSTART = @lista or @listaSTOP = @lista;
      impr_datos(__LINE__.' Tiem',['CONTROLES'],$ref);
      impr_debug(__LINE__.' Tiem @listat',\@lista);
  };
  if ($listaSTART[0] > $listaSTOP[-1]) {
      my $mensaje = " No es posible simular; valores de comienzo mayores que
         valores de final de simulacion";
      parar1($ref,$mensaje);  
  } elsif ($listaSTART[-1] > $listaSTOP[0] ) {
      mensajear(" Hay valores incompatibles de comienzo y final de la simulacion
           se eliminan");
      @listaSTOP = grep ($_ >= $listaSTART[0],@listaSTOP);
      @listaSTART = grep ($_<= $listaSTOP[-1],@listaSTART); 
      # esas listas tienen al menos un elemento
  };
  @listatotal = (@listaSTART,@listaSTOP); 
  @listatotal = union_conjunto(@listatotal);
  @listaord = sort{$a<=>$b}(@listatotal);
  impr_debug(__LINE__.' Tiem',\@listaord);     
  my @tipos = @listaord;
  map(do{$_ >= 0 and $_ = 'n' or $_ = 'o'},@tipos);
  cargar_datos_tipotok($ref,'TIEMPOS','tiempos','D'
                   , join (',',@listaord) ,',',join(',',@tipos),\@listaord);
  impr_datos(__LINE__.' Tiem',['TIEMPOS'],$ref);
  my $coment = '';
  if (valor($ref,'TIPO','STARTTIEMPO') eq ',') {
      $coment = $ref->{VALOR}->{STARTTIEMPO}; 
       cargar_datos_tipotok($ref,'TIEMPOS','STARTTIEMPO','D'
                  , $listaord[0],$tipos[0],$tipos[0],[$listaord[0]]);
      agregar_comentarios($ref,'STARTIEMPO',@listaSTARTori,'Tiem '.__LINE__);
  }
  impr_datos(__LINE__.' Tiem',['TIEMPOS'],$ref);
  $coment = '';  
  if (defined $ref->{VALOR}->{STOPTIEMPO}) {
      $coment = $ref->{VALOR}->{STOPTIEMPO}
  };
  cargar_datos_tipotok($ref,'TIEMPOS','STOPTIEMPO','D'
                      , $listaord[1],$tipos[1],$tipos[1],[$listaord[1]]);
  agregar_comentarios($ref,'STOPTIEMPO',@listaSTOPori,'Tiem '.__LINE__);
  $ref->{ori}->{STOPTIEMPO} = 'STOP TIME';
  impr_datos(__LINE__.' Tiem',['TIEMPOS'],$ref);
  comfin('fini interpretar_lista_TIEMPOS',$coderr);
  return $coderr;
}#interpretar_lista_TIEMPOS   
# ---------------------------------------------------------------------------
sub interpretar_TIEMPOS{
  #se refiere a los tiempos para controlar  la simulación
  #utiliza informacion de los cuadros TIEMPO y CONTROLES
  # en el cuadro TIEMPO se pone la lista de tiempos de corte de la simulacion
  # separados por coma y al final (sin coma) el nombre de la unidad
  # al igual que en el cuadro CONTROLES para STOP TIEMPO; estas unidades
  # se procesan en compaginar....;
  comfin('comi interpretar_TIEMPOS',@_);
  my $ref = $_[0]; my $coderr = '';
  %{$ref->{DEFItiempos}} = %{$refglobal->{DEFItiempos}};
  my ($nombretiempo,$comitiempo,$fintiempo,$unitiempo)
         = @{$ref->{DEFItiempos}}
     {'nombretiempo','comitiempo','fintiempo','unitiempo'};
  if (not defined $ref->{VALOR}->{CUADROTIEMPO}) {
      if (not defined $ref->{VALOR}->{STOPTIEMPO}) {
          mensajear(" No se ha indicado hasta cuando debe durar la simulación
         Pensaremos que, en un cuadro con nombre TIEMPO,  se ha escrito
              $fintiempo $unitiempo");
          my $tipof = 'n'; 
          $fintiempo < 0 and $tipof = 'o';
          cargar_datos_tipotok($ref,'TIEMPOS','STOPTIEMPO','D',$fintiempo,$tipof
			   ,$tipof,[$fintiempo],'',$unitiempo,'STOP TIME');
          agregar_comentarios($ref,'STOPTIEMPO','Propuesto por Simusol'
           ,'Tiem '.__LINE__);
      } else {
          if (not $ref->{uni}->{STOPTIEMPO}) {
             $ref->{uni}->{STOPTIEMPO} = $unitiempo;
          };
      };
  };  
  if (not defined $ref->{VALOR}->{STARTTIEMPO}) {
      my $tipoc = 'n'; $comitiempo < 0 and $tipoc ='o';
      cargar_datos_tipotok($ref,'TIEMPOS','STARTTIEMPO','D',$comitiempo
        ,$tipoc,$tipoc,[$comitiempo],'',$unitiempo,'START TIME');
      if ($comitiempo) {
          agregar_comentarios($ref,'STARTTIEMPO', 'Propuesto por Simusol'
           ,'Tiem '.__LINE__);
      };
  };
  my (%dato,%unidad);
  # en %dato se guardaran  los valores numericos para
  #     START,STOP,CUADRO ..TIEMPOS
  # en %unidad las unidades
  #     del diagrama o los valores por defecto 
  my $tipargt= '';
  map($tipargt .= $ref->{TIPARG}->{$_},@{$ref->{listaTIEMPOS}});
  impr_debug(__LINE__.' Tiem $tipargt',$tipargt);
  if ($tipargt !~ /^[on,]+$/) {
      Simusol::Evaluaciones::simplificar_valores($ref,['TIEMPOS']);
  }; 
  impr_datos(__LINE__.' Tiem', ['TIEMPOS'], $ref );
  foreach my $pre ('START','STOP','CUADRO') {
      my ($tipotok,$valor,$tipo,$tiparg
        ,$refarg,$uni) = tomar_todo_datos($ref,$pre.'TIEMPO');   
      $valor or next;
      $dato{$pre} = $valor;
      $unidad{$pre}= $uni;      
  };
  impr_debug(__LINE__.' Tiem %unidad',\%unidad);
  if ($unis_tiempo{lc($unitiempo)}) {#las unidades deberan seran compatibles
      foreach my $pre (keys %unidad) {
          my $unic = $unidad{$pre}; my $mensaje= '';
          if (not $unic) {
              $ref->{uni}->{$pre.'TIEMPO'} = $unitiempo;
          } elsif (not $unis_tiempo{lc($unic)}) {
              mensajear("unidad para $pre".'TIEMPO, '
     .$unic." no es compatible con $unitiempo; la cambiamos pr $unitiempo");
              $ref->{uni}->{$pre.'TIEMPO'} = $unitiempo;
          }; 
      };
  };    
  if (defined $dato{CUADRO}) {
      if (defined $dato{STOP}) {
          avnograv ("Como hay información en el cuadro TIEMPO,
      se ignorará la información del cuadro CONTROLES  para STOP TIEMPO");
      };
      copiar_datos($ref,'TIEMPOS','CUADROTIEMPO'
        ,$ref,'TIEMPOS','STOPTIEMPO');
      $ref->{TIPOTOK}->{STOPTIEMPO} = 'D';
      $ref->{ori}->{STOPTIEMPO} = 'STOP TIME';
      $dato{STOP} = $dato{CUADRO}; $unidad{STOP} = $unidad{CUADRO};
      borrar_datos($ref,'TIEMPOS','CUADROTIEMPO','');
      #mover_datos dejaria un comentario innecesario  
      delete $dato{CUADRO}; delete $unidad{CUADRO};
 };
     
  compaginar_TIEMPOS($ref,\%dato,\%unidad);
  impr_debug(__LINE__.' Tiem %unidad',Dumper \%unidad);
  $ref->{DEFItiempos}->{unipri} = $unidad{STOP};
  # es la unidad de tiempo por defecto para los graficos
  if (defined $dato{START} and $dato{START} =~/,/ or 
      defined $dato{STOP} and  $dato{STOP} =~/,/) {
      $coderr = interpretar_lista_TIEMPOS($ref);
      $ref->{REFARG}->{tiempos} and @{$ref->{REFARG}->{tiempos}} > 2
        and filtrar_rerun_tiempos($ref); 
  };
  impr_datos(__LINE__.' Tiem',['TIEMPOS'],$ref);
  impr_UNIDADES(__LINE__.' Tiem',$ref);   
  comfin('fini interpretar_TIEMPOS');
  return '';
};#interpretar_TIEMPOS
# ---------------------------------------------------------------------------
sub interpretar_tiempos_extras{
  comfin('comi interpretar_tiempos_extras',@_);my $coderr = '';
  my $ref = $_[0];
  impr_SUST(__LINE__.' Tiem',$ref);
  $ref->{sobreextras} = {};
  $ref->{sobretiempos} = {};
  impr_datos(__LINE__.' Tiem',['TODOS'],$ref);
  impr_campo(__LINE__.' Tiem $ref',$ref,'refvalores','CONTROLES');
  my (@renglonesextras,@renglonestiempos);
  foreach my $numobj (sort keys %{$ref->{refvalores}->{CONTROLES}}) {
      my @lista = @{$ref->{refvalores}->{CONTROLES}->{$numobj}};
      impr_debug(__LINE__.' Tiem @lista',Dumper \@lista);
      ($coderr,@lista) = juntar_por_signos_y_paren(' ',@lista);
       # el ' ' por si hay una unidad puesta en un segundo renglón
       #impr_debug(__LINE__.' Tiem @lista  despues juntar'
       #       ,Dumper [$que,@lista]);
       if ($coderr) {
           mensajear($coderr."; se ignora el cuadro $numobj");$coderr = '';next;
       };
       foreach my $renglonori (@lista) {
           next unless $renglonori;
           my $coment =''; my $renglon = $renglonori;
           if ($renglonori =~ /^([^;]*);\s*(.*)$/) {
              $renglon = $1; $coment = "$2"; $renglon =~ s/\s+$//;
              $renglon =~ /\S/ or 
                  do {cargar_datos_tipotok(
                        $ref,'cCONTROLES',$coment,';','','','',[]);next;
                  };
           };
            #una primer ",", si no hay ningún signo de igual
          # se interpretaba antes como "=" ; pero ya no; habria que hacer
          #los cambios antes de asignar_tipotok... y no solo aqui 
          #$renglon =~ s/^(\D\w+)\,([^=]*)/$1=$2/;
          if ($renglon =~ /([=,])$/) {#solo posible en ultimo renglón;incompleto
              $coderr = 22; mensajear(
           "Ultimo renglón \"$renglonori\", termina en $1; falta completarlo 
                   en ". descripcion_cuadro($numobj));
               comfin('fini interpretar_tiempos_extras',__LINE__." $coderr");
               return $coderr;
          }; 
          my @listita = split (/\s*=\s*/, $renglon);
          impr_debug(__LINE__.' Tiem $renglon',$renglon);
          impr_debug(__LINE__.' Tiem @listita',\@listita); 
          if (@listita > 2) { 
              mensajear("No se entiende asignar igual valor a más de un 
                 elemento de CONTROLES, como en ". descripcion_cuadro($numobj));
              next;
          } elsif (@listita == 1) {
              push @{$ref->{sobrextras}},[$renglon,'',$coment,$numobj];
          } else {
              my ($comandoori,$stringlista) = @listita;
              (my $comando = uc($comandoori)) =~ s/\s+//g;
              $comando =~ s/TIME/TIEMPO/;
              if ($comando =~ /TIEMPO/) {
                  push @{$ref->{sobretiempos}->{$comando}}
                    ,[$comandoori,$stringlista,$coment,$numobj];      
	      } else {
                  push @{$ref->{sobreextras}->{$comando}}
		  ,[$comandoori,$stringlista,$coment];
              }; 
          };
      };#$renglonori @lista
  };  #for $numobj
  impr_campo(__LINE__.' Tiem $ref',$ref,'sobretiempos');                    
  impr_campo(__LINE__.' Tiem $ref',$ref,'sobreextras');
  foreach my $pal (qw(sobretiempos sobreextras)) {
      if ($ref->{$pal}) {
          my ($que,$tipotok);
          foreach my $comando (keys %{$ref->{$pal}}) {
              my @listaval = @{$ref->{$pal}->{$comando}};
              if (@listaval >1) {
                 mensajear ("mas de una definicion para $comando
                 nos quedamos con: $listaval[-1]->[1]");
              };
              $ref->{com}->{$comando} = $listaval[-1]->[2];
              $ref->{ori}->{$comando} =  $listaval[-1]->[0];
              if ($pal eq 'sobretiempos') {
                  $que = 'TIEMPOS';$tipotok = 'D';
                  $ref->{TIPOTOK}->{$comando} = $tipotok;
                  asignar_cosa_tipotok($ref,$que,$comando,$listaval[-1]->[1]
			   ,$tipotok,$listaval[-1]->[3]);
              } else {
                  $que = 'CONTROLES';
                  if ($comando =~/^MINIMUM|MAXIMUM/) {
                      $tipotok = 'D';
                  } else { 
                      $tipotok = 'C';
                  };
                  my ($valor,$tipo,$tiparg,$refarg); 
                  if ($comando eq 'INTEGRATIONROUTINE') {
                      impr_debug(__LINE__.' Tiem ',Dumper \@listaval);
                      my @lista = split /\s*,\s*/,$listaval[-1]->[1];
                      @lista = grep ($_,@lista);
                      ($tiparg,$refarg,$tipo) = ('',[],'C');
                      $valor =  join(",",@lista);
                      map(do{push(@$refarg,$_);$tiparg .= ',C'},@lista);
                      $tiparg =~ s/^,//;
                      if (@lista > 1) {
                          $tipotok = 'b';$tipo = ','; 
                          cargar_datos_tipotok($ref,'RCONTROLES',"rerun$comando"
                         ,'C',$valor,',',$tiparg,$refarg);
                      } else {
                          $tipotok = 'C';$tipo = 'C';
                      };
                      cargar_datos_tipotok($ref,'CONTROLES',$comando,$tipotok
	                ,$valor,$tipo,$tiparg,[$valor]);
	          } elsif ($tipotok eq 'D') {
                      $ref->{TIPOTOK}->{$comando} = $tipotok;
                      asignar_cosa_tipotok($ref,$que,$comando,$listaval[-1]->[1]
			   ,$tipotok,$listaval[-1]->[3]);
                  } else {
                      cargar_datos_tipotok($ref,'CONTROLES',$comando,$tipotok
	                ,'AAAAAA','C','C',['AAAAAA']);
                  };
              };
          };
      };
  };#my $pal
  if ($ref->{listaYPARAMETROS} and @{$ref->{listaYPARAMETROS}} ) {
      foreach my $par (@{$ref->{listaYPARAMETROS}}) {
          my ($coderr,$valor,$tipo,$tiparg,$refarg)
	      = Simusol::Evaluaciones::sustituir_SUST($ref,$par );
          if ($coderr) {
              mensajear(" Hay parametros no numericos para TIEMPOS: $par");
              last;
          } else {
              cargar_datos($ref,'YPARAMETROS',$par,$tipo,$tiparg,$refarg);
              impr_dat(__LINE__.' Tiem ',$par,$ref,'ite');
          };
      }; 
  };
  impr_datos(__LINE__.' Tiem',['TIEMPOS'],$ref);
  impr_datos(__LINE__.' Tiem',['CONTROLES'],$ref);
  comfin('fini interpretar_tiempos_extras',$coderr);
}#interpretar_tiempos_extras; 
# ---------------------------------------------------------------------------
sub mirar_cuadro_TIEMPO{
  comfin('comi mirar_cuadro_TIEMPO', @_);
  my ($ref) = @_;
  my $refvalores = $ref->{refvalores};
  if (scalar keys %{$refvalores->{TIEMPO}} > 1) {
      mensajear(
       "Por favor no incluya más de un cuadro TIEMPO; ignoraremos todos"); 
      comfin('fini mirar_cuadro_TIEMPO');
      return;
  };
  impr_debug(__LINE__.' Tiem', Dumper $refvalores->{TIEMPO});
  scalar %{$refvalores->{TIEMPO}} or return; 
  (my $numobj) =  keys %{$refvalores->{TIEMPO}};
  my $refcrudo = $refvalores->{TIEMPO}->{$numobj}; 
  my $listatori = $refcrudo->[0];

  (my $listat = $listatori) =~ s/^([^;]+)(.*)$/$1/;
  $ref->{CUADROTIEMPO}->{com} = $2;
  $ref->{TIPOTOK}->{CUADROTIEMPO} = 'D';
  my ($coderr,$normal,$uni)
      = asignar_cosa_tipotok($ref,'TIEMPOS','CUADROTIEMPO',$listat
       ,'D',$numobj);
  impr_datos(__LINE__.' Tiem ',['TIEMPOS'],$ref);
  $ref->{TIPARG}->{CUADROTIEMPO} =~ /w/ and $coderr = 68;
  if ($coderr) {
      mensajear(
    " No se entiende   $listatori
        para indicar tiempos de simulacion;\n   en "
       .descripcion_cuadro($numobj));
      comfin('fini mirar_cuadro_TIEMPO linea,$coderr',__LINE__,$coderr);
      return $coderr;
  }; 
  $error_cuadros{CONTROLES} = '';
  impr_debug(__LINE__.' Tiem $coderr',$coderr);
  comfin('fini mirar_cuadro_TIEMPO linea,$coderr',__LINE__,$coderr);
  return $coderr;
} # mirar_cuadro_TIEMPO
# ---------------------------------------------------------------------------
1

