package Simusol::Topologia;
#Para interpretar y adaptar XML
#usados por simusol1.pl
use Simusol::Auxiliares;
use Simusol::GlobalesSimusol;
use Simusol::Ayudas;
use Simusol::Termicos;

use strict;
use warnings;
use Data::Dumper;
$Data::Dumper::Sortkeys= 1;
BEGIN {
     use Exporter ();
     our ($VERSION,@ISA,@EXPORT,@EXPORT_OK,%EXPORT_TAGS);
     @ISA=qw(Exporter);
     @EXPORT=qw(&controlar_iconos_ele
                &controlar_nodos_simples_dobles
                &guardar_conex
                &descripcion_clasepcs
                &enganchar_ele
                &impr_ramas
                &tratar_conex
               );
};

# ---------------------------------------------------------------------------
sub buenos_contactos{
  comfin('comT buenos_contactos',@_);
  my $refgraf = $_[0];
  impr_refall(__LINE__.' Topo');
  my $coderr = '';
  my $numfile = $refgraf->{numfile}; 
  my @todosobj = (1..scalar @$codlista-1);
  my @todosobjgraf;
  my @todosobjcapa;
  @todosobjcapa = grep(do{defined $filelista->[$_]
         and ($filelista->[$_] == $refgraf->{numfile})}
         ,@todosobj);  
  push @todosobjgraf,@todosobjcapa if @todosobjcapa;
  impr_debug(__LINE__.' Topo $refgraf->{numcapa}',$refgraf->{numcapa});
  impr_debug(__LINE__.' Topo @todosobjgraf',\@todosobjgraf);
  my @malos;
  my $numcapa = $refgraf->{numcapa}; 
  my $coderr1 = buenos_1contactos($refgraf,$numcapa,\@todosobjgraf);
  impr_debug(__LINE__.' Topo $refgraf->{capas}',Dumper $refgraf->{capas});
  if ($coderr1) {
          mensajear(" Problemas con contactos en ".descripcion_capa($numcapa)); 
	  $coderr = $coderr1;
  };
  comfin('finT buenos_contactos',$coderr);
  return $coderr;
}#buenos_contactos
# ---------------------------------------------------------------------------
sub buenos_1contactos{
    comfin('comT buenos_1contactos',@_);
  my($refgraf,$ilayer,$reflisobj) = @_;my $coderr = '';
  my @todosobj = @$reflisobj;my @malos;
  my @elems = grep (
      do{$codlista->[$_] =~ /^[CEJLRcejlr]$/},@todosobj);
  my @nodos
    = grep (do {$codlista->[$_] =~ /^[Nn]$/ and $laylista->[$_] == $ilayer}
      ,@todosobj);
  my @tierras
    =  grep (do {$codlista->[$_] eq 't' and $laylista->[$_] == $ilayer}
    ,@todosobj);
  my $reflay = $reflayers[$ilayer];
  impr_objs(__LINE__.' Topo ',$reflay,'^[Nnt]$');
  impr_debug(__LINE__.' Topo @nodos,@tierras',[@nodos,'||',@tierras]);
  my %contactados = %{$refgraf->{contactos}}; 
#  impr_debug(__LINE__.' Topo contactados',Dumper \%contactados);
  my @todosobjconectados = keys %contactados;
  impr_debug(__LINE__.' Topo todosobjconectados',\@todosobjconectados);
  my @elemssinconect = grep (do {$laylista->[$_] == $ilayer and not $contactados{$_}}
                             ,@elems);
  my @nodossinconect = grep(do {not $contactados{$_}},@nodos);
  if (@elemssinconect) {
       mensajear (
       " Han quedado elementos sin conectar: ". scalar @elemssinconect
       . "; objetos: ". join(',',@elemssinconect));
       push @malos, @elemssinconect;
  };
  if (@nodossinconect) {
       mensajear (
       " Han quedado nodos sin conectar: ". scalar @nodossinconect
       . "; objetos: ". join (',', @nodossinconect));
       push @malos, @nodossinconect;
  };
  my @elemin = grep ($codlista->[$_] =~ /^[cejlr]$/,@todosobjconectados);
  my @elemay = grep ($codlista->[$_] =~ /^[CELJR]$/,@todosobjconectados);
  impr_debug(__LINE__.' Topo @elemin,@elemay',[@elemin,'||',@elemay]);
#  my @nodossimples = grep ($codlista->[$_] eq 'N',@todosobjconectados);
  my @malosmas;
  push @malosmas, grep(
      do{@{$contactados{$_}} != 2}, @elemay);
  push @malosmas, grep(
      do{@{$contactados{$_}} != 1}, @elemin);
  if (@malosmas) {
      impr_debug(__LINE__.' Topo @malos',\@malos);
      my $cuantos = scalar @malos;
      mensajear(
      " Hay elementos con más o menos conexiones que las permitidas: "
      .scalar @malosmas. "; objetos: ".join(',',@malosmas));
      push @malos,@malosmas;
  };
  my @renglones;
  if (@malos) {
      map(do{push @renglones,descripcion_objeto($_)}
          ,sort{$a<=>$b} union_conjunto(@malos));
      mensajear("\n" . join ("\n",@renglones));
      mensajear(''); $coderr = 190;
  };
  comfin('finT buenos_1contactos',$coderr);
  return $coderr;
}#buenos_1contactos
# ---------------------------------------------------------------------------
sub buenos_enganches_ramas{  # controla y carga $refgraf->{nodosmasdeuno]
  comfin('comT buenos_enganches_ramas', @_);
  my $refgraf = $_[0]; my $coderr = '';
  my @ramas =  @{$refgraf->{lisramascrudas}};
  my $revisar = 1; my @inutiles;
  my @mult = keys %{$refgraf->{con_resu}};
  my (@malas,@inutilesmas,@inutiles1,@inutiles0,@ramasdos
      ,@ramasdoseles,@ramasdosnodos,@ramasdoseles_ele,@ramasdosnodos_ele);  
  if (@mult) {
      impr_debug (__LINE__.' Topo conexiones extra', \@mult); 
      my @enganchantes;
      map (do{push @enganchantes,@{$refgraf->{con_resu}->{$_}}},@mult);
      map (s/^.//,@enganchantes);
      mensajear(" No enganche ramas directamente; use nodos;
      Hay ramas que enganchan a otras: ".  scalar @enganchantes
      . ";    ramas:  @enganchantes");
      push @malas,  @enganchantes;
  };
  foreach my $rama (@{$refgraf->{lisramascrudas}}) {
      my $cod = $codlista->[$rama];
      my %texto; my $cuantos = 0;
      if ($refgraf->{codeng_resu}->{$rama}) {
          $cuantos  = @{$refgraf->{codeng_resu}->{$rama}};
      };
      if ($cuantos > 2) {
          push @inutilesmas, $rama;
      } elsif ($cuantos == 2) {
          push @ramasdos,$rama;
      } elsif ($cuantos == 1) {
          push @inutiles1, $rama;
      } else {
          push @inutiles0, $rama;
      };   
  }; # foreach my $rama
  if (@inutilesmas) {
      mensajear(" No use enganches intermedios extras;
      Hay ramas con más de dos enganches útiles: " . scalar @inutilesmas
      . ";    ramas:  @inutilesmas");
      push @malas,  @inutilesmas;
  };
  if (@inutiles1) {
      mensajear(
      " Hay ramas con sólo un enganche útil: " . scalar @inutiles1
       . ";   ramas:  @inutiles1");
      push @malas, @inutiles1;  
  };
  if (@inutiles0) {
      mensajear(
      " Hay ramas sin ningún enganche útil: " . scalar @inutiles0
      . ";     ramas:  @inutiles0");
      push @malas, @inutiles0;  
  };
  if (@ramasdos) {
      foreach my $rama (@ramasdos) {
          my @codigos = @{$refgraf->{codeng_resu}->{$rama}};
          my @as = grep($_ eq 'a',@codigos);
          my @ms = grep($_ eq 'm',@codigos);
          my $clasecapa = $reflayers[$laylista->[$rama]]->{clasecapa};
          if ($clasecapa eq 'elementos') {  
              @as == 2 and push @ramasdoseles_ele, $rama
                or @ms == 2 and push @ramasdosnodos_ele, $rama;
          } else {
              @as == 2 and push @ramasdoseles, $rama
                or @ms == 2 and push @ramasdosnodos, $rama;
          }; 
      };
      if (@ramasdoseles) {
	  impr_debug(__LINE__.' Topo @ramasdosles',\@ramasdoseles);
          mensajear(
          " Hay ramas que conectan dos elementos: " . scalar @ramasdoseles
          . "; hay que intercalar un nodo;     ramas:  @ramasdoseles");
      };
      if (@ramasdosnodos) { 
          mensajear(
          " Hay ramas que conectan dos nodos: " . scalar @ramasdosnodos
          . "; se puede intercalar resistencia nula;"
          . "   ramas:  @ramasdosnodos");
      };
      if (@ramasdoseles_ele) {
	  impr_debug(__LINE__.' Topo @ramasdosles',\@ramasdoseles);
          mensajear(
          " Hay ramas que conectan dos elementos: " . scalar @ramasdoseles_ele
          . "     ramas:  @ramasdoseles_ele");
      };
      if (@ramasdosnodos_ele) { 
          mensajear(
          " Hay ramas que conectan dos nodos: " . scalar @ramasdosnodos_ele
           . "   ramas:  @ramasdosnodos_ele");
      };
  };
  push @malas,@ramasdoseles,@ramasdosnodos,@ramasdoseles_ele,@ramasdosnodos_ele;
  if (@malas) {
     @malas = sort {$a<=>$b} (union_conjunto(@malas));
     impr_ramas_problema(__LINE__.' Topo',$refgraf,\@malas);
     $coderr = 195;
  }; 
  comfin('finT buenos_enganches_ramas', $coderr);
  return $coderr;
}
# ---------------------------------------------------------------------------
sub cambiar_enganche{
  comfin('comT cambiar_enganche',@_);
  my ($enganche,$ramav,$handle,$objv,$con) = @_;
  my $codtextov = $enganche->{cod}.$enganche->{texto};
  my ($cod,$texto) = ($codlista->[$objv],$textolista->[$objv]); 
#  impr_debug(__LINE__.' Topo $enganche antes',Dumper $enganche);
  mensajear(
   " Se cambia el enganche $handle de la rama $ramav (estaba en $codtextov)
             conectándolo a $cod$texto");
  @$enganche{'handle','rama','to','cod','texto','connection'}
         = ($handle,$ramav,$objv,$cod,$texto,$con);
#  impr_debug(__LINE__.' Topo $enganche despues',Dumper $enganche);
  comfin('finT cambiar_enganche');
  return '';
}
#---------------------------------------------------------------------------
sub controlar_nodos_simples_dobles{#para clase no elementos
  comfin('comT controlar_nodos_simples_dobles',@_);
  my $refc = $_[0]; my $coderr = '';
  my @nodos = keys %{$refc->{cualobjtextonodo}};
  return unless @nodos;
  @nodos = grep ($_ ne '0',@nodos);
  #impr_debug(__LINE__.' Topo nodos no 0', \@nodos);
  return unless @nodos;
  my (%hashdoblesnosimples,%hashsimplesrepetidos);
  foreach my $nodo (@nodos) {
      my @lisobj = @{$refc->{cualobjtextonodo}->{$nodo}};
      my @dobles = grep($codlista->[$_] eq 'n',@lisobj);
      my @simples =  grep($codlista->[$_] eq 'N',@lisobj);
      my $lugaress = '';
      map($lugaress .= $lugarlista->[$_], @simples);
      my $lugaresd = '';
      map($lugaresd .= $lugarlista->[$_], @dobles);
      if (@simples == 0) {
	  @{$hashdoblesnosimples{$nodo}} = @dobles;
      } elsif (@simples>1) {
	  @{$hashsimplesrepetidos{$nodo}} = @simples;
      }; 
  };
  if (keys %hashdoblesnosimples) {
      mensajear( 
  "Debe haber un nodo simple con igual identificación que el(los) doble(s)");
      foreach my $nodo (sort keys %hashdoblesnosimples) {
          my @lisobj = $hashdoblesnosimples{$nodo};
          my $mensaje .= $nodo;
          foreach my $obj (@lisobj) {     
              $mensaje .= "\n   descripcion_objeto($obj)"
          };
          $mensaje .="\n";
          mensajear($mensaje);$coderr = 72; 
      }; 
  };
  if (keys %hashsimplesrepetidos) {
      mensajear(" Hay nodos repetidos no anunciados;
         Corrija identificación de nodos o use uno de ellos con doble trazo"); 
      foreach my $nodo (sort keys %hashsimplesrepetidos) {
          my @lisobj = $hashdoblesnosimples{$nodo};
          my $mensaje .= $nodo;
          foreach my $obj (@lisobj) {     
              $mensaje .= "\n   descripcion_objeto($obj)"
          };
          $mensaje .="\n";
          mensajear($mensaje);$coderr = 32;
      };
  }; 
  comfin('finT controlar_nodos_simples_dobles',$coderr);
  return $coderr;
}#controlar_nodos_simples
# --------------------------------------------------------------------------
sub controlar_iconos_ele{ # para las capas de clase 'elementos'
  comfin('comT controlar_iconos_ele',@_);
 # que cada elemento tiene sus contactos usados una sola vez,
 # para contactarse a un nodo ya fue controlado
  my ($reffarch,$capa,$reflay)= @_; my $coderr = '';
  impr_debug(__LINE__.' Topo ',descripcion_capa($reflay->{numcapa}));
  impr_objs(__LINE__.' Topo NODOS',$reflay,$codnodos,[$reflay->{numcapa}]); 
  impr_objs(__LINE__.' Topo ELEMENTOS',$reflay,$codelemTs,[$reflay->{numcapa}]);
  my ($numcapa,$numfile) = ($reflay->{numcapa},$reflay->{numfile});;
  my $refgraf = $refgrafers[$numcapa];
  #my @listanodos; # = grep ($codlista->[$_]=~ /^[Nt]$/
  #              ,keys %{$reflay->{contactados}});
  my @listanodos = keys %{$reflay->{cualobjtextonodo}};
  my @listaobjnodos;
  map( do {push @listaobjnodos,@{$reflay->{cualobjtextonodo}->{$_}}}
      ,@listanodos);  
  if (not @listanodos) {
      mensajear(" No hay posibilidad de definicion de elementos");
  };
  impr_debug(__LINE__.' Topo',\@listaobjnodos);
  my @listadobles =  grep (do{$codlista->[$_] eq 'n'},@listaobjnodos);
  if (@listadobles) {
      mensajear(" No se deben usar nodos dobles al definir elementos");
      map(mensajear(descripcion_objeto($_)),@listadobles);
  };
# impr_debug(__LINE__.' Topo enganches ramas',Dumper $refgraf->{enganches});
# impr_debug(__LINE__.' Topo contactos elementos',Dumper $refgraf->{contactos});
  my (@listano1contacto,@listatierrasmalas);
  foreach my $objnodo (@listaobjnodos) {
      impr_debug(__LINE__.' Topo $objnodo,$codlista'
		 ,[$objnodo,$codlista->[$objnodo]]);
      if ($refgraf->{contactos}) {
          if ($codlista->[$objnodo] eq 'N' and
             (not $refgraf->{contactos}->{$objnodo} or
              @{$refgraf->{contactos}->{$objnodo}} != 1)) {
              push @listano1contacto, $objnodo;
          } elsif ($codlista->[$objnodo] eq 't' and
              $refgraf->{contactos}->{$objnodo}) {
              push @listatierrasmalas,$objnodo;
          };
      };
  }  
  if (@listano1contacto) {
      mensajear(" Hay nodos con no exactamente un contacto:");
      map(mensajear(descripcion_objeto($_)),@listano1contacto);
  };
  if (@listatierrasmalas) {
      mensajear(" Al definir tierras, no deben estar contactadas");
      map(mensajear(descripcion_objeto($_)),,@listatierrasmalas);
  };
  if (@listadobles+@listano1contacto+@listatierrasmalas or
      not @listanodos) {
      $coderr = 25;
  };
  my @listaeles = keys %{$reflay->{cualobjele}};
# = grep (/$codelemTs/, keys %{$reflay->{cualidenuniuni}});
  impr_debug(__LINE__.' Topo elementos',\@listaeles);
  my (@eleobjsmalos,@idensmalos,@mensmalos);
  impr_campo(__LINE__.' Topo $reflay',$reflay,'uniuni');
  foreach my $iden (@listaeles) {
      my $reflista = $reflay->{uniuni}->{$iden}; 
      my $otroiden = lc(substr($iden,0,1)) . substr($iden,1);
      my $reflistaotro = $reflay->{uniuni}->{$otroiden};
      if (defined $reflistaotro) {
	  $iden = $otroiden;
          $reflista = $reflistaotro;
      };
      if (defined $reflista) {
          my @lista = union_conjunto(@$reflista);
          if (@lista > 1) {
              push @eleobjsmalos,@{$reflay->{cualobjele}->{$iden}};
              push @idensmalos, $iden;
              push @mensmalos, "      $iden  @{$reflay->{uniuni}->{$iden}}";  
          } else {
              $reflay->{uniuni}->{$iden} = $reflista->[0];
          };
      };
  };
  impr_campo(__LINE__.' Topo $reflay',$reflay,'uniuni');
  impr_debug(__LINE__.' Topo @idendmalos',\@idensmalos);
  if (@eleobjsmalos) {
      my @mens;
      push @mens,
        " Hay elementos con igual identificación pero conectados con 
  nodos de diferentes identificaciones o en diferente orden: "
        . scalar @eleobjsmalos
        ."; objetos @eleobjsmalos";
      map(do {push @mens, descripcion_objeto($_)},@eleobjsmalos);
      push @mens, @idensmalos;
      my  $mensaje = join ("\n",union_conjunto(@mens));
      mensajear($mensaje);
      map (do {delete $reflay->{cualobjele}->{$_};
               delete $reflay->{uniuni}->{$_}},@idensmalos);
  };
  foreach my $iden (keys %{$reflay->{cualobjele}}) {
      my @clase = sort @{$reflay->{cualobjele}->{$iden}};
      map (do {$_ = $plantillalista->[$_].'c'.$shapelista->[$_]},@clase);
      my $clasepcs = join ('d',sort @clase);
      $refgraf->{iden2clase}->{$iden} = $clasepcs;
      if (not defined $reflay->{hashclasepcs}->{$clasepcs}) {
          map(do {$reflay->{hashclasepcs}->{$clasepcs}->{$_} = 1},@clase);
      };
  };
  my @tierrasobj
     = grep (do{$textolista->[$_] eq '&' and $laylista->[$_] == $capa}
                   ,(1..scalar @$laylista - 1));
  my @clase = @tierrasobj;
  map (do{$_ = $plantillalista->[$_].'c'.$shapelista->[$_]},@clase);  
  my $clasepcs = join ('d',sort @clase);
  $refgraf->{iden2clase}->{"t&"} = $clasepcs;
  if (not defined $reflay->{hashclasepcs}->{$clasepcs}) {
      map(do {$reflay->{hashclasepcs}->{$clasepcs}->{$_} = 1},@clase);
  };
  comfin('finT controlar_iconos_ele',$coderr);
  return $coderr;
}#controlar_iconos_ele
# ---------------------------------------------------------------------------
sub eliminar_rama_inutil{
  my ($refgraf,$reframa) = @_;
  my ($rama,$causa) = ($reframa->[0],$reframa->[1]);
  (my $obj = $rama) =~ s/^.//; 
  impr_debug(__LINE__.' Topo',[$rama,$obj,$causa]); 
  push @{$refgraf->{lisramaseliminadas}},$obj;
  for (my $indice = 0; $indice < @{$refgraf->{enganches}->{$rama}}; 
          $indice ++) {
      delete $refgraf->{enganches}->{$rama}->[$indice];
  }; 
  foreach my $pal ('enganches','eng_resu','con_resu','eng_con_resu') {
      my $to = $refgraf->{$pal}->{$obj};
      delete $refgraf->{$pal}->{$obj};
  };
  impr_debug(__LINE__.' Topo {enganches}',
		 Dumper $refgraf->{enganches});
  impr_debug(__LINE__.' Topo {contactos}',
		 Dumper $refgraf->{contactos});

  @{$refgraf->{lisramascrudas}}
     = grep ($_ ne $obj,@{$refgraf->{lisramascrudas}});
  impr_debug(__LINE__.' Topo lisramascrudas',$refgraf->{lisramascrudas});
  mensajear (descripcion_rama($obj));
  return '';
}
# ---------------------------------------------------------------------------
sub eliminar_ramados{
  comfin('comT eliminar_ramados', @_);
  my ($refgraf,$reframados) = @_;
  my (@capaeles,@capamods,@ramaaas,@ramamms);
  foreach my $rama (@$reframados) {  
      my $texto = $refgraf->{eng_resu}->{$rama};
      my $capa = $laylista->[$rama];
      my $clasecapa = $reflayers[$capa]->{clasecapa};
      if ($clasecapa eq 'elementos') {
          push @capaeles,$capa;
      } elsif ($clasecapa eq 'modelo') {
          push @capamods,$capa;
      } elsif ($texto eq 'a,a') {
          push @ramaaas,$rama;
      } else {
          push @ramamms,$rama;
      };
  };
  if (@capaeles) {
      map(do{eliminar_capa($_,'elementos')},@capaeles);
  };
  if (@capamods) {
      map(eliminar_capa($_,'modelo'),@capamods);
  };
  if (@ramamms) {
      map(mensajear(descripcion_rama($_)),@ramamms);
      foreach my $ramamm (@ramamms) {
          my $lug0;
	  my ($ijR,$codR,$textoR) 
              = Ampliaciones::crear_objeto_ele(# en eliminar_ramados
                      $laylista->[$ramamm],'R','','',$lug0, 'R','','0');
      };
  };
  if (@ramaaas) { 
      map(mensajear(descripcion_rama($_)),@ramaaas);
      foreach my $ramamm (@ramamms){
          my ($lug0,$lug1,$cone0,$cone1,$to1);
          my ($inodo,$codn,$texton) = crear_objeto_nodo(# en eliminar_ramados
          $laylista->[$ramamm],'N','','',$lug0,'N',"");
          my ($irama,$codr,$textor)
           = crear_objeto_rama($laylista->[$ramamm],'x','','',$lug0,$lug0,$lug1,
                   $inodo,$cone0,$to1,$cone1);
      };
  };    
  comfin('finT eliminar_ramados', @_);
  return \@capaeles,\@capamods; 
};
# ---------------------------------------------------------------------------
sub enganchar_eles{
  comfin('comT enganchar_eles', @_); my $coderr = '';
  # a partir de $refgraf{enganches} (con hash de 7) y $refgraf->{contactos}  
  # llena $refgraf->{unionesobj} con, para cada elemento, la lista ordenada
  # por número de conexión del objeto
  # a partir de ahi interpreta en terminos de los identificadores de Simusol
  # llevando a $refarch->{uniuni} o $refgraf->{reflay}->{$capa}->{uniuni} 
   
  impr_debug(__LINE__.' Topo Simusol2Dia',Dumper \@Simusol2Dia);
  my $refgraf = $_[0] ;
  $refgraf->{unionesobj} = {};
  $refgraf->{objobj} = {};
#  my @contactados = grep($codlista->[$_] =~ /$codelemTs/
#                         ,keys %{$refgraf->{contactados}});
#  impr_debug(__LINE__.' Topo contactados',Dumper $refgraf->{contactados}); 
#  map (do {$refgraf->{unionesobj}->{$_} = []},@contactados);
#  impr_debug(__LINE__.' Topo uninesobj ',Dumper $refgraf->{unionesobj});  
  foreach my $rama (keys %{$refgraf->{enganches}} ) {
      my $refenganches = $refgraf->{enganches}->{$rama};
      next unless @$refenganches; 
      impr_debug(__LINE__.' Topo $refgraf->{enganches}->{$rama}'
		 , Dumper $refgraf->{enganches}->{$rama});
      my ($objeleT,$objnodo,$contactoele);
      foreach my $enganche (@$refenganches) {# hay dos engan. uno solo con ele 
          
        if ($enganche->{cod} =~ /$codelemTs/) {
               $objeleT = $enganche->{to};
               $contactoele = $enganche->{connection};
          } elsif($enganche->{cod} =~/$codnodos/) {
               $objnodo = $enganche->{to};
          } else {
	      error_progr(__LINE__.' Topo enganchar_eles',$refgraf);
          };
      }; #enganche
      $contactoele eq 0 and
         unshift @{$refgraf->{unionesobj}->{$objeleT}},$objnodo
         or push @{$refgraf->{unionesobj}->{$objeleT}},$objnodo;
  }; #rama
  my $refarch = $refarchers[$refgraf->{numfile}];
  impr_debug(__LINE__.' Topo $refarch->{cualobjorduniuni}'
    ,Dumper $refarch->{cualobjorduniuni});

  if ($refarch->{cualcapaclase}->{circuito} and 
      $refarch->{hashclase}->{ramas}) {
      $refarch->{uniuni} = {};
  };
  impr_debug(__LINE__.' Topo refgraf->{unionesobj}'
    , Dumper $refgraf->{unionesobj});
  foreach my $obj (keys %{$refgraf->{unionesobj}}) {
      impr_debug(__LINE__.' Topo $refarch->{cualobjorduniuni}'
        .' futuro $obj '.$obj,Dumper $refarch->{cualobjorduniuni});
      my $cod = $codlista->[$obj];
      not $cod =~ /$codelemTs/ and next; 
      my $iden = $cod . $textolista->[$obj];
      print STDERR "                                        $obj  $iden\n";
      my $capa = $laylista->[$obj]; 
      my $reflay = $reflayers[$capa];
      my $clasecapa = $reflay->{clasecapa};
      my @lista = @{$refgraf->{unionesobj}->{$obj}};
      @lista or next;
      impr_debug(__LINE__.' Topo $refgraf->{unionesobj}'
        ,Dumper $refgraf->{unionesobj}); 
      $refgraf->{objobj}->{$obj} = join '-',@lista;
      map (do{$_ = $textolista->[$_]; $_ eq '&' and $_ = 0}, @lista);
      my $recibe;
      if ($clasecapa eq 'circuito') {
          $recibe = $refarch;
      } else {
          defined $reflay->{uniuni} or $reflay->{uniuni} = {};
          $recibe = $reflay;
      };

      my $uniuni =  join ('-',@lista);
      $recibe->{uniuni}->{$iden} or $recibe->{uniuni}->{$iden} = [];
      my $orduniuni = join ('-',sort @lista);
      my $ord0uniuni = $orduniuni;
      $ord0uniuni = join ('-',sort (@lista,0)) if @lista == 1;
      impr_debug(__LINE__.' Topo $obj,$iden',[$obj,$iden]);
      my $uniuni0 = $uniuni;
      if ($clasecapa eq 'elementos') {
          push @{$recibe->{uniuni}->{$iden}}, $uniuni;
      } else {
          if (@lista == 1) {
              if (uc($cod) eq 'E') {
                  $uniuni0 = "0-$uniuni";
	      } else {
                  $uniuni0 = "$uniuni-0";
              }; 
              $recibe->{uniuni}->{uc($iden)} = $uniuni0;
              $recibe->{cualidenuniuni}->{$uniuni0} or
		$recibe->{cualidenuniuni}->{$uniuni0} = [];
          };
          $recibe->{uniuni}->{$iden} = $uniuni;  
      };
      impr_debug(__LINE__.' Topo $recibe->{cualidenuniuni}'
        ,Dumper $recibe->{cualidenuniuni});
     impr_debug(__LINE__.' Topo $uniuni,$uniuni0,$orduniuni,$ord0uniuni'
        , [$uniuni,$uniuni0,$orduniuni,$ord0uniuni]);
      impr_debug(__LINE__.' Topo $recibe->{uniuni}',Dumper $recibe->{uniuni});
      impr_debug(__LINE__.' Topo $clasecapa',$clasecapa);
#      $cod = $codlista->[$obj]; 
      if ($clasecapa ne 'elementos') {
          if ($cod =~ /^[cejlr]$/i) {
              push @{$recibe->{cualobjorduniuni}->{$ord0uniuni}},$obj;
              impr_debug(__LINE__.' Topo $recibe->{cualobjorduniuni}'
                ,Dumper $recibe->{cualobjorduniuni});
 	      if (uc($cod) eq 'E') {
                   unshift (@{$recibe->{cualidenuniuni}->{$uniuni0}}
	             ,uc($cod) .$textolista->[$obj]);
	      } else { 
                   push (@{$recibe->{cualidenuniuni}->{$uniuni0}}
	             ,uc($cod) .$textolista->[$obj]);
              };
              if (lc($cod) eq $cod) {
                  push @{$recibe->{cualidenuniuni}->{$uniuni}}
	             ,$cod .$textolista->[$obj];
              };
              impr_debug(__LINE__.' Topo $recibe->{cualidenuniuni}'
                ,Dumper $recibe->{cualidenuniuni});
              if ($cod =~ /^[cejlr]$/) { 
                  push @{$refarch->{cualobjtextonodo}->{0}},$obj;
                  impr_debug(__LINE__.' Topo $recibe->{cualobjtextonodo}'
                    ,Dumper $recibe->{cualobjtextonodo});
                  #para que quede visible que hay nodo tierra, aunque $obj
                  #no es un nodo
	      };
           };
      } else {
           push @{$recibe->{cualidenuniuni}->{$uniuni}}
             ,$codlista->[$obj] . $textolista->[$obj];
      };
  impr_debug(__LINE__.' Topo $recibe ($refarch or $reflay) cualidenuniuni'
      ,Dumper $recibe->{cualidenuniuni}); 
  };
 foreach my $ilayer (@{$refarch->{capas}} ) {
      if ($reflayers[$ilayer]->{cualidenuniuni}) {
          impr_debug(__LINE__.' Topo  $reflayers[$ilayer]->{cualidenuniuni}'
              ." capa $ilayer"
              ,Dumper $reflayers[$ilayer]->{cualidenuniuni});
      };
  };
  return '' if $refarch->{clasearch} eq 'elemod';
  impr_debug(__LINE__.' Topo $refarch uniuni',Dumper $refarch->{uniuni});   
  impr_debug(__LINE__.' Topo $refarch->{cualobjorduniuni}'
   ,Dumper $refarch->{cualobjorduniuni});
  foreach my $orduniuni (keys %{$refarch->{cualobjorduniuni}} ) {
      my $mensaje = '';
      my @listaobj = @{$refarch->{cualobjorduniuni}->{$orduniuni}};
      impr_debug(__LINE__.' Topo'
           ,[$orduniuni,@{$refarch->{cualobjorduniuni}->{$orduniuni}}]);
       next if @listaobj == 1;
      my @listacod = @listaobj;
      map($_ = uc($codlista->[$_]),@listacod);
      my $string = join '',sort @listacod;
      if ($string =~ /EE/) {
          $mensaje = "No tiene sentido fuentes de tension en paralelo";
      } elsif ($string =~ /CE/) {
          $mensaje =
    "No es aceptable para Sceptre capacitores y fuentes de tension en paralelo"
      };
      if ($mensaje) {
          my @descrip;
          map (do{push @descrip, descripcion_objeto($_)}, @listaobj);
          mensajear("$mensaje
           Entre los nodos $orduniuni hay objetos @listaobj:\n" 
             .join "\n",@descrip);
          $coderr = 248;
          parar1($coderr,$refarch)
      };
      impr_debug(__LINE__.' Topo $string',$string);
      impr_debug(__LINE__.' Topo cualidenorduniuni'
         , Dumper $refarch->{cualidenorduniuni}); 
      if ($string =~ /[cC]/) {
   	  @{$refarch->{cualcCorduniuni}->{$orduniuni}} = grep (
              do {uc($codlista->[$_]) eq 'C'}
               ,@{$refarch->{cualidenorduniuni}->{$orduniuni}});
      };
      impr_debug(__LINE__.' Topo cualcCuniuni'
         , Dumper $refarch->{cualcCorduniuni}); 
  };
  comfin('finT enganchar_eles', @_);
  return '';
}
#---------------------------------------------------------------------------
sub enganches_3_7{
  comfin('comT enganches_3_7',@_);
  my $refgraf = $_[0];
  my $numfile = $refgraf->{numfile};
  my @ramas = sort {$a<=>$b} @{$refgraf->{lisramascrudas}};
  # sort solo para facilitar revisiones
  # handle de una rama es un punto importante de la rama para descrirla
  # algunos handles tienen la posibilidad de enganchar cosas
  # algunos handles dan la posibilidad de deformar la rama
  # los handles de las puntas tienen las dos capacidades
  # los numeros de handles dependen del tipo de rama y del modo en que se creo
  # pero no afectan al funcionamiento de Simusol 
  # $refgraf->{enganches}  refiere a una lista de los handles que engancharon
  # algo; los llamamos handles activos
  # el indice de esa lista no esta relacionado con el handle sino con
  # el orden en que Dia ha encontrado ese enganche activo.
  # Simusol engorda cada referencia para hacerla mas directamente utilizable,
  # pasando de un hash de 3 elementos a uno de 7 elementos
  # Simusol elimina de esa lista las referncias a enganches no interesantes


  # $refgraf->{lughandles} refiere a una lista de los lugares de todos
  # los handles de la rama. El indice es el numero de handle
  # Simusol no cambia  esta lista.
#  impr_debug(__LINE__.' Topo Dia2Simusol',Dumper \@Dia2Simusol);
#  impr_debug(__LINE__.' Topo Simusol2Dia',Dumper \@Simusol2Dia);
  my $archivo = $refnombres[$numfile]->{ARCHIVO}; 
  impr_debug(__LINE__.' Topo $numfile,$archivo',[$numfile,$archivo]); 
  impr_debug(__LINE__.' Topo {enganches} de '.$archivo
    , Dumper $refgraf->{enganches});
  foreach my $rama (@ramas ) {
      my $listaeng = $refgraf->{enganches}->{$rama};
      next unless @$listaeng > 0;
      my $listalug = $refgraf->{lughandles}->{$rama};
      my ($cod, $to); 
      my $indice = -1;
      foreach  (@$listaeng) { #cada enganche es, hasta ahora,
             # un hash de tres keys
          $indice ++;
          my ($toDia,$connection,$handle) = @$_{'to','connection','handle'};
          $toDia=~ s/^.//;
          $to = $Dia2Simusol[$numfile]->{$toDia}; #num para Simusol
          if (not $to) {
 	      delete $listaeng->[$indice];
               next;
           };
           $cod = $codlista->[$to];
           if ($rama == $to) {
               mensajear("Conexion inútil de rama consigo misma (se ignora)
                   " . descripcion_rama($rama));
               delete $refgraf->{enganches}->{$rama}->[$indice];
               next;
           };
           if ($cod =~ /^[AO]$/) {
	       impr_enganches(__LINE__.' Topo',$rama);
               #enganches a cosas sin chance de ser elementos, nodos, ramas
               delete $refgraf->{enganches}->{$rama}->[$indice];
               next;
           };
           #transformando cada enganche de $refgraf->{enganches},
           # en un hash de 7 elementos (cambia el significado de 'to':
           # era denominacion para Dia y queda denominacion para Simusol
           #$rama es la key y queda registrada en $_->{rama} 
           my $lug = $listalug->[$handle]; $_->{cod} = $cod;
           $_->{lugar} = $lug; $_->{to} = $to; $_->{rama} = $rama;
           $_->{texto} = $textolista->[$to];
           #se registra lo mismo en $refgraf->contactos}
           push @{$refgraf->{contactos}->{$to}}, $_; 
      };
      @$listaeng = grep ($_,@$listaeng); 
  };
  # impr_debug(__LINE__.' Topo {enganches}', Dumper $refgraf->{enganches});
  # impr_debug(__LINE__.' Topo {contactos}', Dumper $refgraf->{contactos});
  comfin('finT enganches_3_7'); 
  return '';
}#enganches_3_7
#---------------------------------------------------------------------------
sub guardar_conex{
  #completa la descripcion de los enganches, clasifica las ramas y detecta 
  #conexiones multiples a elementos o modelos
  comfin('comT guardar_conex', @_); my $coderr = '';
  my $debug1 = $opt_hash{d}; 
  # $debug = '';
  my $refgraf = $_[0];
  enganches_3_7($refgraf) if $refgraf->{lisramascrudas};
  # $refgraf->{lisramascrudas} = [];
  # clasifica las ramas y completa, ajustando los values para 'to'
  # a partir de $refgraf->{lisobjramascrudas}
  # llena varios $refgraf->{lisramas...}
  #  key informa del to, connection y lugar
  #  y el value del par,handle donde aparecen
#  my $codconectablesnonodos = '[CEJLRcejlrTu]';
  $refgraf->{lisramaseliminadas} = [];
  # sort solo para facilitar revisiones
  $refgraf->{eng_resu} = {}; $refgraf->{con_resu} = {};
  $refgraf->{codeng_resu} = {}; $refgraf->{texto_codeng_resu} = {};
  $refgraf->{engobj_resu} = {}; $refgraf->{conobj_resu} = {};
  $refgraf->{contactados} = {};
  my @ramas;
  @ramas = sort {$a<=>$b} @{$refgraf->{lisramascrudas}}
    if $refgraf->{lisramascrudas};
  foreach my $rama (@ramas ) {
      my $listaeng = $refgraf->{enganches}->{$rama};
      # esta tambien  en $refgraf->{contactos}->{$to} con el $to que se vera
      next unless @$listaeng > 0;
      if (@$listaeng) {
          my ($cod, $to); 
          my $indice = -1;
         foreach  (@$listaeng) { #cada enganche ya es de 7 elementos
          # con los 'to' de Simusol
              $indice ++;
              next unless $_; # por enganches caidos para Simusol 
              my ($to,$connection,$handle) = @$_{'to','connection','handle'};
              # $listaeng est tambien en $refgraf->{contactos}->{$to}
              $cod = $codlista->[$to];
              my $texto = $textolista->[$to];
	      if ($cod eq 'u') {# y aqui no importa cual es el n. de contacto
                  push @{$refgraf->{con_resu}->{$to}},"u$rama";
                  push @{$refgraf->{conobj_resu}->{$to}},"$rama";
                  push @{$refgraf->{codeng_resu}->{$rama}},'u'
              } elsif ($cod =~ /$codelemTs/) {
                  push @{$refgraf->{codeng_resu}->{$rama}},'a';
              } elsif ($cod =~ /$codnodos/) {
                  $texto eq '&' and $texto = 0;
                  push @{$refgraf->{codeng_resu}->{$rama}},'m';
              };
              push @{$refgraf->{texto_contactos}->{$to}}
                 ,"contacto $connection,  rama $rama,  handle $handle";  
              push @{$refgraf->{eng_resu}->{$rama}},"$cod$texto";
              push @{$refgraf->{enggobj_resu}->{$rama}},$to;
           }; # foreach @listaeng
           @$listaeng = grep($_,@$listaeng);
       }; #if listaeng
       if ($refgraf->{codeng_resu}->{$rama}) {
          $refgraf->{texto_codeng_resu}->{$rama} 
	  = join ',',@{$refgraf->{codeng_resu}->{$rama}};
       };
  }; #foreach my rama
  impr_ramas(__LINE__.' Topo al terminar guardar_conex',$refgraf,1);
  if ($refgraf->{lisramascrudas}) {
      my $coderr1 = buenos_enganches_ramas($refgraf);
      my $coderr2 = buenos_contactos($refgraf) if defined $refgraf->{contactos};
      $coderr = $coderr1; $coderr or $coderr = $coderr2;
      if (not $coderr and @{$refgraf->{lisramascrudas}}) {
          enganchar_eles($refgraf);
      };
      if (not $coderr) {
          my $refarch = $refarchers[$refgraf->{numfile}];
          impr_debug(__LINE__.' Topo keys $refarch',[keys %$refarch]);
          impr_debug(__LINE__.' Topo keys $refgraf',[keys %$refgraf]);
          impr_objs(__LINE__.' Topo ELEMS',$refgraf,$codelemTs); 
          impr_objs(__LINE__.' Topo NODOS',$refgraf,$codnodos); 
          impr_objs(__LINE__.' Topo RAMAS',$refgraf,$codramas);
      };
  }; 
  comfin('finT guardar_conex',$coderr);
  return $coderr;
}#guardar_conex
# ---------------------------------------------------------------------------
sub impr_enganches{
  return '' unless $debug;
  # imprime los enganches de la rama dada por su numero de objeto,
  # los numeros de objetos enganchados
  # y los identificadores de los objetos enganchados
  my ($mensaje,$ramao) = @_;
  if (not defined $ramao) {
     eco(" impr_enganches $mensaje; rama no definida");  
     return ''; 
  };
  my $reflay = $reflayers[$laylista->[$ramao]];
  my $numcapa = $reflay->{numcapa};
  my $numfile = $reflay->{numfile};
  my $refgraf = $refgrafers[$reflay->{numcapa}];
  if (not defined $refgraf->{enganches}->{$ramao}) {
      print STDERR "     rama $ramao sin enganches\n";
      return '';
  } else {
      if ($mensaje) {
          $mensaje =~ s/^\s*(\w+)\s+(\w+)(.*)/$1 $2 /;
      };
      # impr_debug(__LINE__.' Topo',Dumper $refgraf->{enganches}->{$ramao});
      my @lista = @{$refgraf->{enganches}->{$ramao}};
      $mensaje .= "($codlista->[$ramao]$codvalorlista->[$ramao])";
      @lista or print STDERR "$mensaje rama   $ramao: ningun enganche\n";
      foreach my $enganche (@lista) {
          my ($cod,$texto);
          my ($rama, $handle,$lugar, $to,$connection) =
            @$enganche{'rama','handle','lugar', 'to','connection','cod'};
          if (defined $to and $to =~ s/^O//) {
             $to = $Dia2Simusol[$numfile]->{$to};
             #en algun momento se hace el cambio definitivo
          };
          if (defined $to and $to != 0) {
              $texto = $textolista->[$to];
              defined $cod or $cod = $codlista->[$to];
          } else {
              $to = 0; $texto = ' ';
              defined $cod or $cod = ' ';
          }; 
          defined $rama or $rama = $ramao;
          if ($rama != $ramao) {
              error_progr($refgraf,__LINE__.' Topo $rama != $ramao');
          };
          defined $lugar or $lugar = ' ';
          if ($lugar =~ /HASH/) {$lugar = $lugar->{val}; die " con HASH"};
          printf STDERR 
  "$mensaje rama%4i, h%2i,  %20s, objeto%4i, con.point%2i, %1s%1s\n"
                ,$rama, $handle,$lugar,$to,$connection,$cod,$texto; 
      }; 
  }; 
  # comfin('finT impr_enganches', @_);
  return '';
}#impr_enganches
# ---------------------------------------------------------------------------
sub impr_ramas{
  return '' unless $debug;
  comfin('comT impr_ramas',@_);
  # sólo se usa para depurar
  my ($mensaje,$refgraf) = @_; # con $completo mas informacion
  # impr_debug(__LINE__.' Topo enganches',Dumper $refgraf->{enganches});
  # impr_debug(__LINE__.' Topo contactos',Dumper $refgraf->{contactos});
  # impr_debug(__LINE__.' Topo lughandles',Dumper $refgraf->{lughandles});
  my $lislay = $refgraf->{capas};
  impr_debug(' lisramascrudas',$refgraf->{lisramascrudas});
  if (defined $refgraf->{enganches} and scalar keys %{$refgraf->{enganches}}) {
      print STDERR "   Enganches de las ramas:\n";
      foreach my $rama (@{$refgraf->{lisramascrudas}}) {
          impr_enganches('  ',$rama);
      };
      if ($refgraf->{eng_resu} or $refgraf->{con_resu} or
          $refgraf->{codeng_resu}) {  
          print STDERR 
            "   Enganches y contactos  resumidos de cada rama; "
            . "y codigos de enganches:\n";
          foreach my $rama (@{$refgraf->{lisramascrudas}}) {
              my $cod = $codlista->[$rama];
              my %texto; my $usada = '';
              foreach my $pal ('eng_resu','con_resu','codeng_resu') {
                  if ($refgraf->{$pal}->{$rama}) {
                      $texto{$pal} = join (','
                        ,  @{$refgraf->{$pal}->{$rama}});
                      } else { $texto{$pal} = '----';
                  };  
              };
              printf STDERR "    %5s -> %8s     %5s <- %8s      %4s\n"
                  , "$cod$rama", $texto{eng_resu}
                  ,"$cod$rama", $texto{con_resu}, $texto{codeng_resu};
          };#foreach my $rama
      };
  };#{enganches} 
  if (defined $refgraf->{contactos} and scalar keys  %{$refgraf->{contactos}}) {
      print STDERR "  Contactos ocupados de elementos, modelos y nodos\n"; 
      foreach my $to (sort keys %{$refgraf->{contactos}} ) {
          my $capa = $laylista->[$to];
          my $clase = $reflayers[$capa]->{clasecapa}; 
          $clase eq 'circuito' and $clase = '';
          foreach my $textocon (sort @{$refgraf->{texto_contactos}->{$to}}) {
              printf STDERR "%10s %5s %13s %7s %1s\n",
              $clase,$to,$lugarlista->[$to],"$codlista->[$to]$textolista->[$to]"
              ,$textocon;
          };
      };
  };
  comfin('finT impr_ramas',@_);
  return '';
}#impr_ramas
# ---------------------------------------------------------------------------
sub impr_ramas_problema{
  my ($mensaje,$refgraf,$lisramas) = @_;
  my $formato = "rama %3s  handles %36s;";
  my $formatoresto = ' ' x 15 ."handles usados %12s %6s %6s";
  my (%pedidas,@renglones);  
  foreach my $rama (@$lisramas) {
      my @conectadas = ();
      $pedidas{$rama} and next;
      $pedidas{$rama} = 1;
      my $lugares = join (' ',@{$refgraf->{lughandles}->{$rama}});
      my $renglon = sprintf $formato, $rama,$lugares;
      push @renglones, $renglon;
      foreach my $refeng (@{$refgraf->{enganches}->{$rama}}) {
          my ($lug,$to,$cod)  = @$refeng{'lugar','to','cod'}; 
 #         next unless $lug and $to and $cod; 
          my $texto = $textolista->[$to];
          my $cosa = 'elem.'; my $cual = "$cod$texto";
          if ($cod =~ /^[Nn]$/) {$cosa = 'nodo'; $cual = $texto;
          } elsif ($cod eq 't') {$cosa = 'nodo tierra'; $cual = '';
          } elsif ($cod eq 'u') {
              $cosa = 'rama'; $cual = $texto;
              if (not $pedidas{$texto}) {
                  push @$lisramas, $texto;
              };
	  };
          push @conectadas,[$lug,$cosa,$cual];
      };  
      foreach my $terna (@conectadas) {
          my $renglon
            = sprintf $formatoresto,$terna->[0],$terna->[1],$terna->[2];
          push @renglones,$renglon;
      };
  };
  mensajear ("\n" . join("\n",@renglones)); mensajear('');
  return '';
}#impr_ramas_problema
# ---------------------------------------------------------------------------
sub lugares_clasepcs{
  # comfin('comT lugares_clasepcs)',@_);
  my ($reflay,$clasepcs) = @_;
  my @listapcss = split 'd', $clasepcs;
  my (@listaobjs,@lugares);
  map (do{push @listaobjs, @{$reflay->{cualobjpcs}->{$_}}}, @listapcss); 
  map (do{push @lugares,$lugarlista->[$_]},@listaobjs);
  # comfin('finT lugares_clasepcs)',@lugares);
  return @lugares;
}#lugares_clasepcs
# ---------------------------------------------------------------------------
sub replicar_rama{
  my ($refgraf,$rama) = @_;
  my $ramarepl = scalar @$textolista;
  $codlista->[$ramarepl] = $codlista->[$rama];
  $textolista->[$ramarepl] = $ramarepl;
  $codvalorlista->[$ramarepl] = $codvalorlista->[$rama];
  $plantillalista->[$ramarepl] = $plantillalista->[$rama];
  $shapelista->[$ramarepl] = $shapelista->[$rama];
  $laylista->[$ramarepl] = $laylista->[$rama];
  $lugarlista->[$ramarepl] = $lugarlista->[$rama];
  @{$refgraf->{lughandles}->{$ramarepl}} = @{$refgraf->{lughandles}->{$rama}};
#  push @{$refgraf->{lisobjnoO}}, $ramarepl;
  push @{$refgraf->{lisramascrudas}}, $ramarepl;
  if (defined $refgraf->{enganches}->{$rama}) {
      foreach my $atr (@{$refgraf->{enganches}->{$rama}}) {
          my %atrib = %$atr;
          $atrib{rama} = $ramarepl;
          push @{$refgraf->{enganches}->{$ramarepl}}, \%atrib;
      };
  };
  mensajear(" Se replicó con rama $ramarepl la " . &descripcion_rama($rama));
  return $ramarepl;
}#replicar_rama
# ---------------------------------------------------------------------------
sub tratar_conex{
  comfin('comT tratar_conex',@_);
  my $refarch = $_[0]; my $coderr = '';
#  impr_debug(__LINE__.' Topo refarch capas',$refarch->{capas});
  impr_debug(__LINE__.' Topo $refall->{cualobjnoigno}'
	   ,Dumper $refall->{cualobjnoigno});
  foreach my $numcapa (@{$refarch->{capas}}) {
      my $refgraf = $refgrafers[$numcapa];
      next unless $refgraf->{enganches};
      impr_debug(__LINE__.' Topo $refgraf->{enganches} numcapa '.$numcapa
        , Dumper $refgraf->{enganches}); 
      $coderr = guardar_conex($refgraf);
  };
  comfin('finT tratar_conex',$coderr);
  return $coderr
}#tratar_conex',@_);

# ---------------------------------------------------------------------------
1
